/*
 * Copyright 2002,2004 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 1.3.28
 * 
 * This file is not intended to be easily readable and contains a number of 
 * coding conventions designed to improve portability and efficiency. Do not make
 * changes to this file unless you know what you are doing--modify the SWIG 
 * interface file instead. 
 * ----------------------------------------------------------------------------- */

#define SWIGPERL
#define SWIG_CASTRANK_MODE

#ifdef __cplusplus
template<class T> class SwigValueWrapper {
    T *tt;
public:
    SwigValueWrapper() : tt(0) { }
    SwigValueWrapper(const SwigValueWrapper<T>& rhs) : tt(new T(*rhs.tt)) { }
    SwigValueWrapper(const T& t) : tt(new T(t)) { }
    ~SwigValueWrapper() { delete tt; } 
    SwigValueWrapper& operator=(const T& t) { delete tt; tt = new T(t); return *this; }
    operator T&() const { return *tt; }
    T *operator&() { return tt; }
private:
    SwigValueWrapper& operator=(const SwigValueWrapper<T>& rhs);
};
#endif

/* -----------------------------------------------------------------------------
 *  This section contains generic SWIG labels for method/variable
 *  declarations/attributes, and other compiler dependent labels.
 * ----------------------------------------------------------------------------- */

/* template workaround for compilers that cannot correctly implement the C++ standard */
#ifndef SWIGTEMPLATEDISAMBIGUATOR
# if defined(__SUNPRO_CC)
#   if (__SUNPRO_CC <= 0x560)
#     define SWIGTEMPLATEDISAMBIGUATOR template
#   else
#     define SWIGTEMPLATEDISAMBIGUATOR 
#   endif
# else
#   define SWIGTEMPLATEDISAMBIGUATOR 
# endif
#endif

/* inline attribute */
#ifndef SWIGINLINE
# if defined(__cplusplus) || (defined(__GNUC__) && !defined(__STRICT_ANSI__))
#   define SWIGINLINE inline
# else
#   define SWIGINLINE
# endif
#endif

/* attribute recognised by some compilers to avoid 'unused' warnings */
#ifndef SWIGUNUSED
# if defined(__GNUC__)
#   if !(defined(__cplusplus)) || (__GNUC__ > 3 || (__GNUC__ == 3 && __GNUC_MINOR__ >= 4))
#     define SWIGUNUSED __attribute__ ((__unused__)) 
#   else
#     define SWIGUNUSED
#   endif
# elif defined(__ICC)
#   define SWIGUNUSED __attribute__ ((__unused__)) 
# else
#   define SWIGUNUSED 
# endif
#endif

#ifndef SWIGUNUSEDPARM
# ifdef __cplusplus
#   define SWIGUNUSEDPARM(p)
# else
#   define SWIGUNUSEDPARM(p) p SWIGUNUSED 
# endif
#endif

/* internal SWIG method */
#ifndef SWIGINTERN
# define SWIGINTERN static SWIGUNUSED
#endif

/* internal inline SWIG method */
#ifndef SWIGINTERNINLINE
# define SWIGINTERNINLINE SWIGINTERN SWIGINLINE
#endif

/* exporting methods */
#if (__GNUC__ >= 4) || (__GNUC__ == 3 && __GNUC_MINOR__ >= 4)
#  ifndef GCC_HASCLASSVISIBILITY
#    define GCC_HASCLASSVISIBILITY
#  endif
#endif

#ifndef SWIGEXPORT
# if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
#   if defined(STATIC_LINKED)
#     define SWIGEXPORT
#   else
#     define SWIGEXPORT __declspec(dllexport)
#   endif
# else
#   if defined(__GNUC__) && defined(GCC_HASCLASSVISIBILITY)
#     define SWIGEXPORT __attribute__ ((visibility("default")))
#   else
#     define SWIGEXPORT
#   endif
# endif
#endif

/* calling conventions for Windows */
#ifndef SWIGSTDCALL
# if defined(_WIN32) || defined(__WIN32__) || defined(__CYGWIN__)
#   define SWIGSTDCALL __stdcall
# else
#   define SWIGSTDCALL
# endif 
#endif

/* Deal with Microsoft's attempt at deprecating C standard runtime functions */
#if !defined(SWIG_NO_CRT_SECURE_NO_DEPRECATE) && defined(_MSC_VER)
# define _CRT_SECURE_NO_DEPRECATE
#endif

/* -----------------------------------------------------------------------------
 * swigrun.swg
 *
 * This file contains generic CAPI SWIG runtime support for pointer
 * type checking.
 * ----------------------------------------------------------------------------- */

/* This should only be incremented when either the layout of swig_type_info changes,
   or for whatever reason, the runtime changes incompatibly */
#define SWIG_RUNTIME_VERSION "2"

/* define SWIG_TYPE_TABLE_NAME as "SWIG_TYPE_TABLE" */
#ifdef SWIG_TYPE_TABLE
# define SWIG_QUOTE_STRING(x) #x
# define SWIG_EXPAND_AND_QUOTE_STRING(x) SWIG_QUOTE_STRING(x)
# define SWIG_TYPE_TABLE_NAME SWIG_EXPAND_AND_QUOTE_STRING(SWIG_TYPE_TABLE)
#else
# define SWIG_TYPE_TABLE_NAME
#endif

/*
  You can use the SWIGRUNTIME and SWIGRUNTIMEINLINE macros for
  creating a static or dynamic library from the swig runtime code.
  In 99.9% of the cases, swig just needs to declare them as 'static'.
  
  But only do this if is strictly necessary, ie, if you have problems
  with your compiler or so.
*/

#ifndef SWIGRUNTIME
# define SWIGRUNTIME SWIGINTERN
#endif

#ifndef SWIGRUNTIMEINLINE
# define SWIGRUNTIMEINLINE SWIGRUNTIME SWIGINLINE
#endif

/*  Generic buffer size */
#ifndef SWIG_BUFFER_SIZE
# define SWIG_BUFFER_SIZE 1024
#endif

/* Flags for pointer conversions */
#define SWIG_POINTER_DISOWN        0x1

/* Flags for new pointer objects */
#define SWIG_POINTER_OWN           0x1


/* 
   Flags/methods for returning states.
   
   The swig conversion methods, as ConvertPtr, return and integer 
   that tells if the conversion was successful or not. And if not,
   an error code can be returned (see swigerrors.swg for the codes).
   
   Use the following macros/flags to set or process the returning
   states.
   
   In old swig versions, you usually write code as:

     if (SWIG_ConvertPtr(obj,vptr,ty.flags) != -1) {
       // success code
     } else {
       //fail code
     }

   Now you can be more explicit as:

    int res = SWIG_ConvertPtr(obj,vptr,ty.flags);
    if (SWIG_IsOK(res)) {
      // success code
    } else {
      // fail code
    }

   that seems to be the same, but now you can also do

    Type *ptr;
    int res = SWIG_ConvertPtr(obj,(void **)(&ptr),ty.flags);
    if (SWIG_IsOK(res)) {
      // success code
      if (SWIG_IsNewObj(res) {
        ...
	delete *ptr;
      } else {
        ...
      }
    } else {
      // fail code
    }
    
   I.e., now SWIG_ConvertPtr can return new objects and you can
   identify the case and take care of the deallocation. Of course that
   requires also to SWIG_ConvertPtr to return new result values, as

      int SWIG_ConvertPtr(obj, ptr,...) {         
        if (<obj is ok>) {			       
          if (<need new object>) {		       
            *ptr = <ptr to new allocated object>; 
            return SWIG_NEWOBJ;		       
          } else {				       
            *ptr = <ptr to old object>;	       
            return SWIG_OLDOBJ;		       
          } 				       
        } else {				       
          return SWIG_BADOBJ;		       
        }					       
      }

   Of course, returning the plain '0(success)/-1(fail)' still works, but you can be
   more explicit by returning SWIG_BADOBJ, SWIG_ERROR or any of the
   swig errors code.

   Finally, if the SWIG_CASTRANK_MODE is enabled, the result code
   allows to return the 'cast rank', for example, if you have this

       int food(double)
       int fooi(int);

   and you call
 
      food(1)   // cast rank '1'  (1 -> 1.0)
      fooi(1)   // cast rank '0'

   just use the SWIG_AddCast()/SWIG_CheckState()


 */
#define SWIG_OK                    (0) 
#define SWIG_ERROR                 (-1)
#define SWIG_IsOK(r)               (r >= 0)
#define SWIG_ArgError(r)           ((r != SWIG_ERROR) ? r : SWIG_TypeError)  

/* The CastRankLimit says how many bits are used for the cast rank */
#define SWIG_CASTRANKLIMIT         (1 << 8)
/* The NewMask denotes the object was created (using new/malloc) */
#define SWIG_NEWOBJMASK            (SWIG_CASTRANKLIMIT  << 1)
/* The TmpMask is for in/out typemaps that use temporal objects */
#define SWIG_TMPOBJMASK            (SWIG_NEWOBJMASK << 1)
/* Simple returning values */
#define SWIG_BADOBJ                (SWIG_ERROR)
#define SWIG_OLDOBJ                (SWIG_OK)
#define SWIG_NEWOBJ                (SWIG_OK | SWIG_NEWOBJMASK)
#define SWIG_TMPOBJ                (SWIG_OK | SWIG_TMPOBJMASK)
/* Check, add and del mask methods */
#define SWIG_AddNewMask(r)         (SWIG_IsOK(r) ? (r | SWIG_NEWOBJMASK) : r)
#define SWIG_DelNewMask(r)         (SWIG_IsOK(r) ? (r & ~SWIG_NEWOBJMASK) : r)
#define SWIG_IsNewObj(r)           (SWIG_IsOK(r) && (r & SWIG_NEWOBJMASK))
#define SWIG_AddTmpMask(r)         (SWIG_IsOK(r) ? (r | SWIG_TMPOBJMASK) : r)
#define SWIG_DelTmpMask(r)         (SWIG_IsOK(r) ? (r & ~SWIG_TMPOBJMASK) : r)
#define SWIG_IsTmpObj(r)           (SWIG_IsOK(r) && (r & SWIG_TMPOBJMASK))


/* Cast-Rank Mode */
#if defined(SWIG_CASTRANK_MODE)
#  ifndef SWIG_TypeRank
#    define SWIG_TypeRank             unsigned long
#  endif
#  ifndef SWIG_MAXCASTRANK            /* Default cast allowed */
#    define SWIG_MAXCASTRANK          (2)
#  endif
#  define SWIG_CASTRANKMASK          ((SWIG_CASTRANKLIMIT) -1)
#  define SWIG_CastRank(r)           (r & SWIG_CASTRANKMASK)
SWIGINTERNINLINE int SWIG_AddCast(int r) { 
  return SWIG_IsOK(r) ? ((SWIG_CastRank(r) < SWIG_MAXCASTRANK) ? (r + 1) : SWIG_ERROR) : r;
}
SWIGINTERNINLINE int SWIG_CheckState(int r) { 
  return SWIG_IsOK(r) ? SWIG_CastRank(r) + 1 : 0; 
}
#else /* no cast-rank mode */
#  define SWIG_AddCast
#  define SWIG_CheckState(r) (SWIG_IsOK(r) ? 1 : 0)
#endif




#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef void *(*swig_converter_func)(void *);
typedef struct swig_type_info *(*swig_dycast_func)(void **);

/* Structure to store inforomation on one type */
typedef struct swig_type_info {
  const char             *name;			/* mangled name of this type */
  const char             *str;			/* human readable name of this type */
  swig_dycast_func        dcast;		/* dynamic cast function down a hierarchy */
  struct swig_cast_info  *cast;			/* linked list of types that can cast into this type */
  void                   *clientdata;		/* language specific type data */
  int                    owndata;		/* flag if the structure owns the clientdata */
} swig_type_info;

/* Structure to store a type and conversion function used for casting */
typedef struct swig_cast_info {
  swig_type_info         *type;			/* pointer to type that is equivalent to this type */
  swig_converter_func     converter;		/* function to cast the void pointers */
  struct swig_cast_info  *next;			/* pointer to next cast in linked list */
  struct swig_cast_info  *prev;			/* pointer to the previous cast */
} swig_cast_info;

/* Structure used to store module information
 * Each module generates one structure like this, and the runtime collects
 * all of these structures and stores them in a circularly linked list.*/
typedef struct swig_module_info {
  swig_type_info         **types;		/* Array of pointers to swig_type_info structures that are in this module */
  size_t                 size;		        /* Number of types in this module */
  struct swig_module_info *next;		/* Pointer to next element in circularly linked list */
  swig_type_info         **type_initial;	/* Array of initially generated type structures */
  swig_cast_info         **cast_initial;	/* Array of initially generated casting structures */
  void                    *clientdata;		/* Language specific module data */
} swig_module_info;

/* 
  Compare two type names skipping the space characters, therefore
  "char*" == "char *" and "Class<int>" == "Class<int >", etc.

  Return 0 when the two name types are equivalent, as in
  strncmp, but skipping ' '.
*/
SWIGRUNTIME int
SWIG_TypeNameComp(const char *f1, const char *l1,
		  const char *f2, const char *l2) {
  for (;(f1 != l1) && (f2 != l2); ++f1, ++f2) {
    while ((*f1 == ' ') && (f1 != l1)) ++f1;
    while ((*f2 == ' ') && (f2 != l2)) ++f2;
    if (*f1 != *f2) return (*f1 > *f2) ? 1 : -1;
  }
  return (l1 - f1) - (l2 - f2);
}

/*
  Check type equivalence in a name list like <name1>|<name2>|...
  Return 0 if not equal, 1 if equal
*/
SWIGRUNTIME int
SWIG_TypeEquiv(const char *nb, const char *tb) {
  int equiv = 0;
  const char* te = tb + strlen(tb);
  const char* ne = nb;
  while (!equiv && *ne) {
    for (nb = ne; *ne; ++ne) {
      if (*ne == '|') break;
    }
    equiv = (SWIG_TypeNameComp(nb, ne, tb, te) == 0) ? 1 : 0;
    if (*ne) ++ne;
  }
  return equiv;
}

/*
  Check type equivalence in a name list like <name1>|<name2>|...
  Return 0 if equal, -1 if nb < tb, 1 if nb > tb
*/
SWIGRUNTIME int
SWIG_TypeCompare(const char *nb, const char *tb) {
  int equiv = 0;
  const char* te = tb + strlen(tb);
  const char* ne = nb;
  while (!equiv && *ne) {
    for (nb = ne; *ne; ++ne) {
      if (*ne == '|') break;
    }
    equiv = (SWIG_TypeNameComp(nb, ne, tb, te) == 0) ? 1 : 0;
    if (*ne) ++ne;
  }
  return equiv;
}


/* think of this as a c++ template<> or a scheme macro */
#define SWIG_TypeCheck_Template(comparison, ty)         \
  if (ty) {                                             \
    swig_cast_info *iter = ty->cast;                    \
    while (iter) {                                      \
      if (comparison) {                                 \
        if (iter == ty->cast) return iter;              \
        /* Move iter to the top of the linked list */   \
        iter->prev->next = iter->next;                  \
        if (iter->next)                                 \
          iter->next->prev = iter->prev;                \
        iter->next = ty->cast;                          \
        iter->prev = 0;                                 \
        if (ty->cast) ty->cast->prev = iter;            \
        ty->cast = iter;                                \
        return iter;                                    \
      }                                                 \
      iter = iter->next;                                \
    }                                                   \
  }                                                     \
  return 0

/*
  Check the typename
*/
SWIGRUNTIME swig_cast_info *
SWIG_TypeCheck(const char *c, swig_type_info *ty) {
  SWIG_TypeCheck_Template(strcmp(iter->type->name, c) == 0, ty);
}

/* Same as previous function, except strcmp is replaced with a pointer comparison */
SWIGRUNTIME swig_cast_info *
SWIG_TypeCheckStruct(swig_type_info *from, swig_type_info *into) {
  SWIG_TypeCheck_Template(iter->type == from, into);
}

/*
  Cast a pointer up an inheritance hierarchy
*/
SWIGRUNTIMEINLINE void *
SWIG_TypeCast(swig_cast_info *ty, void *ptr) {
  return ((!ty) || (!ty->converter)) ? ptr : (*ty->converter)(ptr);
}

/* 
   Dynamic pointer casting. Down an inheritance hierarchy
*/
SWIGRUNTIME swig_type_info *
SWIG_TypeDynamicCast(swig_type_info *ty, void **ptr) {
  swig_type_info *lastty = ty;
  if (!ty || !ty->dcast) return ty;
  while (ty && (ty->dcast)) {
    ty = (*ty->dcast)(ptr);
    if (ty) lastty = ty;
  }
  return lastty;
}

/*
  Return the name associated with this type
*/
SWIGRUNTIMEINLINE const char *
SWIG_TypeName(const swig_type_info *ty) {
  return ty->name;
}

/*
  Return the pretty name associated with this type,
  that is an unmangled type name in a form presentable to the user.
*/
SWIGRUNTIME const char *
SWIG_TypePrettyName(const swig_type_info *type) {
  /* The "str" field contains the equivalent pretty names of the
     type, separated by vertical-bar characters.  We choose
     to print the last name, as it is often (?) the most
     specific. */
  if (!type) return NULL;
  if (type->str != NULL) {
    const char *last_name = type->str;
    const char *s;
    for (s = type->str; *s; s++)
      if (*s == '|') last_name = s+1;
    return last_name;
  }
  else
    return type->name;
}

/* 
   Set the clientdata field for a type
*/
SWIGRUNTIME void
SWIG_TypeClientData(swig_type_info *ti, void *clientdata) {
  swig_cast_info *cast = ti->cast;
  /* if (ti->clientdata == clientdata) return; */
  ti->clientdata = clientdata;
  
  while (cast) {
    if (!cast->converter) {
      swig_type_info *tc = cast->type;
      if (!tc->clientdata) {
	SWIG_TypeClientData(tc, clientdata);
      }
    }    
    cast = cast->next;
  }
}
SWIGRUNTIME void
SWIG_TypeNewClientData(swig_type_info *ti, void *clientdata) {
  SWIG_TypeClientData(ti, clientdata);
  ti->owndata = 1;
}
  
/*
  Search for a swig_type_info structure only by mangled name
  Search is a O(log #types)
  
  We start searching at module start, and finish searching when start == end.  
  Note: if start == end at the beginning of the function, we go all the way around
  the circular list.
*/
SWIGRUNTIME swig_type_info *
SWIG_MangledTypeQueryModule(swig_module_info *start, 
                            swig_module_info *end, 
		            const char *name) {
  swig_module_info *iter = start;
  do {
    if (iter->size) {
      register size_t l = 0;
      register size_t r = iter->size - 1;
      do {
	/* since l+r >= 0, we can (>> 1) instead (/ 2) */
	register size_t i = (l + r) >> 1; 
	const char *iname = iter->types[i]->name;
	if (iname) {
	  register int compare = strcmp(name, iname);
	  if (compare == 0) {	    
	    return iter->types[i];
	  } else if (compare < 0) {
	    if (i) {
	      r = i - 1;
	    } else {
	      break;
	    }
	  } else if (compare > 0) {
	    l = i + 1;
	  }
	} else {
	  break; /* should never happen */
	}
      } while (l <= r);
    }
    iter = iter->next;
  } while (iter != end);
  return 0;
}

/*
  Search for a swig_type_info structure for either a mangled name or a human readable name.
  It first searches the mangled names of the types, which is a O(log #types)
  If a type is not found it then searches the human readable names, which is O(#types).
  
  We start searching at module start, and finish searching when start == end.  
  Note: if start == end at the beginning of the function, we go all the way around
  the circular list.
*/
SWIGRUNTIME swig_type_info *
SWIG_TypeQueryModule(swig_module_info *start, 
                     swig_module_info *end, 
		     const char *name) {
  /* STEP 1: Search the name field using binary search */
  swig_type_info *ret = SWIG_MangledTypeQueryModule(start, end, name);
  if (ret) {
    return ret;
  } else {
    /* STEP 2: If the type hasn't been found, do a complete search
       of the str field (the human readable name) */
    swig_module_info *iter = start;
    do {
      register size_t i = 0;
      for (; i < iter->size; ++i) {
	if (iter->types[i]->str && (SWIG_TypeEquiv(iter->types[i]->str, name)))
	  return iter->types[i];
      }
      iter = iter->next;
    } while (iter != end);
  }
  
  /* neither found a match */
  return 0;
}

/* 
   Pack binary data into a string
*/
SWIGRUNTIME char *
SWIG_PackData(char *c, void *ptr, size_t sz) {
  static const char hex[17] = "0123456789abcdef";
  register const unsigned char *u = (unsigned char *) ptr;
  register const unsigned char *eu =  u + sz;
  for (; u != eu; ++u) {
    register unsigned char uu = *u;
    *(c++) = hex[(uu & 0xf0) >> 4];
    *(c++) = hex[uu & 0xf];
  }
  return c;
}

/* 
   Unpack binary data from a string
*/
SWIGRUNTIME const char *
SWIG_UnpackData(const char *c, void *ptr, size_t sz) {
  register unsigned char *u = (unsigned char *) ptr;
  register const unsigned char *eu = u + sz;
  for (; u != eu; ++u) {
    register char d = *(c++);
    register unsigned char uu;
    if ((d >= '0') && (d <= '9'))
      uu = ((d - '0') << 4);
    else if ((d >= 'a') && (d <= 'f'))
      uu = ((d - ('a'-10)) << 4);
    else 
      return (char *) 0;
    d = *(c++);
    if ((d >= '0') && (d <= '9'))
      uu |= (d - '0');
    else if ((d >= 'a') && (d <= 'f'))
      uu |= (d - ('a'-10));
    else 
      return (char *) 0;
    *u = uu;
  }
  return c;
}

/* 
   Pack 'void *' into a string buffer.
*/
SWIGRUNTIME char *
SWIG_PackVoidPtr(char *buff, void *ptr, const char *name, size_t bsz) {
  char *r = buff;
  if ((2*sizeof(void *) + 2) > bsz) return 0;
  *(r++) = '_';
  r = SWIG_PackData(r,&ptr,sizeof(void *));
  if (strlen(name) + 1 > (bsz - (r - buff))) return 0;
  strcpy(r,name);
  return buff;
}

SWIGRUNTIME const char *
SWIG_UnpackVoidPtr(const char *c, void **ptr, const char *name) {
  if (*c != '_') {
    if (strcmp(c,"NULL") == 0) {
      *ptr = (void *) 0;
      return name;
    } else {
      return 0;
    }
  }
  return SWIG_UnpackData(++c,ptr,sizeof(void *));
}

SWIGRUNTIME char *
SWIG_PackDataName(char *buff, void *ptr, size_t sz, const char *name, size_t bsz) {
  char *r = buff;
  size_t lname = (name ? strlen(name) : 0);
  if ((2*sz + 2 + lname) > bsz) return 0;
  *(r++) = '_';
  r = SWIG_PackData(r,ptr,sz);
  if (lname) {
    strncpy(r,name,lname+1);
  } else {
    *r = 0;
  }
  return buff;
}

SWIGRUNTIME const char *
SWIG_UnpackDataName(const char *c, void *ptr, size_t sz, const char *name) {
  if (*c != '_') {
    if (strcmp(c,"NULL") == 0) {
      memset(ptr,0,sz);
      return name;
    } else {
      return 0;
    }
  }
  return SWIG_UnpackData(++c,ptr,sz);
}

#ifdef __cplusplus
}
#endif

/*  Errors in SWIG */
#define  SWIG_UnknownError    	   -1 
#define  SWIG_IOError        	   -2 
#define  SWIG_RuntimeError   	   -3 
#define  SWIG_IndexError     	   -4 
#define  SWIG_TypeError      	   -5 
#define  SWIG_DivisionByZero 	   -6 
#define  SWIG_OverflowError  	   -7 
#define  SWIG_SyntaxError    	   -8 
#define  SWIG_ValueError     	   -9 
#define  SWIG_SystemError    	   -10
#define  SWIG_AttributeError 	   -11
#define  SWIG_MemoryError    	   -12 
#define  SWIG_NullReferenceError   -13



#ifdef __cplusplus
/* Needed on some windows machines---since MS plays funny games with the header files under C++ */
#include <math.h>
#include <stdlib.h>
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* Add in functionality missing in older versions of Perl. Much of this is based on Devel-PPPort on cpan. */

/* Add PERL_REVISION, PERL_VERSION, PERL_SUBVERSION if missing */
#ifndef PERL_REVISION
#  if !defined(__PATCHLEVEL_H_INCLUDED__) && !(defined(PATCHLEVEL) && defined(SUBVERSION))
#    define PERL_PATCHLEVEL_H_IMPLICIT
#    include <patchlevel.h>
#  endif
#  if !(defined(PERL_VERSION) || (defined(SUBVERSION) && defined(PATCHLEVEL)))
#    include <could_not_find_Perl_patchlevel.h>
#  endif
#  ifndef PERL_REVISION
#    define PERL_REVISION       (5)
#    define PERL_VERSION        PATCHLEVEL
#    define PERL_SUBVERSION     SUBVERSION
#  endif
#endif

#if defined(WIN32) && defined(PERL_OBJECT) && !defined(PerlIO_exportFILE)
#define PerlIO_exportFILE(fh,fl) (FILE*)(fh)
#endif

#ifndef SvIOK_UV
# define SvIOK_UV(sv)       (SvIOK(sv) && (SvUVX(sv) == SvIVX(sv)))
#endif

#ifndef SvUOK
# define SvUOK(sv)           SvIOK_UV(sv)
#endif

#if ((PERL_VERSION < 4) || ((PERL_VERSION == 4) && (PERL_SUBVERSION <= 5)))
#  define PL_sv_undef               sv_undef
#  define PL_na	                    na
#  define PL_errgv                  errgv
#  define PL_sv_no                  sv_no
#  define PL_sv_yes                 sv_yes
#  define PL_markstack_ptr          markstack_ptr
#endif

#ifndef IVSIZE
#  ifdef LONGSIZE
#    define IVSIZE LONGSIZE
#  else
#    define IVSIZE 4 /* A bold guess, but the best we can make. */
#  endif
#endif

#ifndef INT2PTR
#  if (IVSIZE == PTRSIZE) && (UVSIZE == PTRSIZE)
#    define PTRV                  UV
#    define INT2PTR(any,d)        (any)(d)
#  else
#    if PTRSIZE == LONGSIZE
#      define PTRV                unsigned long
#    else
#      define PTRV                unsigned
#    endif
#    define INT2PTR(any,d)        (any)(PTRV)(d)
#  endif

#  define NUM2PTR(any,d)  (any)(PTRV)(d)
#  define PTR2IV(p)       INT2PTR(IV,p)
#  define PTR2UV(p)       INT2PTR(UV,p)
#  define PTR2NV(p)       NUM2PTR(NV,p)

#  if PTRSIZE == LONGSIZE
#    define PTR2ul(p)     (unsigned long)(p)
#  else
#    define PTR2ul(p)     INT2PTR(unsigned long,p)
#  endif
#endif /* !INT2PTR */

#ifndef get_sv
#  define get_sv perl_get_sv
#endif

#ifndef ERRSV
#  define ERRSV get_sv("@",FALSE)
#endif

#ifndef pTHX_
#define pTHX_
#endif   

#include <string.h>
#ifdef __cplusplus
}
#endif

/* -----------------------------------------------------------------------------
 * error manipulation
 * ----------------------------------------------------------------------------- */

SWIGINTERN const char*
SWIG_Perl_ErrorType(int code) {
  const char* type = 0;
  switch(code) {
  case SWIG_MemoryError:
    type = "MemoryError";
    break;
  case SWIG_IOError:
    type = "IOError";
    break;
  case SWIG_RuntimeError:
    type = "RuntimeError";
    break;
  case SWIG_IndexError:
    type = "IndexError";
    break;
  case SWIG_TypeError:
    type = "TypeError";
    break;
  case SWIG_DivisionByZero:
    type = "ZeroDivisionError";
    break;
  case SWIG_OverflowError:
    type = "OverflowError";
    break;
  case SWIG_SyntaxError:
    type = "SyntaxError";
    break;
  case SWIG_ValueError:
    type = "ValueError";
    break;
  case SWIG_SystemError:
    type = "SystemError";
    break;
  case SWIG_AttributeError:
    type = "AttributeError";
    break;
  default:
    type = "RuntimeError";
  }
  return type;
}




/* -----------------------------------------------------------------------------
 * perlrun.swg
 *
 * This file contains the runtime support for Perl modules
 * and includes code for managing global variables and pointer
 * type checking.
 * ----------------------------------------------------------------------------- */

#ifdef PERL_OBJECT
#define SWIG_PERL_OBJECT_DECL CPerlObj *SWIGUNUSEDPARM(pPerl),
#define SWIG_PERL_OBJECT_CALL pPerl,
#else
#define SWIG_PERL_OBJECT_DECL
#define SWIG_PERL_OBJECT_CALL
#endif

/* Common SWIG API */

/* for raw pointers */
#define SWIG_ConvertPtr(obj, pp, type, flags)           SWIG_Perl_ConvertPtr(SWIG_PERL_OBJECT_CALL obj, pp, type, flags)
#define SWIG_NewPointerObj(p, type, flags)              SWIG_Perl_NewPointerObj(SWIG_PERL_OBJECT_CALL p, type, flags)

/* for raw packed data */
#define SWIG_ConvertPacked(obj, p, s, type)             SWIG_Perl_ConvertPacked(SWIG_PERL_OBJECT_CALL obj, p, s, type)
#define SWIG_NewPackedObj(p, s, type)	                SWIG_Perl_NewPackedObj(SWIG_PERL_OBJECT_CALL p, s, type)

/* for class or struct pointers */
#define SWIG_ConvertInstance(obj, pptr, type, flags)    SWIG_ConvertPtr(obj, pptr, type, flags)
#define SWIG_NewInstanceObj(ptr, type, flags)           SWIG_NewPointerObj(ptr, type, flags)

/* for C or C++ function pointers */
#define SWIG_ConvertFunctionPtr(obj, pptr, type)        SWIG_ConvertPtr(obj, pptr, type, 0)
#define SWIG_NewFunctionPtrObj(ptr, type)               SWIG_NewPointerObj(ptr, type, 0)

/* for C++ member pointers, ie, member methods */
#define SWIG_ConvertMember(obj, ptr, sz, ty)            SWIG_ConvertPacked(obj, ptr, sz, ty)
#define SWIG_NewMemberObj(ptr, sz, type)                SWIG_NewPackedObj(ptr, sz, type)


/* Runtime API */

#define SWIG_GetModule(clientdata)                      SWIG_Perl_GetModule()
#define SWIG_SetModule(clientdata, pointer)             SWIG_Perl_SetModule(pointer)


/* Error manipulation */

#define SWIG_ErrorType(code)                            SWIG_Perl_ErrorType(code)               
#define SWIG_Error(code, msg)            		sv_setpvf(GvSV(PL_errgv),"%s %s\n", SWIG_ErrorType(code), msg)
#define SWIG_fail                        		goto fail						    

/* Perl-specific SWIG API */

#define SWIG_MakePtr(sv, ptr, type, flags)              SWIG_Perl_MakePtr(SWIG_PERL_OBJECT_CALL sv, ptr, type, flags)
#define SWIG_MakePackedObj(sv, p, s, type)	        SWIG_Perl_MakePackedObj(SWIG_PERL_OBJECT_CALL sv, p, s, type)
#define SWIG_SetError(str)                              SWIG_Error(SWIG_RuntimeError, str)


#define SWIG_PERL_DECL_ARGS_1(arg1)                     (SWIG_PERL_OBJECT_DECL arg1)
#define SWIG_PERL_CALL_ARGS_1(arg1)                     (SWIG_PERL_OBJECT_CALL arg1)
#define SWIG_PERL_DECL_ARGS_2(arg1, arg2)               (SWIG_PERL_OBJECT_DECL arg1, arg2)
#define SWIG_PERL_CALL_ARGS_2(arg1, arg2)               (SWIG_PERL_OBJECT_CALL arg1, arg2)

/* -----------------------------------------------------------------------------
 * pointers/data manipulation
 * ----------------------------------------------------------------------------- */

/* For backward compatibility only */
#define SWIG_POINTER_EXCEPTION  0

#ifdef __cplusplus
extern "C" {
#endif

#define SWIG_OWNER   SWIG_POINTER_OWN
#define SWIG_SHADOW  SWIG_OWNER << 1

#define SWIG_MAYBE_PERL_OBJECT SWIG_PERL_OBJECT_DECL

/* SWIG Perl macros */

/* Macro to call an XS function */
#ifdef PERL_OBJECT 
#  define SWIG_CALLXS(_name) _name(cv,pPerl) 
#else 
#  ifndef MULTIPLICITY 
#    define SWIG_CALLXS(_name) _name(cv) 
#  else 
#    define SWIG_CALLXS(_name) _name(PERL_GET_THX, cv) 
#  endif 
#endif 

/* Note: SwigMagicFuncHack is a typedef used to get the C++ compiler to just shut up already */

#ifdef PERL_OBJECT
#define MAGIC_PPERL  CPerlObj *pPerl = (CPerlObj *) this;
typedef int (CPerlObj::*SwigMagicFunc)(SV *, MAGIC *);

#ifdef __cplusplus
extern "C" {
#endif
typedef int (CPerlObj::*SwigMagicFuncHack)(SV *, MAGIC *);
#ifdef __cplusplus
}
#endif

#define SWIG_MAGIC(a,b) (SV *a, MAGIC *b)
#define SWIGCLASS_STATIC
#else
#define MAGIC_PPERL
#define SWIGCLASS_STATIC static SWIGUNUSED
#ifndef MULTIPLICITY
#define SWIG_MAGIC(a,b) (SV *a, MAGIC *b)
typedef int (*SwigMagicFunc)(SV *, MAGIC *);

#ifdef __cplusplus
extern "C" {
#endif
typedef int (*SwigMagicFuncHack)(SV *, MAGIC *);
#ifdef __cplusplus
}
#endif


#else
#define SWIG_MAGIC(a,b) (struct interpreter *interp, SV *a, MAGIC *b)
typedef int (*SwigMagicFunc)(struct interpreter *, SV *, MAGIC *);
#ifdef __cplusplus
extern "C" {
#endif
typedef int (*SwigMagicFuncHack)(struct interpreter *, SV *, MAGIC *);
#ifdef __cplusplus
}
#endif

#endif
#endif

/* Workaround for bug in perl 5.6.x croak and earlier */
#if (PERL_VERSION < 8)
#  ifdef PERL_OBJECT
#    define SWIG_croak_null() SWIG_Perl_croak_null(pPerl)
static void SWIG_Perl_croak_null(CPerlObj *pPerl)
#  else
static void SWIG_croak_null()
#  endif
{
  SV *err=ERRSV;
#  if (PERL_VERSION < 6)
  croak("%_", err);
#  else
  if (SvOK(err) && !SvROK(err)) croak("%_", err);
  croak(Nullch);
#  endif
}
#else
#  define SWIG_croak_null() croak(Nullch)
#endif



#include <stdlib.h>

SWIGRUNTIME const char *
SWIG_Perl_TypeProxyName(const swig_type_info *type) {
  if (!type) return NULL;
  if (type->clientdata != NULL) {
    return (const char*) type->clientdata;
  } 
  else {
    return type->name;
  }
}

SWIGRUNTIME swig_cast_info *
SWIG_TypeProxyCheck(const char *c, swig_type_info *ty) {
  SWIG_TypeCheck_Template(( (!iter->type->clientdata && (strcmp((char*)iter->type->name, c) == 0)) 
			    || (iter->type->clientdata && (strcmp((char*)iter->type->clientdata, c) == 0))), ty);
}


/* Function for getting a pointer value */

SWIGRUNTIME int
SWIG_Perl_ConvertPtr(SWIG_MAYBE_PERL_OBJECT SV *sv, void **ptr, swig_type_info *_t, int flags) {
  swig_cast_info *tc;
  void *voidptr = (void *)0;
  SV *tsv = 0;
  /* If magical, apply more magic */
  if (SvGMAGICAL(sv))
    mg_get(sv);

  /* Check to see if this is an object */
  if (sv_isobject(sv)) {
    IV tmp = 0;
    tsv = (SV*) SvRV(sv);
    if ((SvTYPE(tsv) == SVt_PVHV)) {
      MAGIC *mg;
      if (SvMAGICAL(tsv)) {
        mg = mg_find(tsv,'P');
        if (mg) {
          sv = mg->mg_obj;
          if (sv_isobject(sv)) {
	    tsv = (SV*)SvRV(sv);
            tmp = SvIV(tsv);
          }
        }
      } else {
        return SWIG_ERROR;
      }
    } else {
      tmp = SvIV(tsv);
    }
    voidptr = INT2PTR(void *,tmp);
  } else if (! SvOK(sv)) {            /* Check for undef */
    *(ptr) = (void *) 0;
    return SWIG_OK;
  } else if (SvTYPE(sv) == SVt_RV) {  /* Check for NULL pointer */
    if (!SvROK(sv)) {
      *(ptr) = (void *) 0;
      return SWIG_OK;
    } else {
      return SWIG_ERROR;
    }
  } else {                            /* Don't know what it is */
    return SWIG_ERROR;
  }
  if (_t) {
    /* Now see if the types match */
    char *_c = HvNAME(SvSTASH(SvRV(sv)));
    tc = SWIG_TypeProxyCheck(_c,_t);
    if (!tc) {
      return SWIG_ERROR;
    }
    *ptr = SWIG_TypeCast(tc,voidptr);
  } else {
    *ptr = voidptr;
  }

  /* 
   *  DISOWN implementation: we need a perl guru to check this one.
   */
  if (tsv && (flags & SWIG_POINTER_DISOWN)) {
    /* 
     *  almost copy paste code from below SWIG_POINTER_OWN setting
     */
    SV *obj = sv;
    HV *stash = SvSTASH(SvRV(obj));
    GV *gv = *(GV**) hv_fetch(stash, "OWNER", 5, TRUE);
    if (isGV(gv)) {
      HV *hv = GvHVn(gv);
      /*
       * To set ownership (see below), a newSViv(1) entry is added. 
       * Hence, to remove ownership, we delete the entry.
       */
      if (hv_exists_ent(hv, obj, 0)) {
	hv_delete_ent(hv, obj, 0, 0);
      }
    }
  }
  return SWIG_OK;
}

SWIGRUNTIME void
SWIG_Perl_MakePtr(SWIG_MAYBE_PERL_OBJECT SV *sv, void *ptr, swig_type_info *t, int flags) {
  if (ptr && (flags & SWIG_SHADOW)) {
    SV *self;
    SV *obj=newSV(0);
    HV *hash=newHV();
    HV *stash;
    sv_setref_pv(obj, (char *) SWIG_Perl_TypeProxyName(t), ptr);
    stash=SvSTASH(SvRV(obj));
    if (flags & SWIG_POINTER_OWN) {
      HV *hv;
      GV *gv=*(GV**)hv_fetch(stash, "OWNER", 5, TRUE);
      if (!isGV(gv))
        gv_init(gv, stash, "OWNER", 5, FALSE);
      hv=GvHVn(gv);
      hv_store_ent(hv, obj, newSViv(1), 0);
    }
    sv_magic((SV *)hash, (SV *)obj, 'P', Nullch, 0);
    SvREFCNT_dec(obj);
    self=newRV_noinc((SV *)hash);
    sv_setsv(sv, self);
    SvREFCNT_dec((SV *)self);
    sv_bless(sv, stash);
  }
  else {
    sv_setref_pv(sv, (char *) SWIG_Perl_TypeProxyName(t), ptr);
  }
}

SWIGRUNTIMEINLINE SV *
SWIG_Perl_NewPointerObj(SWIG_MAYBE_PERL_OBJECT void *ptr, swig_type_info *t, int flags) {
  SV *result = sv_newmortal();
  SWIG_MakePtr(result, ptr, t, flags);
  return result;
}

SWIGRUNTIME void
SWIG_Perl_MakePackedObj(SWIG_MAYBE_PERL_OBJECT SV *sv, void *ptr, int sz, swig_type_info *type) {
  char result[1024];
  char *r = result;
  if ((2*sz + 1 + strlen(SWIG_Perl_TypeProxyName(type))) > 1000) return;
  *(r++) = '_';
  r = SWIG_PackData(r,ptr,sz);
  strcpy(r,SWIG_Perl_TypeProxyName(type));
  sv_setpv(sv, result);
}

SWIGRUNTIME SV *
SWIG_Perl_NewPackedObj(SWIG_MAYBE_PERL_OBJECT void *ptr, int sz, swig_type_info *type) {
  SV *result = sv_newmortal();
  SWIG_Perl_MakePackedObj(result, ptr, sz, type);
  return result;
}

/* Convert a packed value value */
SWIGRUNTIME int
SWIG_Perl_ConvertPacked(SWIG_MAYBE_PERL_OBJECT SV *obj, void *ptr, int sz, swig_type_info *ty) {
  swig_cast_info *tc;
  const char  *c = 0;

  if ((!obj) || (!SvOK(obj))) return SWIG_ERROR;
  c = SvPV(obj, PL_na);
  /* Pointer values must start with leading underscore */
  if (*c != '_') return SWIG_ERROR;
  c++;
  c = SWIG_UnpackData(c,ptr,sz);
  if (ty) {
    tc = SWIG_TypeCheck(c,ty);
    if (!tc) return SWIG_ERROR;
  }
  return SWIG_OK;
}


/* Macros for low-level exception handling */
#define SWIG_croak(x)    { SWIG_Error(SWIG_RuntimeError, x); SWIG_fail; }


typedef XSPROTO(SwigPerlWrapper);
typedef SwigPerlWrapper *SwigPerlWrapperPtr;

/* Structure for command table */
typedef struct {
  const char         *name;
  SwigPerlWrapperPtr  wrapper;
} swig_command_info;

/* Information for constant table */

#define SWIG_INT     1
#define SWIG_FLOAT   2
#define SWIG_STRING  3
#define SWIG_POINTER 4
#define SWIG_BINARY  5

/* Constant information structure */
typedef struct swig_constant_info {
    int              type;
    const char      *name;
    long             lvalue;
    double           dvalue;
    void            *pvalue;
    swig_type_info **ptype;
} swig_constant_info;


/* Structure for variable table */
typedef struct {
  const char   *name;
  SwigMagicFunc   set;
  SwigMagicFunc   get;
  swig_type_info  **type;
} swig_variable_info;

/* Magic variable code */
#ifndef PERL_OBJECT
#define swig_create_magic(s,a,b,c) _swig_create_magic(s,a,b,c)
  #ifndef MULTIPLICITY
     SWIGRUNTIME void _swig_create_magic(SV *sv, char *name, int (*set)(SV *, MAGIC *), int (*get)(SV *,MAGIC *)) 
  #else
     SWIGRUNTIME void _swig_create_magic(SV *sv, char *name, int (*set)(struct interpreter*, SV *, MAGIC *), int (*get)(struct interpreter*, SV *,MAGIC *)) 
  #endif
#else
#  define swig_create_magic(s,a,b,c) _swig_create_magic(pPerl,s,a,b,c)
SWIGRUNTIME void _swig_create_magic(CPerlObj *pPerl, SV *sv, const char *name, int (CPerlObj::*set)(SV *, MAGIC *), int (CPerlObj::*get)(SV *, MAGIC *)) 
#endif
{
  MAGIC *mg;
  sv_magic(sv,sv,'U',(char *) name,strlen(name));
  mg = mg_find(sv,'U');
  mg->mg_virtual = (MGVTBL *) malloc(sizeof(MGVTBL));
  mg->mg_virtual->svt_get = (SwigMagicFuncHack) get;
  mg->mg_virtual->svt_set = (SwigMagicFuncHack) set;
  mg->mg_virtual->svt_len = 0;
  mg->mg_virtual->svt_clear = 0;
  mg->mg_virtual->svt_free = 0;
}


SWIGRUNTIME swig_module_info *
SWIG_Perl_GetModule(void) {
  static void *type_pointer = (void *)0;
  SV *pointer;

  /* first check if pointer already created */
  if (!type_pointer) {
    pointer = get_sv("swig_runtime_data::type_pointer" SWIG_RUNTIME_VERSION SWIG_TYPE_TABLE_NAME, FALSE);
    if (pointer && SvOK(pointer)) {
      type_pointer = INT2PTR(swig_type_info **, SvIV(pointer));
    }
  }

  return (swig_module_info *) type_pointer;
}

SWIGRUNTIME void
SWIG_Perl_SetModule(swig_module_info *module) {
  SV *pointer;

  /* create a new pointer */
  pointer = get_sv("swig_runtime_data::type_pointer" SWIG_RUNTIME_VERSION SWIG_TYPE_TABLE_NAME, TRUE);
  sv_setiv(pointer, PTR2IV(module));
}

#ifdef __cplusplus
}
#endif

/* Workaround perl5 global namespace pollution. Note that undefining library
 * functions like fopen will not solve the problem on all platforms as fopen
 * might be a macro on Windows but not necessarily on other operating systems. */
#ifdef do_open
  #undef do_open
#endif
#ifdef do_close
  #undef do_close
#endif
#ifdef scalar
  #undef scalar
#endif
#ifdef list
  #undef list
#endif
#ifdef apply
  #undef apply
#endif
#ifdef convert
  #undef convert
#endif
#ifdef Error
  #undef Error
#endif
#ifdef form
  #undef form
#endif
#ifdef vform
  #undef vform
#endif
#ifdef LABEL
  #undef LABEL
#endif
#ifdef METHOD
  #undef METHOD
#endif
#ifdef Move
  #undef Move
#endif
#ifdef yylex
  #undef yylex
#endif
#ifdef yyparse
  #undef yyparse
#endif
#ifdef yyerror
  #undef yyerror
#endif
#ifdef invert
  #undef invert
#endif
#ifdef ref
  #undef ref
#endif
#ifdef read
  #undef read
#endif
#ifdef write
  #undef write
#endif
#ifdef eof
  #undef eof
#endif
#ifdef bool
  #undef bool
#endif
#ifdef close
  #undef close
#endif
#ifdef rewind
  #undef rewind
#endif
#ifdef free
  #undef free
#endif
#ifdef malloc
  #undef malloc
#endif
#ifdef calloc
  #undef calloc
#endif
#ifdef Stat
  #undef Stat
#endif
#ifdef check
  #undef check
#endif



#define SWIG_exception_fail(code, msg) do { SWIG_Error(code, msg); SWIG_fail; } while(0) 

#define SWIG_contract_assert(expr, msg) if (!(expr)) { SWIG_Error(SWIG_RuntimeError, msg); SWIG_fail; } else 



/* -------- TYPES TABLE (BEGIN) -------- */

#define SWIGTYPE_p_DatatypeValidatorFactory swig_types[0]
#define SWIGTYPE_p_IdentityConstraint swig_types[1]
#define SWIGTYPE_p_PSVIAttributeList swig_types[2]
#define SWIGTYPE_p_PSVIDefs__Complexity swig_types[3]
#define SWIGTYPE_p_PSVIDefs__PSVIScope swig_types[4]
#define SWIGTYPE_p_PSVIDefs__Validation swig_types[5]
#define SWIGTYPE_p_PSVIDefs__Validity swig_types[6]
#define SWIGTYPE_p_PSVIElement swig_types[7]
#define SWIGTYPE_p_PanicHandler swig_types[8]
#define SWIGTYPE_p_PanicHandler__PanicReasons swig_types[9]
#define SWIGTYPE_p_PerlCallbackHandler swig_types[10]
#define SWIGTYPE_p_PerlContentCallbackHandler swig_types[11]
#define SWIGTYPE_p_PerlDocumentCallbackHandler swig_types[12]
#define SWIGTYPE_p_PerlEntityResolverHandler swig_types[13]
#define SWIGTYPE_p_PerlErrorCallbackHandler swig_types[14]
#define SWIGTYPE_p_PerlNodeFilterCallbackHandler swig_types[15]
#define SWIGTYPE_p_RefArrayVectorOfTunsigned_short_t swig_types[16]
#define SWIGTYPE_p_RefHash2KeysTableOfTValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t_t swig_types[17]
#define SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__ComplexTypeInfo_t swig_types[18]
#define SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XMLAttDef_t swig_types[19]
#define SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XSAnnotation_t swig_types[20]
#define SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesAttGroupInfo_t swig_types[21]
#define SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesGroupInfo_t swig_types[22]
#define SWIGTYPE_p_RefHashTableOfTXMLRefInfo_t swig_types[23]
#define SWIGTYPE_p_SecurityManager swig_types[24]
#define SWIGTYPE_p_ValidationContext swig_types[25]
#define SWIGTYPE_p_ValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t swig_types[26]
#define SWIGTYPE_p_ValueVectorOfTunsigned_int_t swig_types[27]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser swig_types[28]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList swig_types[29]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes swig_types[30]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__BinInputStream swig_types[31]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__ComplexTypeInfo swig_types[32]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentHandler swig_types[33]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentSpecNode swig_types[34]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr swig_types[35]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder swig_types[36]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilderFilter swig_types[37]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCDATASection swig_types[38]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCharacterData swig_types[39]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMComment swig_types[40]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMConfiguration swig_types[41]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument swig_types[42]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentFragment swig_types[43]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentRange swig_types[44]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal swig_types[45]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType swig_types[46]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement swig_types[47]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity swig_types[48]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntityReference swig_types[49]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntityResolver swig_types[50]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMError swig_types[51]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMErrorHandler swig_types[52]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMException swig_types[53]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation swig_types[54]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationLS swig_types[55]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationRegistry swig_types[56]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationSource swig_types[57]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource swig_types[58]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator swig_types[59]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap swig_types[60]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode swig_types[61]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeFilter swig_types[62]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator swig_types[63]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeList swig_types[64]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNotation swig_types[65]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction swig_types[66]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange swig_types[67]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRangeException swig_types[68]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText swig_types[69]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker swig_types[70]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTypeInfo swig_types[71]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMUserDataHandler swig_types[72]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter swig_types[73]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriterFilter swig_types[74]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef swig_types[75]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList swig_types[76]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl swig_types[77]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl swig_types[78]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar swig_types[79]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDHandler swig_types[80]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDValidator swig_types[81]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DatatypeValidator swig_types[82]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DeclHandler swig_types[83]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler swig_types[84]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__DocumentHandler swig_types[85]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__EntityResolver swig_types[86]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler swig_types[87]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar swig_types[88]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__GrammarResolver swig_types[89]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase swig_types[90]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource swig_types[91]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler swig_types[92]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget swig_types[93]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileInputSource swig_types[94]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator swig_types[95]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufFormatTarget swig_types[96]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufInputSource swig_types[97]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager swig_types[98]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t swig_types[99]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t swig_types[100]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__XMLNotationDecl_t swig_types[101]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t swig_types[102]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t swig_types[103]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__NamespaceScope swig_types[104]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__PSVIHandler swig_types[105]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__Parser swig_types[106]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName swig_types[107]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t swig_types[108]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t swig_types[109]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader swig_types[110]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXException swig_types[111]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException swig_types[112]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXNotSupportedException swig_types[113]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException swig_types[114]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser swig_types[115]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef swig_types[116]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList swig_types[117]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl swig_types[118]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar swig_types[119]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator swig_types[120]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__StdInInputSource swig_types[121]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__StdOutFormatTarget swig_types[122]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__URLInputSource swig_types[123]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource swig_types[124]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource swig_types[125]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef swig_types[126]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList swig_types[127]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLContentModel swig_types[128]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDTDDescription swig_types[129]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDeleter swig_types[130]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDocumentHandler swig_types[131]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl swig_types[132]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl swig_types[133]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityResolver swig_types[134]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t swig_types[135]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t swig_types[136]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t swig_types[137]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLException swig_types[138]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLExcepts swig_types[139]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLFormatTarget swig_types[140]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLFormatter swig_types[141]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription swig_types[142]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarPool swig_types[143]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl swig_types[144]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken swig_types[145]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPlatformUtils swig_types[146]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLReaderFactory swig_types[147]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription swig_types[148]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL swig_types[149]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUni swig_types[150]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri swig_types[151]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator swig_types[152]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMemory swig_types[153]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XSAnnotation swig_types[154]
#define SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser swig_types[155]
#define SWIGTYPE_p_XMLBuffer swig_types[156]
#define SWIGTYPE_p_XMLErrorReporter swig_types[157]
#define SWIGTYPE_p_XMLErrorReporter__ErrTypes swig_types[158]
#define SWIGTYPE_p_XSerializeEngine swig_types[159]
#define SWIGTYPE_p_a_32__unsigned_short swig_types[160]
#define SWIGTYPE_p_bool swig_types[161]
#define SWIGTYPE_p_char swig_types[162]
#define SWIGTYPE_p_int swig_types[163]
#define SWIGTYPE_p_long swig_types[164]
#define SWIGTYPE_p_p_void swig_types[165]
#define SWIGTYPE_p_unsigned_char swig_types[166]
#define SWIGTYPE_p_unsigned_int swig_types[167]
#define SWIGTYPE_p_unsigned_long swig_types[168]
#define SWIGTYPE_p_unsigned_short swig_types[169]
#define SWIGTYPE_p_void swig_types[170]
static swig_type_info *swig_types[172];
static swig_module_info swig_module = {swig_types, 171, 0, 0, 0, 0};
#define SWIG_TypeQuery(name) SWIG_TypeQueryModule(&swig_module, &swig_module, name)
#define SWIG_MangledTypeQuery(name) SWIG_MangledTypeQueryModule(&swig_module, &swig_module, name)

/* -------- TYPES TABLE (END) -------- */

#define SWIG_init    boot_XML__Xerces

#define SWIG_name   "XML::Xercesc::boot_XML__Xerces"
#define SWIG_prefix "XML::Xercesc::"

#define SWIGVERSION 0x010328 


#define SWIG_as_voidptr(a) const_cast< void * >(static_cast< const void * >(a)) 
#define SWIG_as_voidptrptr(a) ((void)SWIG_as_voidptr(*a),reinterpret_cast< void** >(a)) 


#include <stdexcept>


#ifdef __cplusplus
extern "C"
#endif
#ifndef PERL_OBJECT
#ifndef MULTIPLICITY
SWIGEXPORT void SWIG_init (CV* cv);
#else
SWIGEXPORT void SWIG_init (pTHXo_ CV* cv);
#endif
#else
SWIGEXPORT void SWIG_init (CV *cv, CPerlObj *);
#endif


#include "xercesc/sax/InputSource.hpp"
#include "xercesc/sax/SAXException.hpp"
#include "xercesc/sax/SAXParseException.hpp"
#include "xercesc/sax/Locator.hpp"
#include "xercesc/sax/HandlerBase.hpp"
#include "xercesc/sax2/Attributes.hpp"
#include "xercesc/sax2/ContentHandler.hpp"
#include "xercesc/sax2/LexicalHandler.hpp"
#include "xercesc/sax2/DefaultHandler.hpp"
#include "xercesc/sax2/SAX2XMLReader.hpp"
#include "xercesc/sax2/XMLReaderFactory.hpp"
#include "xercesc/util/PlatformUtils.hpp"
#include "xercesc/util/TransService.hpp"
#include "xercesc/util/XMLString.hpp"
#include "xercesc/util/XMLUri.hpp"
#include "xercesc/util/QName.hpp"
#include "xercesc/util/HexBin.hpp"
#include "xercesc/util/Base64.hpp"
#include "xercesc/parsers/AbstractDOMParser.hpp"
#include "xercesc/parsers/XercesDOMParser.hpp"
#include "xercesc/parsers/SAXParser.hpp"
#include "xercesc/dom/DOM.hpp"
#include "xercesc/framework/LocalFileInputSource.hpp"
#include "xercesc/framework/MemBufInputSource.hpp"
#include "xercesc/framework/StdInInputSource.hpp"
#include "xercesc/framework/URLInputSource.hpp"
#include "xercesc/framework/XMLGrammarDescription.hpp"
#include "xercesc/framework/XMLDTDDescription.hpp"
#include "xercesc/framework/XMLSchemaDescription.hpp"
#include "xercesc/util/NameIdPool.hpp"
#include "xercesc/util/XMLEnumerator.hpp"
#include "xercesc/framework/XMLValidator.hpp"
#include "xercesc/validators/common/Grammar.hpp"
#include "xercesc/validators/DTD/DTDAttDef.hpp"
#include "xercesc/validators/DTD/DTDAttDefList.hpp"
#include "xercesc/validators/DTD/DTDGrammar.hpp"
#include "xercesc/validators/DTD/DTDValidator.hpp"
#include "xercesc/validators/schema/SchemaGrammar.hpp"
#include "xercesc/validators/schema/SchemaValidator.hpp"
#include "xercesc/validators/schema/SchemaAttDefList.hpp"
#include "xercesc/validators/schema/SchemaAttDef.hpp"
#include "xercesc/framework/XMLFormatter.hpp"
#include "xercesc/framework/MemBufFormatTarget.hpp"
#include "xercesc/framework/LocalFileFormatTarget.hpp"
#include "xercesc/framework/StdOutFormatTarget.hpp"
#include "xercesc/framework/Wrapper4InputSource.hpp"
#include "xercesc/framework/Wrapper4DOMInputSource.hpp"
#include "xercesc/framework/psvi/PSVIHandler.hpp"

// for resolving XMLExceptions
#include "xercesc/util/ArrayIndexOutOfBoundsException.hpp"
#include "xercesc/util/EmptyStackException.hpp"
#include "xercesc/util/IllegalArgumentException.hpp"
#include "xercesc/util/InvalidCastException.hpp"
#include "xercesc/util/IOException.hpp"
#include "xercesc/util/NoSuchElementException.hpp"
#include "xercesc/util/NullPointerException.hpp"
#include "xercesc/util/NumberFormatException.hpp"
#include "xercesc/util/ParseException.hpp"
#include "xercesc/util/RuntimeException.hpp"
#include "xercesc/util/SchemaDateTimeException.hpp"
#include "xercesc/util/TranscodingException.hpp"
#include "xercesc/util/UnexpectedEOFException.hpp"
#include "xercesc/util/UnsupportedEncodingException.hpp"
#include "xercesc/util/UTFDataFormatException.hpp"
#include "xercesc/util/XMLNetAccessor.hpp"
#include "xercesc/internal/XSerializationException.hpp"
#include "xercesc/validators/datatype/InvalidDatatypeFacetException.hpp"
#include "xercesc/validators/datatype/InvalidDatatypeValueException.hpp"
#include "xercesc/validators/schema/identity/XPathException.hpp"

XERCES_CPP_NAMESPACE_USE

// we initialize the static UTF-8 transcoding info
// these are used by the typemaps to convert between
// Xerces internal UTF-16 and Perl's internal UTF-8
static XMLCh* UTF8_ENCODING = NULL; 
static XMLTranscoder* UTF8_TRANSCODER  = NULL;

static bool DEBUG_UTF8_OUT = 0;
static bool DEBUG_UTF8_IN = 0;




#include "PerlCallbackHandler.hpp"
#include "PerlErrorCallbackHandler.hpp"
#include "PerlDocumentCallbackHandler.hpp"
#include "PerlContentCallbackHandler.hpp"
#include "PerlEntityResolverHandler.i"
#include "PerlNodeFilterCallbackHandler.i"

static void
SWIG_Disown(SV *sv) {
  
  if (SvGMAGICAL(sv)) {
      mg_get(sv);
  }
    

  /* Check to see if this is an object */
  if (sv_isobject(sv)) {
    SV *tsv = (SV*) SvRV(sv);
    if ((SvTYPE(tsv) == SVt_PVHV)) {
      MAGIC *mg;
      if (SvMAGICAL(tsv)) {
        mg = mg_find(tsv,'P');
        if (mg) {
          sv = mg->mg_obj;
          if (sv_isobject(sv)) {
              // fprintf(stderr,"Found object for disown\n");

	      HV *stash;
	      stash=SvSTASH(SvRV(sv));

	      if (stash != 0)
              {
                  // fprintf(stderr,"Found stash: %x\n",stash);
                  HV *hv;
                  GV *gv=*(GV**)hv_fetch(stash, "OWNER", 5, TRUE);
                  if (isGV(gv))
                  {
                      // fprintf(stderr,"Found OWNER glob: %x\n",gv);
                      // fprintf(stderr,"Found object: %x\n",sv);
                      // fprintf(stderr,"Found ref object: %x\n",SvRV(sv));
                      hv=GvHVn(gv);

                      HE *entry;
                      char *key;
                      I32 klen;
                      SV *hval;
	    
                      (void)hv_iterinit(hv);
                      while ((entry = hv_iternext(hv)))  {
                          key = hv_iterkey(entry, &klen);
                          // fprintf(stderr,"Found hash entry: %s\n",key);
                      }
            
		      if (hv_exists_ent(hv, sv, 0))
                      {
                          // fprintf(stderr,"Found key in OWNER hash!\n");
                          if (hv_delete_ent(hv,sv,0,0))
                          {
                              // fprintf(stderr,"Deleted key in OWNER hash!\n");
                          }
                          else 
                          {
                              SWIG_SetError("Couldn't delete key from OWNER hash :-<\n");
                          }
                      }
                      else
                      {
                          SWIG_SetError("no key in OWNER hash :-<\n");
                      }
                  }
                  else
                  {
                      SWIG_SetError("no GV\n");
                  }
              }
              else
              {
                  SWIG_SetError("no stash found\n");
              }
          } else {
              SWIG_SetError("SWIG_Disown: mg is not object");
          }
        } else {
            SWIG_SetError("SWIG_Disown: no mg");
        }
      } else {
          SWIG_SetError("SWIG_Disown: not magical");
      }
    } else {
      SWIG_SetError("SWIG_Disown: not PVHV");
    }
  } else {            /* not an object */
      SWIG_SetError("SWIG_Disown: not an object");
  }
}




SV*
XMLString2Perl(const XMLCh* input) {
    SV *output;
  unsigned int charsEaten = 0;
  int length  = XMLString::stringLen(input);            // string length
  // use +1 to make room for the '\0' at the end of the string
  // in the pathological case when each character of the string 
  // is UTF8_MAXLEN bytes long
  XMLByte* res = new XMLByte[(length * UTF8_MAXLEN) + 1]; // output string

  unsigned int total_chars =
    UTF8_TRANSCODER->transcodeTo((const XMLCh*) input, 
				   (unsigned int) length,
				   (XMLByte*) res,
				   (unsigned int) (length*UTF8_MAXLEN),
				   charsEaten,
				   XMLTranscoder::UnRep_Throw
				   );
  res[total_chars] = '\0';

#if (0) 
  if (DEBUG_UTF8_OUT) {
      printf("Xerces out length = %d: ",total_chars);
      for (int i=0;i<length;i++){
	  printf("<0x%.4X>",res[i]);
      }
      printf("\n");
  }
#endif

  output = sv_newmortal();
  sv_setpv((SV*)output, (char *)res );
  SvUTF8_on((SV*)output);
  delete[] res;
  return output;
}

XMLCh* 
Perl2XMLString(SV* input){
    XMLCh* output;

    STRLEN length;
    char *ptr = (char *)SvPVutf8(input,length);

#if (0) 
    if (DEBUG_UTF8_IN) {
	printf("Perl in length = %d: ",length);
	for (unsigned int i=0;i<length;i++){
	    printf("<0x%.4X>",ptr[i]);
	}
	printf("\n");
    }
#endif

    if (SvUTF8(input)) {
	unsigned int charsEaten = 0;
        unsigned char* sizes = new unsigned char[length+1];
        output = new XMLCh[length+1];
	unsigned int chars_stored = 
	    UTF8_TRANSCODER->transcodeFrom((const XMLByte*) ptr,
					   (unsigned int) length,
					   (XMLCh*) output, 
					   (unsigned int) length,
					   charsEaten,
					   (unsigned char*)sizes
					   );
	delete [] sizes;

#if (0) 
	if (DEBUG_UTF8_IN) {
	    printf("Xerces in length = %d: ",chars_stored);
	    for (unsigned int i=0;i<chars_stored;i++){
		printf("<0x%.4X>",output[i]);
	    }
	    printf("\n");
	}
#endif

	// indicate the end of the string
	output[chars_stored] = '\0';
    } else {
	output = XMLString::transcode(ptr);

#if (0) 
	if (DEBUG_UTF8_IN) {
	    printf("Xerces: ");
	    for (int i=0;output[i];i++){
		printf("<0x%.4X>",output[i]);
	    }
	    printf("\n");
	}
#endif

    }
    return(output);
}



static void
SWIG_Perl_SetErrorf(const char *fmt, ...) {
  va_list args;
  va_start(args, fmt);
  sv_vsetpvfn(perl_get_sv("@", TRUE), fmt, strlen(fmt), &args, Null(SV**), 0, Null(bool*));
  va_end(args);
}

SWIGRUNTIMEINLINE void
SWIG_Perl_NullRef(const char *type, int argnum, const char *symname)
{
  if (type) {
    SWIG_Perl_SetErrorf("null reference of type: '%s' was received as argumnent: %d of %s",type,argnum,symname);
  } else {
    SWIG_Perl_SetErrorf("null reference was received");
  }
}

SWIGRUNTIMEINLINE void
SWIG_Perl_NullRef(const char *type, const char *argname, const char *symname)
{
  if (type) {
    SWIG_Perl_SetErrorf("null reference of type: '%s' was received as argumnent: %s of %s",type,argname,symname);
  } else {
    SWIG_Perl_SetErrorf("null reference was received");
  }
}

SWIGRUNTIME void
SWIG_Perl_TypeError(const char *type, int argnum, const char *symname)
{
  if (type) {
    SWIG_Perl_SetErrorf("Type error in argument %d of %s. Expected %s", argnum, symname, type);
  } else {
    SWIG_Perl_SetErrorf("Type error in argument $argnum of $symname", argnum, symname);
  }
}


SWIGINTERN int
SWIG_AsVal_double SWIG_PERL_DECL_ARGS_2(SV *obj, double *val)
{
  if (SvNIOK(obj)) {
    if (val) *val = SvNV(obj);
    return SWIG_OK;
  } else if (SvIOK(obj)) {
    if (val) *val = (double) SvIV(obj);
    return SWIG_AddCast(SWIG_OK);
  } else {
    const char *nptr = SvPV(obj, PL_na);
    if (nptr) {
      char *endptr;
      double v = strtod(nptr, &endptr);
      if (errno == ERANGE) {
	errno = 0;
	return SWIG_OverflowError;
      } else {
	if (*endptr == '\0') {
	  if (val) *val = v;
	  return SWIG_AddCast(SWIG_OK);
	}
      }
    }
  }
  return SWIG_TypeError;
}


#include <float.h>


#include <math.h>


SWIGINTERNINLINE int
SWIG_CanCastAsInteger(double *d, double min, double max) {
  double x = *d;
  if ((min <= x && x <= max)) {
   double fx = floor(x);
   double cx = ceil(x);
   double rd =  ((x - fx) < 0.5) ? fx : cx; /* simple rint */
   if ((errno == EDOM) || (errno == ERANGE)) {
     errno = 0;
   } else {
     double summ, reps, diff;
     if (rd < x) {
       diff = x - rd;
     } else if (rd > x) {
       diff = rd - x;
     } else {
       return 1;
     }
     summ = rd + x;
     reps = diff/summ;
     if (reps < 8*DBL_EPSILON) {
       *d = rd;
       return 1;
     }
   }
  }
  return 0;
}


SWIGINTERN int
SWIG_AsVal_bool SWIG_PERL_DECL_ARGS_2(SV *obj, bool* val)
{
  if (obj == &PL_sv_yes) {
    if (val) *val = true;
    return SWIG_OK;
  } else if (obj == &PL_sv_no) { 
    if (val) *val = false;
    return SWIG_OK;
  } else {
    if (val) *val = SvTRUE(obj) ? true: false;
    return SWIG_AddCast(SWIG_OK);    
  }
  return SWIG_TypeError;
}


SWIGINTERNINLINE SV *
SWIG_From_bool  SWIG_PERL_DECL_ARGS_1(bool value)
{    
  SV *obj = sv_newmortal();
  if (value) {
    sv_setsv(obj, &PL_sv_yes);
  } else {
    sv_setsv(obj, &PL_sv_no); 
  }
  return obj;
}


XMLException*
copyXMLException(const XMLException& e)
{
    if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgArrayIndexOutOfBoundsException_Name)
    {
        return (XMLException*)((ArrayIndexOutOfBoundsException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgEmptyStackException_Name)
    {
        return (XMLException*)((EmptyStackException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgIllegalArgumentException_Name)
    {
        return (XMLException*)((IllegalArgumentException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgInvalidCastException_Name)
    {
        return (XMLException*)((InvalidCastException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgIOException_Name)
    {
        return (XMLException*)((IOException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgNoSuchElementException_Name)
    {
        return (XMLException*)((NoSuchElementException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgNullPointerException_Name)
    {
        return (XMLException*)((NullPointerException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgNumberFormatException_Name)
    {
        return (XMLException*)((NumberFormatException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgParseException_Name)
    {
        return (XMLException*)((ParseException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgXMLPlatformUtilsException_Name)
    {
        return (XMLException*)((XMLPlatformUtilsException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgRuntimeException_Name)
    {
        return (XMLException*)((RuntimeException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgSchemaDateTimeException_Name)
    {
        return (XMLException*)((SchemaDateTimeException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgTranscodingException_Name)
    {
        return (XMLException*)((TranscodingException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgUnexpectedEOFException_Name)
    {
        return (XMLException*)((UnexpectedEOFException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgUnsupportedEncodingException_Name)
    {
        return (XMLException*)((UnsupportedEncodingException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgUTFDataFormatException_Name)
    {
        return (XMLException*)((UTFDataFormatException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgNetAccessorException_Name)
    {
        return (XMLException*)((NetAccessorException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgMalformedURLException_Name)
    {
        return (XMLException*)((MalformedURLException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgXSerializationException_Name)
    {
        return (XMLException*)((XSerializationException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgInvalidDatatypeFacetException_Name)
    {
        return (XMLException*)((InvalidDatatypeFacetException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgInvalidDatatypeValueException_Name)
    {
        return (XMLException*)((InvalidDatatypeValueException*)&e)->duplicate();
    }
    else if(e.getType() == XERCES_CPP_NAMESPACE::XMLUni::fgXPathException_Name)
    {
        return (XMLException*)((XPathException*)&e)->duplicate();
    }
    else
    {
        SWIG_Perl_SetErrorf("Unknown Exception type: %d", e.getType());
    }
}

void
makeXMLException(const XMLException& e){
    SV *error = ERRSV;
    SWIG_MakePtr(error, (void *) copyXMLException(e), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLException, SWIG_SHADOW|0);
}

void
makeDOMException(const DOMException& e){
    SV *error = ERRSV;
    SWIG_MakePtr(error, (void *) new DOMException(e), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMException, SWIG_SHADOW|0);
}

void
makeSAXNotRecognizedException(const SAXNotRecognizedException& e){
    SV *error = ERRSV;
    SWIG_MakePtr(error, (void *) new SAXNotRecognizedException(e), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException, SWIG_SHADOW|0);
}

void
makeSAXNotSupportedException(const SAXNotSupportedException& e){
    SV *error = ERRSV;
    SWIG_MakePtr(error, (void *) new SAXNotSupportedException(e), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXNotSupportedException, SWIG_SHADOW|0);
}



static swig_type_info *
Grammar_dynamic_cast(void **ptr) {
   Grammar **nptr = (Grammar **) ptr;
   if (*nptr == NULL) {
       return NULL;
   }
   short int type = (*nptr)->getGrammarType();
   if (type == Grammar::DTDGrammarType) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar;
   }
   if (type == Grammar::SchemaGrammarType) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar;
   }
   return NULL;
}


static swig_type_info *
DOMNode_dynamic_cast(void **ptr) {
   DOMNode **nptr = (DOMNode **) ptr;
   if (*nptr == NULL) {
       return NULL;
   }
   short int type = (*nptr)->getNodeType();
   if (type == DOMNode::TEXT_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText;
   }
   if (type == DOMNode::PROCESSING_INSTRUCTION_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction;
   }
   if (type == DOMNode::DOCUMENT_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument;
   }
   if (type == DOMNode::ELEMENT_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement;
   }
   if (type == DOMNode::ENTITY_REFERENCE_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntityReference;
   }
   if (type == DOMNode::CDATA_SECTION_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCDATASection;
   }
   if (type == DOMNode::CDATA_SECTION_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCDATASection;
   }
   if (type == DOMNode::COMMENT_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMComment;
   }
   if (type == DOMNode::DOCUMENT_TYPE_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType;
   }
   if (type == DOMNode::ENTITY_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity;
   }
   if (type == DOMNode::ATTRIBUTE_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr;
   }
   if (type == DOMNode::NOTATION_NODE) {
      return SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNotation;
   }
   return NULL;
}



static swig_type_info *
PerlCallbackHandler_dynamic_cast(void **ptr) {
   PerlCallbackHandler **nptr = (PerlCallbackHandler **) ptr;
   if (*nptr == NULL) {
       return NULL;
   }
   short int type = (*nptr)->type();
   if (type == PERLCALLBACKHANDLER_BASE_TYPE) {
      die("Can't cast a PerlCallbackHandler base type node\n");
   }
   if (type == PERLCALLBACKHANDLER_ERROR_TYPE) {
      return SWIGTYPE_p_PerlErrorCallbackHandler;
   }
   if (type == PERLCALLBACKHANDLER_ENTITY_TYPE) {
      return SWIGTYPE_p_PerlEntityResolverHandler;
   }
   if (type == PERLCALLBACKHANDLER_CONTENT_TYPE) {
      return SWIGTYPE_p_PerlContentCallbackHandler;
   }
   if (type == PERLCALLBACKHANDLER_DOCUMENT_TYPE) {
      return SWIGTYPE_p_PerlDocumentCallbackHandler;
   }
   if (type == PERLCALLBACKHANDLER_NODE_TYPE) {
      return SWIGTYPE_p_PerlNodeFilterCallbackHandler;
   }
   return NULL;
}



#define CATCH_XML_EXCEPTION       \
    catch (const XMLException& e) \
    {                             \
        makeXMLException(e);      \
	goto fail;                \
    }                             \
    catch (...)                   \
    {                             \
        SWIG_croak("Handling Unknown exception"); \
	goto fail;                \
    }


SWIGINTERN swig_type_info*
SWIG_pchar_descriptor()
{
  static int init = 0;
  static swig_type_info* info = 0;
  if (!init) {
    info = SWIG_TypeQuery("_p_char");
    init = 1;
  }
  return info;
}


SWIGINTERN int
SWIG_AsCharPtrAndSize(SV *obj, char** cptr, size_t* psize, int *alloc)
{
  if (SvPOK(obj)) {
    STRLEN len = 0;
    char *cstr = SvPV(obj, len); 
    size_t size = len + 1;
    if (cptr)  {
      if (alloc) {
	if (*alloc == SWIG_NEWOBJ) {
	  *cptr = reinterpret_cast< char* >(memcpy((new char[size]), cstr, sizeof(char)*(size)));
	} else {
	  *cptr = cstr;
	  *alloc = SWIG_OLDOBJ;
	}
      }
    }
    if (psize) *psize = size;
    return SWIG_OK;
  } else {
    swig_type_info* pchar_descriptor = SWIG_pchar_descriptor();
    if (pchar_descriptor) {
      char* vptr = 0; 
      if (SWIG_ConvertPtr(obj, (void**)&vptr, pchar_descriptor, 0) == SWIG_OK) {
	if (cptr) *cptr = vptr;
	if (psize) *psize = vptr ? (strlen(vptr) + 1) : 0;
	if (alloc) *alloc = SWIG_OLDOBJ;
	return SWIG_OK;
      }
    }
  }
  return SWIG_TypeError;
}





SWIGINTERNINLINE SV *
SWIG_From_long  SWIG_PERL_DECL_ARGS_1(long value)
{    
  SV *obj = sv_newmortal();
  sv_setiv(obj, (IV) value);
  return obj;
}


SWIGINTERNINLINE SV *
SWIG_From_int  SWIG_PERL_DECL_ARGS_1(int value)
{    
  return SWIG_From_long  SWIG_PERL_CALL_ARGS_1(value);
}


SWIGINTERNINLINE SV *
SWIG_From_unsigned_SS_long  SWIG_PERL_DECL_ARGS_1(unsigned long value)
{    
  SV *obj = sv_newmortal();
  sv_setuv(obj, (UV) value);
  return obj;
}


SWIGINTERNINLINE SV *
SWIG_From_unsigned_SS_int  SWIG_PERL_DECL_ARGS_1(unsigned int value)
{    
  return SWIG_From_unsigned_SS_long  SWIG_PERL_CALL_ARGS_1(value);
}


#include <limits.h>
#ifndef LLONG_MIN
# define LLONG_MIN	LONG_LONG_MIN
#endif
#ifndef LLONG_MAX
# define LLONG_MAX	LONG_LONG_MAX
#endif
#ifndef ULLONG_MAX
# define ULLONG_MAX	ULONG_LONG_MAX
#endif


SWIGINTERN int
SWIG_AsVal_long SWIG_PERL_DECL_ARGS_2(SV *obj, long* val)
{
  if (SvIOK(obj)) {
    if (val) *val = SvIV(obj);
    return SWIG_OK;
  } else {
    int dispatch = 0;
    const char *nptr = SvPV(obj, PL_na);
    if (nptr) {
      char *endptr;
      long v = strtol(nptr, &endptr,0);
      if (errno == ERANGE) {
	errno = 0;
	return SWIG_OverflowError;
      } else {
	if (*endptr == '\0') {
	  if (val) *val = v;
	  return SWIG_AddCast(SWIG_OK);
	}
      }
    }
    if (!dispatch) {
      double d;
      int res = SWIG_AddCast(SWIG_AsVal_double SWIG_PERL_CALL_ARGS_2(obj,&d));
      if (SWIG_IsOK(res) && SWIG_CanCastAsInteger(&d, LONG_MIN, LONG_MAX)) {
	if (val) *val = (long)(d);
	return res;
      }
    }
  }
  return SWIG_TypeError;
}


SWIGINTERN int
SWIG_AsVal_int SWIG_PERL_DECL_ARGS_2(SV * obj, int *val)
{
  long v;
  int res = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(obj, &v);
  if (SWIG_IsOK(res)) {
    if ((v < INT_MIN || v > INT_MAX)) {
      return SWIG_OverflowError;
    } else {
      if (val) *val = static_cast< int >(v);
    }
  }  
  return res;
}


SWIGINTERNINLINE SV *
SWIG_FromCharPtrAndSize(const char* carray, size_t size)
{
  SV *obj = sv_newmortal();
  if (size && carray) {
    if (carray[size - 1] == 0) {
      sv_setpv(obj, carray);
    } else {
      char *tmp = (new char[size + 1]);
      memcpy(tmp, carray, size);
      tmp[size] = 0;
      sv_setpv(obj, tmp);
      delete[] tmp;
    }
  } else {
    sv_setsv(obj, &PL_sv_undef);
  }
  return obj;
}


SWIGINTERNINLINE SV * 
SWIG_FromCharPtr(const char *cptr)
{ 
  return SWIG_FromCharPtrAndSize(cptr, (cptr ? strlen(cptr) : 0));
}


SWIGINTERN int
SWIG_AsVal_unsigned_SS_long SWIG_PERL_DECL_ARGS_2(SV *obj, unsigned long *val) 
{
  if (SvUOK(obj)) {
    if (val) *val = SvUV(obj);
    return SWIG_OK;
  } else  if (SvIOK(obj)) {
    long v = SvIV(obj);
    if (v >= 0) {
      if (val) *val = v;
      return SWIG_OK;
    } else {
      return SWIG_OverflowError;
    }
  } else {
    int dispatch = 0;
    const char *nptr = SvPV(obj, PL_na);
    if (nptr) {
      char *endptr;
      unsigned long v = strtoul(nptr, &endptr,0);
      if (errno == ERANGE) {
	errno = 0;
	return SWIG_OverflowError;
      } else {
	if (*endptr == '\0') {
	  if (val) *val = v;
	  return SWIG_AddCast(SWIG_OK);
	}
      }
    }
    if (!dispatch) {
      double d;
      int res = SWIG_AddCast(SWIG_AsVal_double SWIG_PERL_CALL_ARGS_2(obj,&d));
      if (SWIG_IsOK(res) && SWIG_CanCastAsInteger(&d, 0, ULONG_MAX)) {
	if (val) *val = (unsigned long)(d);
	return res;
      }
    }
  }
  return SWIG_TypeError;
}


SWIGINTERN int
SWIG_AsVal_unsigned_SS_int SWIG_PERL_DECL_ARGS_2(SV * obj, unsigned int *val)
{
  unsigned long v;
  int res = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(obj, &v);
  if (SWIG_IsOK(res)) {
    if ((v > UINT_MAX)) {
      return SWIG_OverflowError;
    } else {
      if (val) *val = static_cast< unsigned int >(v);
    }
  }  
  return res;
}


#define CATCH_DOM_EXCEPTION         \
    catch (const XMLException& e)   \
    {                               \
        makeXMLException(e);        \
	goto fail;                  \
    }                               \
    catch (const DOMException& e)   \
    {                               \
	makeDOMException(e);        \
	goto fail;                  \
    }                               \
    catch (...)                     \
    {                               \
        SWIG_croak("Handling Unknown exception"); \
        goto fail;                  \
    }


SWIGINTERNINLINE SV *
SWIG_From_short  SWIG_PERL_DECL_ARGS_1(short value)
{    
  return SWIG_From_long  SWIG_PERL_CALL_ARGS_1(value);
}

SWIGINTERN bool XERCES_CPP_NAMESPACE_DOMNode_operator_Se__Se_(XERCES_CPP_NAMESPACE::DOMNode *self,XERCES_CPP_NAMESPACE::DOMNode const *other){
       return self->isSameNode(other);
   }
SWIGINTERN bool XERCES_CPP_NAMESPACE_DOMNode_operator_SN__Se_(XERCES_CPP_NAMESPACE::DOMNode *self,XERCES_CPP_NAMESPACE::DOMNode const *other){
       return !self->isSameNode(other);
   }

SWIGINTERN int
SWIG_AsVal_short SWIG_PERL_DECL_ARGS_2(SV * obj, short *val)
{
  long v;
  int res = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(obj, &v);
  if (SWIG_IsOK(res)) {
    if ((v < SHRT_MIN || v > SHRT_MAX)) {
      return SWIG_OverflowError;
    } else {
      if (val) *val = static_cast< short >(v);
    }
  }  
  return res;
}


SWIGINTERNINLINE int
SWIG_AsVal_size_t SWIG_PERL_DECL_ARGS_2(SV * obj, size_t *val)
{
  unsigned long v;
  int res = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(obj, val ? &v : 0);
  if (SWIG_IsOK(res) && val) *val = static_cast< size_t >(v);
  return res;
}


#define CATCH_SAX_EXCEPTION                           \
    catch (const XMLException& e)                     \
        {                                             \
	    makeXMLException(e);                      \
            goto fail;                                \
        }                                             \
    catch (const SAXNotSupportedException& e)         \
	{                                             \
	    makeSAXNotSupportedException(e);          \
            goto fail;                                \
	}                                             \
    catch (const SAXNotRecognizedException& e)        \
	{                                             \
	    makeSAXNotRecognizedException(e);         \
            goto fail;                                \
	}                                             \
    catch (...)                                       \
        {                                             \
            SWIG_croak("Handling Unknown exception"); \
            goto fail;                                \
        }

#ifdef PERL_OBJECT
#define MAGIC_CLASS _wrap_XML::Xerces_var::
class _wrap_XML::Xerces_var : public CPerlObj {
public:
#else
#define MAGIC_CLASS
#endif
SWIGCLASS_STATIC int swig_magic_readonly(pTHX_ SV *SWIGUNUSEDPARM(sv), MAGIC *SWIGUNUSEDPARM(mg)) {
    MAGIC_PPERL
    croak("Value is read-only.");
    return 0;
}
SWIGCLASS_STATIC int _wrap_DEBUG_UTF8_OUT_set(pTHX_ SV* sv, MAGIC * SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  {
    bool val;
    int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(sv, &val);
    if (!SWIG_IsOK(res)) {
      SWIG_exception_fail(SWIG_ArgError(res), "in variable '""DEBUG_UTF8_OUT""' of type '""bool""'");
    }
    DEBUG_UTF8_OUT = static_cast< bool >(val);
  }
fail:
  return 1;
}


SWIGCLASS_STATIC int _wrap_DEBUG_UTF8_OUT_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  sv_setsv(sv,SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(DEBUG_UTF8_OUT)))  ;
  return 1;
}


SWIGCLASS_STATIC int _wrap_DEBUG_UTF8_IN_set(pTHX_ SV* sv, MAGIC * SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  {
    bool val;
    int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(sv, &val);
    if (!SWIG_IsOK(res)) {
      SWIG_exception_fail(SWIG_ArgError(res), "in variable '""DEBUG_UTF8_IN""' of type '""bool""'");
    }
    DEBUG_UTF8_IN = static_cast< bool >(val);
  }
fail:
  return 1;
}


SWIGCLASS_STATIC int _wrap_DEBUG_UTF8_IN_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  sv_setsv(sv,SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(DEBUG_UTF8_IN)))  ;
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgAnyString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgAnyString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgAttListString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgAttListString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgCommentString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgCommentString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgCDATAString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgCDATAString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDefaultString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDefaultString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDocTypeString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDocTypeString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgEBCDICEncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgEBCDICEncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgElemString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgElemString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgEmptyString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgEmptyString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgEncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgEncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgEntitString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgEntitString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgEntityString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgEntityString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgEntitiesString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgEntitiesString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgEnumerationString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgEnumerationString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgExceptDomain_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgExceptDomain));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgFixedString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgFixedString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIBM037EncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIBM037EncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIBM037EncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIBM037EncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIBM1047EncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIBM1047EncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIBM1047EncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIBM1047EncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIBM1140EncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIBM1140EncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIBM1140EncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIBM1140EncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIBM1140EncodingString3_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIBM1140EncodingString3));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIBM1140EncodingString4_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIBM1140EncodingString4));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIESString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIESString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIDString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIDString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIDRefString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIDRefString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIDRefsString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIDRefsString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgImpliedString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgImpliedString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIgnoreString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIgnoreString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIncludeString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIncludeString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString3_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString3));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString4_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString4));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString5_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString5));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString6_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString6));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString7_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString7));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString8_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString8));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString9_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString9));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString10_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString10));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString11_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString11));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgISO88591EncodingString12_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgISO88591EncodingString12));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgLocalHostString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgLocalHostString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNoString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNoString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNotationString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNotationString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNDATAString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNDATAString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNmTokenString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNmTokenString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNmTokensString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNmTokensString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgPCDATAString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgPCDATAString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgPIString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgPIString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgPubIDString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgPubIDString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgRefString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgRefString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgRequiredString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgRequiredString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgStandaloneString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgStandaloneString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgVersion1_0_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgVersion1_0));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgVersion1_1_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgVersion1_1));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgSysIDString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgSysIDString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUnknownURIName_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUnknownURIName));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUCS4EncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUCS4EncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUCS4EncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUCS4EncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUCS4EncodingString3_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUCS4EncodingString3));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUCS4BEncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUCS4BEncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUCS4BEncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUCS4BEncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUCS4LEncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUCS4LEncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUCS4LEncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUCS4LEncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUSASCIIEncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUSASCIIEncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUSASCIIEncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUSASCIIEncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUSASCIIEncodingString3_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUSASCIIEncodingString3));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUSASCIIEncodingString4_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUSASCIIEncodingString4));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF8EncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF8EncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF8EncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF8EncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF16EncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF16EncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF16EncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF16EncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF16EncodingString3_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF16EncodingString3));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF16EncodingString4_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF16EncodingString4));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF16EncodingString5_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF16EncodingString5));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF16EncodingString6_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF16EncodingString6));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF16EncodingString7_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF16EncodingString7));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF16BEncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF16BEncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF16BEncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF16BEncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF16LEncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF16LEncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTF16LEncodingString2_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTF16LEncodingString2));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgVersionString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgVersionString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgValidityDomain_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgValidityDomain));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgWin1252EncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgWin1252EncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLChEncodingString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLChEncodingString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLDOMMsgDomain_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLDOMMsgDomain));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLStringSpace_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLStringSpace));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLStringHTab_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLStringHTab));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLStringCR_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLStringCR));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLStringLF_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLStringLF));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLStringSpaceU_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLStringSpaceU));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLStringHTabU_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLStringHTabU));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLStringCRU_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLStringCRU));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLStringLFU_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLStringLFU));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLDeclString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLDeclString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLDeclStringSpace_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLDeclStringSpace));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLDeclStringHTab_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLDeclStringHTab));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLDeclStringLF_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLDeclStringLF));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLDeclStringCR_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLDeclStringCR));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLDeclStringSpaceU_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLDeclStringSpaceU));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLDeclStringHTabU_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLDeclStringHTabU));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLDeclStringLFU_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLDeclStringLFU));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLDeclStringCRU_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLDeclStringCRU));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLNSString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLNSString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLNSColonString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLNSColonString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLNSURIName_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLNSURIName));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLErrDomain_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLErrDomain));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLURIName_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLURIName));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgInfosetURIName_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgInfosetURIName));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgYesString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgYesString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgZeroLenString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgZeroLenString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDTDEntityString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDTDEntityString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgAmp_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgAmp));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgLT_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgLT));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgGT_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgGT));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgQuot_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgQuot));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgApos_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgApos));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgWFXMLScanner_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgWFXMLScanner));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIGXMLScanner_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIGXMLScanner));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgSGXMLScanner_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgSGXMLScanner));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDGXMLScanner_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDGXMLScanner));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXSAXMLScanner_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXSAXMLScanner));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgCDataStart_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgCDataStart));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgCDataEnd_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgCDataEnd));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgArrayIndexOutOfBoundsException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgArrayIndexOutOfBoundsException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgEmptyStackException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgEmptyStackException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIllegalArgumentException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIllegalArgumentException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgInvalidCastException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgInvalidCastException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIOException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIOException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNoSuchElementException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNoSuchElementException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNullPointerException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNullPointerException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXMLPlatformUtilsException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXMLPlatformUtilsException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgRuntimeException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgRuntimeException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgTranscodingException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgTranscodingException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUnexpectedEOFException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUnexpectedEOFException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUnsupportedEncodingException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUnsupportedEncodingException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUTFDataFormatException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUTFDataFormatException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNetAccessorException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNetAccessorException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgMalformedURLException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgMalformedURLException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNumberFormatException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNumberFormatException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgParseException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgParseException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgInvalidDatatypeFacetException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgInvalidDatatypeFacetException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgInvalidDatatypeValueException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgInvalidDatatypeValueException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgSchemaDateTimeException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgSchemaDateTimeException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXPathException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXPathException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXSerializationException_Name_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXSerializationException_Name));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNegINFString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNegINFString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNegZeroString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNegZeroString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgPosZeroString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgPosZeroString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgPosINFString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgPosINFString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNaNString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNaNString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgEString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgEString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgZeroString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgZeroString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNullString_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNullString));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesDynamic_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesDynamic));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesSchema_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesSchema));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesSchemaFullChecking_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesSchemaFullChecking));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesIdentityConstraintChecking_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesIdentityConstraintChecking));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesSchemaExternalSchemaLocation_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesSchemaExternalSchemaLocation));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesSchemaExternalNoNameSpaceSchemaLocation_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesSchemaExternalNoNameSpaceSchemaLocation));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesSecurityManager_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesSecurityManager));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesLoadExternalDTD_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesLoadExternalDTD));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesContinueAfterFatalError_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesContinueAfterFatalError));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesValidationErrorAsFatal_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesValidationErrorAsFatal));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesUserAdoptsDOMDocument_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesUserAdoptsDOMDocument));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesCacheGrammarFromParse_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesCacheGrammarFromParse));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesUseCachedGrammarInParse_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesUseCachedGrammarInParse));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesScannerName_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesScannerName));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesParserUseDocumentFromImplementation_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesParserUseDocumentFromImplementation));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesCalculateSrcOfs_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesCalculateSrcOfs));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesStandardUriConformant_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesStandardUriConformant));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesDOMHasPSVIInfo_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesDOMHasPSVIInfo));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesGenerateSyntheticAnnotations_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesGenerateSyntheticAnnotations));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesValidateAnnotations_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesValidateAnnotations));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesIgnoreCachedDTD_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesIgnoreCachedDTD));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesIgnoreAnnotations_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesIgnoreAnnotations));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesDisableDefaultEntityResolution_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesDisableDefaultEntityResolution));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercesSkipDTDValidation_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercesSkipDTDValidation));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgSAX2CoreValidation_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgSAX2CoreValidation));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgSAX2CoreNameSpaces_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgSAX2CoreNameSpaces));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgSAX2CoreNameSpacePrefixes_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgSAX2CoreNameSpacePrefixes));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMCanonicalForm_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMCanonicalForm));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMCDATASections_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMCDATASections));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMComments_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMComments));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMCharsetOverridesXMLEncoding_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMCharsetOverridesXMLEncoding));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMDatatypeNormalization_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMDatatypeNormalization));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMEntities_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMEntities));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMInfoset_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMInfoset));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMNamespaces_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMNamespaces));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMNamespaceDeclarations_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMNamespaceDeclarations));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMSupportedMediatypesOnly_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMSupportedMediatypesOnly));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMValidateIfSchema_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMValidateIfSchema));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMValidation_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMValidation));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMWhitespaceInElementContent_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMWhitespaceInElementContent));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMWRTCanonicalForm_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMWRTCanonicalForm));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMWRTDiscardDefaultContent_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMWRTDiscardDefaultContent));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMWRTEntities_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMWRTEntities));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMWRTFormatPrettyPrint_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMWRTFormatPrettyPrint));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMWRTNormalizeCharacters_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMWRTNormalizeCharacters));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMWRTSplitCdataSections_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMWRTSplitCdataSections));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMWRTValidation_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMWRTValidation));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMWRTWhitespaceInElementContent_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMWRTWhitespaceInElementContent));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMWRTBOM_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMWRTBOM));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDOMXMLDeclaration_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDOMXMLDeclaration));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercescInterfacePSVITypeInfo_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercescInterfacePSVITypeInfo));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercescInterfaceDOMDocumentTypeImpl_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgXercescInterfaceDOMDocumentTypeImpl));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgXercescDefaultLocale_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  sv_setsv(sv,SWIG_FromCharPtr(XERCES_CPP_NAMESPACE::XMLUni::fgXercescDefaultLocale))  ;
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgDefErrMsg_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgDefErrMsg));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgValueZero_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgValueZero));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgNegOne_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgNegOne));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgValueOne_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgValueOne));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgLongMaxInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgLongMaxInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgLongMinInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgLongMinInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIntMaxInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIntMaxInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgIntMinInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgIntMinInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgShortMaxInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgShortMaxInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgShortMinInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgShortMinInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgByteMaxInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgByteMaxInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgByteMinInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgByteMinInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgULongMaxInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgULongMaxInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUIntMaxInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUIntMaxInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUShortMaxInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUShortMaxInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgUByteMaxInc_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgUByteMaxInc));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgLangPattern_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLUni::fgLangPattern));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgBooleanValueSpace_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  sv_setiv(SvRV(sv),PTR2IV(XERCES_CPP_NAMESPACE::XMLUni::fgBooleanValueSpace));
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLUni_fgBooleanValueSpaceArraySize_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  sv_setsv(sv,SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(XERCES_CPP_NAMESPACE::XMLUni::fgBooleanValueSpaceArraySize)))  ;
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLElementDecl_fgInvalidElemId_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  sv_setsv(sv,SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(XERCES_CPP_NAMESPACE::XMLElementDecl::fgInvalidElemId)))  ;
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLElementDecl_fgPCDataElemId_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  sv_setsv(sv,SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(XERCES_CPP_NAMESPACE::XMLElementDecl::fgPCDataElemId)))  ;
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLElementDecl_fgPCDataElemName_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  
  sv_setsv((SV*)sv, XMLString2Perl(XERCES_CPP_NAMESPACE::XMLElementDecl::fgPCDataElemName));
  
  return 1;
}


SWIGCLASS_STATIC int _wrap_XMLAttDef_fgInvalidAttrId_get(pTHX_ SV *sv, MAGIC *SWIGUNUSEDPARM(mg)) {
  MAGIC_PPERL
  sv_setsv(sv,SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(XERCES_CPP_NAMESPACE::XMLAttDef::fgInvalidAttrId)))  ;
  return 1;
}




#ifdef PERL_OBJECT
};
#endif

#ifdef __cplusplus
extern "C" {
#endif
XS(_wrap_delete_XMLDeleter) {
  {
    XERCES_CPP_NAMESPACE::XMLDeleter *arg1 = (XERCES_CPP_NAMESPACE::XMLDeleter *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLDeleter(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDeleter, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLDeleter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLDeleter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLDeleter * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLPlatformUtils_Initialize__SWIG_0) {
  {
    char *arg1 = (char *) (char *)0 ;
    char *arg2 = (char *) (char *)0 ;
    PanicHandler *arg3 = (PanicHandler *) (PanicHandler *)0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *arg4 = (XERCES_CPP_NAMESPACE::MemoryManager *) (XERCES_CPP_NAMESPACE::MemoryManager *)0 ;
    bool arg5 ;
    int res1 ;
    char *buf1 = 0 ;
    int alloc1 = 0 ;
    int res2 ;
    char *buf2 = 0 ;
    int alloc2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    bool val5 ;
    int ecode5 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: XMLPlatformUtils_Initialize(locale,nlsHome,panicHandler,memoryManager,toInitStatics);");
    }
    res1 = SWIG_AsCharPtrAndSize(ST(0), &buf1, NULL, &alloc1);
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLPlatformUtils_Initialize" "', argument " "1"" of type '" "char const *const""'");
    }
    arg1 = buf1;
    res2 = SWIG_AsCharPtrAndSize(ST(1), &buf2, NULL, &alloc2);
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLPlatformUtils_Initialize" "', argument " "2"" of type '" "char const *const""'");
    }
    arg2 = buf2;
    res3 = SWIG_ConvertPtr(ST(2), &argp3,SWIGTYPE_p_PanicHandler, 0 |  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "XMLPlatformUtils_Initialize" "', argument " "3"" of type '" "PanicHandler *const""'"); 
    }
    arg3 = reinterpret_cast< PanicHandler * >(argp3);
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "XMLPlatformUtils_Initialize" "', argument " "4"" of type '" "XERCES_CPP_NAMESPACE::MemoryManager *const""'"); 
    }
    arg4 = reinterpret_cast< XERCES_CPP_NAMESPACE::MemoryManager * >(argp4);
    ecode5 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(4), &val5);
    if (!SWIG_IsOK(ecode5)) {
      SWIG_exception_fail(SWIG_ArgError(ecode5), "in method '" "XMLPlatformUtils_Initialize" "', argument " "5"" of type '" "bool""'");
    } 
    arg5 = static_cast< bool >(val5);
    {
      try 
      {
        XERCES_CPP_NAMESPACE::XMLPlatformUtils::Initialize((char const *)arg1,(char const *)arg2,arg3,arg4,arg5);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    if (alloc1 == SWIG_NEWOBJ) delete[] buf1;
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    
    
    
    XSRETURN(argvi);
  fail:
    if (alloc1 == SWIG_NEWOBJ) delete[] buf1;
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLPlatformUtils_Initialize__SWIG_1) {
  {
    char *arg1 = (char *) (char *)0 ;
    char *arg2 = (char *) (char *)0 ;
    int res1 ;
    char *buf1 = 0 ;
    int alloc1 = 0 ;
    int res2 ;
    char *buf2 = 0 ;
    int alloc2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLPlatformUtils_Initialize(locale,nlsHome);");
    }
    res1 = SWIG_AsCharPtrAndSize(ST(0), &buf1, NULL, &alloc1);
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLPlatformUtils_Initialize" "', argument " "1"" of type '" "char const *const""'");
    }
    arg1 = buf1;
    res2 = SWIG_AsCharPtrAndSize(ST(1), &buf2, NULL, &alloc2);
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLPlatformUtils_Initialize" "', argument " "2"" of type '" "char const *const""'");
    }
    arg2 = buf2;
    {
      try 
      {
        XERCES_CPP_NAMESPACE::XMLPlatformUtils::Initialize((char const *)arg1,(char const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    if (alloc1 == SWIG_NEWOBJ) delete[] buf1;
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    XSRETURN(argvi);
  fail:
    if (alloc1 == SWIG_NEWOBJ) delete[] buf1;
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    SWIG_croak_null();
  }
}


XS(_wrap_XMLPlatformUtils_Initialize__SWIG_2) {
  {
    char *arg1 = (char *) (char *)0 ;
    int res1 ;
    char *buf1 = 0 ;
    int alloc1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLPlatformUtils_Initialize(locale);");
    }
    res1 = SWIG_AsCharPtrAndSize(ST(0), &buf1, NULL, &alloc1);
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLPlatformUtils_Initialize" "', argument " "1"" of type '" "char const *const""'");
    }
    arg1 = buf1;
    {
      try 
      {
        XERCES_CPP_NAMESPACE::XMLPlatformUtils::Initialize((char const *)arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    if (alloc1 == SWIG_NEWOBJ) delete[] buf1;
    XSRETURN(argvi);
  fail:
    if (alloc1 == SWIG_NEWOBJ) delete[] buf1;
    SWIG_croak_null();
  }
}


XS(_wrap_XMLPlatformUtils_Initialize__SWIG_3) {
  {
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: XMLPlatformUtils_Initialize();");
    }
    {
      try 
      {
        XERCES_CPP_NAMESPACE::XMLPlatformUtils::Initialize();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_XMLPlatformUtils_Initialize) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        int res = SWIG_AsCharPtrAndSize(ST(0), 0, NULL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        int res = SWIG_AsCharPtrAndSize(ST(0), 0, NULL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        int res = SWIG_AsCharPtrAndSize(ST(1), 0, NULL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 5) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        int res = SWIG_AsCharPtrAndSize(ST(0), 0, NULL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        int res = SWIG_AsCharPtrAndSize(ST(1), 0, NULL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(2), &vptr, SWIGTYPE_p_PanicHandler, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(3), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(4), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLPlatformUtils_Initialize__SWIG_3); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLPlatformUtils_Initialize__SWIG_2); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLPlatformUtils_Initialize__SWIG_1); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLPlatformUtils_Initialize__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'XMLPlatformUtils_Initialize'");
  XSRETURN(0);
}


XS(_wrap_XMLPlatformUtils_Terminate) {
  {
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: XMLPlatformUtils_Terminate();");
    }
    {
      try 
      {
        XERCES_CPP_NAMESPACE::XMLPlatformUtils::Terminate();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_XMLPlatformUtils_panic) {
  {
    PanicHandler::PanicReasons arg1 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLPlatformUtils_panic(reason);");
    }
    {
      res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_PanicHandler__PanicReasons,  0 );
      if (!SWIG_IsOK(res1)) {
        SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLPlatformUtils_panic" "', argument " "1"" of type '" "PanicHandler::PanicReasons const""'"); 
      }  
      if (!argp1) {
        SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XMLPlatformUtils_panic" "', argument " "1"" of type '" "PanicHandler::PanicReasons const""'");
      } else {
        arg1 = *(reinterpret_cast< PanicHandler::PanicReasons * >(argp1));
      }
    }
    {
      try 
      {
        XERCES_CPP_NAMESPACE::XMLPlatformUtils::panic(arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLPlatformUtils) {
  {
    XERCES_CPP_NAMESPACE::XMLPlatformUtils *arg1 = (XERCES_CPP_NAMESPACE::XMLPlatformUtils *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLPlatformUtils(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPlatformUtils, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLPlatformUtils" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLPlatformUtils *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPlatformUtils * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_lookupByName) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLURL::Protocols result;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_lookupByName(protoName);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"XMLURL_lookupByName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLURL::Protocols)XERCES_CPP_NAMESPACE::XMLURL::lookupByName((unsigned short const *)arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    delete[] arg1;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_parse) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLURL *arg2 = 0 ;
    bool result;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLURL_parse(urlText,xmlURL);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"XMLURL_parse");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLURL_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLURL &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XMLURL_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLURL &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp2);
    {
      try 
      {
        result = (bool)XERCES_CPP_NAMESPACE::XMLURL::parse((unsigned short const *)arg1,*arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    delete[] arg1;
    
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLURL__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_XMLURL();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLURL *)new XERCES_CPP_NAMESPACE::XMLURL();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLURL__SWIG_1) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLURL *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: new_XMLURL(baseURL,relativeURL);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_XMLURL");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"new_XMLURL");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLURL *)new XERCES_CPP_NAMESPACE::XMLURL((XMLCh const *)arg1,(XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLURL__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLURL *result = 0 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: new_XMLURL(baseURL,relativeURL);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_XMLURL" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "new_XMLURL" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"new_XMLURL");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLURL *)new XERCES_CPP_NAMESPACE::XMLURL((XERCES_CPP_NAMESPACE::XMLURL const &)*arg1,(XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLURL__SWIG_3) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLURL *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_XMLURL(urlText);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_XMLURL");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLURL *)new XERCES_CPP_NAMESPACE::XMLURL((XMLCh const *)arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLURL__SWIG_4) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::XMLURL *result = 0 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_XMLURL(toCopy);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_XMLURL" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "new_XMLURL" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLURL *)new XERCES_CPP_NAMESPACE::XMLURL((XERCES_CPP_NAMESPACE::XMLURL const &)*arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLURL) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_5;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_5;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 5;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_5:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLURL__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLURL__SWIG_4); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLURL__SWIG_3); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLURL__SWIG_2); return;
    case 5:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLURL__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_XMLURL'");
  XSRETURN(0);
}


XS(_wrap_delete_XMLURL) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLURL(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLURL" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL___eq__) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XERCES_CPP_NAMESPACE::XMLURL *arg2 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLURL___eq__(self,toCompare);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL___eq__" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLURL___eq__" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XMLURL___eq__" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp2);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->operator ==((XERCES_CPP_NAMESPACE::XMLURL const &)*arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL___ne__) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XERCES_CPP_NAMESPACE::XMLURL *arg2 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLURL___ne__(self,toCompare);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL___ne__" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLURL___ne__" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XMLURL___ne__" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp2);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->operator !=((XERCES_CPP_NAMESPACE::XMLURL const &)*arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_getFragment) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_getFragment(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_getFragment" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->getFragment();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_getHost) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_getHost(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_getHost" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->getHost();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_getPassword) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_getPassword(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_getPassword" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->getPassword();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_getPath) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_getPath(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_getPath" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->getPath();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_getPortNum) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_getPortNum(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_getPortNum" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->getPortNum();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_getProtocol) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XERCES_CPP_NAMESPACE::XMLURL::Protocols result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_getProtocol(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_getProtocol" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLURL::Protocols)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->getProtocol();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_getProtocolName) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_getProtocolName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_getProtocolName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->getProtocolName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_getQuery) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_getQuery(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_getQuery" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->getQuery();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_getURLText) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_getURLText(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_getURLText" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->getURLText();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_getUser) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_getUser(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_getUser" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->getUser();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_getMemoryManager) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_getMemoryManager(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_getMemoryManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemoryManager *)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->getMemoryManager();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_setURL__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLURL_setURL(self,urlText);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_setURL" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLURL_setURL");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setURL((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_setURL__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: XMLURL_setURL(self,baseURL,relativeURL);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_setURL" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLURL_setURL");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"XMLURL_setURL");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->setURL((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_setURL__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XERCES_CPP_NAMESPACE::XMLURL *arg2 = 0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: XMLURL_setURL(self,baseURL,relativeURL);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_setURL" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLURL_setURL" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XMLURL_setURL" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"XMLURL_setURL");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->setURL((XERCES_CPP_NAMESPACE::XMLURL const &)*arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_setURL__SWIG_3) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLURL *arg4 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: XMLURL_setURL(self,baseURL,relativeURL,xmlURL);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_setURL" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLURL_setURL");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"XMLURL_setURL");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    res4 = SWIG_ConvertPtr(ST(3), &argp4, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL,  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "XMLURL_setURL" "', argument " "4"" of type '" "XERCES_CPP_NAMESPACE::XMLURL &""'"); 
    }
    if (!argp4) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XMLURL_setURL" "', argument " "4"" of type '" "XERCES_CPP_NAMESPACE::XMLURL &""'"); 
    }
    arg4 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp4);
    {
      try 
      {
        result = (bool)(arg1)->setURL((XMLCh const *)arg2,(XMLCh const *)arg3,*arg4);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_setURL) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(3), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLURL_setURL__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLURL_setURL__SWIG_2); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLURL_setURL__SWIG_1); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLURL_setURL__SWIG_3); return;
    }
  }
  
  croak("No matching function for overloaded 'XMLURL_setURL'");
  XSRETURN(0);
}


XS(_wrap_XMLURL_isRelative) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_isRelative(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_isRelative" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->isRelative();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_hasInvalidChar) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_hasInvalidChar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_hasInvalidChar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->hasInvalidChar();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_makeNewStream) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XERCES_CPP_NAMESPACE::BinInputStream *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLURL_makeNewStream(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_makeNewStream" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::BinInputStream *)((XERCES_CPP_NAMESPACE::XMLURL const *)arg1)->makeNewStream();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__BinInputStream, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_makeRelativeTo__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLURL_makeRelativeTo(self,baseURLText);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_makeRelativeTo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLURL_makeRelativeTo");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->makeRelativeTo((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_makeRelativeTo__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = (XERCES_CPP_NAMESPACE::XMLURL *) 0 ;
    XERCES_CPP_NAMESPACE::XMLURL *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLURL_makeRelativeTo(self,baseURL);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLURL_makeRelativeTo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLURL_makeRelativeTo" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XMLURL_makeRelativeTo" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp2);
    {
      try 
      {
        (arg1)->makeRelativeTo((XERCES_CPP_NAMESPACE::XMLURL const &)*arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLURL_makeRelativeTo) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLURL_makeRelativeTo__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLURL_makeRelativeTo__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'XMLURL_makeRelativeTo'");
  XSRETURN(0);
}


XS(_wrap_new_XMLUri__SWIG_0) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLUri *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_XMLUri(uriSpec);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_XMLUri");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLUri *)new XERCES_CPP_NAMESPACE::XMLUri((XMLCh const *)arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLUri__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) (XERCES_CPP_NAMESPACE::XMLUri *)0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLUri *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: new_XMLUri(baseURI,uriSpec);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_XMLUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const *const""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"new_XMLUri");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLUri *)new XERCES_CPP_NAMESPACE::XMLUri((XERCES_CPP_NAMESPACE::XMLUri const *)arg1,(XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLUri__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::XMLUri *result = 0 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_XMLUri(toCopy);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_XMLUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "new_XMLUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const &""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLUri *)new XERCES_CPP_NAMESPACE::XMLUri((XERCES_CPP_NAMESPACE::XMLUri const &)*arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLUri) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLUri(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_getUriText) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLUri_getUriText(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_getUriText" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLUri const *)arg1)->getUriText();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_getScheme) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLUri_getScheme(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_getScheme" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLUri const *)arg1)->getScheme();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_getUserInfo) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLUri_getUserInfo(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_getUserInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLUri const *)arg1)->getUserInfo();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_getHost) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLUri_getHost(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_getHost" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLUri const *)arg1)->getHost();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_getPort) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLUri_getPort(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_getPort" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::XMLUri const *)arg1)->getPort();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_getRegBasedAuthority) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLUri_getRegBasedAuthority(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_getRegBasedAuthority" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLUri const *)arg1)->getRegBasedAuthority();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_getPath) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLUri_getPath(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_getPath" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLUri const *)arg1)->getPath();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_getQueryString) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLUri_getQueryString(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_getQueryString" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLUri const *)arg1)->getQueryString();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_getFragment) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLUri_getFragment(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_getFragment" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLUri const *)arg1)->getFragment();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_setScheme) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLUri_setScheme(self,newScheme);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_setScheme" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLUri_setScheme");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setScheme((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_setUserInfo) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLUri_setUserInfo(self,newUserInfo);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_setUserInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLUri_setUserInfo");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setUserInfo((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_setHost) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLUri_setHost(self,newHost);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_setHost" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLUri_setHost");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setHost((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_setPort) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLUri_setPort(self,newPort);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_setPort" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLUri_setPort" "', argument " "2"" of type '" "int""'");
    } 
    arg2 = static_cast< int >(val2);
    {
      try 
      {
        (arg1)->setPort(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_setRegBasedAuthority) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLUri_setRegBasedAuthority(self,newRegAuth);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_setRegBasedAuthority" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLUri_setRegBasedAuthority");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setRegBasedAuthority((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_setPath) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLUri_setPath(self,newPath);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_setPath" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLUri_setPath");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setPath((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_setQueryString) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLUri_setQueryString(self,newQueryString);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_setQueryString" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLUri_setQueryString");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setQueryString((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_setFragment) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLUri_setFragment(self,newFragment);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_setFragment" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLUri_setFragment");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setFragment((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_isURIString) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    bool result;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLUri_isURIString(uric);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"XMLUri_isURIString");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    {
      try 
      {
        result = (bool)XERCES_CPP_NAMESPACE::XMLUri::isURIString((unsigned short const *)arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    delete[] arg1;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_isValidURI__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *arg1 = (XERCES_CPP_NAMESPACE::XMLUri *) (XERCES_CPP_NAMESPACE::XMLUri *)0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLUri_isValidURI(baseURI,uriStr);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLUri_isValidURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUri const *const""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUri * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLUri_isValidURI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (bool)XERCES_CPP_NAMESPACE::XMLUri::isValidURI((XERCES_CPP_NAMESPACE::XMLUri const *)arg1,(unsigned short const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_isValidURI__SWIG_1) {
  {
    bool arg1 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    bool result;
    bool val1 ;
    int ecode1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLUri_isValidURI(haveBaseURI,uriStr);");
    }
    ecode1 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(0), &val1);
    if (!SWIG_IsOK(ecode1)) {
      SWIG_exception_fail(SWIG_ArgError(ecode1), "in method '" "XMLUri_isValidURI" "', argument " "1"" of type '" "bool""'");
    } 
    arg1 = static_cast< bool >(val1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLUri_isValidURI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (bool)XERCES_CPP_NAMESPACE::XMLUri::isValidURI(arg1,(unsigned short const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLUri_isValidURI) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(0), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLUri_isValidURI__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLUri_isValidURI__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'XMLUri_isValidURI'");
  XSRETURN(0);
}


XS(_wrap_XMLUri_normalizeURI) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XMLBuffer *arg2 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLUri_normalizeURI(systemURI,normalizedURI);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"XMLUri_normalizeURI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XMLBuffer,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLUri_normalizeURI" "', argument " "2"" of type '" "XMLBuffer &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XMLUri_normalizeURI" "', argument " "2"" of type '" "XMLBuffer &""'"); 
    }
    arg2 = reinterpret_cast< XMLBuffer * >(argp2);
    {
      try 
      {
        XERCES_CPP_NAMESPACE::XMLUri::normalizeURI((unsigned short const *)arg1,*arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    delete[] arg1;
    
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLUri__SWIG_3) {
  {
    XERCES_CPP_NAMESPACE::XMLUri *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_XMLUri();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLUri *)new XERCES_CPP_NAMESPACE::XMLUri();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLUri) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLUri__SWIG_3); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLUri__SWIG_2); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLUri__SWIG_0); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLUri__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_XMLUri'");
  XSRETURN(0);
}


XS(_wrap_delete_XMLExcepts) {
  {
    XERCES_CPP_NAMESPACE::XMLExcepts *arg1 = (XERCES_CPP_NAMESPACE::XMLExcepts *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLExcepts(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLExcepts, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLExcepts" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLExcepts *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLExcepts * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLException) {
  {
    XERCES_CPP_NAMESPACE::XMLException *arg1 = (XERCES_CPP_NAMESPACE::XMLException *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLException(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLException, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLException" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLException * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLException_getType) {
  {
    XERCES_CPP_NAMESPACE::XMLException *arg1 = (XERCES_CPP_NAMESPACE::XMLException *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLException_getType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLException_getType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLException * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLException const *)arg1)->getType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLException_getCode) {
  {
    XERCES_CPP_NAMESPACE::XMLException *arg1 = (XERCES_CPP_NAMESPACE::XMLException *) 0 ;
    XERCES_CPP_NAMESPACE::XMLExcepts::Codes result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLException_getCode(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLException_getCode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLException * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLExcepts::Codes)((XERCES_CPP_NAMESPACE::XMLException const *)arg1)->getCode();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLException_getMessage) {
  {
    XERCES_CPP_NAMESPACE::XMLException *arg1 = (XERCES_CPP_NAMESPACE::XMLException *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLException_getMessage(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLException_getMessage" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLException * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLException const *)arg1)->getMessage();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLException_getSrcFile) {
  {
    XERCES_CPP_NAMESPACE::XMLException *arg1 = (XERCES_CPP_NAMESPACE::XMLException *) 0 ;
    char *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLException_getSrcFile(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLException_getSrcFile" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLException * >(argp1);
    {
      try 
      {
        result = (char *)((XERCES_CPP_NAMESPACE::XMLException const *)arg1)->getSrcFile();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_FromCharPtr(result); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLException_getSrcLine) {
  {
    XERCES_CPP_NAMESPACE::XMLException *arg1 = (XERCES_CPP_NAMESPACE::XMLException *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLException_getSrcLine(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLException_getSrcLine" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLException * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::XMLException const *)arg1)->getSrcLine();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLException_getErrorType) {
  {
    XERCES_CPP_NAMESPACE::XMLException *arg1 = (XERCES_CPP_NAMESPACE::XMLException *) 0 ;
    XMLErrorReporter::ErrTypes result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLException_getErrorType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLException_getErrorType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLException * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::XMLException const *)arg1)->getErrorType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new XMLErrorReporter::ErrTypes(static_cast< const XMLErrorReporter::ErrTypes& >(result))), SWIGTYPE_p_XMLErrorReporter__ErrTypes, SWIG_POINTER_OWN | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLException_setPosition) {
  {
    XERCES_CPP_NAMESPACE::XMLException *arg1 = (XERCES_CPP_NAMESPACE::XMLException *) 0 ;
    char *arg2 = (char *) (char *)0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int res2 ;
    char *buf2 = 0 ;
    int alloc2 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: XMLException_setPosition(self,file,line);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLException_setPosition" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLException * >(argp1);
    res2 = SWIG_AsCharPtrAndSize(ST(1), &buf2, NULL, &alloc2);
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLException_setPosition" "', argument " "2"" of type '" "char const *const""'");
    }
    arg2 = buf2;
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "XMLException_setPosition" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->setPosition((char const *)arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    
    XSRETURN(argvi);
  fail:
    
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLException_reinitMsgMutex) {
  {
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: XMLException_reinitMsgMutex();");
    }
    {
      try 
      {
        XERCES_CPP_NAMESPACE::XMLException::reinitMsgMutex();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_XMLException_reinitMsgLoader) {
  {
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: XMLException_reinitMsgLoader();");
    }
    {
      try 
      {
        XERCES_CPP_NAMESPACE::XMLException::reinitMsgLoader();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLUni) {
  {
    XERCES_CPP_NAMESPACE::XMLUni *arg1 = (XERCES_CPP_NAMESPACE::XMLUni *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLUni(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUni, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLUni" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLUni *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLUni * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_QName__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::QName *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_QName();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::QName *)new XERCES_CPP_NAMESPACE::QName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_QName__SWIG_1) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    XERCES_CPP_NAMESPACE::QName *result = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: new_QName(prefix,localPart,uriId);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_QName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"new_QName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "new_QName" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::QName *)new XERCES_CPP_NAMESPACE::QName((XMLCh const *)arg1,(XMLCh const *)arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_QName__SWIG_2) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg2 ;
    XERCES_CPP_NAMESPACE::QName *result = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: new_QName(rawName,uriId);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_QName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "new_QName" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::QName *)new XERCES_CPP_NAMESPACE::QName((XMLCh const *)arg1,arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_QName__SWIG_3) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::QName *result = 0 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_QName(qname);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_QName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName const &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "new_QName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName const &""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::QName *)new XERCES_CPP_NAMESPACE::QName((XERCES_CPP_NAMESPACE::QName const &)*arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_QName) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_QName__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_QName__SWIG_3); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_QName__SWIG_2); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_QName__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_QName'");
  XSRETURN(0);
}


XS(_wrap_delete_QName) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_QName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_QName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_getPrefix) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: QName_getPrefix(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_getPrefix" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    {
      try 
      {
        result = (XMLCh *)(arg1)->getPrefix();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_getLocalPart) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: QName_getLocalPart(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_getLocalPart" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    {
      try 
      {
        result = (XMLCh *)(arg1)->getLocalPart();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_getURI) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: QName_getURI(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_getURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::QName const *)arg1)->getURI();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_getRawName) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: QName_getRawName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_getRawName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    {
      try 
      {
        result = (XMLCh *)(arg1)->getRawName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_getMemoryManager) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: QName_getMemoryManager(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_getMemoryManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemoryManager *)((XERCES_CPP_NAMESPACE::QName const *)arg1)->getMemoryManager();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_setName__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg4 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: QName_setName(self,prefix,localPart,uriId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_setName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"QName_setName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"QName_setName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    ecode4 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "QName_setName" "', argument " "4"" of type '" "unsigned int""'");
    } 
    arg4 = static_cast< unsigned int >(val4);
    {
      try 
      {
        (arg1)->setName((XMLCh const *)arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_setName__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: QName_setName(self,rawName,uriId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_setName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"QName_setName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "QName_setName" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->setName((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_setName) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_QName_setName__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_QName_setName__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'QName_setName'");
  XSRETURN(0);
}


XS(_wrap_QName_setPrefix) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: QName_setPrefix(self,XMLCh const *);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_setPrefix" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"QName_setPrefix");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setPrefix((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_setLocalPart) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: QName_setLocalPart(self,XMLCh const *);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_setLocalPart" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"QName_setLocalPart");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setLocalPart((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_setNPrefix) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: QName_setNPrefix(self,XMLCh const *,unsigned int const);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_setNPrefix" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"QName_setNPrefix");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "QName_setNPrefix" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->setNPrefix((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_setNLocalPart) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: QName_setNLocalPart(self,XMLCh const *,unsigned int const);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_setNLocalPart" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"QName_setNLocalPart");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "QName_setNLocalPart" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->setNLocalPart((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_setURI) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    unsigned int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: QName_setURI(self,unsigned int const);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_setURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "QName_setURI" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        (arg1)->setURI(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_setValues) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XERCES_CPP_NAMESPACE::QName *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: QName_setValues(self,qname);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_setValues" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "QName_setValues" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::QName const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "QName_setValues" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::QName const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp2);
    {
      try 
      {
        (arg1)->setValues((XERCES_CPP_NAMESPACE::QName const &)*arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName___eq__) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    XERCES_CPP_NAMESPACE::QName *arg2 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: QName___eq__(self,XERCES_CPP_NAMESPACE::QName const &);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName___eq__" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "QName___eq__" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::QName const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "QName___eq__" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::QName const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp2);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::QName const *)arg1)->operator ==((XERCES_CPP_NAMESPACE::QName const &)*arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_QName_cleanUp) {
  {
    XERCES_CPP_NAMESPACE::QName *arg1 = (XERCES_CPP_NAMESPACE::QName *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: QName_cleanUp(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "QName_cleanUp" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::QName *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp1);
    {
      try 
      {
        (arg1)->cleanUp();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLElementDecl) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLElementDecl(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLElementDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_findAttr) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl::LookupOpts arg6 ;
    bool *arg7 = 0 ;
    XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int val6 ;
    int ecode6 = 0 ;
    void *argp7 = 0 ;
    int res7 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 7) || (items > 7)) {
      SWIG_croak("Usage: XMLElementDecl_findAttr(self,qName,uriId,baseName,prefix,options,wasAdded);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_findAttr" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLElementDecl_findAttr");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "XMLElementDecl_findAttr" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"XMLElementDecl_findAttr");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"XMLElementDecl_findAttr");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "XMLElementDecl_findAttr" "', argument " "6"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl::LookupOpts""'");
    } 
    arg6 = static_cast< XERCES_CPP_NAMESPACE::XMLElementDecl::LookupOpts >(val6);
    res7 = SWIG_ConvertPtr(ST(6), &argp7, SWIGTYPE_p_bool,  0 );
    if (!SWIG_IsOK(res7)) {
      SWIG_exception_fail(SWIG_ArgError(res7), "in method '" "XMLElementDecl_findAttr" "', argument " "7"" of type '" "bool &""'"); 
    }
    if (!argp7) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XMLElementDecl_findAttr" "', argument " "7"" of type '" "bool &""'"); 
    }
    arg7 = reinterpret_cast< bool * >(argp7);
    {
      try 
      {
        result = (XMLAttDef *)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->findAttr((XMLCh const *)arg2,arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6,*arg7);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getAttDefList) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XMLAttDefList *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getAttDefList(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getAttDefList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        {
          XMLAttDefList &_result_ref = ((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->getAttDefList();
          result = (XMLAttDefList *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getCharDataOpts) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl::CharDataOpts result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getCharDataOpts(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getCharDataOpts" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl::CharDataOpts)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->getCharDataOpts();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_hasAttDefs) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_hasAttDefs(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_hasAttDefs" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->hasAttDefs();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_resetDefs) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_resetDefs(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_resetDefs" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)(arg1)->resetDefs();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getContentSpec) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::ContentSpecNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getContentSpec(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getContentSpec" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::ContentSpecNode *)(arg1)->getContentSpec();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentSpecNode, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_setContentSpec) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::ContentSpecNode *arg2 = (XERCES_CPP_NAMESPACE::ContentSpecNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLElementDecl_setContentSpec(self,toAdopt);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_setContentSpec" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentSpecNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLElementDecl_setContentSpec" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::ContentSpecNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::ContentSpecNode * >(argp2);
    {
      try 
      {
        (arg1)->setContentSpec(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getContentModel) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLContentModel *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getContentModel(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getContentModel" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLContentModel *)(arg1)->getContentModel();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLContentModel, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_setContentModel) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLContentModel *arg2 = (XERCES_CPP_NAMESPACE::XMLContentModel *) (XERCES_CPP_NAMESPACE::XMLContentModel *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLElementDecl_setContentModel(self,newModelToAdopt);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_setContentModel" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLContentModel, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLElementDecl_setContentModel" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLContentModel *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLContentModel * >(argp2);
    {
      try 
      {
        (arg1)->setContentModel(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getFormattedContentModel) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getFormattedContentModel(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getFormattedContentModel" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->getFormattedContentModel();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getBaseName) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getBaseName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getBaseName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)(arg1)->getBaseName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getURI) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getURI(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->getURI();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getElementName) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::QName *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getElementName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getElementName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::QName *)(arg1)->getElementName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getFullName) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getFullName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getFullName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->getFullName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getCreateReason) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl::CreateReasons result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getCreateReason(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getCreateReason" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl::CreateReasons)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->getCreateReason();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getId) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->getId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getDOMTypeInfoUri) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getDOMTypeInfoUri(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getDOMTypeInfoUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->getDOMTypeInfoUri();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getDOMTypeInfoName) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getDOMTypeInfoName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getDOMTypeInfoName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->getDOMTypeInfoName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_isDeclared) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_isDeclared(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_isDeclared" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->isDeclared();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_isExternal) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_isExternal(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_isExternal" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->isExternal();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getMemoryManager) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getMemoryManager(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getMemoryManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemoryManager *)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->getMemoryManager();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_setElementName__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    int arg4 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: XMLElementDecl_setElementName(self,prefix,localPart,uriId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_setElementName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLElementDecl_setElementName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"XMLElementDecl_setElementName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    ecode4 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "XMLElementDecl_setElementName" "', argument " "4"" of type '" "int""'");
    } 
    arg4 = static_cast< int >(val4);
    {
      try 
      {
        (arg1)->setElementName((XMLCh const *)arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_setElementName__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: XMLElementDecl_setElementName(self,rawName,uriId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_setElementName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLElementDecl_setElementName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "XMLElementDecl_setElementName" "', argument " "3"" of type '" "int""'");
    } 
    arg3 = static_cast< int >(val3);
    {
      try 
      {
        (arg1)->setElementName((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_setElementName__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::QName *arg2 = (XERCES_CPP_NAMESPACE::QName *) (XERCES_CPP_NAMESPACE::QName *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLElementDecl_setElementName(self,elementName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_setElementName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLElementDecl_setElementName" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::QName const *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp2);
    {
      try 
      {
        (arg1)->setElementName((XERCES_CPP_NAMESPACE::QName const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_setElementName) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLElementDecl_setElementName__SWIG_2); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLElementDecl_setElementName__SWIG_1); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLElementDecl_setElementName__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'XMLElementDecl_setElementName'");
  XSRETURN(0);
}


XS(_wrap_XMLElementDecl_setCreateReason) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl::CreateReasons arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLElementDecl_setCreateReason(self,newReason);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_setCreateReason" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLElementDecl_setCreateReason" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl::CreateReasons""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::XMLElementDecl::CreateReasons >(val2);
    {
      try 
      {
        (arg1)->setCreateReason(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_setId) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    unsigned int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLElementDecl_setId(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_setId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLElementDecl_setId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        (arg1)->setId(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_setExternalElemDeclaration) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLElementDecl_setExternalElemDeclaration(self,aValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_setExternalElemDeclaration" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLElementDecl_setExternalElemDeclaration" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setExternalElemDeclaration(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_getObjectType) {
  {
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl::objectType result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_getObjectType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_getObjectType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl::objectType)((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg1)->getObjectType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_storeElementDecl) {
  {
    XSerializeEngine *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) (XERCES_CPP_NAMESPACE::XMLElementDecl *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLElementDecl_storeElementDecl(serEng,element);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XSerializeEngine,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_storeElementDecl" "', argument " "1"" of type '" "XSerializeEngine &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XMLElementDecl_storeElementDecl" "', argument " "1"" of type '" "XSerializeEngine &""'"); 
    }
    arg1 = reinterpret_cast< XSerializeEngine * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLElementDecl_storeElementDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp2);
    {
      try 
      {
        XERCES_CPP_NAMESPACE::XMLElementDecl::storeElementDecl(*arg1,arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLElementDecl_loadElementDecl) {
  {
    XSerializeEngine *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLElementDecl_loadElementDecl(serEng);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XSerializeEngine,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLElementDecl_loadElementDecl" "', argument " "1"" of type '" "XSerializeEngine &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XMLElementDecl_loadElementDecl" "', argument " "1"" of type '" "XSerializeEngine &""'"); 
    }
    arg1 = reinterpret_cast< XSerializeEngine * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)XERCES_CPP_NAMESPACE::XMLElementDecl::loadElementDecl(*arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLEntityDecl) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLEntityDecl(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLEntityDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getDeclaredInIntSubset) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getDeclaredInIntSubset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getDeclaredInIntSubset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getDeclaredInIntSubset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getIsParameter) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getIsParameter(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getIsParameter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getIsParameter();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getIsSpecialChar) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getIsSpecialChar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getIsSpecialChar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getIsSpecialChar();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getId) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getName) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getNotationName) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getNotationName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getNotationName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getNotationName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getPublicId) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getPublicId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getPublicId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getSystemId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getBaseURI) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getBaseURI(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getBaseURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getBaseURI();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getValue) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getValue(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getValue();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getValueLen) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getValueLen(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getValueLen" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getValueLen();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_isExternal) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_isExternal(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_isExternal" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->isExternal();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_isUnparsed) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_isUnparsed(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_isUnparsed" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->isUnparsed();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getMemoryManager) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getMemoryManager(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getMemoryManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemoryManager *)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getMemoryManager();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_setName) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLEntityDecl_setName(self,entName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_setName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLEntityDecl_setName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setName((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_setNotationName) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLEntityDecl_setNotationName(self,newName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_setNotationName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLEntityDecl_setNotationName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setNotationName((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_setPublicId) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLEntityDecl_setPublicId(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_setPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLEntityDecl_setPublicId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setPublicId((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_setSystemId) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLEntityDecl_setSystemId(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_setSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLEntityDecl_setSystemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setSystemId((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_setBaseURI) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLEntityDecl_setBaseURI(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_setBaseURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLEntityDecl_setBaseURI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setBaseURI((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_setValue) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLEntityDecl_setValue(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_setValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLEntityDecl_setValue");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setValue((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_setId) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    unsigned int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLEntityDecl_setId(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_setId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLEntityDecl_setId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        (arg1)->setId(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLEntityDecl_getKey) {
  {
    XERCES_CPP_NAMESPACE::XMLEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLEntityDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLEntityDecl_getKey(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLEntityDecl_getKey" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLEntityDecl const *)arg1)->getKey();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLNotationDecl__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_XMLNotationDecl();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLNotationDecl *)new XERCES_CPP_NAMESPACE::XMLNotationDecl();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLNotationDecl__SWIG_1) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLNotationDecl *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: new_XMLNotationDecl(notName,pubId,sysId,baseURI);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_XMLNotationDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"new_XMLNotationDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"new_XMLNotationDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"new_XMLNotationDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLNotationDecl *)new XERCES_CPP_NAMESPACE::XMLNotationDecl((XMLCh const *)arg1,(XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLNotationDecl__SWIG_2) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLNotationDecl *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: new_XMLNotationDecl(notName,pubId,sysId);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_XMLNotationDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"new_XMLNotationDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"new_XMLNotationDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLNotationDecl *)new XERCES_CPP_NAMESPACE::XMLNotationDecl((XMLCh const *)arg1,(XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLNotationDecl) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(3)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLNotationDecl__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLNotationDecl__SWIG_2); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLNotationDecl__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_XMLNotationDecl'");
  XSRETURN(0);
}


XS(_wrap_delete_XMLNotationDecl) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLNotationDecl(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLNotationDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_getId) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLNotationDecl_getId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_getId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::XMLNotationDecl const *)arg1)->getId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_getName) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLNotationDecl_getName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_getName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLNotationDecl const *)arg1)->getName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_getPublicId) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLNotationDecl_getPublicId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_getPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLNotationDecl const *)arg1)->getPublicId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLNotationDecl_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLNotationDecl const *)arg1)->getSystemId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_getBaseURI) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLNotationDecl_getBaseURI(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_getBaseURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLNotationDecl const *)arg1)->getBaseURI();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_getNameSpaceId) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLNotationDecl_getNameSpaceId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_getNameSpaceId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::XMLNotationDecl const *)arg1)->getNameSpaceId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_getMemoryManager) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLNotationDecl_getMemoryManager(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_getMemoryManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemoryManager *)((XERCES_CPP_NAMESPACE::XMLNotationDecl const *)arg1)->getMemoryManager();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_setId) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    unsigned int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLNotationDecl_setId(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_setId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLNotationDecl_setId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        (arg1)->setId(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_setName) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLNotationDecl_setName(self,notName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_setName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLNotationDecl_setName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setName((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_setPublicId) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLNotationDecl_setPublicId(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_setPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLNotationDecl_setPublicId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setPublicId((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_setSystemId) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLNotationDecl_setSystemId(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_setSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLNotationDecl_setSystemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setSystemId((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_setBaseURI) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLNotationDecl_setBaseURI(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_setBaseURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLNotationDecl_setBaseURI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setBaseURI((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_setNameSpaceId) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    unsigned int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLNotationDecl_setNameSpaceId(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_setNameSpaceId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLNotationDecl_setNameSpaceId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        (arg1)->setNameSpaceId(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLNotationDecl_getKey) {
  {
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg1 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLNotationDecl_getKey(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLNotationDecl_getKey" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLNotationDecl const *)arg1)->getKey();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLAttDefList) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDefList *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDefList *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLAttDefList(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLAttDefList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDefList * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDefList_hasMoreElements) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDefList *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDefList *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDefList_hasMoreElements(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDefList_hasMoreElements" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDefList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDefList * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLAttDefList const *)arg1)->hasMoreElements();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDefList_isEmpty) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDefList *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDefList *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDefList_isEmpty(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDefList_isEmpty" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDefList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDefList * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLAttDefList const *)arg1)->isEmpty();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDefList_findAttDef__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDefList *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDefList *) 0 ;
    unsigned long arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: XMLAttDefList_findAttDef(self,uriID,attName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDefList_findAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDefList * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLAttDefList_findAttDef" "', argument " "2"" of type '" "unsigned long""'");
    } 
    arg2 = static_cast< unsigned long >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"XMLAttDefList_findAttDef");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef *)(arg1)->findAttDef(arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDefList_findAttDef__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDefList *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDefList *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: XMLAttDefList_findAttDef(self,attURI,attName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDefList_findAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDefList * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLAttDefList_findAttDef");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"XMLAttDefList_findAttDef");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef *)(arg1)->findAttDef((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDefList_findAttDef) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLAttDefList_findAttDef__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLAttDefList_findAttDef__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'XMLAttDefList_findAttDef'");
  XSRETURN(0);
}


XS(_wrap_XMLAttDefList_nextElement) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDefList *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDefList *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDefList_nextElement(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDefList_nextElement" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDefList * >(argp1);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::XMLAttDef &_result_ref = (arg1)->nextElement();
          result = (XERCES_CPP_NAMESPACE::XMLAttDef *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDefList_Reset) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDefList *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDefList *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDefList_Reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDefList_Reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDefList * >(argp1);
    {
      try 
      {
        (arg1)->Reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDefList_getAttDefCount) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDefList *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDefList *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDefList_getAttDefCount(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDefList_getAttDefCount" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDefList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDefList * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::XMLAttDefList const *)arg1)->getAttDefCount();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDefList_getAttDef) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDefList *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDefList *) 0 ;
    unsigned int arg2 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLAttDefList_getAttDef(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDefList_getAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDefList * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLAttDefList_getAttDef" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::XMLAttDef &_result_ref = (arg1)->getAttDef(arg2);
          result = (XERCES_CPP_NAMESPACE::XMLAttDef *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDefList_getMemoryManager) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDefList *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDefList *) 0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDefList_getMemoryManager(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDefList_getMemoryManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDefList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDefList * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemoryManager *)((XERCES_CPP_NAMESPACE::XMLAttDefList const *)arg1)->getMemoryManager();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getAttTypeString) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes arg1 ;
    XMLCh *result = 0 ;
    int val1 ;
    int ecode1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getAttTypeString(attrType);");
    }
    ecode1 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(0), &val1);
    if (!SWIG_IsOK(ecode1)) {
      SWIG_exception_fail(SWIG_ArgError(ecode1), "in method '" "XMLAttDef_getAttTypeString" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes""'");
    } 
    arg1 = static_cast< XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes >(val1);
    {
      try 
      {
        result = (XMLCh *)XERCES_CPP_NAMESPACE::XMLAttDef::getAttTypeString(arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getDefAttTypeString) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes arg1 ;
    XMLCh *result = 0 ;
    int val1 ;
    int ecode1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getDefAttTypeString(attrType);");
    }
    ecode1 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(0), &val1);
    if (!SWIG_IsOK(ecode1)) {
      SWIG_exception_fail(SWIG_ArgError(ecode1), "in method '" "XMLAttDef_getDefAttTypeString" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes""'");
    } 
    arg1 = static_cast< XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes >(val1);
    {
      try 
      {
        result = (XMLCh *)XERCES_CPP_NAMESPACE::XMLAttDef::getDefAttTypeString(arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLAttDef) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLAttDef(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getFullName) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getFullName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_getFullName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->getFullName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_reset) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        (arg1)->reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getDefaultType) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getDefaultType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_getDefaultType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->getDefaultType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getEnumeration) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getEnumeration(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_getEnumeration" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->getEnumeration();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getId) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_getId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->getId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getProvided) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getProvided(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_getProvided" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->getProvided();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getType) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_getType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->getType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getValue) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getValue(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_getValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->getValue();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getCreateReason) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef::CreateReasons result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getCreateReason(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_getCreateReason" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef::CreateReasons)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->getCreateReason();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_isExternal) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_isExternal(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_isExternal" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->isExternal();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getMemoryManager) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getMemoryManager(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_getMemoryManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemoryManager *)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->getMemoryManager();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getDOMTypeInfoUri) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getDOMTypeInfoUri(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_getDOMTypeInfoUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->getDOMTypeInfoUri();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_getDOMTypeInfoName) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLAttDef_getDOMTypeInfoName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_getDOMTypeInfoName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLAttDef const *)arg1)->getDOMTypeInfoName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_setDefaultType) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLAttDef_setDefaultType(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_setDefaultType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLAttDef_setDefaultType" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes >(val2);
    {
      try 
      {
        (arg1)->setDefaultType(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_setId) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    unsigned int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLAttDef_setId(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_setId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLAttDef_setId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        (arg1)->setId(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_setProvided) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLAttDef_setProvided(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_setProvided" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLAttDef_setProvided" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setProvided(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_setType) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLAttDef_setType(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_setType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLAttDef_setType" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes >(val2);
    {
      try 
      {
        (arg1)->setType(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_setValue) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLAttDef_setValue(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_setValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLAttDef_setValue");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setValue((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_setEnumeration) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLAttDef_setEnumeration(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_setEnumeration" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLAttDef_setEnumeration");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setEnumeration((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_setCreateReason) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef::CreateReasons arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLAttDef_setCreateReason(self,newReason);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_setCreateReason" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLAttDef_setCreateReason" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef::CreateReasons""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::XMLAttDef::CreateReasons >(val2);
    {
      try 
      {
        (arg1)->setCreateReason(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLAttDef_setExternalAttDeclaration) {
  {
    XERCES_CPP_NAMESPACE::XMLAttDef *arg1 = (XERCES_CPP_NAMESPACE::XMLAttDef *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLAttDef_setExternalAttDeclaration(self,aValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLAttDef_setExternalAttDeclaration" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLAttDef_setExternalAttDeclaration" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setExternalAttDeclaration(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLValidator) {
  {
    XERCES_CPP_NAMESPACE::XMLValidator *arg1 = (XERCES_CPP_NAMESPACE::XMLValidator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLValidator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLValidator * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLValidator_getGrammar) {
  {
    XERCES_CPP_NAMESPACE::XMLValidator *arg1 = (XERCES_CPP_NAMESPACE::XMLValidator *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLValidator_getGrammar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLValidator_getGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLValidator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLValidator * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)((XERCES_CPP_NAMESPACE::XMLValidator const *)arg1)->getGrammar();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLValidator_setGrammar) {
  {
    XERCES_CPP_NAMESPACE::XMLValidator *arg1 = (XERCES_CPP_NAMESPACE::XMLValidator *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar *arg2 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLValidator_setGrammar(self,aGrammar);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLValidator_setGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLValidator * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLValidator_setGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp2);
    {
      try 
      {
        (arg1)->setGrammar(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_Grammar) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_Grammar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_Grammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_getGrammarType) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar::GrammarType result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Grammar_getGrammarType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_getGrammarType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar::GrammarType)((XERCES_CPP_NAMESPACE::Grammar const *)arg1)->getGrammarType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_getTargetNamespace) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Grammar_getTargetNamespace(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_getTargetNamespace" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Grammar const *)arg1)->getTargetNamespace();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_getValidated) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Grammar_getValidated(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_getValidated" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::Grammar const *)arg1)->getValidated();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_findOrAddElemDecl) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg6 ;
    bool *arg7 = 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val6 ;
    int ecode6 = 0 ;
    void *argp7 = 0 ;
    int res7 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 7) || (items > 7)) {
      SWIG_croak("Usage: Grammar_findOrAddElemDecl(self,uriId,baseName,prefixName,qName,scope,wasAdded);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_findOrAddElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Grammar_findOrAddElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"Grammar_findOrAddElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"Grammar_findOrAddElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"Grammar_findOrAddElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "Grammar_findOrAddElemDecl" "', argument " "6"" of type '" "unsigned int""'");
    } 
    arg6 = static_cast< unsigned int >(val6);
    res7 = SWIG_ConvertPtr(ST(6), &argp7, SWIGTYPE_p_bool,  0 );
    if (!SWIG_IsOK(res7)) {
      SWIG_exception_fail(SWIG_ArgError(res7), "in method '" "Grammar_findOrAddElemDecl" "', argument " "7"" of type '" "bool &""'"); 
    }
    if (!argp7) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "Grammar_findOrAddElemDecl" "', argument " "7"" of type '" "bool &""'"); 
    }
    arg7 = reinterpret_cast< bool * >(argp7);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->findOrAddElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6,*arg7);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_getElemId) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg5 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val5 ;
    int ecode5 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: Grammar_getElemId(self,uriId,baseName,qName,scope);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_getElemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Grammar_getElemId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"Grammar_getElemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"Grammar_getElemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    ecode5 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(4), &val5);
    if (!SWIG_IsOK(ecode5)) {
      SWIG_exception_fail(SWIG_ArgError(ecode5), "in method '" "Grammar_getElemId" "', argument " "5"" of type '" "unsigned int""'");
    } 
    arg5 = static_cast< unsigned int >(val5);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::Grammar const *)arg1)->getElemId(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,arg5);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_getElemDecl__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg5 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val5 ;
    int ecode5 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: Grammar_getElemDecl(self,uriId,baseName,qName,scope);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_getElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Grammar_getElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"Grammar_getElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"Grammar_getElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    ecode5 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(4), &val5);
    if (!SWIG_IsOK(ecode5)) {
      SWIG_exception_fail(SWIG_ArgError(ecode5), "in method '" "Grammar_getElemDecl" "', argument " "5"" of type '" "unsigned int""'");
    } 
    arg5 = static_cast< unsigned int >(val5);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->getElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,arg5);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_getElemDecl__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    unsigned int arg2 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Grammar_getElemDecl(self,elemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_getElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Grammar_getElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->getElemDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_getElemDecl) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 5) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(3)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(4), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Grammar_getElemDecl__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Grammar_getElemDecl__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'Grammar_getElemDecl'");
  XSRETURN(0);
}


XS(_wrap_Grammar_getNotationDecl) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLNotationDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Grammar_getNotationDecl(self,notName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_getNotationDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Grammar_getNotationDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLNotationDecl *)(arg1)->getNotationDecl((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_putElemDecl__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg6 ;
    bool arg7 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val6 ;
    int ecode6 = 0 ;
    bool val7 ;
    int ecode7 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 7) || (items > 7)) {
      SWIG_croak("Usage: Grammar_putElemDecl(self,uriId,baseName,prefixName,qName,scope,notDeclared);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Grammar_putElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"Grammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"Grammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"Grammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "Grammar_putElemDecl" "', argument " "6"" of type '" "unsigned int""'");
    } 
    arg6 = static_cast< unsigned int >(val6);
    ecode7 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(6), &val7);
    if (!SWIG_IsOK(ecode7)) {
      SWIG_exception_fail(SWIG_ArgError(ecode7), "in method '" "Grammar_putElemDecl" "', argument " "7"" of type '" "bool""'");
    } 
    arg7 = static_cast< bool >(val7);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->putElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6,arg7);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_putElemDecl__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg6 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val6 ;
    int ecode6 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 6) || (items > 6)) {
      SWIG_croak("Usage: Grammar_putElemDecl(self,uriId,baseName,prefixName,qName,scope);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Grammar_putElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"Grammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"Grammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"Grammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "Grammar_putElemDecl" "', argument " "6"" of type '" "unsigned int""'");
    } 
    arg6 = static_cast< unsigned int >(val6);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->putElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_putElemDecl__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) (XERCES_CPP_NAMESPACE::XMLElementDecl *)0 ;
    bool arg3 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    bool val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: Grammar_putElemDecl(self,elemDecl,notDeclared);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "Grammar_putElemDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp2);
    ecode3 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "Grammar_putElemDecl" "', argument " "3"" of type '" "bool""'");
    } 
    arg3 = static_cast< bool >(val3);
    {
      try 
      {
        result = (unsigned int)(arg1)->putElemDecl(arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_putElemDecl__SWIG_3) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) (XERCES_CPP_NAMESPACE::XMLElementDecl *)0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Grammar_putElemDecl(self,elemDecl);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "Grammar_putElemDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp2);
    {
      try 
      {
        result = (unsigned int)(arg1)->putElemDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_putElemDecl) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 6) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(3)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(4)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 7) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(3)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(4)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(6), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Grammar_putElemDecl__SWIG_3); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Grammar_putElemDecl__SWIG_2); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Grammar_putElemDecl__SWIG_1); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Grammar_putElemDecl__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'Grammar_putElemDecl'");
  XSRETURN(0);
}


XS(_wrap_Grammar_putNotationDecl) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) (XERCES_CPP_NAMESPACE::XMLNotationDecl *)0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Grammar_putNotationDecl(self,notationDecl);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_putNotationDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "Grammar_putNotationDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp2);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::Grammar const *)arg1)->putNotationDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_setValidated) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Grammar_setValidated(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_setValidated" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Grammar_setValidated" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setValidated(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_reset) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Grammar_reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    {
      try 
      {
        (arg1)->reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_setGrammarDescription) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLGrammarDescription *arg2 = (XERCES_CPP_NAMESPACE::XMLGrammarDescription *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Grammar_setGrammarDescription(self,XERCES_CPP_NAMESPACE::XMLGrammarDescription *);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_setGrammarDescription" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "Grammar_setGrammarDescription" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLGrammarDescription *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLGrammarDescription * >(argp2);
    {
      try 
      {
        (arg1)->setGrammarDescription(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_getGrammarDescription) {
  {
    XERCES_CPP_NAMESPACE::Grammar *arg1 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLGrammarDescription *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Grammar_getGrammarDescription(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_getGrammarDescription" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Grammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLGrammarDescription *)((XERCES_CPP_NAMESPACE::Grammar const *)arg1)->getGrammarDescription();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_storeGrammar) {
  {
    XSerializeEngine *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::Grammar *arg2 = (XERCES_CPP_NAMESPACE::Grammar *) (XERCES_CPP_NAMESPACE::Grammar *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Grammar_storeGrammar(serEng,grammar);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XSerializeEngine,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_storeGrammar" "', argument " "1"" of type '" "XSerializeEngine &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "Grammar_storeGrammar" "', argument " "1"" of type '" "XSerializeEngine &""'"); 
    }
    arg1 = reinterpret_cast< XSerializeEngine * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "Grammar_storeGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::Grammar *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp2);
    {
      try 
      {
        XERCES_CPP_NAMESPACE::Grammar::storeGrammar(*arg1,arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Grammar_loadGrammar) {
  {
    XSerializeEngine *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Grammar_loadGrammar(serEng);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XSerializeEngine,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Grammar_loadGrammar" "', argument " "1"" of type '" "XSerializeEngine &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "Grammar_loadGrammar" "', argument " "1"" of type '" "XSerializeEngine &""'"); 
    }
    arg1 = reinterpret_cast< XSerializeEngine * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)XERCES_CPP_NAMESPACE::Grammar::loadGrammar(*arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLGrammarDescription) {
  {
    XERCES_CPP_NAMESPACE::XMLGrammarDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLGrammarDescription *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLGrammarDescription(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLGrammarDescription" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLGrammarDescription *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLGrammarDescription * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLGrammarDescription_getGrammarType) {
  {
    XERCES_CPP_NAMESPACE::XMLGrammarDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLGrammarDescription *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar::GrammarType result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLGrammarDescription_getGrammarType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLGrammarDescription_getGrammarType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLGrammarDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLGrammarDescription * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar::GrammarType)((XERCES_CPP_NAMESPACE::XMLGrammarDescription const *)arg1)->getGrammarType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLGrammarDescription_getGrammarKey) {
  {
    XERCES_CPP_NAMESPACE::XMLGrammarDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLGrammarDescription *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLGrammarDescription_getGrammarKey(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLGrammarDescription_getGrammarKey" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLGrammarDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLGrammarDescription * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLGrammarDescription const *)arg1)->getGrammarKey();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLGrammarDescription_getMemoryManager) {
  {
    XERCES_CPP_NAMESPACE::XMLGrammarDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLGrammarDescription *) 0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLGrammarDescription_getMemoryManager(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLGrammarDescription_getMemoryManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLGrammarDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLGrammarDescription * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemoryManager *)((XERCES_CPP_NAMESPACE::XMLGrammarDescription const *)arg1)->getMemoryManager();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLDTDDescription) {
  {
    XERCES_CPP_NAMESPACE::XMLDTDDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLDTDDescription *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLDTDDescription(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDTDDescription, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLDTDDescription" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLDTDDescription *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLDTDDescription * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLDTDDescription_getGrammarType) {
  {
    XERCES_CPP_NAMESPACE::XMLDTDDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLDTDDescription *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar::GrammarType result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLDTDDescription_getGrammarType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDTDDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLDTDDescription_getGrammarType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLDTDDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLDTDDescription * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar::GrammarType)((XERCES_CPP_NAMESPACE::XMLDTDDescription const *)arg1)->getGrammarType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLDTDDescription_getRootName) {
  {
    XERCES_CPP_NAMESPACE::XMLDTDDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLDTDDescription *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLDTDDescription_getRootName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDTDDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLDTDDescription_getRootName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLDTDDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLDTDDescription * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLDTDDescription const *)arg1)->getRootName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLDTDDescription_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::XMLDTDDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLDTDDescription *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLDTDDescription_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDTDDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLDTDDescription_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLDTDDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLDTDDescription * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLDTDDescription const *)arg1)->getSystemId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLDTDDescription_setRootName) {
  {
    XERCES_CPP_NAMESPACE::XMLDTDDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLDTDDescription *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLDTDDescription_setRootName(self,XMLCh const *const);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDTDDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLDTDDescription_setRootName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLDTDDescription *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLDTDDescription * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLDTDDescription_setRootName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setRootName((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLDTDDescription_setSystemId) {
  {
    XERCES_CPP_NAMESPACE::XMLDTDDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLDTDDescription *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLDTDDescription_setSystemId(self,XMLCh const *const);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDTDDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLDTDDescription_setSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLDTDDescription *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLDTDDescription * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLDTDDescription_setSystemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setSystemId((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_XMLSchemaDescription) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLSchemaDescription(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLSchemaDescription" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_getGrammarType) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar::GrammarType result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLSchemaDescription_getGrammarType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_getGrammarType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar::GrammarType)((XERCES_CPP_NAMESPACE::XMLSchemaDescription const *)arg1)->getGrammarType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_getContextType) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XERCES_CPP_NAMESPACE::XMLSchemaDescription::ContextType result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLSchemaDescription_getContextType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_getContextType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLSchemaDescription::ContextType)((XERCES_CPP_NAMESPACE::XMLSchemaDescription const *)arg1)->getContextType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_getTargetNamespace) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLSchemaDescription_getTargetNamespace(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_getTargetNamespace" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XMLSchemaDescription const *)arg1)->getTargetNamespace();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_getLocationHints) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    RefArrayVectorOf<XMLCh > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLSchemaDescription_getLocationHints(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_getLocationHints" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    {
      try 
      {
        result = (RefArrayVectorOf<XMLCh > *)((XERCES_CPP_NAMESPACE::XMLSchemaDescription const *)arg1)->getLocationHints();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_RefArrayVectorOfTunsigned_short_t, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_getTriggeringComponent) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XERCES_CPP_NAMESPACE::QName *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLSchemaDescription_getTriggeringComponent(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_getTriggeringComponent" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::QName *)((XERCES_CPP_NAMESPACE::XMLSchemaDescription const *)arg1)->getTriggeringComponent();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_getEnclosingElementName) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XERCES_CPP_NAMESPACE::QName *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLSchemaDescription_getEnclosingElementName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_getEnclosingElementName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::QName *)((XERCES_CPP_NAMESPACE::XMLSchemaDescription const *)arg1)->getEnclosingElementName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_getAttributes) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLSchemaDescription_getAttributes(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_getAttributes" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef *)((XERCES_CPP_NAMESPACE::XMLSchemaDescription const *)arg1)->getAttributes();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_setContextType) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XERCES_CPP_NAMESPACE::XMLSchemaDescription::ContextType arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLSchemaDescription_setContextType(self,XERCES_CPP_NAMESPACE::XMLSchemaDescription::ContextType);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_setContextType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XMLSchemaDescription_setContextType" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription::ContextType""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription::ContextType >(val2);
    {
      try 
      {
        (arg1)->setContextType(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_setTargetNamespace) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLSchemaDescription_setTargetNamespace(self,XMLCh const *const);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_setTargetNamespace" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLSchemaDescription_setTargetNamespace");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setTargetNamespace((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_setLocationHints) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLSchemaDescription_setLocationHints(self,XMLCh const *const);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_setLocationHints" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XMLSchemaDescription_setLocationHints");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setLocationHints((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_setTriggeringComponent) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XERCES_CPP_NAMESPACE::QName *arg2 = (XERCES_CPP_NAMESPACE::QName *) (XERCES_CPP_NAMESPACE::QName *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLSchemaDescription_setTriggeringComponent(self,XERCES_CPP_NAMESPACE::QName *const);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_setTriggeringComponent" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLSchemaDescription_setTriggeringComponent" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::QName *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp2);
    {
      try 
      {
        (arg1)->setTriggeringComponent(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_setEnclosingElementName) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XERCES_CPP_NAMESPACE::QName *arg2 = (XERCES_CPP_NAMESPACE::QName *) (XERCES_CPP_NAMESPACE::QName *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLSchemaDescription_setEnclosingElementName(self,XERCES_CPP_NAMESPACE::QName *const);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_setEnclosingElementName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLSchemaDescription_setEnclosingElementName" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::QName *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::QName * >(argp2);
    {
      try 
      {
        (arg1)->setEnclosingElementName(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLSchemaDescription_setAttributes) {
  {
    XERCES_CPP_NAMESPACE::XMLSchemaDescription *arg1 = (XERCES_CPP_NAMESPACE::XMLSchemaDescription *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *arg2 = (XERCES_CPP_NAMESPACE::XMLAttDef *) (XERCES_CPP_NAMESPACE::XMLAttDef *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XMLSchemaDescription_setAttributes(self,XERCES_CPP_NAMESPACE::XMLAttDef *const);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XMLSchemaDescription_setAttributes" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLSchemaDescription *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLSchemaDescription * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLSchemaDescription_setAttributes" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLAttDef *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLAttDef * >(argp2);
    {
      try 
      {
        (arg1)->setAttributes(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DTDElementDecl) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DTDElementDecl(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DTDElementDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_findAttr) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl::LookupOpts arg6 ;
    bool *arg7 = 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int val6 ;
    int ecode6 = 0 ;
    void *argp7 = 0 ;
    int res7 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 7) || (items > 7)) {
      SWIG_croak("Usage: DTDElementDecl_findAttr(self,qName,uriId,baseName,prefix,options,wasAdded);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_findAttr" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DTDElementDecl_findAttr");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DTDElementDecl_findAttr" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DTDElementDecl_findAttr");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"DTDElementDecl_findAttr");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "DTDElementDecl_findAttr" "', argument " "6"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl::LookupOpts""'");
    } 
    arg6 = static_cast< XERCES_CPP_NAMESPACE::XMLElementDecl::LookupOpts >(val6);
    res7 = SWIG_ConvertPtr(ST(6), &argp7, SWIGTYPE_p_bool,  0 );
    if (!SWIG_IsOK(res7)) {
      SWIG_exception_fail(SWIG_ArgError(res7), "in method '" "DTDElementDecl_findAttr" "', argument " "7"" of type '" "bool &""'"); 
    }
    if (!argp7) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DTDElementDecl_findAttr" "', argument " "7"" of type '" "bool &""'"); 
    }
    arg7 = reinterpret_cast< bool * >(argp7);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef *)((XERCES_CPP_NAMESPACE::DTDElementDecl const *)arg1)->findAttr((XMLCh const *)arg2,arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6,*arg7);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_getAttDefList) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDefList *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_getAttDefList(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_getAttDefList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::XMLAttDefList &_result_ref = ((XERCES_CPP_NAMESPACE::DTDElementDecl const *)arg1)->getAttDefList();
          result = (XERCES_CPP_NAMESPACE::XMLAttDefList *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_getCharDataOpts) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl::CharDataOpts result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_getCharDataOpts(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_getCharDataOpts" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl::CharDataOpts)((XERCES_CPP_NAMESPACE::DTDElementDecl const *)arg1)->getCharDataOpts();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_hasAttDefs) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_hasAttDefs(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_hasAttDefs" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DTDElementDecl const *)arg1)->hasAttDefs();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_resetDefs) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_resetDefs(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_resetDefs" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)(arg1)->resetDefs();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_getContentSpec) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::ContentSpecNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_getContentSpec(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_getContentSpec" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::ContentSpecNode *)(arg1)->getContentSpec();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentSpecNode, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_setContentSpec) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::ContentSpecNode *arg2 = (XERCES_CPP_NAMESPACE::ContentSpecNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDElementDecl_setContentSpec(self,toAdopt);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_setContentSpec" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentSpecNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DTDElementDecl_setContentSpec" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::ContentSpecNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::ContentSpecNode * >(argp2);
    {
      try 
      {
        (arg1)->setContentSpec(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_getContentModel) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLContentModel *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_getContentModel(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_getContentModel" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLContentModel *)(arg1)->getContentModel();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLContentModel, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_setContentModel) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLContentModel *arg2 = (XERCES_CPP_NAMESPACE::XMLContentModel *) (XERCES_CPP_NAMESPACE::XMLContentModel *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDElementDecl_setContentModel(self,newModelToAdopt);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_setContentModel" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLContentModel, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DTDElementDecl_setContentModel" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLContentModel *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLContentModel * >(argp2);
    {
      try 
      {
        (arg1)->setContentModel(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_getFormattedContentModel) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_getFormattedContentModel(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_getFormattedContentModel" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DTDElementDecl const *)arg1)->getFormattedContentModel();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_getKey) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_getKey(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_getKey" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DTDElementDecl const *)arg1)->getKey();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_getAttDef) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    DTDAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDElementDecl_getAttDef(self,attName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_getAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DTDElementDecl_getAttDef");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (DTDAttDef *)(arg1)->getAttDef((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_getModelType) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::DTDElementDecl::ModelTypes result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_getModelType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_getModelType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DTDElementDecl::ModelTypes)((XERCES_CPP_NAMESPACE::DTDElementDecl const *)arg1)->getModelType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_getDOMTypeInfoName) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_getDOMTypeInfoName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_getDOMTypeInfoName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DTDElementDecl const *)arg1)->getDOMTypeInfoName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_getDOMTypeInfoUri) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_getDOMTypeInfoUri(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_getDOMTypeInfoUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DTDElementDecl const *)arg1)->getDOMTypeInfoUri();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_addAttDef) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    DTDAttDef *arg2 = (DTDAttDef *) (DTDAttDef *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDElementDecl_addAttDef(self,toAdd);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_addAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DTDElementDecl_addAttDef" "', argument " "2"" of type '" "DTDAttDef *const""'"); 
    }
    arg2 = reinterpret_cast< DTDAttDef * >(argp2);
    {
      try 
      {
        (arg1)->addAttDef(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_setModelType) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::DTDElementDecl::ModelTypes arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDElementDecl_setModelType(self,toSet);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_setModelType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDElementDecl_setModelType" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl::ModelTypes""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::DTDElementDecl::ModelTypes >(val2);
    {
      try 
      {
        (arg1)->setModelType(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDecl_getObjectType) {
  {
    XERCES_CPP_NAMESPACE::DTDElementDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl::objectType result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDecl_getObjectType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDecl_getObjectType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl::objectType)((XERCES_CPP_NAMESPACE::DTDElementDecl const *)arg1)->getObjectType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDElementDeclEnumerator__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > *) (XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > *)0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *arg2 = (XERCES_CPP_NAMESPACE::MemoryManager *) (XERCES_CPP_NAMESPACE::MemoryManager *)0 ;
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg2 = XERCES_CPP_NAMESPACE::XMLPlatformUtils::fgMemoryManager;
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_DTDElementDeclEnumerator(toEnum);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_DTDElementDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > *const""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *)new XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl >(arg1,arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDElementDeclEnumerator__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > *) (XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > *)0 ;
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_DTDElementDeclEnumerator(toEnum);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_DTDElementDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > *const""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *)new XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl >(arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDElementDeclEnumerator__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *result = 0 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_DTDElementDeclEnumerator(toCopy);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_DTDElementDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > const &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "new_DTDElementDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > const &""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *)new XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl >((XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > const &)*arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDElementDeclEnumerator) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_DTDElementDeclEnumerator__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_DTDElementDeclEnumerator__SWIG_1); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_DTDElementDeclEnumerator__SWIG_2); return;
    }
  }
  
  croak("No matching function for overloaded 'new_DTDElementDeclEnumerator'");
  XSRETURN(0);
}


XS(_wrap_delete_DTDElementDeclEnumerator) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DTDElementDeclEnumerator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DTDElementDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDeclEnumerator_hasMoreElements) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDeclEnumerator_hasMoreElements(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDeclEnumerator_hasMoreElements" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > const *)arg1)->hasMoreElements();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDeclEnumerator_nextElement) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *) 0 ;
    XERCES_CPP_NAMESPACE::DTDElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDeclEnumerator_nextElement(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDeclEnumerator_nextElement" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > * >(argp1);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::DTDElementDecl &_result_ref = (arg1)->nextElement();
          result = (XERCES_CPP_NAMESPACE::DTDElementDecl *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDeclEnumerator_Reset) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDeclEnumerator_Reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDeclEnumerator_Reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > * >(argp1);
    {
      try 
      {
        (arg1)->Reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDElementDeclEnumerator_size) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDElementDeclEnumerator_size(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDElementDeclEnumerator_size" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > * >(argp1);
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > const *)arg1)->size();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DTDEntityDecl) {
  {
    XERCES_CPP_NAMESPACE::DTDEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDEntityDecl *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DTDEntityDecl(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DTDEntityDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDEntityDecl * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDEntityDecl_getDeclaredInIntSubset) {
  {
    XERCES_CPP_NAMESPACE::DTDEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDEntityDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDEntityDecl_getDeclaredInIntSubset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDEntityDecl_getDeclaredInIntSubset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDEntityDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DTDEntityDecl const *)arg1)->getDeclaredInIntSubset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDEntityDecl_getIsParameter) {
  {
    XERCES_CPP_NAMESPACE::DTDEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDEntityDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDEntityDecl_getIsParameter(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDEntityDecl_getIsParameter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDEntityDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DTDEntityDecl const *)arg1)->getIsParameter();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDEntityDecl_getIsSpecialChar) {
  {
    XERCES_CPP_NAMESPACE::DTDEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDEntityDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDEntityDecl_getIsSpecialChar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDEntityDecl_getIsSpecialChar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDEntityDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDEntityDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DTDEntityDecl const *)arg1)->getIsSpecialChar();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDEntityDecl_setDeclaredInIntSubset) {
  {
    XERCES_CPP_NAMESPACE::DTDEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDEntityDecl *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDEntityDecl_setDeclaredInIntSubset(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDEntityDecl_setDeclaredInIntSubset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDEntityDecl * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDEntityDecl_setDeclaredInIntSubset" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setDeclaredInIntSubset(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDEntityDecl_setIsParameter) {
  {
    XERCES_CPP_NAMESPACE::DTDEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDEntityDecl *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDEntityDecl_setIsParameter(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDEntityDecl_setIsParameter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDEntityDecl * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDEntityDecl_setIsParameter" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIsParameter(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDEntityDecl_setIsSpecialChar) {
  {
    XERCES_CPP_NAMESPACE::DTDEntityDecl *arg1 = (XERCES_CPP_NAMESPACE::DTDEntityDecl *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDEntityDecl_setIsSpecialChar(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDEntityDecl_setIsSpecialChar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDEntityDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDEntityDecl * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDEntityDecl_setIsSpecialChar" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIsSpecialChar(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDEntityDeclEnumerator__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *) (XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *)0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *arg2 = (XERCES_CPP_NAMESPACE::MemoryManager *) (XERCES_CPP_NAMESPACE::MemoryManager *)0 ;
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg2 = XERCES_CPP_NAMESPACE::XMLPlatformUtils::fgMemoryManager;
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_DTDEntityDeclEnumerator(toEnum);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_DTDEntityDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *const""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *)new XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl >(arg1,arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDEntityDeclEnumerator__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *) (XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *)0 ;
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_DTDEntityDeclEnumerator(toEnum);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_DTDEntityDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *const""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *)new XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl >(arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDEntityDeclEnumerator__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *result = 0 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_DTDEntityDeclEnumerator(toCopy);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_DTDEntityDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > const &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "new_DTDEntityDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > const &""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *)new XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl >((XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > const &)*arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDEntityDeclEnumerator) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_DTDEntityDeclEnumerator__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_DTDEntityDeclEnumerator__SWIG_1); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_DTDEntityDeclEnumerator__SWIG_2); return;
    }
  }
  
  croak("No matching function for overloaded 'new_DTDEntityDeclEnumerator'");
  XSRETURN(0);
}


XS(_wrap_delete_DTDEntityDeclEnumerator) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DTDEntityDeclEnumerator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DTDEntityDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDEntityDeclEnumerator_hasMoreElements) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDEntityDeclEnumerator_hasMoreElements(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDEntityDeclEnumerator_hasMoreElements" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > const *)arg1)->hasMoreElements();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDEntityDeclEnumerator_nextElement) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *) 0 ;
    XERCES_CPP_NAMESPACE::DTDEntityDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDEntityDeclEnumerator_nextElement(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDEntityDeclEnumerator_nextElement" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > * >(argp1);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::DTDEntityDecl &_result_ref = (arg1)->nextElement();
          result = (XERCES_CPP_NAMESPACE::DTDEntityDecl *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDEntityDeclEnumerator_Reset) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDEntityDeclEnumerator_Reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDEntityDeclEnumerator_Reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > * >(argp1);
    {
      try 
      {
        (arg1)->Reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDEntityDeclEnumerator_size) {
  {
    XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *arg1 = (XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDEntityDeclEnumerator_size(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDEntityDeclEnumerator_size" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > * >(argp1);
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > const *)arg1)->size();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DTDAttDefList) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDefList *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDefList *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DTDAttDefList(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DTDAttDefList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDefList * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDefList_hasMoreElements) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDefList *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDefList *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDAttDefList_hasMoreElements(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDefList_hasMoreElements" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDefList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDefList * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DTDAttDefList const *)arg1)->hasMoreElements();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDefList_isEmpty) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDefList *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDefList *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDAttDefList_isEmpty(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDefList_isEmpty" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDefList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDefList * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DTDAttDefList const *)arg1)->isEmpty();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDefList_findAttDef__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDefList *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDefList *) 0 ;
    unsigned long arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DTDAttDefList_findAttDef(self,uriID,attName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDefList_findAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDefList * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDAttDefList_findAttDef" "', argument " "2"" of type '" "unsigned long""'");
    } 
    arg2 = static_cast< unsigned long >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DTDAttDefList_findAttDef");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef *)(arg1)->findAttDef(arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDefList_findAttDef__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDefList *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDefList *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DTDAttDefList_findAttDef(self,attURI,attName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDefList_findAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDefList * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DTDAttDefList_findAttDef");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DTDAttDefList_findAttDef");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef *)(arg1)->findAttDef((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDefList_findAttDef) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DTDAttDefList_findAttDef__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DTDAttDefList_findAttDef__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'DTDAttDefList_findAttDef'");
  XSRETURN(0);
}


XS(_wrap_DTDAttDefList_nextElement) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDefList *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDefList *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDAttDefList_nextElement(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDefList_nextElement" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDefList * >(argp1);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::XMLAttDef &_result_ref = (arg1)->nextElement();
          result = (XERCES_CPP_NAMESPACE::XMLAttDef *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDefList_Reset) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDefList *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDefList *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDAttDefList_Reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDefList_Reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDefList * >(argp1);
    {
      try 
      {
        (arg1)->Reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDefList_getAttDefCount) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDefList *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDefList *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDAttDefList_getAttDefCount(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDefList_getAttDefCount" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDefList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDefList * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::DTDAttDefList const *)arg1)->getAttDefCount();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDefList_getAttDef) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDefList *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDefList *) 0 ;
    unsigned int arg2 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDAttDefList_getAttDef(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDefList_getAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDefList * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDAttDefList_getAttDef" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::XMLAttDef &_result_ref = (arg1)->getAttDef(arg2);
          result = (XERCES_CPP_NAMESPACE::XMLAttDef *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DTDAttDef) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDef *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDef *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DTDAttDef(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DTDAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDef * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDef_getFullName) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDef *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDAttDef_getFullName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDef_getFullName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DTDAttDef const *)arg1)->getFullName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDef_reset) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDef *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDef *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDAttDef_reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDef_reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDef * >(argp1);
    {
      try 
      {
        (arg1)->reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDef_getElemId) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDef *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDef *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDAttDef_getElemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDef_getElemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDef * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::DTDAttDef const *)arg1)->getElemId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDef_getDOMTypeInfoName) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDef *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDAttDef_getDOMTypeInfoName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDef_getDOMTypeInfoName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DTDAttDef const *)arg1)->getDOMTypeInfoName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDef_getDOMTypeInfoUri) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDef *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDAttDef_getDOMTypeInfoUri(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDef_getDOMTypeInfoUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DTDAttDef const *)arg1)->getDOMTypeInfoUri();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDef_setElemId) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDef *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDef *) 0 ;
    unsigned int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDAttDef_setElemId(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDef_setElemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDef * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDAttDef_setElemId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        (arg1)->setElemId(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDAttDef_setName) {
  {
    XERCES_CPP_NAMESPACE::DTDAttDef *arg1 = (XERCES_CPP_NAMESPACE::DTDAttDef *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDAttDef_setName(self,newName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDAttDef_setName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDAttDef * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DTDAttDef_setName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setName((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDGrammar) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_DTDGrammar();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DTDGrammar *)new XERCES_CPP_NAMESPACE::DTDGrammar();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DTDGrammar) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DTDGrammar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DTDGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getGrammarType) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar::GrammarType result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDGrammar_getGrammarType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getGrammarType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar::GrammarType)((XERCES_CPP_NAMESPACE::DTDGrammar const *)arg1)->getGrammarType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getTargetNamespace) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDGrammar_getTargetNamespace(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getTargetNamespace" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DTDGrammar const *)arg1)->getTargetNamespace();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_findOrAddElemDecl) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg6 ;
    bool *arg7 = 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val6 ;
    int ecode6 = 0 ;
    void *argp7 = 0 ;
    int res7 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 7) || (items > 7)) {
      SWIG_croak("Usage: DTDGrammar_findOrAddElemDecl(self,uriId,baseName,prefixName,qName,scope,wasAdded);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_findOrAddElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDGrammar_findOrAddElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DTDGrammar_findOrAddElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DTDGrammar_findOrAddElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"DTDGrammar_findOrAddElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "DTDGrammar_findOrAddElemDecl" "', argument " "6"" of type '" "unsigned int""'");
    } 
    arg6 = static_cast< unsigned int >(val6);
    res7 = SWIG_ConvertPtr(ST(6), &argp7, SWIGTYPE_p_bool,  0 );
    if (!SWIG_IsOK(res7)) {
      SWIG_exception_fail(SWIG_ArgError(res7), "in method '" "DTDGrammar_findOrAddElemDecl" "', argument " "7"" of type '" "bool &""'"); 
    }
    if (!argp7) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DTDGrammar_findOrAddElemDecl" "', argument " "7"" of type '" "bool &""'"); 
    }
    arg7 = reinterpret_cast< bool * >(argp7);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->findOrAddElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6,*arg7);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getElemId) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg5 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val5 ;
    int ecode5 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: DTDGrammar_getElemId(self,uriId,baseName,qName,scope);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getElemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDGrammar_getElemId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DTDGrammar_getElemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DTDGrammar_getElemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    ecode5 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(4), &val5);
    if (!SWIG_IsOK(ecode5)) {
      SWIG_exception_fail(SWIG_ArgError(ecode5), "in method '" "DTDGrammar_getElemId" "', argument " "5"" of type '" "unsigned int""'");
    } 
    arg5 = static_cast< unsigned int >(val5);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::DTDGrammar const *)arg1)->getElemId(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,arg5);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getElemDecl__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg5 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val5 ;
    int ecode5 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: DTDGrammar_getElemDecl(self,uriId,baseName,qName,scope);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDGrammar_getElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DTDGrammar_getElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DTDGrammar_getElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    ecode5 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(4), &val5);
    if (!SWIG_IsOK(ecode5)) {
      SWIG_exception_fail(SWIG_ArgError(ecode5), "in method '" "DTDGrammar_getElemDecl" "', argument " "5"" of type '" "unsigned int""'");
    } 
    arg5 = static_cast< unsigned int >(val5);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->getElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,arg5);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getElemDecl__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    unsigned int arg2 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDGrammar_getElemDecl(self,elemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDGrammar_getElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->getElemDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getElemDecl) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 5) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(3)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(4), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DTDGrammar_getElemDecl__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DTDGrammar_getElemDecl__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'DTDGrammar_getElemDecl'");
  XSRETURN(0);
}


XS(_wrap_DTDGrammar_getNotationDecl) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLNotationDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDGrammar_getNotationDecl(self,notName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getNotationDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DTDGrammar_getNotationDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLNotationDecl *)(arg1)->getNotationDecl((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getValidated) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDGrammar_getValidated(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getValidated" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DTDGrammar const *)arg1)->getValidated();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_putElemDecl__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg6 ;
    bool arg7 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val6 ;
    int ecode6 = 0 ;
    bool val7 ;
    int ecode7 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 7) || (items > 7)) {
      SWIG_croak("Usage: DTDGrammar_putElemDecl(self,uriId,baseName,prefixName,qName,scope,notDeclared);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDGrammar_putElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DTDGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DTDGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"DTDGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "DTDGrammar_putElemDecl" "', argument " "6"" of type '" "unsigned int""'");
    } 
    arg6 = static_cast< unsigned int >(val6);
    ecode7 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(6), &val7);
    if (!SWIG_IsOK(ecode7)) {
      SWIG_exception_fail(SWIG_ArgError(ecode7), "in method '" "DTDGrammar_putElemDecl" "', argument " "7"" of type '" "bool""'");
    } 
    arg7 = static_cast< bool >(val7);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->putElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6,arg7);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_putElemDecl__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg6 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val6 ;
    int ecode6 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 6) || (items > 6)) {
      SWIG_croak("Usage: DTDGrammar_putElemDecl(self,uriId,baseName,prefixName,qName,scope);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDGrammar_putElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DTDGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DTDGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"DTDGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "DTDGrammar_putElemDecl" "', argument " "6"" of type '" "unsigned int""'");
    } 
    arg6 = static_cast< unsigned int >(val6);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->putElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_putElemDecl__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) (XERCES_CPP_NAMESPACE::XMLElementDecl *)0 ;
    bool arg3 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    bool val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DTDGrammar_putElemDecl(self,elemDecl,notDeclared);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DTDGrammar_putElemDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp2);
    ecode3 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DTDGrammar_putElemDecl" "', argument " "3"" of type '" "bool""'");
    } 
    arg3 = static_cast< bool >(val3);
    {
      try 
      {
        result = (unsigned int)(arg1)->putElemDecl(arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_putElemDecl__SWIG_3) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) (XERCES_CPP_NAMESPACE::XMLElementDecl *)0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDGrammar_putElemDecl(self,elemDecl);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DTDGrammar_putElemDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp2);
    {
      try 
      {
        result = (unsigned int)(arg1)->putElemDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_putElemDecl) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 6) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(3)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(4)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 7) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(3)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(4)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(6), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DTDGrammar_putElemDecl__SWIG_3); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DTDGrammar_putElemDecl__SWIG_2); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DTDGrammar_putElemDecl__SWIG_1); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DTDGrammar_putElemDecl__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'DTDGrammar_putElemDecl'");
  XSRETURN(0);
}


XS(_wrap_DTDGrammar_putNotationDecl) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) (XERCES_CPP_NAMESPACE::XMLNotationDecl *)0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDGrammar_putNotationDecl(self,notationDecl);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_putNotationDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DTDGrammar_putNotationDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp2);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::DTDGrammar const *)arg1)->putNotationDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_setValidated) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDGrammar_setValidated(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_setValidated" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDGrammar_setValidated" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setValidated(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_reset) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDGrammar_reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    {
      try 
      {
        (arg1)->reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getRootElemId) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDGrammar_getRootElemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getRootElemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::DTDGrammar const *)arg1)->getRootElemId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getEntityDecl) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::DTDEntityDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDGrammar_getEntityDecl(self,entName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getEntityDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DTDGrammar_getEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DTDEntityDecl *)(arg1)->getEntityDecl((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getEntityDeclPool) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDGrammar_getEntityDeclPool(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getEntityDeclPool" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *)(arg1)->getEntityDeclPool();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getElemEnumerator) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    SwigValueWrapper<XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > > result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDGrammar_getElemEnumerator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getElemEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::DTDGrammar const *)arg1)->getElemEnumerator();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl >(static_cast< const XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl >& >(result))), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, SWIG_POINTER_OWN | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getEntityEnumerator) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    SwigValueWrapper<XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > > result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDGrammar_getEntityEnumerator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getEntityEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::DTDGrammar const *)arg1)->getEntityEnumerator();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl >(static_cast< const XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl >& >(result))), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, SWIG_POINTER_OWN | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getNotationEnumerator) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    SwigValueWrapper<XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::XMLNotationDecl > > result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDGrammar_getNotationEnumerator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getNotationEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::DTDGrammar const *)arg1)->getNotationEnumerator();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::XMLNotationDecl >(static_cast< const XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::XMLNotationDecl >& >(result))), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__XMLNotationDecl_t, SWIG_POINTER_OWN | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_setRootElemId) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    unsigned int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDGrammar_setRootElemId(self,rootElemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_setRootElemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DTDGrammar_setRootElemId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        (arg1)->setRootElemId(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_setGrammarDescription) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLGrammarDescription *arg2 = (XERCES_CPP_NAMESPACE::XMLGrammarDescription *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDGrammar_setGrammarDescription(self,XERCES_CPP_NAMESPACE::XMLGrammarDescription *);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_setGrammarDescription" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DTDGrammar_setGrammarDescription" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLGrammarDescription *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLGrammarDescription * >(argp2);
    {
      try 
      {
        (arg1)->setGrammarDescription(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_getGrammarDescription) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLGrammarDescription *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDGrammar_getGrammarDescription(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_getGrammarDescription" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLGrammarDescription *)((XERCES_CPP_NAMESPACE::DTDGrammar const *)arg1)->getGrammarDescription();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_putEntityDecl) {
  {
    XERCES_CPP_NAMESPACE::DTDGrammar *arg1 = (XERCES_CPP_NAMESPACE::DTDGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::DTDEntityDecl *arg2 = (XERCES_CPP_NAMESPACE::DTDEntityDecl *) (XERCES_CPP_NAMESPACE::DTDEntityDecl *)0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDGrammar_putEntityDecl(self,entityDecl);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDGrammar_putEntityDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DTDGrammar_putEntityDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DTDEntityDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDEntityDecl * >(argp2);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::DTDGrammar const *)arg1)->putEntityDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDGrammar_reinitDfltEntities) {
  {
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: DTDGrammar_reinitDfltEntities();");
    }
    {
      try 
      {
        XERCES_CPP_NAMESPACE::DTDGrammar::reinitDfltEntities();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDValidator__SWIG_0) {
  {
    XMLErrorReporter *arg1 = (XMLErrorReporter *) (XMLErrorReporter *)0 ;
    XERCES_CPP_NAMESPACE::DTDValidator *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_DTDValidator(errReporter);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XMLErrorReporter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_DTDValidator" "', argument " "1"" of type '" "XMLErrorReporter *const""'"); 
    }
    arg1 = reinterpret_cast< XMLErrorReporter * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DTDValidator *)new XERCES_CPP_NAMESPACE::DTDValidator(arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDValidator, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDValidator__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::DTDValidator *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_DTDValidator();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DTDValidator *)new XERCES_CPP_NAMESPACE::DTDValidator();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDValidator, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_DTDValidator) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XMLErrorReporter, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_DTDValidator__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_DTDValidator__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'new_DTDValidator'");
  XSRETURN(0);
}


XS(_wrap_delete_DTDValidator) {
  {
    XERCES_CPP_NAMESPACE::DTDValidator *arg1 = (XERCES_CPP_NAMESPACE::DTDValidator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DTDValidator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDValidator, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DTDValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDValidator * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDValidator_getGrammar) {
  {
    XERCES_CPP_NAMESPACE::DTDValidator *arg1 = (XERCES_CPP_NAMESPACE::DTDValidator *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DTDValidator_getGrammar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDValidator_getGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDValidator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDValidator * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)((XERCES_CPP_NAMESPACE::DTDValidator const *)arg1)->getGrammar();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDValidator_setGrammar) {
  {
    XERCES_CPP_NAMESPACE::DTDValidator *arg1 = (XERCES_CPP_NAMESPACE::DTDValidator *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar *arg2 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DTDValidator_setGrammar(self,aGrammar);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDValidator_setGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDValidator * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DTDValidator_setGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp2);
    {
      try 
      {
        (arg1)->setGrammar(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_SchemaElementDecl) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SchemaElementDecl(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SchemaElementDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_findAttr) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl::LookupOpts arg6 ;
    bool *arg7 = 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int val6 ;
    int ecode6 = 0 ;
    void *argp7 = 0 ;
    int res7 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 7) || (items > 7)) {
      SWIG_croak("Usage: SchemaElementDecl_findAttr(self,qName,uriId,baseName,prefix,options,wasAdded);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_findAttr" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SchemaElementDecl_findAttr");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SchemaElementDecl_findAttr" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"SchemaElementDecl_findAttr");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"SchemaElementDecl_findAttr");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "SchemaElementDecl_findAttr" "', argument " "6"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl::LookupOpts""'");
    } 
    arg6 = static_cast< XERCES_CPP_NAMESPACE::XMLElementDecl::LookupOpts >(val6);
    res7 = SWIG_ConvertPtr(ST(6), &argp7, SWIGTYPE_p_bool,  0 );
    if (!SWIG_IsOK(res7)) {
      SWIG_exception_fail(SWIG_ArgError(res7), "in method '" "SchemaElementDecl_findAttr" "', argument " "7"" of type '" "bool &""'"); 
    }
    if (!argp7) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaElementDecl_findAttr" "', argument " "7"" of type '" "bool &""'"); 
    }
    arg7 = reinterpret_cast< bool * >(argp7);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->findAttr((XMLCh const *)arg2,arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6,*arg7);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getAttDefList) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDefList *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getAttDefList(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getAttDefList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::XMLAttDefList &_result_ref = ((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getAttDefList();
          result = (XERCES_CPP_NAMESPACE::XMLAttDefList *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getCharDataOpts) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl::CharDataOpts result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getCharDataOpts(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getCharDataOpts" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl::CharDataOpts)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getCharDataOpts();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_hasAttDefs) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_hasAttDefs(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_hasAttDefs" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->hasAttDefs();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_resetDefs) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_resetDefs(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_resetDefs" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)(arg1)->resetDefs();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getContentSpec) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::ContentSpecNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getContentSpec(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getContentSpec" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::ContentSpecNode *)(arg1)->getContentSpec();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentSpecNode, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setContentSpec) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::ContentSpecNode *arg2 = (XERCES_CPP_NAMESPACE::ContentSpecNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setContentSpec(self,toAdopt);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setContentSpec" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentSpecNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_setContentSpec" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::ContentSpecNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::ContentSpecNode * >(argp2);
    {
      try 
      {
        (arg1)->setContentSpec(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getContentModel) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLContentModel *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getContentModel(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getContentModel" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLContentModel *)(arg1)->getContentModel();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLContentModel, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setContentModel) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLContentModel *arg2 = (XERCES_CPP_NAMESPACE::XMLContentModel *) (XERCES_CPP_NAMESPACE::XMLContentModel *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setContentModel(self,newModelToAdopt);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setContentModel" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLContentModel, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_setContentModel" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLContentModel *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLContentModel * >(argp2);
    {
      try 
      {
        (arg1)->setContentModel(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getFormattedContentModel) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getFormattedContentModel(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getFormattedContentModel" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getFormattedContentModel();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getAttDef) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    int arg3 ;
    SchemaAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SchemaElementDecl_getAttDef(self,baseName,uriId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SchemaElementDecl_getAttDef");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SchemaElementDecl_getAttDef" "', argument " "3"" of type '" "int""'");
    } 
    arg3 = static_cast< int >(val3);
    {
      try 
      {
        result = (SchemaAttDef *)(arg1)->getAttDef((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getAttWildCard) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    SchemaAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getAttWildCard(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getAttWildCard" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (SchemaAttDef *)(arg1)->getAttWildCard();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getModelType) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::SchemaElementDecl::ModelTypes result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getModelType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getModelType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SchemaElementDecl::ModelTypes)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getModelType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getPSVIScope) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    PSVIDefs::PSVIScope result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getPSVIScope(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getPSVIScope" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getPSVIScope();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new PSVIDefs::PSVIScope(static_cast< const PSVIDefs::PSVIScope& >(result))), SWIGTYPE_p_PSVIDefs__PSVIScope, SWIG_POINTER_OWN | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getDatatypeValidator) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    DatatypeValidator *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getDatatypeValidator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getDatatypeValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (DatatypeValidator *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getDatatypeValidator();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DatatypeValidator, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getEnclosingScope) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getEnclosingScope(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getEnclosingScope" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getEnclosingScope();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getFinalSet) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getFinalSet(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getFinalSet" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getFinalSet();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getBlockSet) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getBlockSet(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getBlockSet" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getBlockSet();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getMiscFlags) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getMiscFlags(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getMiscFlags" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getMiscFlags();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getDefaultValue) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getDefaultValue(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getDefaultValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getDefaultValue();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getComplexTypeInfo) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    ComplexTypeInfo *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getComplexTypeInfo(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getComplexTypeInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (ComplexTypeInfo *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getComplexTypeInfo();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__ComplexTypeInfo, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_isGlobalDecl) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_isGlobalDecl(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_isGlobalDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->isGlobalDecl();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getSubstitutionGroupElem) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::SchemaElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getSubstitutionGroupElem(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getSubstitutionGroupElem" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SchemaElementDecl *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getSubstitutionGroupElem();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getValidity) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    PSVIDefs::Validity result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getValidity(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getValidity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getValidity();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new PSVIDefs::Validity(static_cast< const PSVIDefs::Validity& >(result))), SWIGTYPE_p_PSVIDefs__Validity, SWIG_POINTER_OWN | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getValidationAttempted) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    PSVIDefs::Validation result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getValidationAttempted(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getValidationAttempted" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getValidationAttempted();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new PSVIDefs::Validation(static_cast< const PSVIDefs::Validation& >(result))), SWIGTYPE_p_PSVIDefs__Validation, SWIG_POINTER_OWN | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getTypeType) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    PSVIDefs::Complexity result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getTypeType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getTypeType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getTypeType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new PSVIDefs::Complexity(static_cast< const PSVIDefs::Complexity& >(result))), SWIGTYPE_p_PSVIDefs__Complexity, SWIG_POINTER_OWN | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getTypeUri) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getTypeUri(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getTypeUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getTypeUri();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getTypeName) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getTypeName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getTypeName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getTypeName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getTypeAnonymous) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getTypeAnonymous(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getTypeAnonymous" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getTypeAnonymous();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_isTypeDefinitionUnion) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_isTypeDefinitionUnion(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_isTypeDefinitionUnion" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->isTypeDefinitionUnion();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getMemberTypeUri) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getMemberTypeUri(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getMemberTypeUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getMemberTypeUri();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getMemberTypeAnonymous) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getMemberTypeAnonymous(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getMemberTypeAnonymous" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getMemberTypeAnonymous();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getMemberTypeName) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getMemberTypeName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getMemberTypeName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getMemberTypeName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getDOMTypeInfoUri) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getDOMTypeInfoUri(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getDOMTypeInfoUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getDOMTypeInfoUri();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getDOMTypeInfoName) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getDOMTypeInfoName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getDOMTypeInfoName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getDOMTypeInfoName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setElemId) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    unsigned int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setElemId(self,elemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setElemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaElementDecl_setElemId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        (arg1)->setElemId(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setModelType) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::SchemaElementDecl::ModelTypes arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setModelType(self,toSet);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setModelType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaElementDecl_setModelType" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl::ModelTypes""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl::ModelTypes >(val2);
    {
      try 
      {
        (arg1)->setModelType(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setPSVIScope) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    PSVIDefs::PSVIScope arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setPSVIScope(self,toSet);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setPSVIScope" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_PSVIDefs__PSVIScope,  0 );
      if (!SWIG_IsOK(res2)) {
        SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_setPSVIScope" "', argument " "2"" of type '" "PSVIDefs::PSVIScope const""'"); 
      }  
      if (!argp2) {
        SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaElementDecl_setPSVIScope" "', argument " "2"" of type '" "PSVIDefs::PSVIScope const""'");
      } else {
        arg2 = *(reinterpret_cast< PSVIDefs::PSVIScope * >(argp2));
      }
    }
    {
      try 
      {
        (arg1)->setPSVIScope(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setDatatypeValidator) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    DatatypeValidator *arg2 = (DatatypeValidator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setDatatypeValidator(self,newDatatypeValidator);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setDatatypeValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DatatypeValidator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_setDatatypeValidator" "', argument " "2"" of type '" "DatatypeValidator *""'"); 
    }
    arg2 = reinterpret_cast< DatatypeValidator * >(argp2);
    {
      try 
      {
        (arg1)->setDatatypeValidator(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setEnclosingScope) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setEnclosingScope(self,enclosingScope);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setEnclosingScope" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaElementDecl_setEnclosingScope" "', argument " "2"" of type '" "int""'");
    } 
    arg2 = static_cast< int >(val2);
    {
      try 
      {
        (arg1)->setEnclosingScope(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setFinalSet) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setFinalSet(self,finalSet);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setFinalSet" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaElementDecl_setFinalSet" "', argument " "2"" of type '" "int""'");
    } 
    arg2 = static_cast< int >(val2);
    {
      try 
      {
        (arg1)->setFinalSet(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setBlockSet) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setBlockSet(self,blockSet);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setBlockSet" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaElementDecl_setBlockSet" "', argument " "2"" of type '" "int""'");
    } 
    arg2 = static_cast< int >(val2);
    {
      try 
      {
        (arg1)->setBlockSet(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setMiscFlags) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setMiscFlags(self,flags);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setMiscFlags" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaElementDecl_setMiscFlags" "', argument " "2"" of type '" "int""'");
    } 
    arg2 = static_cast< int >(val2);
    {
      try 
      {
        (arg1)->setMiscFlags(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setDefaultValue) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setDefaultValue(self,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setDefaultValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SchemaElementDecl_setDefaultValue");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setDefaultValue((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setComplexTypeInfo) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    ComplexTypeInfo *arg2 = (ComplexTypeInfo *) (ComplexTypeInfo *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setComplexTypeInfo(self,typeInfo);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setComplexTypeInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ComplexTypeInfo, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_setComplexTypeInfo" "', argument " "2"" of type '" "ComplexTypeInfo *const""'"); 
    }
    arg2 = reinterpret_cast< ComplexTypeInfo * >(argp2);
    {
      try 
      {
        (arg1)->setComplexTypeInfo(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setXsiComplexTypeInfo) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    ComplexTypeInfo *arg2 = (ComplexTypeInfo *) (ComplexTypeInfo *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setXsiComplexTypeInfo(self,typeInfo);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setXsiComplexTypeInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ComplexTypeInfo, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_setXsiComplexTypeInfo" "', argument " "2"" of type '" "ComplexTypeInfo *const""'"); 
    }
    arg2 = reinterpret_cast< ComplexTypeInfo * >(argp2);
    {
      try 
      {
        (arg1)->setXsiComplexTypeInfo(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setXsiSimpleTypeInfo) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    DatatypeValidator *arg2 = (DatatypeValidator *) (DatatypeValidator *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setXsiSimpleTypeInfo(self,dtv);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setXsiSimpleTypeInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DatatypeValidator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_setXsiSimpleTypeInfo" "', argument " "2"" of type '" "DatatypeValidator const *const""'"); 
    }
    arg2 = reinterpret_cast< DatatypeValidator * >(argp2);
    {
      try 
      {
        (arg1)->setXsiSimpleTypeInfo((DatatypeValidator const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setAttWildCard) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    SchemaAttDef *arg2 = (SchemaAttDef *) (SchemaAttDef *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setAttWildCard(self,attWildCard);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setAttWildCard" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_setAttWildCard" "', argument " "2"" of type '" "SchemaAttDef *const""'"); 
    }
    arg2 = reinterpret_cast< SchemaAttDef * >(argp2);
    {
      try 
      {
        (arg1)->setAttWildCard(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setSubstitutionGroupElem) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg2 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) (XERCES_CPP_NAMESPACE::SchemaElementDecl *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setSubstitutionGroupElem(self,elemDecl);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setSubstitutionGroupElem" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_setSubstitutionGroupElem" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp2);
    {
      try 
      {
        (arg1)->setSubstitutionGroupElem(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setValidity) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    PSVIDefs::Validity arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setValidity(self,valid);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setValidity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_PSVIDefs__Validity,  0 );
      if (!SWIG_IsOK(res2)) {
        SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_setValidity" "', argument " "2"" of type '" "PSVIDefs::Validity""'"); 
      }  
      if (!argp2) {
        SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaElementDecl_setValidity" "', argument " "2"" of type '" "PSVIDefs::Validity""'");
      } else {
        arg2 = *(reinterpret_cast< PSVIDefs::Validity * >(argp2));
      }
    }
    {
      try 
      {
        (arg1)->setValidity(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_setValidationAttempted) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    PSVIDefs::Validation arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_setValidationAttempted(self,validation);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_setValidationAttempted" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_PSVIDefs__Validation,  0 );
      if (!SWIG_IsOK(res2)) {
        SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_setValidationAttempted" "', argument " "2"" of type '" "PSVIDefs::Validation""'"); 
      }  
      if (!argp2) {
        SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaElementDecl_setValidationAttempted" "', argument " "2"" of type '" "PSVIDefs::Validation""'");
      } else {
        arg2 = *(reinterpret_cast< PSVIDefs::Validation * >(argp2));
      }
    }
    {
      try 
      {
        (arg1)->setValidationAttempted(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_updateValidityFromElement) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar::GrammarType arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SchemaElementDecl_updateValidityFromElement(self,decl,eleGrammar);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_updateValidityFromElement" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_updateValidityFromElement" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp2);
    ecode3 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SchemaElementDecl_updateValidityFromElement" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::Grammar::GrammarType""'");
    } 
    arg3 = static_cast< XERCES_CPP_NAMESPACE::Grammar::GrammarType >(val3);
    {
      try 
      {
        (arg1)->updateValidityFromElement((XERCES_CPP_NAMESPACE::XMLElementDecl const *)arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_updateValidityFromAttribute) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    SchemaAttDef *arg2 = (SchemaAttDef *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_updateValidityFromAttribute(self,def);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_updateValidityFromAttribute" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_updateValidityFromAttribute" "', argument " "2"" of type '" "SchemaAttDef const *""'"); 
    }
    arg2 = reinterpret_cast< SchemaAttDef * >(argp2);
    {
      try 
      {
        (arg1)->updateValidityFromAttribute((SchemaAttDef const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_reset) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        (arg1)->reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_addIdentityConstraint) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    IdentityConstraint *arg2 = (IdentityConstraint *) (IdentityConstraint *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_addIdentityConstraint(self,ic);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_addIdentityConstraint" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_IdentityConstraint, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDecl_addIdentityConstraint" "', argument " "2"" of type '" "IdentityConstraint *const""'"); 
    }
    arg2 = reinterpret_cast< IdentityConstraint * >(argp2);
    {
      try 
      {
        (arg1)->addIdentityConstraint(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getIdentityConstraintCount) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getIdentityConstraintCount(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getIdentityConstraintCount" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getIdentityConstraintCount();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getIdentityConstraintAt) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    unsigned int arg2 ;
    IdentityConstraint *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaElementDecl_getIdentityConstraintAt(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getIdentityConstraintAt" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaElementDecl_getIdentityConstraintAt" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (IdentityConstraint *)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getIdentityConstraintAt(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_IdentityConstraint, 0 | 0); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDecl_getObjectType) {
  {
    XERCES_CPP_NAMESPACE::SchemaElementDecl *arg1 = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl::objectType result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDecl_getObjectType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDecl_getObjectType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaElementDecl const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaElementDecl * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl::objectType)((XERCES_CPP_NAMESPACE::SchemaElementDecl const *)arg1)->getObjectType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SchemaElementDeclEnumerator__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) (XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *)0 ;
    bool arg2 ;
    XERCES_CPP_NAMESPACE::MemoryManager *arg3 = (XERCES_CPP_NAMESPACE::MemoryManager *) (XERCES_CPP_NAMESPACE::MemoryManager *)0 ;
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg3 = XERCES_CPP_NAMESPACE::XMLPlatformUtils::fgMemoryManager;
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: new_SchemaElementDeclEnumerator(toEnum,adopt);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_SchemaElementDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *const""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "new_SchemaElementDeclEnumerator" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *)new XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl >(arg1,arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SchemaElementDeclEnumerator__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) (XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *)0 ;
    bool arg2 ;
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: new_SchemaElementDeclEnumerator(toEnum,adopt);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_SchemaElementDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *const""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "new_SchemaElementDeclEnumerator" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *)new XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl >(arg1,arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SchemaElementDeclEnumerator__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) (XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *)0 ;
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_SchemaElementDeclEnumerator(toEnum);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_SchemaElementDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *const""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *)new XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl >(arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_SchemaElementDeclEnumerator) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SchemaElementDeclEnumerator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SchemaElementDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SchemaElementDeclEnumerator__SWIG_3) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *result = 0 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_SchemaElementDeclEnumerator(XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > const &);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_SchemaElementDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > const &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "new_SchemaElementDeclEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > const &""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *)new XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl >((XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > const &)*arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SchemaElementDeclEnumerator) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_SchemaElementDeclEnumerator__SWIG_2); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_SchemaElementDeclEnumerator__SWIG_3); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_SchemaElementDeclEnumerator__SWIG_0); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_SchemaElementDeclEnumerator__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_SchemaElementDeclEnumerator'");
  XSRETURN(0);
}


XS(_wrap_SchemaElementDeclEnumerator_hasMoreElements) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDeclEnumerator_hasMoreElements(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDeclEnumerator_hasMoreElements" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > const *)arg1)->hasMoreElements();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDeclEnumerator_nextElement) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) 0 ;
    XERCES_CPP_NAMESPACE::SchemaElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDeclEnumerator_nextElement(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDeclEnumerator_nextElement" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::SchemaElementDecl &_result_ref = (arg1)->nextElement();
          result = (XERCES_CPP_NAMESPACE::SchemaElementDecl *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDeclEnumerator_Reset) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDeclEnumerator_Reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDeclEnumerator_Reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    {
      try 
      {
        (arg1)->Reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDeclEnumerator_size) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDeclEnumerator_size(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDeclEnumerator_size" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > const *)arg1)->size();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDeclEnumerator_resetKey) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDeclEnumerator_resetKey(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDeclEnumerator_resetKey" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    {
      try 
      {
        (arg1)->resetKey();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDeclEnumerator_nextElementKey) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) 0 ;
    void **arg2 = 0 ;
    int *arg3 = 0 ;
    int *arg4 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: SchemaElementDeclEnumerator_nextElementKey(self,void *&,int &,int &);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDeclEnumerator_nextElementKey" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_p_void,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaElementDeclEnumerator_nextElementKey" "', argument " "2"" of type '" "void *&""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaElementDeclEnumerator_nextElementKey" "', argument " "2"" of type '" "void *&""'"); 
    }
    arg2 = reinterpret_cast< void ** >(argp2);
    res3 = SWIG_ConvertPtr(ST(2), &argp3, SWIGTYPE_p_int,  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "SchemaElementDeclEnumerator_nextElementKey" "', argument " "3"" of type '" "int &""'"); 
    }
    if (!argp3) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaElementDeclEnumerator_nextElementKey" "', argument " "3"" of type '" "int &""'"); 
    }
    arg3 = reinterpret_cast< int * >(argp3);
    res4 = SWIG_ConvertPtr(ST(3), &argp4, SWIGTYPE_p_int,  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "SchemaElementDeclEnumerator_nextElementKey" "', argument " "4"" of type '" "int &""'"); 
    }
    if (!argp4) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaElementDeclEnumerator_nextElementKey" "', argument " "4"" of type '" "int &""'"); 
    }
    arg4 = reinterpret_cast< int * >(argp4);
    {
      try 
      {
        (arg1)->nextElementKey(*arg2,*arg3,*arg4);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaElementDeclEnumerator_hasMoreKeys) {
  {
    XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *arg1 = (XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaElementDeclEnumerator_hasMoreKeys(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaElementDeclEnumerator_hasMoreKeys" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > const *)arg1)->hasMoreKeys();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SchemaGrammar) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_SchemaGrammar();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SchemaGrammar *)new XERCES_CPP_NAMESPACE::SchemaGrammar();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_delete_SchemaGrammar) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SchemaGrammar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SchemaGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getGrammarType) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar::GrammarType result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getGrammarType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getGrammarType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar::GrammarType)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getGrammarType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getTargetNamespace) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getTargetNamespace(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getTargetNamespace" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getTargetNamespace();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_findOrAddElemDecl) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg6 ;
    bool *arg7 = 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val6 ;
    int ecode6 = 0 ;
    void *argp7 = 0 ;
    int res7 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 7) || (items > 7)) {
      SWIG_croak("Usage: SchemaGrammar_findOrAddElemDecl(self,uriId,baseName,prefixName,qName,scope,wasAdded);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_findOrAddElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaGrammar_findOrAddElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaGrammar_findOrAddElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"SchemaGrammar_findOrAddElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"SchemaGrammar_findOrAddElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "SchemaGrammar_findOrAddElemDecl" "', argument " "6"" of type '" "unsigned int""'");
    } 
    arg6 = static_cast< unsigned int >(val6);
    res7 = SWIG_ConvertPtr(ST(6), &argp7, SWIGTYPE_p_bool,  0 );
    if (!SWIG_IsOK(res7)) {
      SWIG_exception_fail(SWIG_ArgError(res7), "in method '" "SchemaGrammar_findOrAddElemDecl" "', argument " "7"" of type '" "bool &""'"); 
    }
    if (!argp7) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaGrammar_findOrAddElemDecl" "', argument " "7"" of type '" "bool &""'"); 
    }
    arg7 = reinterpret_cast< bool * >(argp7);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->findOrAddElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6,*arg7);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getElemId) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg5 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val5 ;
    int ecode5 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: SchemaGrammar_getElemId(self,uriId,baseName,qName,scope);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getElemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaGrammar_getElemId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaGrammar_getElemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"SchemaGrammar_getElemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    ecode5 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(4), &val5);
    if (!SWIG_IsOK(ecode5)) {
      SWIG_exception_fail(SWIG_ArgError(ecode5), "in method '" "SchemaGrammar_getElemId" "', argument " "5"" of type '" "unsigned int""'");
    } 
    arg5 = static_cast< unsigned int >(val5);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getElemId(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,arg5);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getElemDecl__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg5 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val5 ;
    int ecode5 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: SchemaGrammar_getElemDecl(self,uriId,baseName,qName,scope);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaGrammar_getElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaGrammar_getElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"SchemaGrammar_getElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    ecode5 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(4), &val5);
    if (!SWIG_IsOK(ecode5)) {
      SWIG_exception_fail(SWIG_ArgError(ecode5), "in method '" "SchemaGrammar_getElemDecl" "', argument " "5"" of type '" "unsigned int""'");
    } 
    arg5 = static_cast< unsigned int >(val5);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->getElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,arg5);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getElemDecl__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    unsigned int arg2 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_getElemDecl(self,elemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaGrammar_getElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->getElemDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getElemDecl) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 5) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(3)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(4), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaGrammar_getElemDecl__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaGrammar_getElemDecl__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'SchemaGrammar_getElemDecl'");
  XSRETURN(0);
}


XS(_wrap_SchemaGrammar_getNotationDecl) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLNotationDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_getNotationDecl(self,notName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getNotationDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SchemaGrammar_getNotationDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLNotationDecl *)(arg1)->getNotationDecl((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getValidated) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getValidated(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getValidated" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getValidated();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_putElemDecl__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg6 ;
    bool arg7 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val6 ;
    int ecode6 = 0 ;
    bool val7 ;
    int ecode7 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 7) || (items > 7)) {
      SWIG_croak("Usage: SchemaGrammar_putElemDecl(self,uriId,baseName,prefixName,qName,scope,notDeclared);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaGrammar_putElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"SchemaGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"SchemaGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "SchemaGrammar_putElemDecl" "', argument " "6"" of type '" "unsigned int""'");
    } 
    arg6 = static_cast< unsigned int >(val6);
    ecode7 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(6), &val7);
    if (!SWIG_IsOK(ecode7)) {
      SWIG_exception_fail(SWIG_ArgError(ecode7), "in method '" "SchemaGrammar_putElemDecl" "', argument " "7"" of type '" "bool""'");
    } 
    arg7 = static_cast< bool >(val7);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->putElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6,arg7);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_putElemDecl__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg6 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    unsigned int val6 ;
    int ecode6 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 6) || (items > 6)) {
      SWIG_croak("Usage: SchemaGrammar_putElemDecl(self,uriId,baseName,prefixName,qName,scope);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaGrammar_putElemDecl" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"SchemaGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"SchemaGrammar_putElemDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    ecode6 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), &val6);
    if (!SWIG_IsOK(ecode6)) {
      SWIG_exception_fail(SWIG_ArgError(ecode6), "in method '" "SchemaGrammar_putElemDecl" "', argument " "6"" of type '" "unsigned int""'");
    } 
    arg6 = static_cast< unsigned int >(val6);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLElementDecl *)(arg1)->putElemDecl(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,arg6);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_putElemDecl__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) (XERCES_CPP_NAMESPACE::XMLElementDecl *)0 ;
    bool arg3 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    bool val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SchemaGrammar_putElemDecl(self,elemDecl,notDeclared);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_putElemDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp2);
    ecode3 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SchemaGrammar_putElemDecl" "', argument " "3"" of type '" "bool""'");
    } 
    arg3 = static_cast< bool >(val3);
    {
      try 
      {
        result = (unsigned int)(arg1)->putElemDecl(arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_putElemDecl__SWIG_3) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) (XERCES_CPP_NAMESPACE::XMLElementDecl *)0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_putElemDecl(self,elemDecl);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_putElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_putElemDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp2);
    {
      try 
      {
        result = (unsigned int)(arg1)->putElemDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_putElemDecl) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 6) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(3)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(4)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 7) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(3)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(4)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(5), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(6), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaGrammar_putElemDecl__SWIG_3); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaGrammar_putElemDecl__SWIG_2); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaGrammar_putElemDecl__SWIG_1); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaGrammar_putElemDecl__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'SchemaGrammar_putElemDecl'");
  XSRETURN(0);
}


XS(_wrap_SchemaGrammar_putNotationDecl) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLNotationDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLNotationDecl *) (XERCES_CPP_NAMESPACE::XMLNotationDecl *)0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_putNotationDecl(self,notationDecl);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_putNotationDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_putNotationDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLNotationDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLNotationDecl * >(argp2);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->putNotationDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_setValidated) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_setValidated(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_setValidated" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaGrammar_setValidated" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setValidated(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_reset) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        (arg1)->reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getElemEnumerator) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    SwigValueWrapper<XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > > result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getElemEnumerator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getElemEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getElemEnumerator();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl >(static_cast< const XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl >& >(result))), SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, SWIG_POINTER_OWN | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getNotationEnumerator) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    SwigValueWrapper<XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::XMLNotationDecl > > result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getNotationEnumerator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getNotationEnumerator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getNotationEnumerator();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::XMLNotationDecl >(static_cast< const XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::XMLNotationDecl >& >(result))), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__XMLNotationDecl_t, SWIG_POINTER_OWN | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getAttributeDeclRegistry) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHashTableOf<XERCES_CPP_NAMESPACE::XMLAttDef > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getAttributeDeclRegistry(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getAttributeDeclRegistry" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (RefHashTableOf<XERCES_CPP_NAMESPACE::XMLAttDef > *)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getAttributeDeclRegistry();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XMLAttDef_t, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getComplexTypeRegistry) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHashTableOf<XERCES_CPP_NAMESPACE::ComplexTypeInfo > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getComplexTypeRegistry(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getComplexTypeRegistry" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (RefHashTableOf<XERCES_CPP_NAMESPACE::ComplexTypeInfo > *)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getComplexTypeRegistry();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__ComplexTypeInfo_t, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getGroupInfoRegistry) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHashTableOf<XERCES_CPP_NAMESPACE::XercesGroupInfo > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getGroupInfoRegistry(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getGroupInfoRegistry" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (RefHashTableOf<XERCES_CPP_NAMESPACE::XercesGroupInfo > *)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getGroupInfoRegistry();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesGroupInfo_t, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getAttGroupInfoRegistry) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHashTableOf<XERCES_CPP_NAMESPACE::XercesAttGroupInfo > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getAttGroupInfoRegistry(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getAttGroupInfoRegistry" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (RefHashTableOf<XERCES_CPP_NAMESPACE::XercesAttGroupInfo > *)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getAttGroupInfoRegistry();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesAttGroupInfo_t, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getDatatypeRegistry) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    DatatypeValidatorFactory *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getDatatypeRegistry(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getDatatypeRegistry" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (DatatypeValidatorFactory *)(arg1)->getDatatypeRegistry();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_DatatypeValidatorFactory, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getNamespaceScope) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::NamespaceScope *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getNamespaceScope(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getNamespaceScope" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::NamespaceScope *)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getNamespaceScope();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__NamespaceScope, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getValidSubstitutionGroups) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHash2KeysTableOf<XERCES_CPP_NAMESPACE::ElemVector > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getValidSubstitutionGroups(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getValidSubstitutionGroups" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (RefHash2KeysTableOf<XERCES_CPP_NAMESPACE::ElemVector > *)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getValidSubstitutionGroups();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_RefHash2KeysTableOfTValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t_t, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getIDRefList) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHashTableOf<XMLRefInfo > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getIDRefList(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getIDRefList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (RefHashTableOf<XMLRefInfo > *)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getIDRefList();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_RefHashTableOfTXMLRefInfo_t, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getValidationContext) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    ValidationContext *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getValidationContext(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getValidationContext" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (ValidationContext *)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getValidationContext();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_ValidationContext, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_setTargetNamespace) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_setTargetNamespace(self,targetNamespace);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_setTargetNamespace" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SchemaGrammar_setTargetNamespace");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setTargetNamespace((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_setAttributeDeclRegistry) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHashTableOf<XERCES_CPP_NAMESPACE::XMLAttDef > *arg2 = (RefHashTableOf<XERCES_CPP_NAMESPACE::XMLAttDef > *) (RefHashTableOf<XERCES_CPP_NAMESPACE::XMLAttDef > *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_setAttributeDeclRegistry(self,attReg);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_setAttributeDeclRegistry" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XMLAttDef_t, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_setAttributeDeclRegistry" "', argument " "2"" of type '" "RefHashTableOf<XERCES_CPP_NAMESPACE::XMLAttDef > *const""'"); 
    }
    arg2 = reinterpret_cast< RefHashTableOf<XERCES_CPP_NAMESPACE::XMLAttDef > * >(argp2);
    {
      try 
      {
        (arg1)->setAttributeDeclRegistry(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_setComplexTypeRegistry) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHashTableOf<XERCES_CPP_NAMESPACE::ComplexTypeInfo > *arg2 = (RefHashTableOf<XERCES_CPP_NAMESPACE::ComplexTypeInfo > *) (RefHashTableOf<XERCES_CPP_NAMESPACE::ComplexTypeInfo > *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_setComplexTypeRegistry(self,other);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_setComplexTypeRegistry" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__ComplexTypeInfo_t, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_setComplexTypeRegistry" "', argument " "2"" of type '" "RefHashTableOf<XERCES_CPP_NAMESPACE::ComplexTypeInfo > *const""'"); 
    }
    arg2 = reinterpret_cast< RefHashTableOf<XERCES_CPP_NAMESPACE::ComplexTypeInfo > * >(argp2);
    {
      try 
      {
        (arg1)->setComplexTypeRegistry(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_setGroupInfoRegistry) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHashTableOf<XERCES_CPP_NAMESPACE::XercesGroupInfo > *arg2 = (RefHashTableOf<XERCES_CPP_NAMESPACE::XercesGroupInfo > *) (RefHashTableOf<XERCES_CPP_NAMESPACE::XercesGroupInfo > *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_setGroupInfoRegistry(self,other);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_setGroupInfoRegistry" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesGroupInfo_t, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_setGroupInfoRegistry" "', argument " "2"" of type '" "RefHashTableOf<XERCES_CPP_NAMESPACE::XercesGroupInfo > *const""'"); 
    }
    arg2 = reinterpret_cast< RefHashTableOf<XERCES_CPP_NAMESPACE::XercesGroupInfo > * >(argp2);
    {
      try 
      {
        (arg1)->setGroupInfoRegistry(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_setAttGroupInfoRegistry) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHashTableOf<XERCES_CPP_NAMESPACE::XercesAttGroupInfo > *arg2 = (RefHashTableOf<XERCES_CPP_NAMESPACE::XercesAttGroupInfo > *) (RefHashTableOf<XERCES_CPP_NAMESPACE::XercesAttGroupInfo > *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_setAttGroupInfoRegistry(self,other);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_setAttGroupInfoRegistry" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesAttGroupInfo_t, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_setAttGroupInfoRegistry" "', argument " "2"" of type '" "RefHashTableOf<XERCES_CPP_NAMESPACE::XercesAttGroupInfo > *const""'"); 
    }
    arg2 = reinterpret_cast< RefHashTableOf<XERCES_CPP_NAMESPACE::XercesAttGroupInfo > * >(argp2);
    {
      try 
      {
        (arg1)->setAttGroupInfoRegistry(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_setNamespaceScope) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::NamespaceScope *arg2 = (XERCES_CPP_NAMESPACE::NamespaceScope *) (XERCES_CPP_NAMESPACE::NamespaceScope *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_setNamespaceScope(self,nsScope);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_setNamespaceScope" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__NamespaceScope, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_setNamespaceScope" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::NamespaceScope *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::NamespaceScope * >(argp2);
    {
      try 
      {
        (arg1)->setNamespaceScope(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_setValidSubstitutionGroups) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHash2KeysTableOf<XERCES_CPP_NAMESPACE::ElemVector > *arg2 = (RefHash2KeysTableOf<XERCES_CPP_NAMESPACE::ElemVector > *) (RefHash2KeysTableOf<XERCES_CPP_NAMESPACE::ElemVector > *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_setValidSubstitutionGroups(self,RefHash2KeysTableOf<XERCES_CPP_NAMESPACE::ElemVector > *const);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_setValidSubstitutionGroups" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_RefHash2KeysTableOfTValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t_t, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_setValidSubstitutionGroups" "', argument " "2"" of type '" "RefHash2KeysTableOf<XERCES_CPP_NAMESPACE::ElemVector > *const""'"); 
    }
    arg2 = reinterpret_cast< RefHash2KeysTableOf<XERCES_CPP_NAMESPACE::ElemVector > * >(argp2);
    {
      try 
      {
        (arg1)->setValidSubstitutionGroups(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_setGrammarDescription) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLGrammarDescription *arg2 = (XERCES_CPP_NAMESPACE::XMLGrammarDescription *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_setGrammarDescription(self,XERCES_CPP_NAMESPACE::XMLGrammarDescription *);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_setGrammarDescription" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_setGrammarDescription" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLGrammarDescription *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLGrammarDescription * >(argp2);
    {
      try 
      {
        (arg1)->setGrammarDescription(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getGrammarDescription) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLGrammarDescription *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getGrammarDescription(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getGrammarDescription" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLGrammarDescription *)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->getGrammarDescription();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_putGroupElemDecl) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XMLElementDecl *arg2 = (XERCES_CPP_NAMESPACE::XMLElementDecl *) (XERCES_CPP_NAMESPACE::XMLElementDecl *)0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_putGroupElemDecl(self,elemDecl);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_putGroupElemDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_putGroupElemDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLElementDecl *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLElementDecl * >(argp2);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::SchemaGrammar const *)arg1)->putGroupElemDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_putAnnotation) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    void *arg2 = (void *) 0 ;
    XERCES_CPP_NAMESPACE::XSAnnotation *arg3 = (XERCES_CPP_NAMESPACE::XSAnnotation *) (XERCES_CPP_NAMESPACE::XSAnnotation *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SchemaGrammar_putAnnotation(self,key,annotation);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_putAnnotation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      arg2 = (void*) ST(1);
    }
    res3 = SWIG_ConvertPtr(ST(2), &argp3,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XSAnnotation, 0 |  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "SchemaGrammar_putAnnotation" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XSAnnotation *const""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XSAnnotation * >(argp3);
    {
      try 
      {
        (arg1)->putAnnotation(arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_addAnnotation) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XSAnnotation *arg2 = (XERCES_CPP_NAMESPACE::XSAnnotation *) (XERCES_CPP_NAMESPACE::XSAnnotation *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_addAnnotation(self,annotation);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_addAnnotation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XSAnnotation, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaGrammar_addAnnotation" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XSAnnotation *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XSAnnotation * >(argp2);
    {
      try 
      {
        (arg1)->addAnnotation(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getAnnotation__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    void *arg2 = (void *) (void *)0 ;
    XERCES_CPP_NAMESPACE::XSAnnotation *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaGrammar_getAnnotation(self,key);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getAnnotation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      arg2 = (void*) ST(1);
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XSAnnotation *)(arg1)->getAnnotation((void const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XSAnnotation, 0 | 0); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getAnnotation__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    XERCES_CPP_NAMESPACE::XSAnnotation *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getAnnotation(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getAnnotation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XSAnnotation *)(arg1)->getAnnotation();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XSAnnotation, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaGrammar_getAnnotation) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *ptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &ptr, 0, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaGrammar_getAnnotation__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaGrammar_getAnnotation__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'SchemaGrammar_getAnnotation'");
  XSRETURN(0);
}


XS(_wrap_SchemaGrammar_getAnnotations) {
  {
    XERCES_CPP_NAMESPACE::SchemaGrammar *arg1 = (XERCES_CPP_NAMESPACE::SchemaGrammar *) 0 ;
    RefHashTableOf<XERCES_CPP_NAMESPACE::XSAnnotation > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaGrammar_getAnnotations(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaGrammar_getAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaGrammar *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaGrammar * >(argp1);
    {
      try 
      {
        result = (RefHashTableOf<XERCES_CPP_NAMESPACE::XSAnnotation > *)(arg1)->getAnnotations();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XSAnnotation_t, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SchemaValidator__SWIG_0) {
  {
    XMLErrorReporter *arg1 = (XMLErrorReporter *) (XMLErrorReporter *)0 ;
    XERCES_CPP_NAMESPACE::SchemaValidator *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_SchemaValidator(errReporter);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XMLErrorReporter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_SchemaValidator" "', argument " "1"" of type '" "XMLErrorReporter *const""'"); 
    }
    arg1 = reinterpret_cast< XMLErrorReporter * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SchemaValidator *)new XERCES_CPP_NAMESPACE::SchemaValidator(arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SchemaValidator__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_SchemaValidator();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SchemaValidator *)new XERCES_CPP_NAMESPACE::SchemaValidator();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_SchemaValidator) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XMLErrorReporter, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_SchemaValidator__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_SchemaValidator__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'new_SchemaValidator'");
  XSRETURN(0);
}


XS(_wrap_delete_SchemaValidator) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SchemaValidator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SchemaValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_getGrammar) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaValidator_getGrammar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_getGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)((XERCES_CPP_NAMESPACE::SchemaValidator const *)arg1)->getGrammar();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_setGrammar) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar *arg2 = (XERCES_CPP_NAMESPACE::Grammar *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaValidator_setGrammar(self,aGrammar);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_setGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaValidator_setGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::Grammar *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::Grammar * >(argp2);
    {
      try 
      {
        (arg1)->setGrammar(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_normalizeWhiteSpace) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    XERCES_CPP_NAMESPACE::DatatypeValidator *arg2 = (XERCES_CPP_NAMESPACE::DatatypeValidator *) 0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLBuffer *arg4 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: SchemaValidator_normalizeWhiteSpace(self,dV,value,toFill);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_normalizeWhiteSpace" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DatatypeValidator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaValidator_normalizeWhiteSpace" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DatatypeValidator *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DatatypeValidator * >(argp2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaValidator_normalizeWhiteSpace");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    res4 = SWIG_ConvertPtr(ST(3), &argp4, SWIGTYPE_p_XMLBuffer,  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "SchemaValidator_normalizeWhiteSpace" "', argument " "4"" of type '" "XMLBuffer &""'"); 
    }
    if (!argp4) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaValidator_normalizeWhiteSpace" "', argument " "4"" of type '" "XMLBuffer &""'"); 
    }
    arg4 = reinterpret_cast< XMLBuffer * >(argp4);
    {
      try 
      {
        (arg1)->normalizeWhiteSpace(arg2,(XMLCh const *)arg3,*arg4);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_setGrammarResolver) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    XERCES_CPP_NAMESPACE::GrammarResolver *arg2 = (XERCES_CPP_NAMESPACE::GrammarResolver *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaValidator_setGrammarResolver(self,grammarResolver);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_setGrammarResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__GrammarResolver, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaValidator_setGrammarResolver" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::GrammarResolver *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::GrammarResolver * >(argp2);
    {
      try 
      {
        (arg1)->setGrammarResolver(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_setXsiType) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg4 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: SchemaValidator_setXsiType(self,prefix,localPart,uriId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_setXsiType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SchemaValidator_setXsiType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaValidator_setXsiType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    ecode4 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "SchemaValidator_setXsiType" "', argument " "4"" of type '" "unsigned int""'");
    } 
    arg4 = static_cast< unsigned int >(val4);
    {
      try 
      {
        (arg1)->setXsiType((XMLCh const *)arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_setNillable) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaValidator_setNillable(self,isNil);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_setNillable" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaValidator_setNillable" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setNillable(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_setExitOnFirstFatal) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaValidator_setExitOnFirstFatal(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_setExitOnFirstFatal" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaValidator_setExitOnFirstFatal" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setExitOnFirstFatal(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_setDatatypeBuffer) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaValidator_setDatatypeBuffer(self,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_setDatatypeBuffer" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SchemaValidator_setDatatypeBuffer");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setDatatypeBuffer((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_clearDatatypeBuffer) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaValidator_clearDatatypeBuffer(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_clearDatatypeBuffer" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    {
      try 
      {
        (arg1)->clearDatatypeBuffer();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_getCurrentTypeInfo) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    XERCES_CPP_NAMESPACE::ComplexTypeInfo *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaValidator_getCurrentTypeInfo(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_getCurrentTypeInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::ComplexTypeInfo *)((XERCES_CPP_NAMESPACE::SchemaValidator const *)arg1)->getCurrentTypeInfo();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__ComplexTypeInfo, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_getCurrentDatatypeValidator) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    XERCES_CPP_NAMESPACE::DatatypeValidator *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaValidator_getCurrentDatatypeValidator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_getCurrentDatatypeValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DatatypeValidator *)((XERCES_CPP_NAMESPACE::SchemaValidator const *)arg1)->getCurrentDatatypeValidator();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DatatypeValidator, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_getMostRecentAttrValidator) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    XERCES_CPP_NAMESPACE::DatatypeValidator *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaValidator_getMostRecentAttrValidator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_getMostRecentAttrValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DatatypeValidator *)((XERCES_CPP_NAMESPACE::SchemaValidator const *)arg1)->getMostRecentAttrValidator();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DatatypeValidator, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_getErrorOccurred) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaValidator_getErrorOccurred(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_getErrorOccurred" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaValidator const *)arg1)->getErrorOccurred();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_getIsElemSpecified) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaValidator_getIsElemSpecified(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_getIsElemSpecified" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaValidator const *)arg1)->getIsElemSpecified();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaValidator_getNormalizedValue) {
  {
    XERCES_CPP_NAMESPACE::SchemaValidator *arg1 = (XERCES_CPP_NAMESPACE::SchemaValidator *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaValidator_getNormalizedValue(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaValidator_getNormalizedValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaValidator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaValidator * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaValidator const *)arg1)->getNormalizedValue();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_SchemaAttDefList) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDefList *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDefList *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SchemaAttDefList(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SchemaAttDefList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDefList * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDefList_hasMoreElements) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDefList *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDefList *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDefList_hasMoreElements(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDefList_hasMoreElements" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDefList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDefList * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaAttDefList const *)arg1)->hasMoreElements();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDefList_isEmpty) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDefList *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDefList *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDefList_isEmpty(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDefList_isEmpty" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDefList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDefList * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaAttDefList const *)arg1)->isEmpty();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDefList_findAttDef__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDefList *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDefList *) 0 ;
    unsigned long arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SchemaAttDefList_findAttDef(self,uriID,attName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDefList_findAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDefList * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaAttDefList_findAttDef" "', argument " "2"" of type '" "unsigned long""'");
    } 
    arg2 = static_cast< unsigned long >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaAttDefList_findAttDef");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef *)(arg1)->findAttDef(arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDefList_findAttDef__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDefList *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDefList *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SchemaAttDefList_findAttDef(self,attURI,attName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDefList_findAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDefList * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SchemaAttDefList_findAttDef");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaAttDefList_findAttDef");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef *)(arg1)->findAttDef((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDefList_findAttDef) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaAttDefList_findAttDef__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaAttDefList_findAttDef__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'SchemaAttDefList_findAttDef'");
  XSRETURN(0);
}


XS(_wrap_SchemaAttDefList_findAttDefLocalPart) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDefList *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDefList *) 0 ;
    unsigned long arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SchemaAttDefList_findAttDefLocalPart(self,uriID,attLocalPart);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDefList_findAttDefLocalPart" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDefList * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaAttDefList_findAttDefLocalPart" "', argument " "2"" of type '" "unsigned long""'");
    } 
    arg2 = static_cast< unsigned long >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaAttDefList_findAttDefLocalPart");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLAttDef *)(arg1)->findAttDefLocalPart(arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDefList_nextElement) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDefList *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDefList *) 0 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDefList_nextElement(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDefList_nextElement" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDefList * >(argp1);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::XMLAttDef &_result_ref = (arg1)->nextElement();
          result = (XERCES_CPP_NAMESPACE::XMLAttDef *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDefList_Reset) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDefList *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDefList *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDefList_Reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDefList_Reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDefList * >(argp1);
    {
      try 
      {
        (arg1)->Reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDefList_getAttDefCount) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDefList *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDefList *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDefList_getAttDefCount(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDefList_getAttDefCount" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDefList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDefList * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::SchemaAttDefList const *)arg1)->getAttDefCount();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDefList_getAttDef) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDefList *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDefList *) 0 ;
    unsigned int arg2 ;
    XERCES_CPP_NAMESPACE::XMLAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaAttDefList_getAttDef(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDefList_getAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDefList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDefList * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaAttDefList_getAttDef" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::XMLAttDef &_result_ref = (arg1)->getAttDef(arg2);
          result = (XERCES_CPP_NAMESPACE::XMLAttDef *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_SchemaAttDef) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SchemaAttDef(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SchemaAttDef" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getFullName) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getFullName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getFullName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getFullName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_reset) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        (arg1)->reset();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getValidity) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    PSVIDefs::Validity result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getValidity(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getValidity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getValidity();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new PSVIDefs::Validity(static_cast< const PSVIDefs::Validity& >(result))), SWIGTYPE_p_PSVIDefs__Validity, SWIG_POINTER_OWN | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getValidationAttempted) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    PSVIDefs::Validation result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getValidationAttempted(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getValidationAttempted" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getValidationAttempted();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new PSVIDefs::Validation(static_cast< const PSVIDefs::Validation& >(result))), SWIGTYPE_p_PSVIDefs__Validation, SWIG_POINTER_OWN | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getTypeType) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    PSVIDefs::Complexity result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getTypeType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getTypeType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getTypeType();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new PSVIDefs::Complexity(static_cast< const PSVIDefs::Complexity& >(result))), SWIGTYPE_p_PSVIDefs__Complexity, SWIG_POINTER_OWN | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getTypeUri) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getTypeUri(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getTypeUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getTypeUri();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getTypeName) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getTypeName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getTypeName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getTypeName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getTypeAnonymous) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getTypeAnonymous(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getTypeAnonymous" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getTypeAnonymous();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_isTypeDefinitionUnion) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_isTypeDefinitionUnion(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_isTypeDefinitionUnion" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->isTypeDefinitionUnion();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getMemberTypeUri) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getMemberTypeUri(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getMemberTypeUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getMemberTypeUri();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getMemberTypeAnonymous) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getMemberTypeAnonymous(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getMemberTypeAnonymous" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getMemberTypeAnonymous();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getMemberTypeName) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getMemberTypeName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getMemberTypeName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getMemberTypeName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getDOMTypeInfoUri) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getDOMTypeInfoUri(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getDOMTypeInfoUri" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getDOMTypeInfoUri();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getDOMTypeInfoName) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getDOMTypeInfoName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getDOMTypeInfoName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getDOMTypeInfoName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getElemId) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getElemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getElemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getElemId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getAttName) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::QName *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getAttName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getAttName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::QName *)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getAttName();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getDatatypeValidator) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::DatatypeValidator *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getDatatypeValidator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getDatatypeValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DatatypeValidator *)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getDatatypeValidator();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DatatypeValidator, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getNamespaceList) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    ValueVectorOf<unsigned int > *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getNamespaceList(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getNamespaceList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (ValueVectorOf<unsigned int > *)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getNamespaceList();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_ValueVectorOfTunsigned_int_t, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getBaseAttDecl) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::SchemaAttDef *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getBaseAttDecl(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getBaseAttDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SchemaAttDef *)(arg1)->getBaseAttDecl();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getPSVIScope) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    PSVIDefs::PSVIScope result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getPSVIScope(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getPSVIScope" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = ((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getPSVIScope();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj((new PSVIDefs::PSVIScope(static_cast< const PSVIDefs::PSVIScope& >(result))), SWIGTYPE_p_PSVIDefs__PSVIScope, SWIG_POINTER_OWN | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_getEnclosingCT) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::ComplexTypeInfo *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_getEnclosingCT(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_getEnclosingCT" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::ComplexTypeInfo *)((XERCES_CPP_NAMESPACE::SchemaAttDef const *)arg1)->getEnclosingCT();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__ComplexTypeInfo, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setElemId) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    unsigned int arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaAttDef_setElemId(self,newId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setElemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SchemaAttDef_setElemId" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        (arg1)->setElemId(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setAttName__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    int arg4 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: SchemaAttDef_setAttName(self,prefix,localPart,uriId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setAttName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SchemaAttDef_setAttName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaAttDef_setAttName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    ecode4 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "SchemaAttDef_setAttName" "', argument " "4"" of type '" "int""'");
    } 
    arg4 = static_cast< int >(val4);
    {
      try 
      {
        (arg1)->setAttName((XMLCh const *)arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setAttName__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SchemaAttDef_setAttName(self,prefix,localPart);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setAttName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SchemaAttDef_setAttName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SchemaAttDef_setAttName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->setAttName((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setAttName) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaAttDef_setAttName__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SchemaAttDef_setAttName__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'SchemaAttDef_setAttName'");
  XSRETURN(0);
}


XS(_wrap_SchemaAttDef_setDatatypeValidator) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::DatatypeValidator *arg2 = (XERCES_CPP_NAMESPACE::DatatypeValidator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaAttDef_setDatatypeValidator(self,newDatatypeValidator);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setDatatypeValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DatatypeValidator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaAttDef_setDatatypeValidator" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DatatypeValidator *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DatatypeValidator * >(argp2);
    {
      try 
      {
        (arg1)->setDatatypeValidator(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setAnyDatatypeValidator) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::DatatypeValidator *arg2 = (XERCES_CPP_NAMESPACE::DatatypeValidator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaAttDef_setAnyDatatypeValidator(self,newDatatypeValidator);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setAnyDatatypeValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DatatypeValidator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaAttDef_setAnyDatatypeValidator" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DatatypeValidator *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DatatypeValidator * >(argp2);
    {
      try 
      {
        (arg1)->setAnyDatatypeValidator(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setBaseAttDecl) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg2 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) (XERCES_CPP_NAMESPACE::SchemaAttDef *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaAttDef_setBaseAttDecl(self,attDef);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setBaseAttDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaAttDef_setBaseAttDecl" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp2);
    {
      try 
      {
        (arg1)->setBaseAttDecl(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setPSVIScope) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    PSVIDefs::PSVIScope arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaAttDef_setPSVIScope(self,toSet);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setPSVIScope" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_PSVIDefs__PSVIScope,  0 );
      if (!SWIG_IsOK(res2)) {
        SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaAttDef_setPSVIScope" "', argument " "2"" of type '" "PSVIDefs::PSVIScope const""'"); 
      }  
      if (!argp2) {
        SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaAttDef_setPSVIScope" "', argument " "2"" of type '" "PSVIDefs::PSVIScope const""'");
      } else {
        arg2 = *(reinterpret_cast< PSVIDefs::PSVIScope * >(argp2));
      }
    }
    {
      try 
      {
        (arg1)->setPSVIScope(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setMembertypeValidator) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::DatatypeValidator *arg2 = (XERCES_CPP_NAMESPACE::DatatypeValidator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaAttDef_setMembertypeValidator(self,newDatatypeValidator);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setMembertypeValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DatatypeValidator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaAttDef_setMembertypeValidator" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DatatypeValidator const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DatatypeValidator * >(argp2);
    {
      try 
      {
        (arg1)->setMembertypeValidator((XERCES_CPP_NAMESPACE::DatatypeValidator const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setNamespaceList) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    ValueVectorOf<unsigned int > *arg2 = (ValueVectorOf<unsigned int > *) (ValueVectorOf<unsigned int > *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaAttDef_setNamespaceList(self,toSet);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setNamespaceList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_ValueVectorOfTunsigned_int_t, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaAttDef_setNamespaceList" "', argument " "2"" of type '" "ValueVectorOf<unsigned int > const *const""'"); 
    }
    arg2 = reinterpret_cast< ValueVectorOf<unsigned int > * >(argp2);
    {
      try 
      {
        (arg1)->setNamespaceList((ValueVectorOf<unsigned int > const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_resetNamespaceList) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SchemaAttDef_resetNamespaceList(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_resetNamespaceList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      try 
      {
        (arg1)->resetNamespaceList();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setValidity) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    PSVIDefs::Validity arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaAttDef_setValidity(self,valid);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setValidity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_PSVIDefs__Validity,  0 );
      if (!SWIG_IsOK(res2)) {
        SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaAttDef_setValidity" "', argument " "2"" of type '" "PSVIDefs::Validity""'"); 
      }  
      if (!argp2) {
        SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaAttDef_setValidity" "', argument " "2"" of type '" "PSVIDefs::Validity""'");
      } else {
        arg2 = *(reinterpret_cast< PSVIDefs::Validity * >(argp2));
      }
    }
    {
      try 
      {
        (arg1)->setValidity(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setValidationAttempted) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    PSVIDefs::Validation arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaAttDef_setValidationAttempted(self,validation);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setValidationAttempted" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    {
      res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_PSVIDefs__Validation,  0 );
      if (!SWIG_IsOK(res2)) {
        SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaAttDef_setValidationAttempted" "', argument " "2"" of type '" "PSVIDefs::Validation""'"); 
      }  
      if (!argp2) {
        SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SchemaAttDef_setValidationAttempted" "', argument " "2"" of type '" "PSVIDefs::Validation""'");
      } else {
        arg2 = *(reinterpret_cast< PSVIDefs::Validation * >(argp2));
      }
    }
    {
      try 
      {
        (arg1)->setValidationAttempted(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SchemaAttDef_setEnclosingCT) {
  {
    XERCES_CPP_NAMESPACE::SchemaAttDef *arg1 = (XERCES_CPP_NAMESPACE::SchemaAttDef *) 0 ;
    XERCES_CPP_NAMESPACE::ComplexTypeInfo *arg2 = (XERCES_CPP_NAMESPACE::ComplexTypeInfo *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SchemaAttDef_setEnclosingCT(self,complexTypeInfo);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SchemaAttDef_setEnclosingCT" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SchemaAttDef *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SchemaAttDef * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ComplexTypeInfo, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SchemaAttDef_setEnclosingCT" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::ComplexTypeInfo *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::ComplexTypeInfo * >(argp2);
    {
      try 
      {
        (arg1)->setEnclosingCT(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_InputSource) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_InputSource(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_InputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_InputSource_makeStream) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) 0 ;
    XERCES_CPP_NAMESPACE::BinInputStream *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: InputSource_makeStream(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "InputSource_makeStream" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::BinInputStream *)((XERCES_CPP_NAMESPACE::InputSource const *)arg1)->makeStream();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__BinInputStream, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_InputSource_getEncoding) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: InputSource_getEncoding(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "InputSource_getEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::InputSource const *)arg1)->getEncoding();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_InputSource_getPublicId) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: InputSource_getPublicId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "InputSource_getPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::InputSource const *)arg1)->getPublicId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_InputSource_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: InputSource_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "InputSource_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::InputSource const *)arg1)->getSystemId();
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_InputSource_getIssueFatalErrorIfNotFound) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: InputSource_getIssueFatalErrorIfNotFound(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "InputSource_getIssueFatalErrorIfNotFound" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::InputSource const *)arg1)->getIssueFatalErrorIfNotFound();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_InputSource_getMemoryManager) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) 0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: InputSource_getMemoryManager(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "InputSource_getMemoryManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemoryManager *)((XERCES_CPP_NAMESPACE::InputSource const *)arg1)->getMemoryManager();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemoryManager, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_InputSource_setEncoding) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: InputSource_setEncoding(self,encodingStr);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "InputSource_setEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"InputSource_setEncoding");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setEncoding((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_InputSource_setPublicId) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: InputSource_setPublicId(self,publicId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "InputSource_setPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"InputSource_setPublicId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setPublicId((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_InputSource_setSystemId) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: InputSource_setSystemId(self,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "InputSource_setSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"InputSource_setSystemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setSystemId((XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_InputSource_setIssueFatalErrorIfNotFound) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: InputSource_setIssueFatalErrorIfNotFound(self,flag);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "InputSource_setIssueFatalErrorIfNotFound" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "InputSource_setIssueFatalErrorIfNotFound" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIssueFatalErrorIfNotFound(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_LocalFileInputSource__SWIG_0) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::LocalFileInputSource *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: new_LocalFileInputSource(basePath,relativePath);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_LocalFileInputSource");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"new_LocalFileInputSource");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::LocalFileInputSource *)new XERCES_CPP_NAMESPACE::LocalFileInputSource((XMLCh const *)arg1,(XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileInputSource, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_LocalFileInputSource__SWIG_1) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::LocalFileInputSource *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_LocalFileInputSource(filePath);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_LocalFileInputSource");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::LocalFileInputSource *)new XERCES_CPP_NAMESPACE::LocalFileInputSource((XMLCh const *)arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileInputSource, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_LocalFileInputSource) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_LocalFileInputSource__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_LocalFileInputSource__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'new_LocalFileInputSource'");
  XSRETURN(0);
}


XS(_wrap_delete_LocalFileInputSource) {
  {
    XERCES_CPP_NAMESPACE::LocalFileInputSource *arg1 = (XERCES_CPP_NAMESPACE::LocalFileInputSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_LocalFileInputSource(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileInputSource, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_LocalFileInputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LocalFileInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LocalFileInputSource * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_LocalFileInputSource_makeStream) {
  {
    XERCES_CPP_NAMESPACE::LocalFileInputSource *arg1 = (XERCES_CPP_NAMESPACE::LocalFileInputSource *) 0 ;
    XERCES_CPP_NAMESPACE::BinInputStream *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: LocalFileInputSource_makeStream(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "LocalFileInputSource_makeStream" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LocalFileInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LocalFileInputSource * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::BinInputStream *)((XERCES_CPP_NAMESPACE::LocalFileInputSource const *)arg1)->makeStream();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__BinInputStream, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_StdInInputSource) {
  {
    XERCES_CPP_NAMESPACE::StdInInputSource *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_StdInInputSource();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::StdInInputSource *)new XERCES_CPP_NAMESPACE::StdInInputSource();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__StdInInputSource, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_delete_StdInInputSource) {
  {
    XERCES_CPP_NAMESPACE::StdInInputSource *arg1 = (XERCES_CPP_NAMESPACE::StdInInputSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_StdInInputSource(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__StdInInputSource, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_StdInInputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::StdInInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::StdInInputSource * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_StdInInputSource_makeStream) {
  {
    XERCES_CPP_NAMESPACE::StdInInputSource *arg1 = (XERCES_CPP_NAMESPACE::StdInInputSource *) 0 ;
    XERCES_CPP_NAMESPACE::BinInputStream *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: StdInInputSource_makeStream(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__StdInInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "StdInInputSource_makeStream" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::StdInInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::StdInInputSource * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::BinInputStream *)((XERCES_CPP_NAMESPACE::StdInInputSource const *)arg1)->makeStream();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__BinInputStream, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_URLInputSource__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XMLURL *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::URLInputSource *result = 0 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_URLInputSource(urlId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_URLInputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "new_URLInputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLURL const &""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLURL * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::URLInputSource *)new XERCES_CPP_NAMESPACE::URLInputSource((XERCES_CPP_NAMESPACE::XMLURL const &)*arg1);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__URLInputSource, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_URLInputSource__SWIG_1) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::URLInputSource *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: new_URLInputSource(baseId,systemId);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_URLInputSource");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"new_URLInputSource");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::URLInputSource *)new XERCES_CPP_NAMESPACE::URLInputSource((XMLCh const *)arg1,(XMLCh const *)arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__URLInputSource, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_URLInputSource__SWIG_2) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::URLInputSource *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: new_URLInputSource(baseId,systemId,publicId);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_URLInputSource");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"new_URLInputSource");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"new_URLInputSource");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::URLInputSource *)new XERCES_CPP_NAMESPACE::URLInputSource((XMLCh const *)arg1,(XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__URLInputSource, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_URLInputSource) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_URLInputSource__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_URLInputSource__SWIG_1); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_URLInputSource__SWIG_2); return;
    }
  }
  
  croak("No matching function for overloaded 'new_URLInputSource'");
  XSRETURN(0);
}


XS(_wrap_delete_URLInputSource) {
  {
    XERCES_CPP_NAMESPACE::URLInputSource *arg1 = (XERCES_CPP_NAMESPACE::URLInputSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_URLInputSource(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__URLInputSource, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_URLInputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::URLInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::URLInputSource * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_URLInputSource_makeStream) {
  {
    XERCES_CPP_NAMESPACE::URLInputSource *arg1 = (XERCES_CPP_NAMESPACE::URLInputSource *) 0 ;
    XERCES_CPP_NAMESPACE::BinInputStream *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: URLInputSource_makeStream(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__URLInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "URLInputSource_makeStream" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::URLInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::URLInputSource * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::BinInputStream *)((XERCES_CPP_NAMESPACE::URLInputSource const *)arg1)->makeStream();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__BinInputStream, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_URLInputSource_urlSrc) {
  {
    XERCES_CPP_NAMESPACE::URLInputSource *arg1 = (XERCES_CPP_NAMESPACE::URLInputSource *) 0 ;
    XERCES_CPP_NAMESPACE::XMLURL *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: URLInputSource_urlSrc(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__URLInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "URLInputSource_urlSrc" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::URLInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::URLInputSource * >(argp1);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::XMLURL const &_result_ref = ((XERCES_CPP_NAMESPACE::URLInputSource const *)arg1)->urlSrc();
          result = (XERCES_CPP_NAMESPACE::XMLURL *) &_result_ref;
        }
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_MemBufInputSource) {
  {
    XMLByte *arg1 = (XMLByte *) (XMLByte *)0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    bool arg4 ;
    XERCES_CPP_NAMESPACE::MemBufInputSource *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg4 = true;
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: new_MemBufInputSource(srcDocBytes,byteCount,bufId);");
    }
    {
      if (SvPOK(ST(0))||SvIOK(ST(0))||SvNOK(ST(0))) {
        STRLEN len;
        XMLByte *xmlbytes = (XMLByte *)SvPV(ST(0), len);
        arg2 = len;
        arg1 = new XMLByte[len];
        memcpy(arg1, xmlbytes, len);
      } else {
        SWIG_croak("Type error in argument 2 of new_MemBufInputSource, Expected perl-string.");
      }
    }
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"new_MemBufInputSource");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemBufInputSource *)new XERCES_CPP_NAMESPACE::MemBufInputSource((XMLByte const *)arg1,arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufInputSource, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_MemBufInputSource) {
  {
    XERCES_CPP_NAMESPACE::MemBufInputSource *arg1 = (XERCES_CPP_NAMESPACE::MemBufInputSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_MemBufInputSource(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufInputSource, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_MemBufInputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::MemBufInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::MemBufInputSource * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_MemBufInputSource_makeStream) {
  {
    XERCES_CPP_NAMESPACE::MemBufInputSource *arg1 = (XERCES_CPP_NAMESPACE::MemBufInputSource *) 0 ;
    XERCES_CPP_NAMESPACE::BinInputStream *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: MemBufInputSource_makeStream(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "MemBufInputSource_makeStream" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::MemBufInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::MemBufInputSource * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::BinInputStream *)((XERCES_CPP_NAMESPACE::MemBufInputSource const *)arg1)->makeStream();
        
      } 
      CATCH_XML_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__BinInputStream, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_MemBufInputSource_setCopyBufToStream) {
  {
    XERCES_CPP_NAMESPACE::MemBufInputSource *arg1 = (XERCES_CPP_NAMESPACE::MemBufInputSource *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: MemBufInputSource_setCopyBufToStream(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "MemBufInputSource_setCopyBufToStream" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::MemBufInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::MemBufInputSource * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "MemBufInputSource_setCopyBufToStream" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setCopyBufToStream(arg2);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_MemBufInputSource_resetMemBufInputSource) {
  {
    XERCES_CPP_NAMESPACE::MemBufInputSource *arg1 = (XERCES_CPP_NAMESPACE::MemBufInputSource *) 0 ;
    XMLByte *arg2 = (XMLByte *) (XMLByte *)0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: MemBufInputSource_resetMemBufInputSource(self,srcDocBytes,byteCount);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "MemBufInputSource_resetMemBufInputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::MemBufInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::MemBufInputSource * >(argp1);
    {
      if (SvPOK(ST(1))||SvIOK(ST(1))||SvNOK(ST(1))) {
        STRLEN len;
        XMLByte *xmlbytes = (XMLByte *)SvPV(ST(1), len);
        arg3 = len;
        arg2 = new XMLByte[len];
        memcpy(arg2, xmlbytes, len);
      } else {
        SWIG_croak("Type error in argument 2 of MemBufInputSource_resetMemBufInputSource, Expected perl-string.");
      }
    }
    {
      try 
      {
        (arg1)->resetMemBufInputSource((XMLByte const *)arg2,arg3);
        
      } 
      CATCH_XML_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMException) {
  {
    XERCES_CPP_NAMESPACE::DOMException *arg1 = (XERCES_CPP_NAMESPACE::DOMException *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMException(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMException, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMException" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMException * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMException_getMessage) {
  {
    XERCES_CPP_NAMESPACE::DOMException *arg1 = (XERCES_CPP_NAMESPACE::DOMException *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMException_getMessage(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMException_getMessage" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMException * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMException const *)arg1)->getMessage();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMException_code_set) {
  {
    XERCES_CPP_NAMESPACE::DOMException *arg1 = (XERCES_CPP_NAMESPACE::DOMException *) 0 ;
    XERCES_CPP_NAMESPACE::DOMException::ExceptionCode arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMException_code_set(self,code);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMException_code_set" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMException * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMException_code_set" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMException::ExceptionCode""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::DOMException::ExceptionCode >(val2);
    if (arg1) (arg1)->code = arg2;
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMException_code_get) {
  {
    XERCES_CPP_NAMESPACE::DOMException *arg1 = (XERCES_CPP_NAMESPACE::DOMException *) 0 ;
    XERCES_CPP_NAMESPACE::DOMException::ExceptionCode result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMException_code_get(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMException_code_get" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMException * >(argp1);
    result = (XERCES_CPP_NAMESPACE::DOMException::ExceptionCode) ((arg1)->code);
    
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMException_msg_set) {
  {
    XERCES_CPP_NAMESPACE::DOMException *arg1 = (XERCES_CPP_NAMESPACE::DOMException *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMException_msg_set(self,msg);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMException_msg_set" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMException * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMException_msg_set");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    if (arg1) (arg1)->msg = (XMLCh const *)arg2;
    
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMException_msg_get) {
  {
    XERCES_CPP_NAMESPACE::DOMException *arg1 = (XERCES_CPP_NAMESPACE::DOMException *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMException_msg_get(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMException_msg_get" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMException * >(argp1);
    result = (XMLCh *) ((arg1)->msg);
    
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMNode) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMNode(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getNodeName) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getNodeName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getNodeName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getNodeName();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getNodeValue) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getNodeValue(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getNodeValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getNodeValue();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getNodeType) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    short result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getNodeType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getNodeType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (short)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getNodeType();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_short  SWIG_PERL_CALL_ARGS_1(static_cast< short >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getParentNode) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getParentNode(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getParentNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getParentNode();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getChildNodes) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNodeList *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getChildNodes(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getChildNodes" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNodeList *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getChildNodes();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeList, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getFirstChild) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getFirstChild(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getFirstChild" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getFirstChild();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getLastChild) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getLastChild(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getLastChild" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getLastChild();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getPreviousSibling) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getPreviousSibling(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getPreviousSibling" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getPreviousSibling();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getNextSibling) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getNextSibling(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getNextSibling" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getNextSibling();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getAttributes) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getAttributes(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getAttributes" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getAttributes();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getOwnerDocument) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocument *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getOwnerDocument(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getOwnerDocument" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocument *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getOwnerDocument();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_cloneNode) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    bool arg2 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_cloneNode(self,deep);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_cloneNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMNode_cloneNode" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->cloneNode(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_insertBefore) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg3 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMNode_insertBefore(self,newChild,refChild);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_insertBefore" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNode_insertBefore" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    res3 = SWIG_ConvertPtr(ST(2), &argp3,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "DOMNode_insertBefore" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->insertBefore(arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_replaceChild) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg3 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMNode_replaceChild(self,newChild,oldChild);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_replaceChild" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNode_replaceChild" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    res3 = SWIG_ConvertPtr(ST(2), &argp3,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "DOMNode_replaceChild" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->replaceChild(arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_removeChild) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_removeChild(self,oldChild);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_removeChild" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNode_removeChild" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->removeChild(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_appendChild) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_appendChild(self,newChild);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_appendChild" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNode_appendChild" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->appendChild(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_hasChildNodes) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_hasChildNodes(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_hasChildNodes" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->hasChildNodes();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_setNodeValue) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_setNodeValue(self,nodeValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_setNodeValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNode_setNodeValue");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setNodeValue((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_normalize) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_normalize(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_normalize" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        (arg1)->normalize();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_isSupported) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMNode_isSupported(self,feature,version);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_isSupported" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNode_isSupported");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMNode_isSupported");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->isSupported((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getNamespaceURI) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getNamespaceURI(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getNamespaceURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getNamespaceURI();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getLocalName) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getLocalName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getLocalName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getLocalName();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_setPrefix) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_setPrefix(self,prefix);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_setPrefix" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNode_setPrefix");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setPrefix((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_hasAttributes) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_hasAttributes(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_hasAttributes" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->hasAttributes();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_isSameNode) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_isSameNode(self,other);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_isSameNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNode_isSameNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->isSameNode((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_isEqualNode) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_isEqualNode(self,arg);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_isEqualNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNode_isEqualNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->isEqualNode((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_setUserData) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *arg3 = (void *) 0 ;
    XERCES_CPP_NAMESPACE::DOMUserDataHandler *arg4 = (XERCES_CPP_NAMESPACE::DOMUserDataHandler *) 0 ;
    void *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DOMNode_setUserData(self,key,data,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_setUserData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNode_setUserData");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      arg3 = (void*) ST(2);
    }
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMUserDataHandler, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "DOMNode_setUserData" "', argument " "4"" of type '" "XERCES_CPP_NAMESPACE::DOMUserDataHandler *""'"); 
    }
    arg4 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMUserDataHandler * >(argp4);
    {
      try 
      {
        result = (void *)(arg1)->setUserData((XMLCh const *)arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_void, 0 | 0); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getUserData) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_getUserData(self,key);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getUserData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNode_getUserData");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (void *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getUserData((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_void, 0 | 0); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getBaseURI) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getBaseURI(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getBaseURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getBaseURI();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_compareTreePosition) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    short result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_compareTreePosition(self,other);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_compareTreePosition" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNode_compareTreePosition" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (short)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->compareTreePosition((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_short  SWIG_PERL_CALL_ARGS_1(static_cast< short >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getTextContent) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_getTextContent(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getTextContent" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->getTextContent();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_setTextContent) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_setTextContent(self,textContent);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_setTextContent" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNode_setTextContent");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setTextContent((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_lookupNamespacePrefix) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    bool arg3 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMNode_lookupNamespacePrefix(self,namespaceURI,useDefault);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_lookupNamespacePrefix" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNode_lookupNamespacePrefix");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMNode_lookupNamespacePrefix" "', argument " "3"" of type '" "bool""'");
    } 
    arg3 = static_cast< bool >(val3);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->lookupNamespacePrefix((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_isDefaultNamespace) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_isDefaultNamespace(self,namespaceURI);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_isDefaultNamespace" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNode_isDefaultNamespace");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->isDefaultNamespace((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_lookupNamespaceURI) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_lookupNamespaceURI(self,prefix);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_lookupNamespaceURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNode_lookupNamespaceURI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMNode const *)arg1)->lookupNamespaceURI((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_getInterface) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode_getInterface(self,feature);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_getInterface" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNode_getInterface");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->getInterface((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode_release) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNode_release(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode_release" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    {
      try 
      {
        (arg1)->release();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode___eq__) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode___eq__(self,other);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode___eq__" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNode___eq__" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (bool)XERCES_CPP_NAMESPACE_DOMNode_operator_Se__Se_(arg1,(XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNode___ne__) {
  {
    XERCES_CPP_NAMESPACE::DOMNode *arg1 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNode___ne__(self,other);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNode___ne__" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNode___ne__" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (bool)XERCES_CPP_NAMESPACE_DOMNode_operator_SN__Se_(arg1,(XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMAttr) {
  {
    XERCES_CPP_NAMESPACE::DOMAttr *arg1 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMAttr(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMAttr" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMAttr_getName) {
  {
    XERCES_CPP_NAMESPACE::DOMAttr *arg1 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMAttr_getName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMAttr_getName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMAttr const *)arg1)->getName();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMAttr_getSpecified) {
  {
    XERCES_CPP_NAMESPACE::DOMAttr *arg1 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMAttr_getSpecified(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMAttr_getSpecified" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMAttr const *)arg1)->getSpecified();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMAttr_getValue) {
  {
    XERCES_CPP_NAMESPACE::DOMAttr *arg1 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMAttr_getValue(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMAttr_getValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMAttr const *)arg1)->getValue();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMAttr_setValue) {
  {
    XERCES_CPP_NAMESPACE::DOMAttr *arg1 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMAttr_setValue(self,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMAttr_setValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMAttr_setValue");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setValue((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMAttr_getOwnerElement) {
  {
    XERCES_CPP_NAMESPACE::DOMAttr *arg1 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    XERCES_CPP_NAMESPACE::DOMElement *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMAttr_getOwnerElement(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMAttr_getOwnerElement" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMElement *)((XERCES_CPP_NAMESPACE::DOMAttr const *)arg1)->getOwnerElement();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMAttr_isId) {
  {
    XERCES_CPP_NAMESPACE::DOMAttr *arg1 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMAttr_isId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMAttr_isId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMAttr const *)arg1)->isId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMAttr_getTypeInfo) {
  {
    XERCES_CPP_NAMESPACE::DOMAttr *arg1 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    XERCES_CPP_NAMESPACE::DOMTypeInfo *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMAttr_getTypeInfo(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMAttr_getTypeInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMTypeInfo *)((XERCES_CPP_NAMESPACE::DOMAttr const *)arg1)->getTypeInfo();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTypeInfo, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMElement) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMElement(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMElement" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_getTagName) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMElement_getTagName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_getTagName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMElement const *)arg1)->getTagName();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_getAttribute) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMElement_getAttribute(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_getAttribute" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_getAttribute");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMElement const *)arg1)->getAttribute((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_getAttributeNode) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMAttr *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMElement_getAttributeNode(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_getAttributeNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_getAttributeNode");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMAttr *)((XERCES_CPP_NAMESPACE::DOMElement const *)arg1)->getAttributeNode((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_getElementsByTagName) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNodeList *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMElement_getElementsByTagName(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_getElementsByTagName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_getElementsByTagName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNodeList *)((XERCES_CPP_NAMESPACE::DOMElement const *)arg1)->getElementsByTagName((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeList, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_setAttribute) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMElement_setAttribute(self,name,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_setAttribute" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_setAttribute");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMElement_setAttribute");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->setAttribute((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_setAttributeNode) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XERCES_CPP_NAMESPACE::DOMAttr *arg2 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    XERCES_CPP_NAMESPACE::DOMAttr *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMElement_setAttributeNode(self,newAttr);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_setAttributeNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMElement_setAttributeNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMAttr *)(arg1)->setAttributeNode(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_removeAttributeNode) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XERCES_CPP_NAMESPACE::DOMAttr *arg2 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    XERCES_CPP_NAMESPACE::DOMAttr *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMElement_removeAttributeNode(self,oldAttr);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_removeAttributeNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMElement_removeAttributeNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMAttr *)(arg1)->removeAttributeNode(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_removeAttribute) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMElement_removeAttribute(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_removeAttribute" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_removeAttribute");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->removeAttribute((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_getAttributeNS) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMElement_getAttributeNS(self,namespaceURI,localName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_getAttributeNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_getAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMElement_getAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMElement const *)arg1)->getAttributeNS((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_setAttributeNS) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XMLCh *arg4 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DOMElement_setAttributeNS(self,namespaceURI,qualifiedName,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_setAttributeNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_setAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMElement_setAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DOMElement_setAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    {
      try 
      {
        (arg1)->setAttributeNS((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_removeAttributeNS) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMElement_removeAttributeNS(self,namespaceURI,localName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_removeAttributeNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_removeAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMElement_removeAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->removeAttributeNS((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_getAttributeNodeNS) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMAttr *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMElement_getAttributeNodeNS(self,namespaceURI,localName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_getAttributeNodeNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_getAttributeNodeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMElement_getAttributeNodeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMAttr *)((XERCES_CPP_NAMESPACE::DOMElement const *)arg1)->getAttributeNodeNS((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_setAttributeNodeNS) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XERCES_CPP_NAMESPACE::DOMAttr *arg2 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    XERCES_CPP_NAMESPACE::DOMAttr *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMElement_setAttributeNodeNS(self,newAttr);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_setAttributeNodeNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMElement_setAttributeNodeNS" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMAttr *)(arg1)->setAttributeNodeNS(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_getElementsByTagNameNS) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNodeList *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMElement_getElementsByTagNameNS(self,namespaceURI,localName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_getElementsByTagNameNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_getElementsByTagNameNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMElement_getElementsByTagNameNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNodeList *)((XERCES_CPP_NAMESPACE::DOMElement const *)arg1)->getElementsByTagNameNS((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeList, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_hasAttribute) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMElement_hasAttribute(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_hasAttribute" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_hasAttribute");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMElement const *)arg1)->hasAttribute((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_hasAttributeNS) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMElement_hasAttributeNS(self,namespaceURI,localName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_hasAttributeNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_hasAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMElement_hasAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMElement const *)arg1)->hasAttributeNS((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_setIdAttribute) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMElement_setIdAttribute(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_setIdAttribute" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_setIdAttribute");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setIdAttribute((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_setIdAttributeNS) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMElement_setIdAttributeNS(self,namespaceURI,localName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_setIdAttributeNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMElement_setIdAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMElement_setIdAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->setIdAttributeNS((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_setIdAttributeNode) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XERCES_CPP_NAMESPACE::DOMAttr *arg2 = (XERCES_CPP_NAMESPACE::DOMAttr *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMElement_setIdAttributeNode(self,idAttr);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_setIdAttributeNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMElement_setIdAttributeNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMAttr const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMAttr * >(argp2);
    {
      try 
      {
        (arg1)->setIdAttributeNode((XERCES_CPP_NAMESPACE::DOMAttr const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMElement_getTypeInfo) {
  {
    XERCES_CPP_NAMESPACE::DOMElement *arg1 = (XERCES_CPP_NAMESPACE::DOMElement *) 0 ;
    XERCES_CPP_NAMESPACE::DOMTypeInfo *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMElement_getTypeInfo(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMElement_getTypeInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMElement const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMElement * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMTypeInfo *)((XERCES_CPP_NAMESPACE::DOMElement const *)arg1)->getTypeInfo();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTypeInfo, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMEntity) {
  {
    XERCES_CPP_NAMESPACE::DOMEntity *arg1 = (XERCES_CPP_NAMESPACE::DOMEntity *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMEntity(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMEntity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntity *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntity * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMEntity_getPublicId) {
  {
    XERCES_CPP_NAMESPACE::DOMEntity *arg1 = (XERCES_CPP_NAMESPACE::DOMEntity *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMEntity_getPublicId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMEntity_getPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntity const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntity * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMEntity const *)arg1)->getPublicId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMEntity_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::DOMEntity *arg1 = (XERCES_CPP_NAMESPACE::DOMEntity *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMEntity_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMEntity_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntity const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntity * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMEntity const *)arg1)->getSystemId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMEntity_getNotationName) {
  {
    XERCES_CPP_NAMESPACE::DOMEntity *arg1 = (XERCES_CPP_NAMESPACE::DOMEntity *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMEntity_getNotationName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMEntity_getNotationName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntity const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntity * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMEntity const *)arg1)->getNotationName();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMEntity_getActualEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMEntity *arg1 = (XERCES_CPP_NAMESPACE::DOMEntity *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMEntity_getActualEncoding(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMEntity_getActualEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntity const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntity * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMEntity const *)arg1)->getActualEncoding();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMEntity_setActualEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMEntity *arg1 = (XERCES_CPP_NAMESPACE::DOMEntity *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMEntity_setActualEncoding(self,actualEncoding);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMEntity_setActualEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntity *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntity * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMEntity_setActualEncoding");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setActualEncoding((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMEntity_getEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMEntity *arg1 = (XERCES_CPP_NAMESPACE::DOMEntity *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMEntity_getEncoding(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMEntity_getEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntity const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntity * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMEntity const *)arg1)->getEncoding();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMEntity_setEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMEntity *arg1 = (XERCES_CPP_NAMESPACE::DOMEntity *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMEntity_setEncoding(self,encoding);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMEntity_setEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntity *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntity * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMEntity_setEncoding");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setEncoding((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMEntity_getVersion) {
  {
    XERCES_CPP_NAMESPACE::DOMEntity *arg1 = (XERCES_CPP_NAMESPACE::DOMEntity *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMEntity_getVersion(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMEntity_getVersion" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntity const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntity * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMEntity const *)arg1)->getVersion();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMEntity_setVersion) {
  {
    XERCES_CPP_NAMESPACE::DOMEntity *arg1 = (XERCES_CPP_NAMESPACE::DOMEntity *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMEntity_setVersion(self,version);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMEntity_setVersion" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntity *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntity * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMEntity_setVersion");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setVersion((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMDocumentType) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentType *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentType *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMDocumentType(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMDocumentType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentType *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentType * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocumentType_getName) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentType *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentType *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocumentType_getName(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocumentType_getName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentType const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentType * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMDocumentType const *)arg1)->getName();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocumentType_getEntities) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentType *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentType *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocumentType_getEntities(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocumentType_getEntities" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentType const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentType * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *)((XERCES_CPP_NAMESPACE::DOMDocumentType const *)arg1)->getEntities();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocumentType_getNotations) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentType *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentType *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocumentType_getNotations(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocumentType_getNotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentType const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentType * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *)((XERCES_CPP_NAMESPACE::DOMDocumentType const *)arg1)->getNotations();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocumentType_getPublicId) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentType *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentType *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocumentType_getPublicId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocumentType_getPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentType const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentType * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMDocumentType const *)arg1)->getPublicId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocumentType_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentType *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentType *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocumentType_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocumentType_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentType const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentType * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMDocumentType const *)arg1)->getSystemId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocumentType_getInternalSubset) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentType *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentType *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocumentType_getInternalSubset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocumentType_getInternalSubset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentType const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentType * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMDocumentType const *)arg1)->getInternalSubset();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMCharacterData) {
  {
    XERCES_CPP_NAMESPACE::DOMCharacterData *arg1 = (XERCES_CPP_NAMESPACE::DOMCharacterData *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMCharacterData(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCharacterData, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMCharacterData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMCharacterData *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMCharacterData * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMCharacterData_getData) {
  {
    XERCES_CPP_NAMESPACE::DOMCharacterData *arg1 = (XERCES_CPP_NAMESPACE::DOMCharacterData *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMCharacterData_getData(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMCharacterData_getData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMCharacterData const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMCharacterData * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMCharacterData const *)arg1)->getData();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMCharacterData_getLength) {
  {
    XERCES_CPP_NAMESPACE::DOMCharacterData *arg1 = (XERCES_CPP_NAMESPACE::DOMCharacterData *) 0 ;
    XMLSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMCharacterData_getLength(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMCharacterData_getLength" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMCharacterData const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMCharacterData * >(argp1);
    {
      try 
      {
        result = (XMLSize_t)((XERCES_CPP_NAMESPACE::DOMCharacterData const *)arg1)->getLength();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_long  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMCharacterData_substringData) {
  {
    XERCES_CPP_NAMESPACE::DOMCharacterData *arg1 = (XERCES_CPP_NAMESPACE::DOMCharacterData *) 0 ;
    XMLSize_t arg2 ;
    XMLSize_t arg3 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    unsigned long val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMCharacterData_substringData(self,offset,count);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMCharacterData_substringData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMCharacterData const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMCharacterData * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMCharacterData_substringData" "', argument " "2"" of type '" "XMLSize_t""'");
    } 
    arg2 = static_cast< XMLSize_t >(val2);
    ecode3 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMCharacterData_substringData" "', argument " "3"" of type '" "XMLSize_t""'");
    } 
    arg3 = static_cast< XMLSize_t >(val3);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMCharacterData const *)arg1)->substringData(arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMCharacterData_appendData) {
  {
    XERCES_CPP_NAMESPACE::DOMCharacterData *arg1 = (XERCES_CPP_NAMESPACE::DOMCharacterData *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMCharacterData_appendData(self,arg);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMCharacterData_appendData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMCharacterData *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMCharacterData * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMCharacterData_appendData");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->appendData((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMCharacterData_insertData) {
  {
    XERCES_CPP_NAMESPACE::DOMCharacterData *arg1 = (XERCES_CPP_NAMESPACE::DOMCharacterData *) 0 ;
    XMLSize_t arg2 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMCharacterData_insertData(self,offset,arg);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMCharacterData_insertData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMCharacterData *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMCharacterData * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMCharacterData_insertData" "', argument " "2"" of type '" "XMLSize_t""'");
    } 
    arg2 = static_cast< XMLSize_t >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMCharacterData_insertData");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->insertData(arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMCharacterData_deleteData) {
  {
    XERCES_CPP_NAMESPACE::DOMCharacterData *arg1 = (XERCES_CPP_NAMESPACE::DOMCharacterData *) 0 ;
    XMLSize_t arg2 ;
    XMLSize_t arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    unsigned long val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMCharacterData_deleteData(self,offset,count);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMCharacterData_deleteData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMCharacterData *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMCharacterData * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMCharacterData_deleteData" "', argument " "2"" of type '" "XMLSize_t""'");
    } 
    arg2 = static_cast< XMLSize_t >(val2);
    ecode3 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMCharacterData_deleteData" "', argument " "3"" of type '" "XMLSize_t""'");
    } 
    arg3 = static_cast< XMLSize_t >(val3);
    {
      try 
      {
        (arg1)->deleteData(arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMCharacterData_replaceData) {
  {
    XERCES_CPP_NAMESPACE::DOMCharacterData *arg1 = (XERCES_CPP_NAMESPACE::DOMCharacterData *) 0 ;
    XMLSize_t arg2 ;
    XMLSize_t arg3 ;
    XMLCh *arg4 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    unsigned long val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DOMCharacterData_replaceData(self,offset,count,arg);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMCharacterData_replaceData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMCharacterData *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMCharacterData * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMCharacterData_replaceData" "', argument " "2"" of type '" "XMLSize_t""'");
    } 
    arg2 = static_cast< XMLSize_t >(val2);
    ecode3 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMCharacterData_replaceData" "', argument " "3"" of type '" "XMLSize_t""'");
    } 
    arg3 = static_cast< XMLSize_t >(val3);
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DOMCharacterData_replaceData");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    {
      try 
      {
        (arg1)->replaceData(arg2,arg3,(XMLCh const *)arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    
    
    delete[] arg4;
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    delete[] arg4;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMCharacterData_setData) {
  {
    XERCES_CPP_NAMESPACE::DOMCharacterData *arg1 = (XERCES_CPP_NAMESPACE::DOMCharacterData *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMCharacterData_setData(self,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMCharacterData_setData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMCharacterData *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMCharacterData * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMCharacterData_setData");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setData((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMComment) {
  {
    XERCES_CPP_NAMESPACE::DOMComment *arg1 = (XERCES_CPP_NAMESPACE::DOMComment *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMComment(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMComment, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMComment" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMComment *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMComment * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMText) {
  {
    XERCES_CPP_NAMESPACE::DOMText *arg1 = (XERCES_CPP_NAMESPACE::DOMText *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMText(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMText" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMText *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMText * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMText_splitText) {
  {
    XERCES_CPP_NAMESPACE::DOMText *arg1 = (XERCES_CPP_NAMESPACE::DOMText *) 0 ;
    XMLSize_t arg2 ;
    XERCES_CPP_NAMESPACE::DOMText *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMText_splitText(self,offset);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMText_splitText" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMText *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMText * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMText_splitText" "', argument " "2"" of type '" "XMLSize_t""'");
    } 
    arg2 = static_cast< XMLSize_t >(val2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMText *)(arg1)->splitText(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText, 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMText_getIsWhitespaceInElementContent) {
  {
    XERCES_CPP_NAMESPACE::DOMText *arg1 = (XERCES_CPP_NAMESPACE::DOMText *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMText_getIsWhitespaceInElementContent(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMText_getIsWhitespaceInElementContent" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMText const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMText * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMText const *)arg1)->getIsWhitespaceInElementContent();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMText_getWholeText) {
  {
    XERCES_CPP_NAMESPACE::DOMText *arg1 = (XERCES_CPP_NAMESPACE::DOMText *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMText_getWholeText(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMText_getWholeText" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMText *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMText * >(argp1);
    {
      try 
      {
        result = (XMLCh *)(arg1)->getWholeText();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMText_replaceWholeText) {
  {
    XERCES_CPP_NAMESPACE::DOMText *arg1 = (XERCES_CPP_NAMESPACE::DOMText *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMText *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMText_replaceWholeText(self,content);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMText_replaceWholeText" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMText *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMText * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMText_replaceWholeText");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMText *)(arg1)->replaceWholeText((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMText_isIgnorableWhitespace) {
  {
    XERCES_CPP_NAMESPACE::DOMText *arg1 = (XERCES_CPP_NAMESPACE::DOMText *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMText_isIgnorableWhitespace(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMText_isIgnorableWhitespace" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMText const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMText * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMText const *)arg1)->isIgnorableWhitespace();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMCDATASection) {
  {
    XERCES_CPP_NAMESPACE::DOMCDATASection *arg1 = (XERCES_CPP_NAMESPACE::DOMCDATASection *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMCDATASection(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCDATASection, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMCDATASection" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMCDATASection *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMCDATASection * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMNodeList) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeList *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeList *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMNodeList(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeList, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMNodeList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeList * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNodeList_item) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeList *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeList *) 0 ;
    XMLSize_t arg2 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNodeList_item(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNodeList_item" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeList * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMNodeList_item" "', argument " "2"" of type '" "XMLSize_t""'");
    } 
    arg2 = static_cast< XMLSize_t >(val2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMNodeList const *)arg1)->item(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNodeList_getLength) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeList *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeList *) 0 ;
    XMLSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNodeList_getLength(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNodeList_getLength" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeList * >(argp1);
    {
      try 
      {
        result = (XMLSize_t)((XERCES_CPP_NAMESPACE::DOMNodeList const *)arg1)->getLength();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_long  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMNamedNodeMap) {
  {
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *arg1 = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMNamedNodeMap(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMNamedNodeMap" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNamedNodeMap *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNamedNodeMap * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNamedNodeMap_setNamedItem) {
  {
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *arg1 = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNamedNodeMap_setNamedItem(self,arg);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNamedNodeMap_setNamedItem" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNamedNodeMap *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNamedNodeMap * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNamedNodeMap_setNamedItem" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->setNamedItem(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNamedNodeMap_item) {
  {
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *arg1 = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *) 0 ;
    XMLSize_t arg2 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNamedNodeMap_item(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNamedNodeMap_item" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNamedNodeMap const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNamedNodeMap * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMNamedNodeMap_item" "', argument " "2"" of type '" "XMLSize_t""'");
    } 
    arg2 = static_cast< XMLSize_t >(val2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMNamedNodeMap const *)arg1)->item(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNamedNodeMap_getNamedItem) {
  {
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *arg1 = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNamedNodeMap_getNamedItem(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNamedNodeMap_getNamedItem" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNamedNodeMap const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNamedNodeMap * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNamedNodeMap_getNamedItem");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMNamedNodeMap const *)arg1)->getNamedItem((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNamedNodeMap_getLength) {
  {
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *arg1 = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *) 0 ;
    XMLSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNamedNodeMap_getLength(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNamedNodeMap_getLength" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNamedNodeMap const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNamedNodeMap * >(argp1);
    {
      try 
      {
        result = (XMLSize_t)((XERCES_CPP_NAMESPACE::DOMNamedNodeMap const *)arg1)->getLength();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_long  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNamedNodeMap_removeNamedItem) {
  {
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *arg1 = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNamedNodeMap_removeNamedItem(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNamedNodeMap_removeNamedItem" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNamedNodeMap *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNamedNodeMap * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNamedNodeMap_removeNamedItem");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->removeNamedItem((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNamedNodeMap_getNamedItemNS) {
  {
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *arg1 = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMNamedNodeMap_getNamedItemNS(self,namespaceURI,localName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNamedNodeMap_getNamedItemNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNamedNodeMap const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNamedNodeMap * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNamedNodeMap_getNamedItemNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMNamedNodeMap_getNamedItemNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMNamedNodeMap const *)arg1)->getNamedItemNS((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNamedNodeMap_setNamedItemNS) {
  {
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *arg1 = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNamedNodeMap_setNamedItemNS(self,arg);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNamedNodeMap_setNamedItemNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNamedNodeMap *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNamedNodeMap * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNamedNodeMap_setNamedItemNS" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->setNamedItemNS(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNamedNodeMap_removeNamedItemNS) {
  {
    XERCES_CPP_NAMESPACE::DOMNamedNodeMap *arg1 = (XERCES_CPP_NAMESPACE::DOMNamedNodeMap *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMNamedNodeMap_removeNamedItemNS(self,namespaceURI,localName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNamedNodeMap_removeNamedItemNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNamedNodeMap *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNamedNodeMap * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMNamedNodeMap_removeNamedItemNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMNamedNodeMap_removeNamedItemNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->removeNamedItemNS((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMDocumentFragment) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentFragment *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentFragment *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMDocumentFragment(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentFragment, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMDocumentFragment" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentFragment *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentFragment * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMEntityReference) {
  {
    XERCES_CPP_NAMESPACE::DOMEntityReference *arg1 = (XERCES_CPP_NAMESPACE::DOMEntityReference *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMEntityReference(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntityReference, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMEntityReference" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntityReference *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntityReference * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMNotation) {
  {
    XERCES_CPP_NAMESPACE::DOMNotation *arg1 = (XERCES_CPP_NAMESPACE::DOMNotation *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMNotation(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNotation, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMNotation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNotation *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNotation * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNotation_getPublicId) {
  {
    XERCES_CPP_NAMESPACE::DOMNotation *arg1 = (XERCES_CPP_NAMESPACE::DOMNotation *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNotation_getPublicId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNotation, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNotation_getPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNotation const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNotation * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMNotation const *)arg1)->getPublicId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNotation_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::DOMNotation *arg1 = (XERCES_CPP_NAMESPACE::DOMNotation *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNotation_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNotation, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNotation_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNotation const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNotation * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMNotation const *)arg1)->getSystemId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMProcessingInstruction) {
  {
    XERCES_CPP_NAMESPACE::DOMProcessingInstruction *arg1 = (XERCES_CPP_NAMESPACE::DOMProcessingInstruction *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMProcessingInstruction(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMProcessingInstruction" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMProcessingInstruction *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMProcessingInstruction * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMProcessingInstruction_getTarget) {
  {
    XERCES_CPP_NAMESPACE::DOMProcessingInstruction *arg1 = (XERCES_CPP_NAMESPACE::DOMProcessingInstruction *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMProcessingInstruction_getTarget(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMProcessingInstruction_getTarget" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMProcessingInstruction const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMProcessingInstruction * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMProcessingInstruction const *)arg1)->getTarget();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMProcessingInstruction_getData) {
  {
    XERCES_CPP_NAMESPACE::DOMProcessingInstruction *arg1 = (XERCES_CPP_NAMESPACE::DOMProcessingInstruction *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMProcessingInstruction_getData(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMProcessingInstruction_getData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMProcessingInstruction const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMProcessingInstruction * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMProcessingInstruction const *)arg1)->getData();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMProcessingInstruction_setData) {
  {
    XERCES_CPP_NAMESPACE::DOMProcessingInstruction *arg1 = (XERCES_CPP_NAMESPACE::DOMProcessingInstruction *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMProcessingInstruction_setData(self,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMProcessingInstruction_setData" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMProcessingInstruction *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMProcessingInstruction * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMProcessingInstruction_setData");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setData((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMDocumentRange) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentRange *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentRange *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMDocumentRange(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentRange, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMDocumentRange" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentRange * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocumentRange_createRange) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentRange *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMRange *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocumentRange_createRange(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocumentRange_createRange" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentRange * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMRange *)(arg1)->createRange();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMDocumentTraversal) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentTraversal *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentTraversal *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMDocumentTraversal(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMDocumentTraversal" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentTraversal *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentTraversal * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocumentTraversal_createNodeIterator) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentTraversal *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentTraversal *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    unsigned long arg3 ;
    XERCES_CPP_NAMESPACE::DOMNodeFilter *arg4 = (XERCES_CPP_NAMESPACE::DOMNodeFilter *) 0 ;
    bool arg5 ;
    XERCES_CPP_NAMESPACE::DOMNodeIterator *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    unsigned long val3 ;
    int ecode3 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    bool val5 ;
    int ecode5 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: DOMDocumentTraversal_createNodeIterator(self,root,whatToShow,filter,entityReferenceExpansion);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocumentTraversal_createNodeIterator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentTraversal *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentTraversal * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMDocumentTraversal_createNodeIterator" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    ecode3 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMDocumentTraversal_createNodeIterator" "', argument " "3"" of type '" "unsigned long""'");
    } 
    arg3 = static_cast< unsigned long >(val3);
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeFilter, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "DOMDocumentTraversal_createNodeIterator" "', argument " "4"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeFilter *""'"); 
    }
    arg4 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeFilter * >(argp4);
    ecode5 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(4), &val5);
    if (!SWIG_IsOK(ecode5)) {
      SWIG_exception_fail(SWIG_ArgError(ecode5), "in method '" "DOMDocumentTraversal_createNodeIterator" "', argument " "5"" of type '" "bool""'");
    } 
    arg5 = static_cast< bool >(val5);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNodeIterator *)(arg1)->createNodeIterator(arg2,arg3,arg4,arg5);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocumentTraversal_createTreeWalker) {
  {
    XERCES_CPP_NAMESPACE::DOMDocumentTraversal *arg1 = (XERCES_CPP_NAMESPACE::DOMDocumentTraversal *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    unsigned long arg3 ;
    XERCES_CPP_NAMESPACE::DOMNodeFilter *arg4 = (XERCES_CPP_NAMESPACE::DOMNodeFilter *) 0 ;
    bool arg5 ;
    XERCES_CPP_NAMESPACE::DOMTreeWalker *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    unsigned long val3 ;
    int ecode3 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    bool val5 ;
    int ecode5 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: DOMDocumentTraversal_createTreeWalker(self,root,whatToShow,filter,entityReferenceExpansion);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocumentTraversal_createTreeWalker" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentTraversal *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentTraversal * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMDocumentTraversal_createTreeWalker" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    ecode3 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMDocumentTraversal_createTreeWalker" "', argument " "3"" of type '" "unsigned long""'");
    } 
    arg3 = static_cast< unsigned long >(val3);
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeFilter, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "DOMDocumentTraversal_createTreeWalker" "', argument " "4"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeFilter *""'"); 
    }
    arg4 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeFilter * >(argp4);
    ecode5 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(4), &val5);
    if (!SWIG_IsOK(ecode5)) {
      SWIG_exception_fail(SWIG_ArgError(ecode5), "in method '" "DOMDocumentTraversal_createTreeWalker" "', argument " "5"" of type '" "bool""'");
    } 
    arg5 = static_cast< bool >(val5);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMTreeWalker *)(arg1)->createTreeWalker(arg2,arg3,arg4,arg5);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMNodeIterator) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeIterator *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeIterator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMNodeIterator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMNodeIterator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeIterator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeIterator * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNodeIterator_getRoot) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeIterator *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeIterator *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNodeIterator_getRoot(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNodeIterator_getRoot" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeIterator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeIterator * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->getRoot();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNodeIterator_getWhatToShow) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeIterator *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeIterator *) 0 ;
    unsigned long result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNodeIterator_getWhatToShow(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNodeIterator_getWhatToShow" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeIterator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeIterator * >(argp1);
    {
      try 
      {
        result = (unsigned long)(arg1)->getWhatToShow();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_long  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNodeIterator_getFilter) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeIterator *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeIterator *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNodeFilter *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNodeIterator_getFilter(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNodeIterator_getFilter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeIterator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeIterator * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNodeFilter *)(arg1)->getFilter();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeFilter, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNodeIterator_getExpandEntityReferences) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeIterator *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeIterator *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNodeIterator_getExpandEntityReferences(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNodeIterator_getExpandEntityReferences" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeIterator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeIterator * >(argp1);
    {
      try 
      {
        result = (bool)(arg1)->getExpandEntityReferences();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNodeIterator_nextNode) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeIterator *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeIterator *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNodeIterator_nextNode(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNodeIterator_nextNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeIterator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeIterator * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->nextNode();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNodeIterator_previousNode) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeIterator *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeIterator *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNodeIterator_previousNode(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNodeIterator_previousNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeIterator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeIterator * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->previousNode();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNodeIterator_detach) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeIterator *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeIterator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNodeIterator_detach(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNodeIterator_detach" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeIterator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeIterator * >(argp1);
    {
      try 
      {
        (arg1)->detach();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNodeIterator_release) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeIterator *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeIterator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMNodeIterator_release(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNodeIterator_release" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeIterator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeIterator * >(argp1);
    {
      try 
      {
        (arg1)->release();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMNodeFilter) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeFilter *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeFilter *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMNodeFilter(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeFilter, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMNodeFilter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeFilter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeFilter * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMNodeFilter_acceptNode) {
  {
    XERCES_CPP_NAMESPACE::DOMNodeFilter *arg1 = (XERCES_CPP_NAMESPACE::DOMNodeFilter *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    short result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMNodeFilter_acceptNode(self,node);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeFilter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMNodeFilter_acceptNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMNodeFilter const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNodeFilter * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMNodeFilter_acceptNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (short)((XERCES_CPP_NAMESPACE::DOMNodeFilter const *)arg1)->acceptNode((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_short  SWIG_PERL_CALL_ARGS_1(static_cast< short >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMRange) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMRange(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMRange" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_getStartContainer) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_getStartContainer(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_getStartContainer" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMRange const *)arg1)->getStartContainer();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_getStartOffset) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XMLSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_getStartOffset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_getStartOffset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        result = (XMLSize_t)((XERCES_CPP_NAMESPACE::DOMRange const *)arg1)->getStartOffset();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_long  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_getEndContainer) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_getEndContainer(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_getEndContainer" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMRange const *)arg1)->getEndContainer();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_getEndOffset) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XMLSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_getEndOffset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_getEndOffset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        result = (XMLSize_t)((XERCES_CPP_NAMESPACE::DOMRange const *)arg1)->getEndOffset();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_long  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_getCollapsed) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_getCollapsed(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_getCollapsed" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMRange const *)arg1)->getCollapsed();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_getCommonAncestorContainer) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_getCommonAncestorContainer(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_getCommonAncestorContainer" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMRange const *)arg1)->getCommonAncestorContainer();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_setStart) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLSize_t arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    unsigned long val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMRange_setStart(self,refNode,offset);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_setStart" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMRange_setStart" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    ecode3 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMRange_setStart" "', argument " "3"" of type '" "XMLSize_t""'");
    } 
    arg3 = static_cast< XMLSize_t >(val3);
    {
      try 
      {
        (arg1)->setStart((XERCES_CPP_NAMESPACE::DOMNode const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_setEnd) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLSize_t arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    unsigned long val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMRange_setEnd(self,refNode,offset);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_setEnd" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMRange_setEnd" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    ecode3 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMRange_setEnd" "', argument " "3"" of type '" "XMLSize_t""'");
    } 
    arg3 = static_cast< XMLSize_t >(val3);
    {
      try 
      {
        (arg1)->setEnd((XERCES_CPP_NAMESPACE::DOMNode const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_setStartBefore) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMRange_setStartBefore(self,refNode);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_setStartBefore" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMRange_setStartBefore" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        (arg1)->setStartBefore((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_setStartAfter) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMRange_setStartAfter(self,refNode);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_setStartAfter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMRange_setStartAfter" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        (arg1)->setStartAfter((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_setEndBefore) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMRange_setEndBefore(self,refNode);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_setEndBefore" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMRange_setEndBefore" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        (arg1)->setEndBefore((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_setEndAfter) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMRange_setEndAfter(self,refNode);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_setEndAfter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMRange_setEndAfter" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        (arg1)->setEndAfter((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_collapse) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMRange_collapse(self,toStart);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_collapse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMRange_collapse" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->collapse(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_selectNode) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMRange_selectNode(self,refNode);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_selectNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMRange_selectNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        (arg1)->selectNode((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_selectNodeContents) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMRange_selectNodeContents(self,refNode);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_selectNodeContents" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMRange_selectNodeContents" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        (arg1)->selectNodeContents((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_compareBoundaryPoints) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMRange::CompareHow arg2 ;
    XERCES_CPP_NAMESPACE::DOMRange *arg3 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    short result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMRange_compareBoundaryPoints(self,how,sourceRange);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_compareBoundaryPoints" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMRange_compareBoundaryPoints" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMRange::CompareHow""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::DOMRange::CompareHow >(val2);
    res3 = SWIG_ConvertPtr(ST(2), &argp3,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "DOMRange_compareBoundaryPoints" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::DOMRange const *""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp3);
    {
      try 
      {
        result = (short)((XERCES_CPP_NAMESPACE::DOMRange const *)arg1)->compareBoundaryPoints(arg2,(XERCES_CPP_NAMESPACE::DOMRange const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_short  SWIG_PERL_CALL_ARGS_1(static_cast< short >(result)); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_deleteContents) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_deleteContents(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_deleteContents" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        (arg1)->deleteContents();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_extractContents) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocumentFragment *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_extractContents(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_extractContents" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocumentFragment *)(arg1)->extractContents();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentFragment, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_cloneContents) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocumentFragment *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_cloneContents(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_cloneContents" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocumentFragment *)((XERCES_CPP_NAMESPACE::DOMRange const *)arg1)->cloneContents();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentFragment, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_insertNode) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMRange_insertNode(self,newNode);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_insertNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMRange_insertNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        (arg1)->insertNode(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_surroundContents) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMRange_surroundContents(self,newParent);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_surroundContents" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMRange_surroundContents" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        (arg1)->surroundContents(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_cloneRange) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XERCES_CPP_NAMESPACE::DOMRange *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_cloneRange(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_cloneRange" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMRange *)((XERCES_CPP_NAMESPACE::DOMRange const *)arg1)->cloneRange();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_toString) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_toString(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_toString" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMRange const *)arg1)->toString();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_detach) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_detach(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_detach" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        (arg1)->detach();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRange_release) {
  {
    XERCES_CPP_NAMESPACE::DOMRange *arg1 = (XERCES_CPP_NAMESPACE::DOMRange *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRange_release(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRange_release" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRange *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRange * >(argp1);
    {
      try 
      {
        (arg1)->release();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMRangeException) {
  {
    XERCES_CPP_NAMESPACE::DOMRangeException *arg1 = (XERCES_CPP_NAMESPACE::DOMRangeException *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMRangeException(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRangeException, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMRangeException" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRangeException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRangeException * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRangeException_code_set) {
  {
    XERCES_CPP_NAMESPACE::DOMRangeException *arg1 = (XERCES_CPP_NAMESPACE::DOMRangeException *) 0 ;
    XERCES_CPP_NAMESPACE::DOMRangeException::RangeExceptionCode arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMRangeException_code_set(self,code);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRangeException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRangeException_code_set" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRangeException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRangeException * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMRangeException_code_set" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMRangeException::RangeExceptionCode""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::DOMRangeException::RangeExceptionCode >(val2);
    if (arg1) (arg1)->code = arg2;
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMRangeException_code_get) {
  {
    XERCES_CPP_NAMESPACE::DOMRangeException *arg1 = (XERCES_CPP_NAMESPACE::DOMRangeException *) 0 ;
    XERCES_CPP_NAMESPACE::DOMRangeException::RangeExceptionCode result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMRangeException_code_get(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRangeException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMRangeException_code_get" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMRangeException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMRangeException * >(argp1);
    result = (XERCES_CPP_NAMESPACE::DOMRangeException::RangeExceptionCode) ((arg1)->code);
    
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMTreeWalker) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMTreeWalker(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMTreeWalker" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_getRoot) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_getRoot(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_getRoot" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->getRoot();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_getWhatToShow) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    unsigned long result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_getWhatToShow(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_getWhatToShow" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (unsigned long)(arg1)->getWhatToShow();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_long  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_getFilter) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNodeFilter *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_getFilter(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_getFilter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNodeFilter *)(arg1)->getFilter();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeFilter, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_getExpandEntityReferences) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_getExpandEntityReferences(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_getExpandEntityReferences" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (bool)(arg1)->getExpandEntityReferences();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_getCurrentNode) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_getCurrentNode(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_getCurrentNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->getCurrentNode();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_parentNode) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_parentNode(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_parentNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->parentNode();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_firstChild) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_firstChild(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_firstChild" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->firstChild();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_lastChild) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_lastChild(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_lastChild" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->lastChild();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_previousSibling) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_previousSibling(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_previousSibling" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->previousSibling();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_nextSibling) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_nextSibling(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_nextSibling" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->nextSibling();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_previousNode) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_previousNode(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_previousNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->previousNode();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_nextNode) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_nextNode(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_nextNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->nextNode();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_setCurrentNode) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMTreeWalker_setCurrentNode(self,currentNode);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_setCurrentNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMTreeWalker_setCurrentNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        (arg1)->setCurrentNode(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMTreeWalker_release) {
  {
    XERCES_CPP_NAMESPACE::DOMTreeWalker *arg1 = (XERCES_CPP_NAMESPACE::DOMTreeWalker *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMTreeWalker_release(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMTreeWalker_release" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMTreeWalker *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMTreeWalker * >(argp1);
    {
      try 
      {
        (arg1)->release();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMImplementationLS) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementationLS *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementationLS *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMImplementationLS(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationLS, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMImplementationLS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementationLS *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementationLS * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementationLS_createDOMBuilder__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementationLS *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementationLS *) 0 ;
    short arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *arg4 = (XERCES_CPP_NAMESPACE::MemoryManager *) (XERCES_CPP_NAMESPACE::MemoryManager *)0 ;
    XERCES_CPP_NAMESPACE::XMLGrammarPool *arg5 = (XERCES_CPP_NAMESPACE::XMLGrammarPool *) (XERCES_CPP_NAMESPACE::XMLGrammarPool *)0 ;
    XERCES_CPP_NAMESPACE::DOMBuilder *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    short val2 ;
    int ecode2 = 0 ;
    void *argp5 = 0 ;
    int res5 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg4 = XERCES_CPP_NAMESPACE::XMLPlatformUtils::fgMemoryManager;
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DOMImplementationLS_createDOMBuilder(self,mode,schemaType,gramPool);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationLS, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMImplementationLS_createDOMBuilder" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementationLS *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementationLS * >(argp1);
    ecode2 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMImplementationLS_createDOMBuilder" "', argument " "2"" of type '" "short""'");
    } 
    arg2 = static_cast< short >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMImplementationLS_createDOMBuilder");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    res5 = SWIG_ConvertPtr(ST(3), &argp5,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarPool, 0 |  0 );
    if (!SWIG_IsOK(res5)) {
      SWIG_exception_fail(SWIG_ArgError(res5), "in method '" "DOMImplementationLS_createDOMBuilder" "', argument " "5"" of type '" "XERCES_CPP_NAMESPACE::XMLGrammarPool *const""'"); 
    }
    arg5 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLGrammarPool * >(argp5);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMBuilder *)(arg1)->createDOMBuilder(arg2,(XMLCh const *)arg3,arg4,arg5);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementationLS_createDOMBuilder__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementationLS *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementationLS *) 0 ;
    short arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *arg4 = (XERCES_CPP_NAMESPACE::MemoryManager *) (XERCES_CPP_NAMESPACE::MemoryManager *)0 ;
    XERCES_CPP_NAMESPACE::DOMBuilder *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    short val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg4 = XERCES_CPP_NAMESPACE::XMLPlatformUtils::fgMemoryManager;
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMImplementationLS_createDOMBuilder(self,mode,schemaType);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationLS, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMImplementationLS_createDOMBuilder" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementationLS *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementationLS * >(argp1);
    ecode2 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMImplementationLS_createDOMBuilder" "', argument " "2"" of type '" "short""'");
    } 
    arg2 = static_cast< short >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMImplementationLS_createDOMBuilder");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMBuilder *)(arg1)->createDOMBuilder(arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementationLS_createDOMBuilder) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationLS, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationLS, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(3), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarPool, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMImplementationLS_createDOMBuilder__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMImplementationLS_createDOMBuilder__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'DOMImplementationLS_createDOMBuilder'");
  XSRETURN(0);
}


XS(_wrap_DOMImplementationLS_createDOMWriter) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementationLS *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementationLS *) 0 ;
    XERCES_CPP_NAMESPACE::DOMWriter *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMImplementationLS_createDOMWriter(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationLS, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMImplementationLS_createDOMWriter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementationLS *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementationLS * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMWriter *)(arg1)->createDOMWriter();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementationLS_createDOMInputSource) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementationLS *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementationLS *) 0 ;
    XERCES_CPP_NAMESPACE::DOMInputSource *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMImplementationLS_createDOMInputSource(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationLS, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMImplementationLS_createDOMInputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementationLS *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementationLS * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMInputSource *)(arg1)->createDOMInputSource();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMImplementation) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementation *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementation *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMImplementation(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMImplementation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementation *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementation * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementation_hasFeature) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementation *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementation *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMImplementation_hasFeature(self,feature,version);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMImplementation_hasFeature" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementation const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementation * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMImplementation_hasFeature");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMImplementation_hasFeature");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMImplementation const *)arg1)->hasFeature((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementation_createDocumentType) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementation *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementation *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XMLCh *arg4 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocumentType *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DOMImplementation_createDocumentType(self,qualifiedName,publicId,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMImplementation_createDocumentType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementation *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementation * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMImplementation_createDocumentType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMImplementation_createDocumentType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DOMImplementation_createDocumentType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocumentType *)(arg1)->createDocumentType((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementation_createDocument__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementation *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementation *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocumentType *arg4 = (XERCES_CPP_NAMESPACE::DOMDocumentType *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocument *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DOMImplementation_createDocument(self,namespaceURI,qualifiedName,doctype);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMImplementation_createDocument" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementation *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementation * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMImplementation_createDocument");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMImplementation_createDocument");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "DOMImplementation_createDocument" "', argument " "4"" of type '" "XERCES_CPP_NAMESPACE::DOMDocumentType *""'"); 
    }
    arg4 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocumentType * >(argp4);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocument *)(arg1)->createDocument((XMLCh const *)arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementation_getInterface) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementation *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementation *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMImplementation *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMImplementation_getInterface(self,feature);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMImplementation_getInterface" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementation *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementation * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMImplementation_getInterface");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMImplementation *)(arg1)->getInterface((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementation_createDocument__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementation *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementation *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocument *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMImplementation_createDocument(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMImplementation_createDocument" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementation *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementation * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocument *)(arg1)->createDocument();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementation_createDocument) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(3), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMImplementation_createDocument__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMImplementation_createDocument__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'DOMImplementation_createDocument'");
  XSRETURN(0);
}


XS(_wrap_DOMImplementation_getImplementation) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementation *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: DOMImplementation_getImplementation();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMImplementation *)XERCES_CPP_NAMESPACE::DOMImplementation::getImplementation();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0 | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMImplementationSource) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementationSource *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementationSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMImplementationSource(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationSource, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMImplementationSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementationSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementationSource * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementationSource_getDOMImplementation) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementationSource *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementationSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMImplementation *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMImplementationSource_getDOMImplementation(self,features);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMImplementationSource_getDOMImplementation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementationSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementationSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMImplementationSource_getDOMImplementation");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMImplementation *)((XERCES_CPP_NAMESPACE::DOMImplementationSource const *)arg1)->getDOMImplementation((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementationRegistry_getDOMImplementation) {
  {
    XMLCh *arg1 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMImplementation *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMImplementationRegistry_getDOMImplementation(features);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"DOMImplementationRegistry_getDOMImplementation");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMImplementation *)XERCES_CPP_NAMESPACE::DOMImplementationRegistry::getDOMImplementation((unsigned short const *)arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0 | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMImplementationRegistry_addSource) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementationSource *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementationSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMImplementationRegistry_addSource(source);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMImplementationRegistry_addSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementationSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementationSource * >(argp1);
    {
      try 
      {
        XERCES_CPP_NAMESPACE::DOMImplementationRegistry::addSource(arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMImplementationRegistry) {
  {
    XERCES_CPP_NAMESPACE::DOMImplementationRegistry *arg1 = (XERCES_CPP_NAMESPACE::DOMImplementationRegistry *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMImplementationRegistry(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationRegistry, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMImplementationRegistry" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMImplementationRegistry *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMImplementationRegistry * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMErrorHandler) {
  {
    XERCES_CPP_NAMESPACE::DOMErrorHandler *arg1 = (XERCES_CPP_NAMESPACE::DOMErrorHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMErrorHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMErrorHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMErrorHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMErrorHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMErrorHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMErrorHandler_handleError) {
  {
    XERCES_CPP_NAMESPACE::DOMErrorHandler *arg1 = (XERCES_CPP_NAMESPACE::DOMErrorHandler *) 0 ;
    XERCES_CPP_NAMESPACE::DOMError *arg2 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMErrorHandler_handleError(self,domError);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMErrorHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMErrorHandler_handleError" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMErrorHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMErrorHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMError,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMErrorHandler_handleError" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMError const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DOMErrorHandler_handleError" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMError const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMError * >(argp2);
    {
      try 
      {
        result = (bool)(arg1)->handleError((XERCES_CPP_NAMESPACE::DOMError const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::DOMEntityResolver *arg1 = (XERCES_CPP_NAMESPACE::DOMEntityResolver *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMEntityResolver(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntityResolver, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMEntityResolver *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntityResolver * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMDocument) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMDocument(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMDocument" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createElement) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMElement *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_createElement(self,tagName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createElement" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createElement");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMElement *)(arg1)->createElement((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createDocumentFragment) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocumentFragment *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_createDocumentFragment(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createDocumentFragment" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocumentFragment *)(arg1)->createDocumentFragment();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentFragment, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createTextNode) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMText *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_createTextNode(self,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createTextNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createTextNode");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMText *)(arg1)->createTextNode((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createComment) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMComment *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_createComment(self,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createComment" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createComment");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMComment *)(arg1)->createComment((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMComment, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createCDATASection) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMCDATASection *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_createCDATASection(self,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createCDATASection" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createCDATASection");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMCDATASection *)(arg1)->createCDATASection((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCDATASection, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createProcessingInstruction) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMProcessingInstruction *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMDocument_createProcessingInstruction(self,target,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createProcessingInstruction" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createProcessingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMDocument_createProcessingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMProcessingInstruction *)(arg1)->createProcessingInstruction((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createAttribute) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMAttr *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_createAttribute(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createAttribute" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createAttribute");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMAttr *)(arg1)->createAttribute((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createEntityReference) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMEntityReference *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_createEntityReference(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createEntityReference" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createEntityReference");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMEntityReference *)(arg1)->createEntityReference((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntityReference, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getDoctype) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocumentType *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_getDoctype(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getDoctype" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocumentType *)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getDoctype();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getImplementation) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XERCES_CPP_NAMESPACE::DOMImplementation *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_getImplementation(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getImplementation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMImplementation *)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getImplementation();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getDocumentElement) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XERCES_CPP_NAMESPACE::DOMElement *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_getDocumentElement(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getDocumentElement" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMElement *)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getDocumentElement();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getElementsByTagName) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNodeList *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_getElementsByTagName(self,tagname);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getElementsByTagName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_getElementsByTagName");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNodeList *)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getElementsByTagName((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeList, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_importNode) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    bool arg3 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    bool val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMDocument_importNode(self,importedNode,deep);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_importNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMDocument_importNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    ecode3 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMDocument_importNode" "', argument " "3"" of type '" "bool""'");
    } 
    arg3 = static_cast< bool >(val3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->importNode(arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createElementNS__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMElement *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMDocument_createElementNS(self,namespaceURI,qualifiedName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createElementNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createElementNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMDocument_createElementNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMElement *)(arg1)->createElementNS((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createAttributeNS) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMAttr *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMDocument_createAttributeNS(self,namespaceURI,qualifiedName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createAttributeNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMDocument_createAttributeNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMAttr *)(arg1)->createAttributeNS((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getElementsByTagNameNS) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNodeList *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMDocument_getElementsByTagNameNS(self,namespaceURI,localName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getElementsByTagNameNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_getElementsByTagNameNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMDocument_getElementsByTagNameNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNodeList *)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getElementsByTagNameNS((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeList, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getElementById) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMElement *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_getElementById(self,elementId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getElementById" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_getElementById");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMElement *)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getElementById((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getActualEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_getActualEncoding(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getActualEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getActualEncoding();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_setActualEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_setActualEncoding(self,actualEncoding);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_setActualEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_setActualEncoding");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setActualEncoding((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_getEncoding(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getEncoding();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_setEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_setEncoding(self,encoding);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_setEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_setEncoding");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setEncoding((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getStandalone) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_getStandalone(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getStandalone" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getStandalone();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_setStandalone) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_setStandalone(self,standalone);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_setStandalone" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMDocument_setStandalone" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setStandalone(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getVersion) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_getVersion(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getVersion" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getVersion();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_setVersion) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_setVersion(self,version);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_setVersion" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_setVersion");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setVersion((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getDocumentURI) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_getDocumentURI(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getDocumentURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getDocumentURI();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_setDocumentURI) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_setDocumentURI(self,documentURI);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_setDocumentURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_setDocumentURI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setDocumentURI((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getStrictErrorChecking) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_getStrictErrorChecking(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getStrictErrorChecking" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getStrictErrorChecking();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_setStrictErrorChecking) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_setStrictErrorChecking(self,strictErrorChecking);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_setStrictErrorChecking" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMDocument_setStrictErrorChecking" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setStrictErrorChecking(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_renameNode) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XMLCh *arg4 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DOMDocument_renameNode(self,n,namespaceURI,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_renameNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMDocument_renameNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMDocument_renameNode");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DOMDocument_renameNode");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->renameNode(arg2,(XMLCh const *)arg3,(XMLCh const *)arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_adoptNode) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_adoptNode(self,source);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_adoptNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMDocument_adoptNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)(arg1)->adoptNode(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_normalizeDocument) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_normalizeDocument(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_normalizeDocument" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        (arg1)->normalizeDocument();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_getDOMConfiguration) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XERCES_CPP_NAMESPACE::DOMConfiguration *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMDocument_getDOMConfiguration(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_getDOMConfiguration" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMConfiguration *)((XERCES_CPP_NAMESPACE::DOMDocument const *)arg1)->getDOMConfiguration();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMConfiguration, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createEntity) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMEntity *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_createEntity(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createEntity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createEntity");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMEntity *)(arg1)->createEntity((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createDocumentType__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocumentType *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_createDocumentType(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createDocumentType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createDocumentType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocumentType *)(arg1)->createDocumentType((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createDocumentType__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XMLCh *arg4 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocumentType *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DOMDocument_createDocumentType(self,qName,XMLCh const *,XMLCh const *);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createDocumentType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createDocumentType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMDocument_createDocumentType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DOMDocument_createDocumentType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocumentType *)(arg1)->createDocumentType((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createDocumentType) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(3)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMDocument_createDocumentType__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMDocument_createDocumentType__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'DOMDocument_createDocumentType'");
  XSRETURN(0);
}


XS(_wrap_DOMDocument_createNotation) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNotation *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMDocument_createNotation(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createNotation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createNotation");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNotation *)(arg1)->createNotation((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNotation, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createElementNS__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::DOMDocument *arg1 = (XERCES_CPP_NAMESPACE::DOMDocument *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    XMLCh *arg3 = (XMLCh *) 0 ;
    XMLSSize_t arg4 ;
    XMLSSize_t arg5 ;
    XERCES_CPP_NAMESPACE::DOMElement *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    long val4 ;
    int ecode4 = 0 ;
    long val5 ;
    int ecode5 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: DOMDocument_createElementNS(self,namespaceURI,qualifiedName,lineNum,columnNum);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMDocument_createElementNS" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMDocument *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMDocument * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMDocument_createElementNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DOMDocument_createElementNS");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    ecode4 = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "DOMDocument_createElementNS" "', argument " "4"" of type '" "XMLSSize_t""'");
    } 
    arg4 = static_cast< XMLSSize_t >(val4);
    ecode5 = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(ST(4), &val5);
    if (!SWIG_IsOK(ecode5)) {
      SWIG_exception_fail(SWIG_ArgError(ecode5), "in method '" "DOMDocument_createElementNS" "', argument " "5"" of type '" "XMLSSize_t""'");
    } 
    arg5 = static_cast< XMLSSize_t >(val5);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMElement *)(arg1)->createElementNS((XMLCh const *)arg2,(XMLCh const *)arg3,arg4,arg5);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMDocument_createElementNS) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 5) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(ST(4), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMDocument_createElementNS__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMDocument_createElementNS__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'DOMDocument_createElementNS'");
  XSRETURN(0);
}


XS(_wrap_delete_DOMLocator) {
  {
    XERCES_CPP_NAMESPACE::DOMLocator *arg1 = (XERCES_CPP_NAMESPACE::DOMLocator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMLocator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMLocator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMLocator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMLocator * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMLocator_getLineNumber) {
  {
    XERCES_CPP_NAMESPACE::DOMLocator *arg1 = (XERCES_CPP_NAMESPACE::DOMLocator *) 0 ;
    XMLSSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMLocator_getLineNumber(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMLocator_getLineNumber" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMLocator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMLocator * >(argp1);
    {
      try 
      {
        result = (XMLSSize_t)((XERCES_CPP_NAMESPACE::DOMLocator const *)arg1)->getLineNumber();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_long  SWIG_PERL_CALL_ARGS_1(static_cast< long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMLocator_getColumnNumber) {
  {
    XERCES_CPP_NAMESPACE::DOMLocator *arg1 = (XERCES_CPP_NAMESPACE::DOMLocator *) 0 ;
    XMLSSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMLocator_getColumnNumber(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMLocator_getColumnNumber" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMLocator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMLocator * >(argp1);
    {
      try 
      {
        result = (XMLSSize_t)((XERCES_CPP_NAMESPACE::DOMLocator const *)arg1)->getColumnNumber();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_long  SWIG_PERL_CALL_ARGS_1(static_cast< long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMLocator_getOffset) {
  {
    XERCES_CPP_NAMESPACE::DOMLocator *arg1 = (XERCES_CPP_NAMESPACE::DOMLocator *) 0 ;
    XMLSSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMLocator_getOffset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMLocator_getOffset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMLocator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMLocator * >(argp1);
    {
      try 
      {
        result = (XMLSSize_t)((XERCES_CPP_NAMESPACE::DOMLocator const *)arg1)->getOffset();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_long  SWIG_PERL_CALL_ARGS_1(static_cast< long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMLocator_getErrorNode) {
  {
    XERCES_CPP_NAMESPACE::DOMLocator *arg1 = (XERCES_CPP_NAMESPACE::DOMLocator *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMLocator_getErrorNode(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMLocator_getErrorNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMLocator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMLocator * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMNode *)((XERCES_CPP_NAMESPACE::DOMLocator const *)arg1)->getErrorNode();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMLocator_getURI) {
  {
    XERCES_CPP_NAMESPACE::DOMLocator *arg1 = (XERCES_CPP_NAMESPACE::DOMLocator *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMLocator_getURI(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMLocator_getURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMLocator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMLocator * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMLocator const *)arg1)->getURI();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMLocator_setLineNumber) {
  {
    XERCES_CPP_NAMESPACE::DOMLocator *arg1 = (XERCES_CPP_NAMESPACE::DOMLocator *) 0 ;
    XMLSSize_t arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMLocator_setLineNumber(self,lineNumber);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMLocator_setLineNumber" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMLocator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMLocator * >(argp1);
    ecode2 = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMLocator_setLineNumber" "', argument " "2"" of type '" "XMLSSize_t""'");
    } 
    arg2 = static_cast< XMLSSize_t >(val2);
    {
      try 
      {
        (arg1)->setLineNumber(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMLocator_setColumnNumber) {
  {
    XERCES_CPP_NAMESPACE::DOMLocator *arg1 = (XERCES_CPP_NAMESPACE::DOMLocator *) 0 ;
    XMLSSize_t arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMLocator_setColumnNumber(self,columnNumber);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMLocator_setColumnNumber" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMLocator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMLocator * >(argp1);
    ecode2 = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMLocator_setColumnNumber" "', argument " "2"" of type '" "XMLSSize_t""'");
    } 
    arg2 = static_cast< XMLSSize_t >(val2);
    {
      try 
      {
        (arg1)->setColumnNumber(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMLocator_setOffset) {
  {
    XERCES_CPP_NAMESPACE::DOMLocator *arg1 = (XERCES_CPP_NAMESPACE::DOMLocator *) 0 ;
    XMLSSize_t arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMLocator_setOffset(self,offset);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMLocator_setOffset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMLocator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMLocator * >(argp1);
    ecode2 = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMLocator_setOffset" "', argument " "2"" of type '" "XMLSSize_t""'");
    } 
    arg2 = static_cast< XMLSSize_t >(val2);
    {
      try 
      {
        (arg1)->setOffset(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMLocator_setErrorNode) {
  {
    XERCES_CPP_NAMESPACE::DOMLocator *arg1 = (XERCES_CPP_NAMESPACE::DOMLocator *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) (XERCES_CPP_NAMESPACE::DOMNode *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMLocator_setErrorNode(self,errorNode);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMLocator_setErrorNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMLocator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMLocator * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMLocator_setErrorNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        (arg1)->setErrorNode(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMLocator_setURI) {
  {
    XERCES_CPP_NAMESPACE::DOMLocator *arg1 = (XERCES_CPP_NAMESPACE::DOMLocator *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMLocator_setURI(self,uri);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMLocator_setURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMLocator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMLocator * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMLocator_setURI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setURI((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMInputSource) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMInputSource(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMInputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_getEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMInputSource_getEncoding(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_getEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMInputSource const *)arg1)->getEncoding();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_getPublicId) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMInputSource_getPublicId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_getPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMInputSource const *)arg1)->getPublicId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMInputSource_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMInputSource const *)arg1)->getSystemId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_getBaseURI) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMInputSource_getBaseURI(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_getBaseURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMInputSource const *)arg1)->getBaseURI();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_setEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMInputSource_setEncoding(self,encodingStr);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_setEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMInputSource_setEncoding");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setEncoding((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_setPublicId) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMInputSource_setPublicId(self,publicId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_setPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMInputSource_setPublicId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setPublicId((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_setSystemId) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMInputSource_setSystemId(self,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_setSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMInputSource_setSystemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setSystemId((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_setBaseURI) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMInputSource_setBaseURI(self,baseURI);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_setBaseURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMInputSource_setBaseURI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setBaseURI((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_makeStream) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    XERCES_CPP_NAMESPACE::BinInputStream *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMInputSource_makeStream(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_makeStream" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::BinInputStream *)((XERCES_CPP_NAMESPACE::DOMInputSource const *)arg1)->makeStream();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__BinInputStream, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_setIssueFatalErrorIfNotFound) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMInputSource_setIssueFatalErrorIfNotFound(self,flag);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_setIssueFatalErrorIfNotFound" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMInputSource_setIssueFatalErrorIfNotFound" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIssueFatalErrorIfNotFound(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_getIssueFatalErrorIfNotFound) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMInputSource_getIssueFatalErrorIfNotFound(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_getIssueFatalErrorIfNotFound" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMInputSource const *)arg1)->getIssueFatalErrorIfNotFound();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMInputSource_release) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMInputSource_release(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMInputSource_release" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    {
      try 
      {
        (arg1)->release();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_Wrapper4InputSource) {
  {
    XERCES_CPP_NAMESPACE::InputSource *arg1 = (XERCES_CPP_NAMESPACE::InputSource *) (XERCES_CPP_NAMESPACE::InputSource *)0 ;
    bool arg2 ;
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg2 = true;
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_Wrapper4InputSource(inputSource);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_Wrapper4InputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::InputSource *const""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *)new XERCES_CPP_NAMESPACE::Wrapper4InputSource(arg1,arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_Wrapper4InputSource) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_Wrapper4InputSource(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_Wrapper4InputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_makeStream) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    XERCES_CPP_NAMESPACE::BinInputStream *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4InputSource_makeStream(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_makeStream" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::BinInputStream *)((XERCES_CPP_NAMESPACE::Wrapper4InputSource const *)arg1)->makeStream();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__BinInputStream, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_getEncoding) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4InputSource_getEncoding(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_getEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Wrapper4InputSource const *)arg1)->getEncoding();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_getPublicId) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4InputSource_getPublicId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_getPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Wrapper4InputSource const *)arg1)->getPublicId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4InputSource_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Wrapper4InputSource const *)arg1)->getSystemId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_getBaseURI) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4InputSource_getBaseURI(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_getBaseURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Wrapper4InputSource const *)arg1)->getBaseURI();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_getIssueFatalErrorIfNotFound) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4InputSource_getIssueFatalErrorIfNotFound(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_getIssueFatalErrorIfNotFound" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::Wrapper4InputSource const *)arg1)->getIssueFatalErrorIfNotFound();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_setEncoding) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Wrapper4InputSource_setEncoding(self,encodingStr);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_setEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Wrapper4InputSource_setEncoding");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setEncoding((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_setPublicId) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Wrapper4InputSource_setPublicId(self,publicId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_setPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Wrapper4InputSource_setPublicId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setPublicId((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_setSystemId) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Wrapper4InputSource_setSystemId(self,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_setSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Wrapper4InputSource_setSystemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setSystemId((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_setBaseURI) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Wrapper4InputSource_setBaseURI(self,baseURI);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_setBaseURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Wrapper4InputSource_setBaseURI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setBaseURI((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_setIssueFatalErrorIfNotFound) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Wrapper4InputSource_setIssueFatalErrorIfNotFound(self,flag);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_setIssueFatalErrorIfNotFound" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Wrapper4InputSource_setIssueFatalErrorIfNotFound" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIssueFatalErrorIfNotFound(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4InputSource_release) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4InputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4InputSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4InputSource_release(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4InputSource_release" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4InputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4InputSource * >(argp1);
    {
      try 
      {
        (arg1)->release();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_Wrapper4DOMInputSource) {
  {
    XERCES_CPP_NAMESPACE::DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::DOMInputSource *) (XERCES_CPP_NAMESPACE::DOMInputSource *)0 ;
    bool arg2 ;
    XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg2 = true;
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_Wrapper4DOMInputSource(inputSource);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_Wrapper4DOMInputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource *const""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *)new XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource(arg1,arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_Wrapper4DOMInputSource) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_Wrapper4DOMInputSource(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_Wrapper4DOMInputSource" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4DOMInputSource_makeStream) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) 0 ;
    XERCES_CPP_NAMESPACE::BinInputStream *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4DOMInputSource_makeStream(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4DOMInputSource_makeStream" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::BinInputStream *)((XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource const *)arg1)->makeStream();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__BinInputStream, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4DOMInputSource_getEncoding) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4DOMInputSource_getEncoding(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4DOMInputSource_getEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource const *)arg1)->getEncoding();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4DOMInputSource_getPublicId) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4DOMInputSource_getPublicId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4DOMInputSource_getPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource const *)arg1)->getPublicId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4DOMInputSource_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4DOMInputSource_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4DOMInputSource_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource const *)arg1)->getSystemId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4DOMInputSource_getIssueFatalErrorIfNotFound) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Wrapper4DOMInputSource_getIssueFatalErrorIfNotFound(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4DOMInputSource_getIssueFatalErrorIfNotFound" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource const *)arg1)->getIssueFatalErrorIfNotFound();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4DOMInputSource_setEncoding) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Wrapper4DOMInputSource_setEncoding(self,encodingStr);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4DOMInputSource_setEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Wrapper4DOMInputSource_setEncoding");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setEncoding((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4DOMInputSource_setPublicId) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Wrapper4DOMInputSource_setPublicId(self,publicId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4DOMInputSource_setPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Wrapper4DOMInputSource_setPublicId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setPublicId((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4DOMInputSource_setSystemId) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Wrapper4DOMInputSource_setSystemId(self,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4DOMInputSource_setSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Wrapper4DOMInputSource_setSystemId");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setSystemId((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Wrapper4DOMInputSource_setIssueFatalErrorIfNotFound) {
  {
    XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *arg1 = (XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Wrapper4DOMInputSource_setIssueFatalErrorIfNotFound(self,flag);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Wrapper4DOMInputSource_setIssueFatalErrorIfNotFound" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Wrapper4DOMInputSource_setIssueFatalErrorIfNotFound" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIssueFatalErrorIfNotFound(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMBuilder) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMBuilder(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMBuilder" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_getErrorHandler) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XERCES_CPP_NAMESPACE::DOMErrorHandler *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMBuilder_getErrorHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_getErrorHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMErrorHandler *)(arg1)->getErrorHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMErrorHandler, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_getEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XERCES_CPP_NAMESPACE::DOMEntityResolver *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMBuilder_getEntityResolver(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_getEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMEntityResolver *)(arg1)->getEntityResolver();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntityResolver, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_getFilter) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XERCES_CPP_NAMESPACE::DOMBuilderFilter *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMBuilder_getFilter(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_getFilter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMBuilderFilter *)(arg1)->getFilter();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilderFilter, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_setErrorHandler) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XERCES_CPP_NAMESPACE::DOMErrorHandler *arg2 = (XERCES_CPP_NAMESPACE::DOMErrorHandler *) (XERCES_CPP_NAMESPACE::DOMErrorHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMBuilder_setErrorHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_setErrorHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMErrorHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMBuilder_setErrorHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMErrorHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMErrorHandler * >(argp2);
    {
      try 
      {
        (arg1)->setErrorHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_setEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XERCES_CPP_NAMESPACE::DOMEntityResolver *arg2 = (XERCES_CPP_NAMESPACE::DOMEntityResolver *) (XERCES_CPP_NAMESPACE::DOMEntityResolver *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMBuilder_setEntityResolver(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_setEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntityResolver, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMBuilder_setEntityResolver" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMEntityResolver *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMEntityResolver * >(argp2);
    {
      try 
      {
        (arg1)->setEntityResolver(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_setFilter) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XERCES_CPP_NAMESPACE::DOMBuilderFilter *arg2 = (XERCES_CPP_NAMESPACE::DOMBuilderFilter *) (XERCES_CPP_NAMESPACE::DOMBuilderFilter *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMBuilder_setFilter(self,filter);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_setFilter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilderFilter, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMBuilder_setFilter" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilderFilter *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilderFilter * >(argp2);
    {
      try 
      {
        (arg1)->setFilter(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_setFeature) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    bool arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMBuilder_setFeature(self,name,state);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_setFeature" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMBuilder_setFeature");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMBuilder_setFeature" "', argument " "3"" of type '" "bool""'");
    } 
    arg3 = static_cast< bool >(val3);
    {
      try 
      {
        (arg1)->setFeature((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_getFeature) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMBuilder_getFeature(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_getFeature" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMBuilder_getFeature");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMBuilder const *)arg1)->getFeature((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_canSetFeature) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    bool arg3 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMBuilder_canSetFeature(self,name,state);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_canSetFeature" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMBuilder_canSetFeature");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMBuilder_canSetFeature" "', argument " "3"" of type '" "bool""'");
    } 
    arg3 = static_cast< bool >(val3);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMBuilder const *)arg1)->canSetFeature((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_parse) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XERCES_CPP_NAMESPACE::DOMInputSource *arg2 = 0 ;
    XERCES_CPP_NAMESPACE::DOMDocument *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMBuilder_parse(self,source);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_parse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMBuilder_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DOMBuilder_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocument *)(arg1)->parse((XERCES_CPP_NAMESPACE::DOMInputSource const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_parseURI) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::DOMDocument *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMBuilder_parseURI(self,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_parseURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMBuilder_parseURI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocument *)(arg1)->parseURI((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_parseWithContext) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XERCES_CPP_NAMESPACE::DOMInputSource *arg2 = 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg3 = (XERCES_CPP_NAMESPACE::DOMNode *) (XERCES_CPP_NAMESPACE::DOMNode *)0 ;
    short arg4 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    short val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DOMBuilder_parseWithContext(self,source,contextNode,action);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_parseWithContext" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMBuilder_parseWithContext" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DOMBuilder_parseWithContext" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp2);
    res3 = SWIG_ConvertPtr(ST(2), &argp3,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "DOMBuilder_parseWithContext" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::DOMNode *const""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp3);
    ecode4 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "DOMBuilder_parseWithContext" "', argument " "4"" of type '" "short""'");
    } 
    arg4 = static_cast< short >(val4);
    {
      try 
      {
        (arg1)->parseWithContext((XERCES_CPP_NAMESPACE::DOMInputSource const &)*arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_getProperty) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMBuilder_getProperty(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_getProperty" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMBuilder_getProperty");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (void *)((XERCES_CPP_NAMESPACE::DOMBuilder const *)arg1)->getProperty((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_void, 0 | 0); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_setProperty) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *arg3 = (void *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMBuilder_setProperty(self,name,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_setProperty" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMBuilder_setProperty");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      // now check the value
      if (ST(2) == &PL_sv_undef) {
        SWIG_Perl_NullRef("perl-string",3,"DOMBuilder_setProperty");
        goto fail;
      } else {
        // we convert *everything* into a string that isn't undef
        arg3 = Perl2XMLString(ST(2));
      }
    }
    {
      try 
      {
        (arg1)->setProperty((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_release) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMBuilder_release(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_release" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    {
      try 
      {
        (arg1)->release();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_resetDocumentPool) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMBuilder_resetDocumentPool(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_resetDocumentPool" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    {
      try 
      {
        (arg1)->resetDocumentPool();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_loadGrammar__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XERCES_CPP_NAMESPACE::DOMInputSource *arg2 = 0 ;
    short arg3 ;
    bool arg4 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    bool val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DOMBuilder_loadGrammar(self,source,grammarType,toCache);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMBuilder_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DOMBuilder_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp2);
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMBuilder_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    ecode4 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "DOMBuilder_loadGrammar" "', argument " "4"" of type '" "bool""'");
    } 
    arg4 = static_cast< bool >(val4);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XERCES_CPP_NAMESPACE::DOMInputSource const &)*arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_loadGrammar__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XERCES_CPP_NAMESPACE::DOMInputSource *arg2 = 0 ;
    short arg3 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMBuilder_loadGrammar(self,source,grammarType);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMBuilder_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DOMBuilder_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMInputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMInputSource * >(argp2);
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMBuilder_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XERCES_CPP_NAMESPACE::DOMInputSource const &)*arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_loadGrammar__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    short arg3 ;
    bool arg4 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    bool val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DOMBuilder_loadGrammar(self,systemId,grammarType,toCache);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMBuilder_loadGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMBuilder_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    ecode4 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "DOMBuilder_loadGrammar" "', argument " "4"" of type '" "bool""'");
    } 
    arg4 = static_cast< bool >(val4);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XMLCh const *)arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_loadGrammar__SWIG_3) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    short arg3 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMBuilder_loadGrammar(self,systemId,grammarType);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMBuilder_loadGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMBuilder_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_loadGrammar) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMBuilder_loadGrammar__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMBuilder_loadGrammar__SWIG_3); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMBuilder_loadGrammar__SWIG_0); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_DOMBuilder_loadGrammar__SWIG_2); return;
    }
  }
  
  croak("No matching function for overloaded 'DOMBuilder_loadGrammar'");
  XSRETURN(0);
}


XS(_wrap_DOMBuilder_getGrammar) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMBuilder_getGrammar(self,nameSpaceKey);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_getGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMBuilder_getGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)((XERCES_CPP_NAMESPACE::DOMBuilder const *)arg1)->getGrammar((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_getRootGrammar) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMBuilder_getRootGrammar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_getRootGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)((XERCES_CPP_NAMESPACE::DOMBuilder const *)arg1)->getRootGrammar();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_getURIText) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMBuilder_getURIText(self,uriId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_getURIText" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMBuilder_getURIText" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMBuilder const *)arg1)->getURIText(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_resetCachedGrammarPool) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMBuilder_resetCachedGrammarPool(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_resetCachedGrammarPool" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    {
      try 
      {
        (arg1)->resetCachedGrammarPool();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMBuilder_getSrcOffset) {
  {
    XERCES_CPP_NAMESPACE::DOMBuilder *arg1 = (XERCES_CPP_NAMESPACE::DOMBuilder *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMBuilder_getSrcOffset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMBuilder_getSrcOffset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMBuilder const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMBuilder * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::DOMBuilder const *)arg1)->getSrcOffset();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_StdOutFormatTarget) {
  {
    XERCES_CPP_NAMESPACE::StdOutFormatTarget *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_StdOutFormatTarget();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::StdOutFormatTarget *)new XERCES_CPP_NAMESPACE::StdOutFormatTarget();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__StdOutFormatTarget, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_delete_StdOutFormatTarget) {
  {
    XERCES_CPP_NAMESPACE::StdOutFormatTarget *arg1 = (XERCES_CPP_NAMESPACE::StdOutFormatTarget *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_StdOutFormatTarget(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__StdOutFormatTarget, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_StdOutFormatTarget" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::StdOutFormatTarget *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::StdOutFormatTarget * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_StdOutFormatTarget_writeChars) {
  {
    XERCES_CPP_NAMESPACE::StdOutFormatTarget *arg1 = (XERCES_CPP_NAMESPACE::StdOutFormatTarget *) 0 ;
    XMLByte *arg2 = (XMLByte *) (XMLByte *)0 ;
    unsigned int arg3 ;
    XERCES_CPP_NAMESPACE::XMLFormatter *arg4 = (XERCES_CPP_NAMESPACE::XMLFormatter *) (XERCES_CPP_NAMESPACE::XMLFormatter *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: StdOutFormatTarget_writeChars(self,toWrite,count,formatter);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__StdOutFormatTarget, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "StdOutFormatTarget_writeChars" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::StdOutFormatTarget *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::StdOutFormatTarget * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_unsigned_char, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "StdOutFormatTarget_writeChars" "', argument " "2"" of type '" "XMLByte const *const""'"); 
    }
    arg2 = reinterpret_cast< XMLByte * >(argp2);
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "StdOutFormatTarget_writeChars" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLFormatter, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "StdOutFormatTarget_writeChars" "', argument " "4"" of type '" "XERCES_CPP_NAMESPACE::XMLFormatter *const""'"); 
    }
    arg4 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLFormatter * >(argp4);
    {
      try 
      {
        (arg1)->writeChars((XMLByte const *)arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_StdOutFormatTarget_flush) {
  {
    XERCES_CPP_NAMESPACE::StdOutFormatTarget *arg1 = (XERCES_CPP_NAMESPACE::StdOutFormatTarget *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: StdOutFormatTarget_flush(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__StdOutFormatTarget, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "StdOutFormatTarget_flush" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::StdOutFormatTarget *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::StdOutFormatTarget * >(argp1);
    {
      try 
      {
        (arg1)->flush();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_LocalFileFormatTarget) {
  {
    XMLCh *arg1 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::LocalFileFormatTarget *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_LocalFileFormatTarget(XMLCh const *const);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"new_LocalFileFormatTarget");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::LocalFileFormatTarget *)new XERCES_CPP_NAMESPACE::LocalFileFormatTarget((XMLCh const *)arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_LocalFileFormatTarget) {
  {
    XERCES_CPP_NAMESPACE::LocalFileFormatTarget *arg1 = (XERCES_CPP_NAMESPACE::LocalFileFormatTarget *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_LocalFileFormatTarget(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_LocalFileFormatTarget" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LocalFileFormatTarget *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LocalFileFormatTarget * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_LocalFileFormatTarget_writeChars) {
  {
    XERCES_CPP_NAMESPACE::LocalFileFormatTarget *arg1 = (XERCES_CPP_NAMESPACE::LocalFileFormatTarget *) 0 ;
    XMLByte *arg2 = (XMLByte *) (XMLByte *)0 ;
    unsigned int arg3 ;
    XERCES_CPP_NAMESPACE::XMLFormatter *arg4 = (XERCES_CPP_NAMESPACE::XMLFormatter *) (XERCES_CPP_NAMESPACE::XMLFormatter *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: LocalFileFormatTarget_writeChars(self,toWrite,count,formatter);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "LocalFileFormatTarget_writeChars" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LocalFileFormatTarget *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LocalFileFormatTarget * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_unsigned_char, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "LocalFileFormatTarget_writeChars" "', argument " "2"" of type '" "XMLByte const *const""'"); 
    }
    arg2 = reinterpret_cast< XMLByte * >(argp2);
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "LocalFileFormatTarget_writeChars" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLFormatter, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "LocalFileFormatTarget_writeChars" "', argument " "4"" of type '" "XERCES_CPP_NAMESPACE::XMLFormatter *const""'"); 
    }
    arg4 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLFormatter * >(argp4);
    {
      try 
      {
        (arg1)->writeChars((XMLByte const *)arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_LocalFileFormatTarget_flush) {
  {
    XERCES_CPP_NAMESPACE::LocalFileFormatTarget *arg1 = (XERCES_CPP_NAMESPACE::LocalFileFormatTarget *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: LocalFileFormatTarget_flush(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "LocalFileFormatTarget_flush" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LocalFileFormatTarget *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LocalFileFormatTarget * >(argp1);
    {
      try 
      {
        (arg1)->flush();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_MemBufFormatTarget__SWIG_0) {
  {
    int arg1 ;
    XERCES_CPP_NAMESPACE::MemBufFormatTarget *result = 0 ;
    int val1 ;
    int ecode1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_MemBufFormatTarget(initCapacity);");
    }
    ecode1 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(0), &val1);
    if (!SWIG_IsOK(ecode1)) {
      SWIG_exception_fail(SWIG_ArgError(ecode1), "in method '" "new_MemBufFormatTarget" "', argument " "1"" of type '" "int""'");
    } 
    arg1 = static_cast< int >(val1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemBufFormatTarget *)new XERCES_CPP_NAMESPACE::MemBufFormatTarget(arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufFormatTarget, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_MemBufFormatTarget__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::MemBufFormatTarget *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_MemBufFormatTarget();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::MemBufFormatTarget *)new XERCES_CPP_NAMESPACE::MemBufFormatTarget();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufFormatTarget, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_MemBufFormatTarget) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          int res = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(0), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_MemBufFormatTarget__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_MemBufFormatTarget__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'new_MemBufFormatTarget'");
  XSRETURN(0);
}


XS(_wrap_delete_MemBufFormatTarget) {
  {
    XERCES_CPP_NAMESPACE::MemBufFormatTarget *arg1 = (XERCES_CPP_NAMESPACE::MemBufFormatTarget *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_MemBufFormatTarget(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufFormatTarget, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_MemBufFormatTarget" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::MemBufFormatTarget *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::MemBufFormatTarget * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_MemBufFormatTarget_writeChars) {
  {
    XERCES_CPP_NAMESPACE::MemBufFormatTarget *arg1 = (XERCES_CPP_NAMESPACE::MemBufFormatTarget *) 0 ;
    XMLByte *arg2 = (XMLByte *) (XMLByte *)0 ;
    unsigned int arg3 ;
    XERCES_CPP_NAMESPACE::XMLFormatter *arg4 = (XERCES_CPP_NAMESPACE::XMLFormatter *) (XERCES_CPP_NAMESPACE::XMLFormatter *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: MemBufFormatTarget_writeChars(self,toWrite,count,formatter);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufFormatTarget, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "MemBufFormatTarget_writeChars" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::MemBufFormatTarget *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::MemBufFormatTarget * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_unsigned_char, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "MemBufFormatTarget_writeChars" "', argument " "2"" of type '" "XMLByte const *const""'"); 
    }
    arg2 = reinterpret_cast< XMLByte * >(argp2);
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "MemBufFormatTarget_writeChars" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLFormatter, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "MemBufFormatTarget_writeChars" "', argument " "4"" of type '" "XERCES_CPP_NAMESPACE::XMLFormatter *const""'"); 
    }
    arg4 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLFormatter * >(argp4);
    {
      try 
      {
        (arg1)->writeChars((XMLByte const *)arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_MemBufFormatTarget_getRawBuffer) {
  {
    XERCES_CPP_NAMESPACE::MemBufFormatTarget *arg1 = (XERCES_CPP_NAMESPACE::MemBufFormatTarget *) 0 ;
    XMLByte *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: MemBufFormatTarget_getRawBuffer(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufFormatTarget, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "MemBufFormatTarget_getRawBuffer" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::MemBufFormatTarget const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::MemBufFormatTarget * >(argp1);
    {
      try 
      {
        result = (XMLByte *)((XERCES_CPP_NAMESPACE::MemBufFormatTarget const *)arg1)->getRawBuffer();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    {
      ST(argvi) = SWIG_FromCharPtr((char*)result); argvi++ ;
    }
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_MemBufFormatTarget_getLen) {
  {
    XERCES_CPP_NAMESPACE::MemBufFormatTarget *arg1 = (XERCES_CPP_NAMESPACE::MemBufFormatTarget *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: MemBufFormatTarget_getLen(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufFormatTarget, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "MemBufFormatTarget_getLen" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::MemBufFormatTarget const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::MemBufFormatTarget * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::MemBufFormatTarget const *)arg1)->getLen();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_MemBufFormatTarget_reset) {
  {
    XERCES_CPP_NAMESPACE::MemBufFormatTarget *arg1 = (XERCES_CPP_NAMESPACE::MemBufFormatTarget *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: MemBufFormatTarget_reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufFormatTarget, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "MemBufFormatTarget_reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::MemBufFormatTarget *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::MemBufFormatTarget * >(argp1);
    {
      try 
      {
        (arg1)->reset();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMWriter) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMWriter(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMWriter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_canSetFeature) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    bool arg3 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMWriter_canSetFeature(self,featName,state);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_canSetFeature" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMWriter_canSetFeature");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMWriter_canSetFeature" "', argument " "3"" of type '" "bool""'");
    } 
    arg3 = static_cast< bool >(val3);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMWriter const *)arg1)->canSetFeature((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_setFeature) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    bool arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMWriter_setFeature(self,featName,state);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_setFeature" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMWriter_setFeature");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DOMWriter_setFeature" "', argument " "3"" of type '" "bool""'");
    } 
    arg3 = static_cast< bool >(val3);
    {
      try 
      {
        (arg1)->setFeature((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_getFeature) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMWriter_getFeature(self,featName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_getFeature" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMWriter_getFeature");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::DOMWriter const *)arg1)->getFeature((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_setEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMWriter_setEncoding(self,encoding);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_setEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMWriter_setEncoding");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setEncoding((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_setNewLine) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMWriter_setNewLine(self,newLine);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_setNewLine" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DOMWriter_setNewLine");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setNewLine((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_setErrorHandler) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    XERCES_CPP_NAMESPACE::DOMErrorHandler *arg2 = (XERCES_CPP_NAMESPACE::DOMErrorHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMWriter_setErrorHandler(self,errorHandler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_setErrorHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMErrorHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMWriter_setErrorHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMErrorHandler *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMErrorHandler * >(argp2);
    {
      try 
      {
        (arg1)->setErrorHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_setFilter) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    DOMWriterFilter *arg2 = (DOMWriterFilter *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMWriter_setFilter(self,filter);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_setFilter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriterFilter, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMWriter_setFilter" "', argument " "2"" of type '" "DOMWriterFilter *""'"); 
    }
    arg2 = reinterpret_cast< DOMWriterFilter * >(argp2);
    {
      try 
      {
        (arg1)->setFilter(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_getEncoding) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMWriter_getEncoding(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_getEncoding" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMWriter const *)arg1)->getEncoding();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_getNewLine) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMWriter_getNewLine(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_getNewLine" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::DOMWriter const *)arg1)->getNewLine();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_writeNode) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    XERCES_CPP_NAMESPACE::XMLFormatTarget *arg2 = (XERCES_CPP_NAMESPACE::XMLFormatTarget *) (XERCES_CPP_NAMESPACE::XMLFormatTarget *)0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg3 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    void *argp3 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DOMWriter_writeNode(self,destination,nodeToWrite);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_writeNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLFormatTarget, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMWriter_writeNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLFormatTarget *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLFormatTarget * >(argp2);
    res3 = SWIG_ConvertPtr(ST(2), &argp3, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode,  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "DOMWriter_writeNode" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const &""'"); 
    }
    if (!argp3) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DOMWriter_writeNode" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const &""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp3);
    {
      try 
      {
        result = (bool)(arg1)->writeNode(arg2,(XERCES_CPP_NAMESPACE::DOMNode const &)*arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_writeToString) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMWriter_writeToString(self,nodeToWrite);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_writeToString" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMWriter_writeToString" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DOMWriter_writeToString" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (XMLCh *)(arg1)->writeToString((XERCES_CPP_NAMESPACE::DOMNode const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriter_release) {
  {
    XERCES_CPP_NAMESPACE::DOMWriter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriter *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMWriter_release(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriter_release" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriter * >(argp1);
    {
      try 
      {
        (arg1)->release();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DOMWriterFilter) {
  {
    XERCES_CPP_NAMESPACE::DOMWriterFilter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriterFilter *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DOMWriterFilter(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriterFilter, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DOMWriterFilter" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriterFilter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriterFilter * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriterFilter_acceptNode) {
  {
    XERCES_CPP_NAMESPACE::DOMWriterFilter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriterFilter *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    short result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMWriterFilter_acceptNode(self,node);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriterFilter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriterFilter_acceptNode" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriterFilter const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriterFilter * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DOMWriterFilter_acceptNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (short)((XERCES_CPP_NAMESPACE::DOMWriterFilter const *)arg1)->acceptNode((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_short  SWIG_PERL_CALL_ARGS_1(static_cast< short >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriterFilter_getWhatToShow) {
  {
    XERCES_CPP_NAMESPACE::DOMWriterFilter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriterFilter *) 0 ;
    unsigned long result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DOMWriterFilter_getWhatToShow(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriterFilter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriterFilter_getWhatToShow" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriterFilter const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriterFilter * >(argp1);
    {
      try 
      {
        result = (unsigned long)((XERCES_CPP_NAMESPACE::DOMWriterFilter const *)arg1)->getWhatToShow();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_long  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DOMWriterFilter_setWhatToShow) {
  {
    XERCES_CPP_NAMESPACE::DOMWriterFilter *arg1 = (XERCES_CPP_NAMESPACE::DOMWriterFilter *) 0 ;
    unsigned long arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned long val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DOMWriterFilter_setWhatToShow(self,toShow);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriterFilter, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DOMWriterFilter_setWhatToShow" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DOMWriterFilter *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMWriterFilter * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_long SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "DOMWriterFilter_setWhatToShow" "', argument " "2"" of type '" "unsigned long""'");
    } 
    arg2 = static_cast< unsigned long >(val2);
    {
      try 
      {
        (arg1)->setWhatToShow(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_SAXException) {
  {
    XERCES_CPP_NAMESPACE::SAXException *arg1 = (XERCES_CPP_NAMESPACE::SAXException *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SAXException(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXException, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SAXException" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXException * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXException_getMessage) {
  {
    XERCES_CPP_NAMESPACE::SAXException *arg1 = (XERCES_CPP_NAMESPACE::SAXException *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXException_getMessage(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXException_getMessage" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXException * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SAXException const *)arg1)->getMessage();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SAXNotSupportedException) {
  {
    XERCES_CPP_NAMESPACE::SAXException *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::SAXNotSupportedException *result = 0 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_SAXNotSupportedException(toCopy);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXException,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_SAXNotSupportedException" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXException const &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "new_SAXNotSupportedException" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXException const &""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXException * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SAXNotSupportedException *)new XERCES_CPP_NAMESPACE::SAXNotSupportedException((XERCES_CPP_NAMESPACE::SAXException const &)*arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXNotSupportedException, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_SAXNotSupportedException) {
  {
    XERCES_CPP_NAMESPACE::SAXNotSupportedException *arg1 = (XERCES_CPP_NAMESPACE::SAXNotSupportedException *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SAXNotSupportedException(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXNotSupportedException, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SAXNotSupportedException" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXNotSupportedException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXNotSupportedException * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SAXNotRecognizedException) {
  {
    XERCES_CPP_NAMESPACE::SAXException *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::SAXNotRecognizedException *result = 0 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_SAXNotRecognizedException(toCopy);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXException,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_SAXNotRecognizedException" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXException const &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "new_SAXNotRecognizedException" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXException const &""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXException * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SAXNotRecognizedException *)new XERCES_CPP_NAMESPACE::SAXNotRecognizedException((XERCES_CPP_NAMESPACE::SAXException const &)*arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_SAXNotRecognizedException) {
  {
    XERCES_CPP_NAMESPACE::SAXNotRecognizedException *arg1 = (XERCES_CPP_NAMESPACE::SAXNotRecognizedException *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SAXNotRecognizedException(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SAXNotRecognizedException" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXNotRecognizedException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXNotRecognizedException * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_SAXParseException) {
  {
    XERCES_CPP_NAMESPACE::SAXParseException *arg1 = (XERCES_CPP_NAMESPACE::SAXParseException *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SAXParseException(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SAXParseException" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParseException_getColumnNumber) {
  {
    XERCES_CPP_NAMESPACE::SAXParseException *arg1 = (XERCES_CPP_NAMESPACE::SAXParseException *) 0 ;
    XMLSSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParseException_getColumnNumber(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParseException_getColumnNumber" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp1);
    {
      try 
      {
        result = (XMLSSize_t)((XERCES_CPP_NAMESPACE::SAXParseException const *)arg1)->getColumnNumber();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_long  SWIG_PERL_CALL_ARGS_1(static_cast< long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParseException_getLineNumber) {
  {
    XERCES_CPP_NAMESPACE::SAXParseException *arg1 = (XERCES_CPP_NAMESPACE::SAXParseException *) 0 ;
    XMLSSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParseException_getLineNumber(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParseException_getLineNumber" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp1);
    {
      try 
      {
        result = (XMLSSize_t)((XERCES_CPP_NAMESPACE::SAXParseException const *)arg1)->getLineNumber();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_long  SWIG_PERL_CALL_ARGS_1(static_cast< long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParseException_getPublicId) {
  {
    XERCES_CPP_NAMESPACE::SAXParseException *arg1 = (XERCES_CPP_NAMESPACE::SAXParseException *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParseException_getPublicId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParseException_getPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SAXParseException const *)arg1)->getPublicId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParseException_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::SAXParseException *arg1 = (XERCES_CPP_NAMESPACE::SAXParseException *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParseException_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParseException_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SAXParseException const *)arg1)->getSystemId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_ErrorHandler) {
  {
    XERCES_CPP_NAMESPACE::ErrorHandler *arg1 = (XERCES_CPP_NAMESPACE::ErrorHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_ErrorHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_ErrorHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ErrorHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ErrorHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_ErrorHandler_warning) {
  {
    XERCES_CPP_NAMESPACE::ErrorHandler *arg1 = (XERCES_CPP_NAMESPACE::ErrorHandler *) 0 ;
    XERCES_CPP_NAMESPACE::SAXParseException *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: ErrorHandler_warning(self,exc);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "ErrorHandler_warning" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ErrorHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ErrorHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "ErrorHandler_warning" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "ErrorHandler_warning" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp2);
    {
      try 
      {
        (arg1)->warning((XERCES_CPP_NAMESPACE::SAXParseException const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_ErrorHandler_error) {
  {
    XERCES_CPP_NAMESPACE::ErrorHandler *arg1 = (XERCES_CPP_NAMESPACE::ErrorHandler *) 0 ;
    XERCES_CPP_NAMESPACE::SAXParseException *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: ErrorHandler_error(self,exc);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "ErrorHandler_error" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ErrorHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ErrorHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "ErrorHandler_error" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "ErrorHandler_error" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp2);
    {
      try 
      {
        (arg1)->error((XERCES_CPP_NAMESPACE::SAXParseException const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_ErrorHandler_fatalError) {
  {
    XERCES_CPP_NAMESPACE::ErrorHandler *arg1 = (XERCES_CPP_NAMESPACE::ErrorHandler *) 0 ;
    XERCES_CPP_NAMESPACE::SAXParseException *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: ErrorHandler_fatalError(self,exc);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "ErrorHandler_fatalError" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ErrorHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ErrorHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "ErrorHandler_fatalError" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "ErrorHandler_fatalError" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp2);
    {
      try 
      {
        (arg1)->fatalError((XERCES_CPP_NAMESPACE::SAXParseException const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_ErrorHandler_resetErrors) {
  {
    XERCES_CPP_NAMESPACE::ErrorHandler *arg1 = (XERCES_CPP_NAMESPACE::ErrorHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: ErrorHandler_resetErrors(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "ErrorHandler_resetErrors" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ErrorHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ErrorHandler * >(argp1);
    {
      try 
      {
        (arg1)->resetErrors();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DTDHandler) {
  {
    XERCES_CPP_NAMESPACE::DTDHandler *arg1 = (XERCES_CPP_NAMESPACE::DTDHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DTDHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DTDHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DTDHandler_unparsedEntityDecl) {
  {
    XERCES_CPP_NAMESPACE::DTDHandler *arg1 = (XERCES_CPP_NAMESPACE::DTDHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: DTDHandler_unparsedEntityDecl(self,name,publicId,systemId,notationName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DTDHandler_unparsedEntityDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DTDHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DTDHandler_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DTDHandler_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DTDHandler_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"DTDHandler_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    {
      try 
      {
        (arg1)->unparsedEntityDecl((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DocumentHandler) {
  {
    XERCES_CPP_NAMESPACE::DocumentHandler *arg1 = (XERCES_CPP_NAMESPACE::DocumentHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DocumentHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DocumentHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DocumentHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DocumentHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DocumentHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DocumentHandler_characters) {
  {
    XERCES_CPP_NAMESPACE::DocumentHandler *arg1 = (XERCES_CPP_NAMESPACE::DocumentHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DocumentHandler_characters(self,chars,length);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DocumentHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DocumentHandler_characters" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DocumentHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DocumentHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DocumentHandler_characters");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DocumentHandler_characters" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->characters((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DocumentHandler_processingInstruction) {
  {
    XERCES_CPP_NAMESPACE::DocumentHandler *arg1 = (XERCES_CPP_NAMESPACE::DocumentHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DocumentHandler_processingInstruction(self,target,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DocumentHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DocumentHandler_processingInstruction" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DocumentHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DocumentHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DocumentHandler_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DocumentHandler_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->processingInstruction((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DocumentHandler_setDocumentLocator) {
  {
    XERCES_CPP_NAMESPACE::DocumentHandler *arg1 = (XERCES_CPP_NAMESPACE::DocumentHandler *) 0 ;
    XERCES_CPP_NAMESPACE::Locator *arg2 = (XERCES_CPP_NAMESPACE::Locator *) (XERCES_CPP_NAMESPACE::Locator *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DocumentHandler_setDocumentLocator(self,locator);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DocumentHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DocumentHandler_setDocumentLocator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DocumentHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DocumentHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DocumentHandler_setDocumentLocator" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::Locator const *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::Locator * >(argp2);
    {
      try 
      {
        (arg1)->setDocumentLocator((XERCES_CPP_NAMESPACE::Locator const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_EntityResolver) {
  {
    XERCES_CPP_NAMESPACE::EntityResolver *arg1 = (XERCES_CPP_NAMESPACE::EntityResolver *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_EntityResolver(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__EntityResolver, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_EntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::EntityResolver *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::EntityResolver * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_AttributeList) {
  {
    XERCES_CPP_NAMESPACE::AttributeList *arg1 = (XERCES_CPP_NAMESPACE::AttributeList *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_AttributeList(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_AttributeList" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AttributeList *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AttributeList * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AttributeList_getLength) {
  {
    XERCES_CPP_NAMESPACE::AttributeList *arg1 = (XERCES_CPP_NAMESPACE::AttributeList *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AttributeList_getLength(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AttributeList_getLength" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AttributeList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AttributeList * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::AttributeList const *)arg1)->getLength();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AttributeList_getName) {
  {
    XERCES_CPP_NAMESPACE::AttributeList *arg1 = (XERCES_CPP_NAMESPACE::AttributeList *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AttributeList_getName(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AttributeList_getName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AttributeList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AttributeList * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AttributeList_getName" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::AttributeList const *)arg1)->getName(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AttributeList_getType__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::AttributeList *arg1 = (XERCES_CPP_NAMESPACE::AttributeList *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AttributeList_getType(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AttributeList_getType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AttributeList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AttributeList * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AttributeList_getType" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::AttributeList const *)arg1)->getType(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AttributeList_getValue__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::AttributeList *arg1 = (XERCES_CPP_NAMESPACE::AttributeList *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AttributeList_getValue(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AttributeList_getValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AttributeList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AttributeList * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AttributeList_getValue" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::AttributeList const *)arg1)->getValue(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AttributeList_getType__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::AttributeList *arg1 = (XERCES_CPP_NAMESPACE::AttributeList *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AttributeList_getType(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AttributeList_getType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AttributeList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AttributeList * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AttributeList_getType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::AttributeList const *)arg1)->getType((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_AttributeList_getType) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_AttributeList_getType__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_AttributeList_getType__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'AttributeList_getType'");
  XSRETURN(0);
}


XS(_wrap_AttributeList_getValue__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::AttributeList *arg1 = (XERCES_CPP_NAMESPACE::AttributeList *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AttributeList_getValue(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AttributeList_getValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AttributeList const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AttributeList * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AttributeList_getValue");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::AttributeList const *)arg1)->getValue((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_AttributeList_getValue) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_AttributeList_getValue__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_AttributeList_getValue__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'AttributeList_getValue'");
  XSRETURN(0);
}


XS(_wrap_HandlerBase_characters) {
  {
    XERCES_CPP_NAMESPACE::HandlerBase *arg1 = (XERCES_CPP_NAMESPACE::HandlerBase *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: HandlerBase_characters(self,chars,length);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "HandlerBase_characters" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::HandlerBase *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::HandlerBase * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"HandlerBase_characters");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "HandlerBase_characters" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->characters((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_HandlerBase_processingInstruction) {
  {
    XERCES_CPP_NAMESPACE::HandlerBase *arg1 = (XERCES_CPP_NAMESPACE::HandlerBase *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: HandlerBase_processingInstruction(self,target,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "HandlerBase_processingInstruction" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::HandlerBase *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::HandlerBase * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"HandlerBase_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"HandlerBase_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->processingInstruction((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_HandlerBase_setDocumentLocator) {
  {
    XERCES_CPP_NAMESPACE::HandlerBase *arg1 = (XERCES_CPP_NAMESPACE::HandlerBase *) 0 ;
    XERCES_CPP_NAMESPACE::Locator *arg2 = (XERCES_CPP_NAMESPACE::Locator *) (XERCES_CPP_NAMESPACE::Locator *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: HandlerBase_setDocumentLocator(self,locator);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "HandlerBase_setDocumentLocator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::HandlerBase *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::HandlerBase * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "HandlerBase_setDocumentLocator" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::Locator const *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::Locator * >(argp2);
    {
      try 
      {
        (arg1)->setDocumentLocator((XERCES_CPP_NAMESPACE::Locator const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_HandlerBase_error) {
  {
    XERCES_CPP_NAMESPACE::HandlerBase *arg1 = (XERCES_CPP_NAMESPACE::HandlerBase *) 0 ;
    XERCES_CPP_NAMESPACE::SAXParseException *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: HandlerBase_error(self,exc);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "HandlerBase_error" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::HandlerBase *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::HandlerBase * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "HandlerBase_error" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "HandlerBase_error" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp2);
    {
      try 
      {
        (arg1)->error((XERCES_CPP_NAMESPACE::SAXParseException const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_HandlerBase_fatalError) {
  {
    XERCES_CPP_NAMESPACE::HandlerBase *arg1 = (XERCES_CPP_NAMESPACE::HandlerBase *) 0 ;
    XERCES_CPP_NAMESPACE::SAXParseException *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: HandlerBase_fatalError(self,exc);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "HandlerBase_fatalError" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::HandlerBase *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::HandlerBase * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "HandlerBase_fatalError" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "HandlerBase_fatalError" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp2);
    {
      try 
      {
        (arg1)->fatalError((XERCES_CPP_NAMESPACE::SAXParseException const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_HandlerBase_warning) {
  {
    XERCES_CPP_NAMESPACE::HandlerBase *arg1 = (XERCES_CPP_NAMESPACE::HandlerBase *) 0 ;
    XERCES_CPP_NAMESPACE::SAXParseException *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: HandlerBase_warning(self,exc);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "HandlerBase_warning" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::HandlerBase *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::HandlerBase * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "HandlerBase_warning" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "HandlerBase_warning" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp2);
    {
      try 
      {
        (arg1)->warning((XERCES_CPP_NAMESPACE::SAXParseException const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_HandlerBase_resetErrors) {
  {
    XERCES_CPP_NAMESPACE::HandlerBase *arg1 = (XERCES_CPP_NAMESPACE::HandlerBase *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: HandlerBase_resetErrors(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "HandlerBase_resetErrors" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::HandlerBase *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::HandlerBase * >(argp1);
    {
      try 
      {
        (arg1)->resetErrors();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_HandlerBase_unparsedEntityDecl) {
  {
    XERCES_CPP_NAMESPACE::HandlerBase *arg1 = (XERCES_CPP_NAMESPACE::HandlerBase *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: HandlerBase_unparsedEntityDecl(self,name,publicId,systemId,notationName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "HandlerBase_unparsedEntityDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::HandlerBase *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::HandlerBase * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"HandlerBase_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"HandlerBase_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"HandlerBase_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"HandlerBase_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    {
      try 
      {
        (arg1)->unparsedEntityDecl((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_HandlerBase) {
  {
    XERCES_CPP_NAMESPACE::HandlerBase *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_HandlerBase();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::HandlerBase *)new XERCES_CPP_NAMESPACE::HandlerBase();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_delete_HandlerBase) {
  {
    XERCES_CPP_NAMESPACE::HandlerBase *arg1 = (XERCES_CPP_NAMESPACE::HandlerBase *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_HandlerBase(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_HandlerBase" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::HandlerBase *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::HandlerBase * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_Locator) {
  {
    XERCES_CPP_NAMESPACE::Locator *arg1 = (XERCES_CPP_NAMESPACE::Locator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_Locator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_Locator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Locator *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Locator * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Locator_getPublicId) {
  {
    XERCES_CPP_NAMESPACE::Locator *arg1 = (XERCES_CPP_NAMESPACE::Locator *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Locator_getPublicId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Locator_getPublicId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Locator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Locator * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Locator const *)arg1)->getPublicId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Locator_getSystemId) {
  {
    XERCES_CPP_NAMESPACE::Locator *arg1 = (XERCES_CPP_NAMESPACE::Locator *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Locator_getSystemId(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Locator_getSystemId" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Locator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Locator * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Locator const *)arg1)->getSystemId();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Locator_getLineNumber) {
  {
    XERCES_CPP_NAMESPACE::Locator *arg1 = (XERCES_CPP_NAMESPACE::Locator *) 0 ;
    XMLSSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Locator_getLineNumber(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Locator_getLineNumber" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Locator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Locator * >(argp1);
    {
      try 
      {
        result = (XMLSSize_t)((XERCES_CPP_NAMESPACE::Locator const *)arg1)->getLineNumber();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_long  SWIG_PERL_CALL_ARGS_1(static_cast< long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Locator_getColumnNumber) {
  {
    XERCES_CPP_NAMESPACE::Locator *arg1 = (XERCES_CPP_NAMESPACE::Locator *) 0 ;
    XMLSSize_t result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Locator_getColumnNumber(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Locator_getColumnNumber" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Locator const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Locator * >(argp1);
    {
      try 
      {
        result = (XMLSSize_t)((XERCES_CPP_NAMESPACE::Locator const *)arg1)->getColumnNumber();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_long  SWIG_PERL_CALL_ARGS_1(static_cast< long >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_Attributes) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_Attributes(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_Attributes" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getLength) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: Attributes_getLength(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getLength" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getLength();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getURI) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Attributes_getURI(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getURI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Attributes_getURI" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getURI(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getLocalName) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Attributes_getLocalName(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getLocalName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Attributes_getLocalName" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getLocalName(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getQName) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Attributes_getQName(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getQName" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Attributes_getQName" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getQName(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getType__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Attributes_getType(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Attributes_getType" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getType(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getValue__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Attributes_getValue(self,index);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "Attributes_getValue" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getValue(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getIndex__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: Attributes_getIndex(self,uri,localPart);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getIndex" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Attributes_getIndex");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"Attributes_getIndex");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getIndex((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getIndex__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Attributes_getIndex(self,qName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getIndex" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Attributes_getIndex");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getIndex((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getIndex) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Attributes_getIndex__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Attributes_getIndex__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'Attributes_getIndex'");
  XSRETURN(0);
}


XS(_wrap_Attributes_getType__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: Attributes_getType(self,uri,localPart);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Attributes_getType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"Attributes_getType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getType((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getType__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Attributes_getType(self,qName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getType" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Attributes_getType");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getType((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getType) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Attributes_getType__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Attributes_getType__SWIG_2); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Attributes_getType__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'Attributes_getType'");
  XSRETURN(0);
}


XS(_wrap_Attributes_getValue__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: Attributes_getValue(self,uri,localPart);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Attributes_getValue");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"Attributes_getValue");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getValue((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getValue__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::Attributes *arg1 = (XERCES_CPP_NAMESPACE::Attributes *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Attributes_getValue(self,qName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Attributes_getValue" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Attributes const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Attributes * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Attributes_getValue");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::Attributes const *)arg1)->getValue((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Attributes_getValue) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(2)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Attributes_getValue__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Attributes_getValue__SWIG_2); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Attributes_getValue__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'Attributes_getValue'");
  XSRETURN(0);
}


XS(_wrap_delete_ContentHandler) {
  {
    XERCES_CPP_NAMESPACE::ContentHandler *arg1 = (XERCES_CPP_NAMESPACE::ContentHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_ContentHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_ContentHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ContentHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ContentHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_ContentHandler_characters) {
  {
    XERCES_CPP_NAMESPACE::ContentHandler *arg1 = (XERCES_CPP_NAMESPACE::ContentHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: ContentHandler_characters(self,chars,length);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "ContentHandler_characters" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ContentHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ContentHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"ContentHandler_characters");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "ContentHandler_characters" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->characters((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_ContentHandler_processingInstruction) {
  {
    XERCES_CPP_NAMESPACE::ContentHandler *arg1 = (XERCES_CPP_NAMESPACE::ContentHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: ContentHandler_processingInstruction(self,target,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "ContentHandler_processingInstruction" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ContentHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ContentHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"ContentHandler_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"ContentHandler_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->processingInstruction((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_ContentHandler_setDocumentLocator) {
  {
    XERCES_CPP_NAMESPACE::ContentHandler *arg1 = (XERCES_CPP_NAMESPACE::ContentHandler *) 0 ;
    XERCES_CPP_NAMESPACE::Locator *arg2 = (XERCES_CPP_NAMESPACE::Locator *) (XERCES_CPP_NAMESPACE::Locator *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: ContentHandler_setDocumentLocator(self,locator);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "ContentHandler_setDocumentLocator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ContentHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ContentHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "ContentHandler_setDocumentLocator" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::Locator const *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::Locator * >(argp2);
    {
      try 
      {
        (arg1)->setDocumentLocator((XERCES_CPP_NAMESPACE::Locator const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_ContentHandler_startPrefixMapping) {
  {
    XERCES_CPP_NAMESPACE::ContentHandler *arg1 = (XERCES_CPP_NAMESPACE::ContentHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: ContentHandler_startPrefixMapping(self,prefix,uri);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "ContentHandler_startPrefixMapping" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ContentHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ContentHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"ContentHandler_startPrefixMapping");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"ContentHandler_startPrefixMapping");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->startPrefixMapping((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_ContentHandler_endPrefixMapping) {
  {
    XERCES_CPP_NAMESPACE::ContentHandler *arg1 = (XERCES_CPP_NAMESPACE::ContentHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: ContentHandler_endPrefixMapping(self,prefix);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "ContentHandler_endPrefixMapping" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ContentHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ContentHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"ContentHandler_endPrefixMapping");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->endPrefixMapping((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_ContentHandler_skippedEntity) {
  {
    XERCES_CPP_NAMESPACE::ContentHandler *arg1 = (XERCES_CPP_NAMESPACE::ContentHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: ContentHandler_skippedEntity(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "ContentHandler_skippedEntity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::ContentHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::ContentHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"ContentHandler_skippedEntity");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->skippedEntity((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_LexicalHandler) {
  {
    XERCES_CPP_NAMESPACE::LexicalHandler *arg1 = (XERCES_CPP_NAMESPACE::LexicalHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_LexicalHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_LexicalHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LexicalHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LexicalHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_LexicalHandler_comment) {
  {
    XERCES_CPP_NAMESPACE::LexicalHandler *arg1 = (XERCES_CPP_NAMESPACE::LexicalHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: LexicalHandler_comment(self,chars,length);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "LexicalHandler_comment" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LexicalHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LexicalHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"LexicalHandler_comment");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "LexicalHandler_comment" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->comment((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_LexicalHandler_endCDATA) {
  {
    XERCES_CPP_NAMESPACE::LexicalHandler *arg1 = (XERCES_CPP_NAMESPACE::LexicalHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: LexicalHandler_endCDATA(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "LexicalHandler_endCDATA" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LexicalHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LexicalHandler * >(argp1);
    {
      try 
      {
        (arg1)->endCDATA();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_LexicalHandler_endDTD) {
  {
    XERCES_CPP_NAMESPACE::LexicalHandler *arg1 = (XERCES_CPP_NAMESPACE::LexicalHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: LexicalHandler_endDTD(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "LexicalHandler_endDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LexicalHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LexicalHandler * >(argp1);
    {
      try 
      {
        (arg1)->endDTD();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_LexicalHandler_endEntity) {
  {
    XERCES_CPP_NAMESPACE::LexicalHandler *arg1 = (XERCES_CPP_NAMESPACE::LexicalHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: LexicalHandler_endEntity(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "LexicalHandler_endEntity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LexicalHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LexicalHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"LexicalHandler_endEntity");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->endEntity((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_LexicalHandler_startCDATA) {
  {
    XERCES_CPP_NAMESPACE::LexicalHandler *arg1 = (XERCES_CPP_NAMESPACE::LexicalHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: LexicalHandler_startCDATA(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "LexicalHandler_startCDATA" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LexicalHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LexicalHandler * >(argp1);
    {
      try 
      {
        (arg1)->startCDATA();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_LexicalHandler_startDTD) {
  {
    XERCES_CPP_NAMESPACE::LexicalHandler *arg1 = (XERCES_CPP_NAMESPACE::LexicalHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: LexicalHandler_startDTD(self,name,publicId,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "LexicalHandler_startDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LexicalHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LexicalHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"LexicalHandler_startDTD");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"LexicalHandler_startDTD");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"LexicalHandler_startDTD");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    {
      try 
      {
        (arg1)->startDTD((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    SWIG_croak_null();
  }
}


XS(_wrap_LexicalHandler_startEntity) {
  {
    XERCES_CPP_NAMESPACE::LexicalHandler *arg1 = (XERCES_CPP_NAMESPACE::LexicalHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: LexicalHandler_startEntity(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "LexicalHandler_startEntity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::LexicalHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::LexicalHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"LexicalHandler_startEntity");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->startEntity((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DeclHandler) {
  {
    XERCES_CPP_NAMESPACE::DeclHandler *arg1 = (XERCES_CPP_NAMESPACE::DeclHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DeclHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DeclHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DeclHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DeclHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DeclHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DeclHandler_attributeDecl) {
  {
    XERCES_CPP_NAMESPACE::DeclHandler *arg1 = (XERCES_CPP_NAMESPACE::DeclHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg6 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 6) || (items > 6)) {
      SWIG_croak("Usage: DeclHandler_attributeDecl(self,eName,aName,type,mode,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DeclHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DeclHandler_attributeDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DeclHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DeclHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DeclHandler_attributeDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DeclHandler_attributeDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DeclHandler_attributeDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"DeclHandler_attributeDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    
    if (ST(5) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",6,"DeclHandler_attributeDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg6 = Perl2XMLString(ST(5));
    }
    
    {
      try 
      {
        (arg1)->attributeDecl((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,(XMLCh const *)arg6);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    delete[] arg6;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    delete[] arg6;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DeclHandler_internalEntityDecl) {
  {
    XERCES_CPP_NAMESPACE::DeclHandler *arg1 = (XERCES_CPP_NAMESPACE::DeclHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DeclHandler_internalEntityDecl(self,name,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DeclHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DeclHandler_internalEntityDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DeclHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DeclHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DeclHandler_internalEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DeclHandler_internalEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->internalEntityDecl((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DeclHandler_externalEntityDecl) {
  {
    XERCES_CPP_NAMESPACE::DeclHandler *arg1 = (XERCES_CPP_NAMESPACE::DeclHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DeclHandler_externalEntityDecl(self,name,publicId,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DeclHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DeclHandler_externalEntityDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DeclHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DeclHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DeclHandler_externalEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DeclHandler_externalEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DeclHandler_externalEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    {
      try 
      {
        (arg1)->externalEntityDecl((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_characters) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DefaultHandler_characters(self,chars,length);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_characters" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_characters");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DefaultHandler_characters" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->characters((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_processingInstruction) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DefaultHandler_processingInstruction(self,target,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_processingInstruction" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DefaultHandler_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->processingInstruction((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_setDocumentLocator) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XERCES_CPP_NAMESPACE::Locator *arg2 = (XERCES_CPP_NAMESPACE::Locator *) (XERCES_CPP_NAMESPACE::Locator *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DefaultHandler_setDocumentLocator(self,locator);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_setDocumentLocator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DefaultHandler_setDocumentLocator" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::Locator const *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::Locator * >(argp2);
    {
      try 
      {
        (arg1)->setDocumentLocator((XERCES_CPP_NAMESPACE::Locator const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_startPrefixMapping) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DefaultHandler_startPrefixMapping(self,prefix,uri);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_startPrefixMapping" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_startPrefixMapping");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DefaultHandler_startPrefixMapping");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->startPrefixMapping((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_endPrefixMapping) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DefaultHandler_endPrefixMapping(self,prefix);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_endPrefixMapping" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_endPrefixMapping");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->endPrefixMapping((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_skippedEntity) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DefaultHandler_skippedEntity(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_skippedEntity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_skippedEntity");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->skippedEntity((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_error) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XERCES_CPP_NAMESPACE::SAXParseException *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DefaultHandler_error(self,exc);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_error" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DefaultHandler_error" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DefaultHandler_error" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp2);
    {
      try 
      {
        (arg1)->error((XERCES_CPP_NAMESPACE::SAXParseException const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_fatalError) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XERCES_CPP_NAMESPACE::SAXParseException *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DefaultHandler_fatalError(self,exc);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_fatalError" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DefaultHandler_fatalError" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DefaultHandler_fatalError" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp2);
    {
      try 
      {
        (arg1)->fatalError((XERCES_CPP_NAMESPACE::SAXParseException const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_warning) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XERCES_CPP_NAMESPACE::SAXParseException *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DefaultHandler_warning(self,exc);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_warning" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "DefaultHandler_warning" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "DefaultHandler_warning" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParseException const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParseException * >(argp2);
    {
      try 
      {
        (arg1)->warning((XERCES_CPP_NAMESPACE::SAXParseException const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_resetErrors) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DefaultHandler_resetErrors(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_resetErrors" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    {
      try 
      {
        (arg1)->resetErrors();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_unparsedEntityDecl) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 5) || (items > 5)) {
      SWIG_croak("Usage: DefaultHandler_unparsedEntityDecl(self,name,publicId,systemId,notationName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_unparsedEntityDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DefaultHandler_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DefaultHandler_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"DefaultHandler_unparsedEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    {
      try 
      {
        (arg1)->unparsedEntityDecl((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_comment) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DefaultHandler_comment(self,chars,length);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_comment" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_comment");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "DefaultHandler_comment" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->comment((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_endCDATA) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DefaultHandler_endCDATA(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_endCDATA" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    {
      try 
      {
        (arg1)->endCDATA();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_endDTD) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DefaultHandler_endDTD(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_endDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    {
      try 
      {
        (arg1)->endDTD();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_endEntity) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DefaultHandler_endEntity(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_endEntity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_endEntity");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->endEntity((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_startCDATA) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: DefaultHandler_startCDATA(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_startCDATA" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    {
      try 
      {
        (arg1)->startCDATA();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_startDTD) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DefaultHandler_startDTD(self,name,publicId,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_startDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_startDTD");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DefaultHandler_startDTD");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DefaultHandler_startDTD");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    {
      try 
      {
        (arg1)->startDTD((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_startEntity) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: DefaultHandler_startEntity(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_startEntity" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_startEntity");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->startEntity((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_attributeDecl) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg6 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 6) || (items > 6)) {
      SWIG_croak("Usage: DefaultHandler_attributeDecl(self,eName,aName,type,mode,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_attributeDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_attributeDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DefaultHandler_attributeDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DefaultHandler_attributeDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"DefaultHandler_attributeDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    
    if (ST(5) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",6,"DefaultHandler_attributeDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg6 = Perl2XMLString(ST(5));
    }
    
    {
      try 
      {
        (arg1)->attributeDecl((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4,(XMLCh const *)arg5,(XMLCh const *)arg6);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    delete[] arg6;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    
    delete[] arg5;
    
    
    delete[] arg6;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_internalEntityDecl) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: DefaultHandler_internalEntityDecl(self,name,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_internalEntityDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_internalEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DefaultHandler_internalEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->internalEntityDecl((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_DefaultHandler_externalEntityDecl) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg4 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: DefaultHandler_externalEntityDecl(self,name,publicId,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "DefaultHandler_externalEntityDecl" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"DefaultHandler_externalEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"DefaultHandler_externalEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    
    if (ST(3) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",4,"DefaultHandler_externalEntityDecl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg4 = Perl2XMLString(ST(3));
    }
    
    {
      try 
      {
        (arg1)->externalEntityDecl((XMLCh const *)arg2,(XMLCh const *)arg3,(XMLCh const *)arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    delete[] arg4;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_DefaultHandler) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_DefaultHandler();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DefaultHandler *)new XERCES_CPP_NAMESPACE::DefaultHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_delete_DefaultHandler) {
  {
    XERCES_CPP_NAMESPACE::DefaultHandler *arg1 = (XERCES_CPP_NAMESPACE::DefaultHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_DefaultHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_DefaultHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::DefaultHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::DefaultHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLPScanToken__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XMLPScanToken *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_XMLPScanToken();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLPScanToken *)new XERCES_CPP_NAMESPACE::XMLPScanToken();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLPScanToken__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg1 = 0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *result = 0 ;
    void *argp1 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_XMLPScanToken(toCopy);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "new_XMLPScanToken" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken const &""'"); 
    }
    if (!argp1) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "new_XMLPScanToken" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken const &""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLPScanToken *)new XERCES_CPP_NAMESPACE::XMLPScanToken((XERCES_CPP_NAMESPACE::XMLPScanToken const &)*arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XMLPScanToken) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLPScanToken__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XMLPScanToken__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_XMLPScanToken'");
  XSRETURN(0);
}


XS(_wrap_delete_XMLPScanToken) {
  {
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg1 = (XERCES_CPP_NAMESPACE::XMLPScanToken *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XMLPScanToken(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XMLPScanToken" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_PSVIHandler) {
  {
    XERCES_CPP_NAMESPACE::PSVIHandler *arg1 = (XERCES_CPP_NAMESPACE::PSVIHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_PSVIHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__PSVIHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_PSVIHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::PSVIHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::PSVIHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PSVIHandler_handleElementPSVI) {
  {
    XERCES_CPP_NAMESPACE::PSVIHandler *arg1 = (XERCES_CPP_NAMESPACE::PSVIHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    PSVIElement *arg4 = (PSVIElement *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: PSVIHandler_handleElementPSVI(self,localName,uri,elementInfo);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__PSVIHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PSVIHandler_handleElementPSVI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::PSVIHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::PSVIHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"PSVIHandler_handleElementPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"PSVIHandler_handleElementPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_PSVIElement, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "PSVIHandler_handleElementPSVI" "', argument " "4"" of type '" "PSVIElement *""'"); 
    }
    arg4 = reinterpret_cast< PSVIElement * >(argp4);
    {
      try 
      {
        (arg1)->handleElementPSVI((XMLCh const *)arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_PSVIHandler_handlePartialElementPSVI) {
  {
    XERCES_CPP_NAMESPACE::PSVIHandler *arg1 = (XERCES_CPP_NAMESPACE::PSVIHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    PSVIElement *arg4 = (PSVIElement *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: PSVIHandler_handlePartialElementPSVI(self,localName,uri,elementInfo);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__PSVIHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PSVIHandler_handlePartialElementPSVI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::PSVIHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::PSVIHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"PSVIHandler_handlePartialElementPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"PSVIHandler_handlePartialElementPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_PSVIElement, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "PSVIHandler_handlePartialElementPSVI" "', argument " "4"" of type '" "PSVIElement *""'"); 
    }
    arg4 = reinterpret_cast< PSVIElement * >(argp4);
    {
      try 
      {
        (arg1)->handlePartialElementPSVI((XMLCh const *)arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_PSVIHandler_handleAttributesPSVI) {
  {
    XERCES_CPP_NAMESPACE::PSVIHandler *arg1 = (XERCES_CPP_NAMESPACE::PSVIHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    PSVIAttributeList *arg4 = (PSVIAttributeList *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: PSVIHandler_handleAttributesPSVI(self,localName,uri,psviAttributes);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__PSVIHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PSVIHandler_handleAttributesPSVI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::PSVIHandler *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::PSVIHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"PSVIHandler_handleAttributesPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"PSVIHandler_handleAttributesPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_PSVIAttributeList, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "PSVIHandler_handleAttributesPSVI" "', argument " "4"" of type '" "PSVIAttributeList *""'"); 
    }
    arg4 = reinterpret_cast< PSVIAttributeList * >(argp4);
    {
      try 
      {
        (arg1)->handleAttributesPSVI((XMLCh const *)arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_Parser) {
  {
    XERCES_CPP_NAMESPACE::Parser *arg1 = (XERCES_CPP_NAMESPACE::Parser *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_Parser(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Parser, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_Parser" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Parser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Parser * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_Parser_setEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::Parser *arg1 = (XERCES_CPP_NAMESPACE::Parser *) 0 ;
    XERCES_CPP_NAMESPACE::EntityResolver *arg2 = (XERCES_CPP_NAMESPACE::EntityResolver *) (XERCES_CPP_NAMESPACE::EntityResolver *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Parser_setEntityResolver(self,resolver);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Parser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Parser_setEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Parser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Parser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__EntityResolver, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "Parser_setEntityResolver" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::EntityResolver *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::EntityResolver * >(argp2);
    {
      try 
      {
        (arg1)->setEntityResolver(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Parser_setDTDHandler) {
  {
    XERCES_CPP_NAMESPACE::Parser *arg1 = (XERCES_CPP_NAMESPACE::Parser *) 0 ;
    XERCES_CPP_NAMESPACE::DTDHandler *arg2 = (XERCES_CPP_NAMESPACE::DTDHandler *) (XERCES_CPP_NAMESPACE::DTDHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Parser_setDTDHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Parser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Parser_setDTDHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Parser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Parser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "Parser_setDTDHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DTDHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDHandler * >(argp2);
    {
      try 
      {
        (arg1)->setDTDHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Parser_setDocumentHandler) {
  {
    XERCES_CPP_NAMESPACE::Parser *arg1 = (XERCES_CPP_NAMESPACE::Parser *) 0 ;
    XERCES_CPP_NAMESPACE::DocumentHandler *arg2 = (XERCES_CPP_NAMESPACE::DocumentHandler *) (XERCES_CPP_NAMESPACE::DocumentHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Parser_setDocumentHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Parser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Parser_setDocumentHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Parser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Parser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DocumentHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "Parser_setDocumentHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DocumentHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DocumentHandler * >(argp2);
    {
      try 
      {
        (arg1)->setDocumentHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Parser_setErrorHandler) {
  {
    XERCES_CPP_NAMESPACE::Parser *arg1 = (XERCES_CPP_NAMESPACE::Parser *) 0 ;
    XERCES_CPP_NAMESPACE::ErrorHandler *arg2 = (XERCES_CPP_NAMESPACE::ErrorHandler *) (XERCES_CPP_NAMESPACE::ErrorHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Parser_setErrorHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Parser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Parser_setErrorHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Parser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Parser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "Parser_setErrorHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::ErrorHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::ErrorHandler * >(argp2);
    {
      try 
      {
        (arg1)->setErrorHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Parser_parse__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::Parser *arg1 = (XERCES_CPP_NAMESPACE::Parser *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Parser_parse(self,source);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Parser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Parser_parse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Parser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Parser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "Parser_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "Parser_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    {
      try 
      {
        (arg1)->parse((XERCES_CPP_NAMESPACE::InputSource const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_Parser_parse__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::Parser *arg1 = (XERCES_CPP_NAMESPACE::Parser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: Parser_parse(self,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Parser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "Parser_parse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::Parser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::Parser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"Parser_parse");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->parse((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_Parser_parse) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Parser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__Parser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Parser_parse__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_Parser_parse__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'Parser_parse'");
  XSRETURN(0);
}


XS(_wrap_delete_AbstractDOMParser) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_AbstractDOMParser(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_AbstractDOMParser" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_reset) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_reset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_reset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        (arg1)->reset();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_adoptDocument) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocument *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_adoptDocument(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_adoptDocument" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocument *)(arg1)->adoptDocument();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getDocument) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::DOMDocument *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getDocument(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getDocument" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DOMDocument *)(arg1)->getDocument();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getValidator) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::XMLValidator *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getValidator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::XMLValidator const &_result_ref = ((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getValidator();
          result = (XERCES_CPP_NAMESPACE::XMLValidator *) &_result_ref;
        }
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getValidationScheme) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::AbstractDOMParser::ValSchemes result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getValidationScheme(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getValidationScheme" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::AbstractDOMParser::ValSchemes)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getValidationScheme();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getDoSchema) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getDoSchema(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getDoSchema" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getDoSchema();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getValidationSchemaFullChecking) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getValidationSchemaFullChecking(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getValidationSchemaFullChecking" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getValidationSchemaFullChecking();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getIdentityConstraintChecking) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getIdentityConstraintChecking(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getIdentityConstraintChecking" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getIdentityConstraintChecking();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getErrorCount) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getErrorCount(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getErrorCount" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getErrorCount();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getDoNamespaces) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getDoNamespaces(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getDoNamespaces" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getDoNamespaces();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getExitOnFirstFatalError) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getExitOnFirstFatalError(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getExitOnFirstFatalError" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getExitOnFirstFatalError();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getValidationConstraintFatal) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getValidationConstraintFatal(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getValidationConstraintFatal" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getValidationConstraintFatal();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getCreateEntityReferenceNodes) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getCreateEntityReferenceNodes(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getCreateEntityReferenceNodes" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getCreateEntityReferenceNodes();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getIncludeIgnorableWhitespace) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getIncludeIgnorableWhitespace(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getIncludeIgnorableWhitespace" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getIncludeIgnorableWhitespace();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getExternalSchemaLocation) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getExternalSchemaLocation(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getExternalSchemaLocation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getExternalSchemaLocation();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getExternalNoNamespaceSchemaLocation) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getExternalNoNamespaceSchemaLocation(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getExternalNoNamespaceSchemaLocation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getExternalNoNamespaceSchemaLocation();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getSecurityManager) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    SecurityManager *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getSecurityManager(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getSecurityManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (SecurityManager *)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getSecurityManager();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_SecurityManager, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getLoadExternalDTD) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getLoadExternalDTD(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getLoadExternalDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getLoadExternalDTD();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getCreateCommentNodes) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getCreateCommentNodes(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getCreateCommentNodes" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getCreateCommentNodes();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getCalculateSrcOfs) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getCalculateSrcOfs(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getCalculateSrcOfs" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getCalculateSrcOfs();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getStandardUriConformant) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getStandardUriConformant(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getStandardUriConformant" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getStandardUriConformant();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getPSVIHandler) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::PSVIHandler *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getPSVIHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getPSVIHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::PSVIHandler *)(arg1)->getPSVIHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__PSVIHandler, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getCreateSchemaInfo) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getCreateSchemaInfo(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getCreateSchemaInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getCreateSchemaInfo();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getGenerateSyntheticAnnotations) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getGenerateSyntheticAnnotations(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getGenerateSyntheticAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getGenerateSyntheticAnnotations();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getValidateAnnotations) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getValidateAnnotations(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getValidateAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getValidateAnnotations();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getIgnoreAnnotations) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getIgnoreAnnotations(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getIgnoreAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getIgnoreAnnotations();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getDisableDefaultEntityResolution) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getDisableDefaultEntityResolution(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getDisableDefaultEntityResolution" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getDisableDefaultEntityResolution();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getSkipDTDValidation) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getSkipDTDValidation(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getSkipDTDValidation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getSkipDTDValidation();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setGenerateSyntheticAnnotations) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setGenerateSyntheticAnnotations(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setGenerateSyntheticAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setGenerateSyntheticAnnotations" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setGenerateSyntheticAnnotations(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setValidateAnnotations) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setValidateAnnotations(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setValidateAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setValidateAnnotations" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setValidateAnnotations(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setDoNamespaces) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setDoNamespaces(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setDoNamespaces" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setDoNamespaces" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setDoNamespaces(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setExitOnFirstFatalError) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setExitOnFirstFatalError(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setExitOnFirstFatalError" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setExitOnFirstFatalError" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setExitOnFirstFatalError(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setValidationConstraintFatal) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setValidationConstraintFatal(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setValidationConstraintFatal" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setValidationConstraintFatal" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setValidationConstraintFatal(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setCreateEntityReferenceNodes) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setCreateEntityReferenceNodes(self,create);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setCreateEntityReferenceNodes" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setCreateEntityReferenceNodes" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setCreateEntityReferenceNodes(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setIncludeIgnorableWhitespace) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setIncludeIgnorableWhitespace(self,include);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setIncludeIgnorableWhitespace" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setIncludeIgnorableWhitespace" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIncludeIgnorableWhitespace(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setValidationScheme) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::AbstractDOMParser::ValSchemes arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setValidationScheme(self,newScheme);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setValidationScheme" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setValidationScheme" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser::ValSchemes""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser::ValSchemes >(val2);
    {
      try 
      {
        (arg1)->setValidationScheme(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setDoSchema) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setDoSchema(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setDoSchema" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setDoSchema" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setDoSchema(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setValidationSchemaFullChecking) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setValidationSchemaFullChecking(self,schemaFullChecking);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setValidationSchemaFullChecking" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setValidationSchemaFullChecking" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setValidationSchemaFullChecking(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setIdentityConstraintChecking) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setIdentityConstraintChecking(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setIdentityConstraintChecking" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setIdentityConstraintChecking" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIdentityConstraintChecking(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setExternalSchemaLocation) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setExternalSchemaLocation(self,schemaLocation);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setExternalSchemaLocation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AbstractDOMParser_setExternalSchemaLocation");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setExternalSchemaLocation((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setExternalNoNamespaceSchemaLocation) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setExternalNoNamespaceSchemaLocation(self,noNamespaceSchemaLocation);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setExternalNoNamespaceSchemaLocation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AbstractDOMParser_setExternalNoNamespaceSchemaLocation");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setExternalNoNamespaceSchemaLocation((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setSecurityManager) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    SecurityManager *arg2 = (SecurityManager *) (SecurityManager *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setSecurityManager(self,securityManager);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setSecurityManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_SecurityManager, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "AbstractDOMParser_setSecurityManager" "', argument " "2"" of type '" "SecurityManager *const""'"); 
    }
    arg2 = reinterpret_cast< SecurityManager * >(argp2);
    {
      try 
      {
        (arg1)->setSecurityManager(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setLoadExternalDTD) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setLoadExternalDTD(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setLoadExternalDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setLoadExternalDTD" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setLoadExternalDTD(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setCreateCommentNodes) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setCreateCommentNodes(self,create);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setCreateCommentNodes" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setCreateCommentNodes" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setCreateCommentNodes(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setCalculateSrcOfs) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setCalculateSrcOfs(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setCalculateSrcOfs" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setCalculateSrcOfs" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setCalculateSrcOfs(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setStandardUriConformant) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setStandardUriConformant(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setStandardUriConformant" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setStandardUriConformant" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setStandardUriConformant(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_useScanner) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_useScanner(self,scannerName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_useScanner" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AbstractDOMParser_useScanner");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->useScanner((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_useImplementation) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_useImplementation(self,implementationFeatures);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_useImplementation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AbstractDOMParser_useImplementation");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->useImplementation((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setPSVIHandler) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::PSVIHandler *arg2 = (XERCES_CPP_NAMESPACE::PSVIHandler *) (XERCES_CPP_NAMESPACE::PSVIHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setPSVIHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setPSVIHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__PSVIHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "AbstractDOMParser_setPSVIHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::PSVIHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::PSVIHandler * >(argp2);
    {
      try 
      {
        (arg1)->setPSVIHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setCreateSchemaInfo) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setCreateSchemaInfo(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setCreateSchemaInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setCreateSchemaInfo" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setCreateSchemaInfo(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setIgnoreAnnotations) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setIgnoreAnnotations(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setIgnoreAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setIgnoreAnnotations" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIgnoreAnnotations(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setDisableDefaultEntityResolution) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setDisableDefaultEntityResolution(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setDisableDefaultEntityResolution" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setDisableDefaultEntityResolution" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setDisableDefaultEntityResolution(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setSkipDTDValidation) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setSkipDTDValidation(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setSkipDTDValidation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setSkipDTDValidation" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setSkipDTDValidation(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_parse__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_parse(self,source);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_parse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "AbstractDOMParser_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "AbstractDOMParser_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    {
      try 
      {
        (arg1)->parse((XERCES_CPP_NAMESPACE::InputSource const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_parse__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_parse(self,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_parse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AbstractDOMParser_parse");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->parse((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_parse) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_AbstractDOMParser_parse__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_AbstractDOMParser_parse__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'AbstractDOMParser_parse'");
  XSRETURN(0);
}


XS(_wrap_AbstractDOMParser_parseFirst__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg3 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: AbstractDOMParser_parseFirst(self,systemId,toFill);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_parseFirst" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AbstractDOMParser_parseFirst");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    res3 = SWIG_ConvertPtr(ST(2), &argp3, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "AbstractDOMParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp3) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "AbstractDOMParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp3);
    {
      try 
      {
        result = (bool)(arg1)->parseFirst((XMLCh const *)arg2,*arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_parseFirst__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    char *arg2 = (char *) (char *)0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg3 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int res2 ;
    char *buf2 = 0 ;
    int alloc2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: AbstractDOMParser_parseFirst(self,systemId,toFill);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_parseFirst" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    res2 = SWIG_AsCharPtrAndSize(ST(1), &buf2, NULL, &alloc2);
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "AbstractDOMParser_parseFirst" "', argument " "2"" of type '" "char const *const""'");
    }
    arg2 = buf2;
    res3 = SWIG_ConvertPtr(ST(2), &argp3, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "AbstractDOMParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp3) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "AbstractDOMParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp3);
    {
      try 
      {
        result = (bool)(arg1)->parseFirst((char const *)arg2,*arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    
    XSRETURN(argvi);
  fail:
    
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_parseFirst__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg3 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: AbstractDOMParser_parseFirst(self,source,toFill);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_parseFirst" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "AbstractDOMParser_parseFirst" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "AbstractDOMParser_parseFirst" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    res3 = SWIG_ConvertPtr(ST(2), &argp3, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "AbstractDOMParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp3) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "AbstractDOMParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp3);
    {
      try 
      {
        result = (bool)(arg1)->parseFirst((XERCES_CPP_NAMESPACE::InputSource const &)*arg2,*arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_parseFirst) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(2), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(2), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        int res = SWIG_AsCharPtrAndSize(ST(1), 0, NULL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(2), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_AbstractDOMParser_parseFirst__SWIG_2); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_AbstractDOMParser_parseFirst__SWIG_0); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_AbstractDOMParser_parseFirst__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'AbstractDOMParser_parseFirst'");
  XSRETURN(0);
}


XS(_wrap_AbstractDOMParser_parseNext) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg2 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_parseNext(self,token);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_parseNext" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "AbstractDOMParser_parseNext" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "AbstractDOMParser_parseNext" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp2);
    {
      try 
      {
        result = (bool)(arg1)->parseNext(*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_parseReset) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_parseReset(self,token);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_parseReset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "AbstractDOMParser_parseReset" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "AbstractDOMParser_parseReset" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp2);
    {
      try 
      {
        (arg1)->parseReset(*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_handleElementPSVI) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    PSVIElement *arg4 = (PSVIElement *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: AbstractDOMParser_handleElementPSVI(self,localName,uri,elementInfo);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_handleElementPSVI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AbstractDOMParser_handleElementPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"AbstractDOMParser_handleElementPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_PSVIElement, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "AbstractDOMParser_handleElementPSVI" "', argument " "4"" of type '" "PSVIElement *""'"); 
    }
    arg4 = reinterpret_cast< PSVIElement * >(argp4);
    {
      try 
      {
        (arg1)->handleElementPSVI((XMLCh const *)arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_handlePartialElementPSVI) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    PSVIElement *arg4 = (PSVIElement *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: AbstractDOMParser_handlePartialElementPSVI(self,localName,uri,elementInfo);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_handlePartialElementPSVI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AbstractDOMParser_handlePartialElementPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"AbstractDOMParser_handlePartialElementPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_PSVIElement, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "AbstractDOMParser_handlePartialElementPSVI" "', argument " "4"" of type '" "PSVIElement *""'"); 
    }
    arg4 = reinterpret_cast< PSVIElement * >(argp4);
    {
      try 
      {
        (arg1)->handlePartialElementPSVI((XMLCh const *)arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_handleAttributesPSVI) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    PSVIAttributeList *arg4 = (PSVIAttributeList *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp4 = 0 ;
    int res4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: AbstractDOMParser_handleAttributesPSVI(self,localName,uri,psviAttributes);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_handleAttributesPSVI" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AbstractDOMParser_handleAttributesPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"AbstractDOMParser_handleAttributesPSVI");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    res4 = SWIG_ConvertPtr(ST(3), &argp4,SWIGTYPE_p_PSVIAttributeList, 0 |  0 );
    if (!SWIG_IsOK(res4)) {
      SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "AbstractDOMParser_handleAttributesPSVI" "', argument " "4"" of type '" "PSVIAttributeList *""'"); 
    }
    arg4 = reinterpret_cast< PSVIAttributeList * >(argp4);
    {
      try 
      {
        (arg1)->handleAttributesPSVI((XMLCh const *)arg2,(XMLCh const *)arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_elementTypeInfo) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: AbstractDOMParser_elementTypeInfo(self,typeName,typeURI);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_elementTypeInfo" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"AbstractDOMParser_elementTypeInfo");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"AbstractDOMParser_elementTypeInfo");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->elementTypeInfo((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_getExpandEntityReferences) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: AbstractDOMParser_getExpandEntityReferences(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_getExpandEntityReferences" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::AbstractDOMParser const *)arg1)->getExpandEntityReferences();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_AbstractDOMParser_setExpandEntityReferences) {
  {
    XERCES_CPP_NAMESPACE::AbstractDOMParser *arg1 = (XERCES_CPP_NAMESPACE::AbstractDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: AbstractDOMParser_setExpandEntityReferences(self,expand);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "AbstractDOMParser_setExpandEntityReferences" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::AbstractDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::AbstractDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "AbstractDOMParser_setExpandEntityReferences" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setExpandEntityReferences(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XercesDOMParser__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XMLValidator *arg1 = (XERCES_CPP_NAMESPACE::XMLValidator *) (XERCES_CPP_NAMESPACE::XMLValidator *)0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *arg2 = (XERCES_CPP_NAMESPACE::MemoryManager *) (XERCES_CPP_NAMESPACE::MemoryManager *)0 ;
    XERCES_CPP_NAMESPACE::XMLGrammarPool *arg3 = (XERCES_CPP_NAMESPACE::XMLGrammarPool *) (XERCES_CPP_NAMESPACE::XMLGrammarPool *)0 ;
    XERCES_CPP_NAMESPACE::XercesDOMParser *result = 0 ;
    SV *temp1 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg2 = XERCES_CPP_NAMESPACE::XMLPlatformUtils::fgMemoryManager;
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: new_XercesDOMParser(valToAdopt,gramPool);");
    }
    {
      temp1 = ST(0);
      if (SWIG_ConvertPtr(ST(0), (void **) &arg1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator,0) < 0) {
        SWIG_Perl_TypeError("_p_XERCES_CPP_NAMESPACE__XMLValidator",1,"new_XercesDOMParser");
      }
    }
    res3 = SWIG_ConvertPtr(ST(1), &argp3,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarPool, 0 |  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "new_XercesDOMParser" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLGrammarPool *const""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLGrammarPool * >(argp3);
    {
      SWIG_Disown(temp1);
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XercesDOMParser *)new XERCES_CPP_NAMESPACE::XercesDOMParser(arg1,arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XercesDOMParser__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::XMLValidator *arg1 = (XERCES_CPP_NAMESPACE::XMLValidator *) (XERCES_CPP_NAMESPACE::XMLValidator *)0 ;
    XERCES_CPP_NAMESPACE::XercesDOMParser *result = 0 ;
    SV *temp1 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_XercesDOMParser(valToAdopt);");
    }
    {
      temp1 = ST(0);
      if (SWIG_ConvertPtr(ST(0), (void **) &arg1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator,0) < 0) {
        SWIG_Perl_TypeError("_p_XERCES_CPP_NAMESPACE__XMLValidator",1,"new_XercesDOMParser");
      }
    }
    {
      SWIG_Disown(temp1);
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XercesDOMParser *)new XERCES_CPP_NAMESPACE::XercesDOMParser(arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_XercesDOMParser__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_XercesDOMParser();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XercesDOMParser *)new XERCES_CPP_NAMESPACE::XercesDOMParser();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_XercesDOMParser) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarPool, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XercesDOMParser__SWIG_2); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XercesDOMParser__SWIG_1); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_XercesDOMParser__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'new_XercesDOMParser'");
  XSRETURN(0);
}


XS(_wrap_delete_XercesDOMParser) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_XercesDOMParser(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_XercesDOMParser" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_getErrorHandler) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::ErrorHandler *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XercesDOMParser_getErrorHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_getErrorHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::ErrorHandler *)(arg1)->getErrorHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_getEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::EntityResolver *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XercesDOMParser_getEntityResolver(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_getEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::EntityResolver *)(arg1)->getEntityResolver();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__EntityResolver, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_getXMLEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::XMLEntityResolver *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XercesDOMParser_getXMLEntityResolver(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_getXMLEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLEntityResolver *)(arg1)->getXMLEntityResolver();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityResolver, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_isCachingGrammarFromParse) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XercesDOMParser_isCachingGrammarFromParse(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_isCachingGrammarFromParse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XercesDOMParser const *)arg1)->isCachingGrammarFromParse();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_isUsingCachedGrammarInParse) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XercesDOMParser_isUsingCachedGrammarInParse(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_isUsingCachedGrammarInParse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XercesDOMParser const *)arg1)->isUsingCachedGrammarInParse();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_getGrammar) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XercesDOMParser_getGrammar(self,nameSpaceKey);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_getGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XercesDOMParser_getGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->getGrammar((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_getRootGrammar) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XercesDOMParser_getRootGrammar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_getRootGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->getRootGrammar();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_getURIText) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XercesDOMParser_getURIText(self,uriId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_getURIText" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XercesDOMParser_getURIText" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::XercesDOMParser const *)arg1)->getURIText(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_getSrcOffset) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XercesDOMParser_getSrcOffset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_getSrcOffset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::XercesDOMParser const *)arg1)->getSrcOffset();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_getIgnoreCachedDTD) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XercesDOMParser_getIgnoreCachedDTD(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_getIgnoreCachedDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::XercesDOMParser const *)arg1)->getIgnoreCachedDTD();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_setErrorHandler) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::ErrorHandler *arg2 = (XERCES_CPP_NAMESPACE::ErrorHandler *) (XERCES_CPP_NAMESPACE::ErrorHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XercesDOMParser_setErrorHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_setErrorHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XercesDOMParser_setErrorHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::ErrorHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::ErrorHandler * >(argp2);
    {
      try 
      {
        (arg1)->setErrorHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_setEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::EntityResolver *arg2 = (XERCES_CPP_NAMESPACE::EntityResolver *) (XERCES_CPP_NAMESPACE::EntityResolver *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XercesDOMParser_setEntityResolver(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_setEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__EntityResolver, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XercesDOMParser_setEntityResolver" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::EntityResolver *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::EntityResolver * >(argp2);
    {
      try 
      {
        (arg1)->setEntityResolver(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_setXMLEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::XMLEntityResolver *arg2 = (XERCES_CPP_NAMESPACE::XMLEntityResolver *) (XERCES_CPP_NAMESPACE::XMLEntityResolver *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XercesDOMParser_setXMLEntityResolver(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_setXMLEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityResolver, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XercesDOMParser_setXMLEntityResolver" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityResolver *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityResolver * >(argp2);
    {
      try 
      {
        (arg1)->setXMLEntityResolver(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_cacheGrammarFromParse) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XercesDOMParser_cacheGrammarFromParse(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_cacheGrammarFromParse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XercesDOMParser_cacheGrammarFromParse" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->cacheGrammarFromParse(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_useCachedGrammarInParse) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XercesDOMParser_useCachedGrammarInParse(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_useCachedGrammarInParse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XercesDOMParser_useCachedGrammarInParse" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->useCachedGrammarInParse(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_setIgnoreCachedDTD) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: XercesDOMParser_setIgnoreCachedDTD(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_setIgnoreCachedDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XercesDOMParser_setIgnoreCachedDTD" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIgnoreCachedDTD(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_resetDocumentPool) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XercesDOMParser_resetDocumentPool(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_resetDocumentPool" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        (arg1)->resetDocumentPool();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_error) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLErrorReporter::ErrTypes arg4 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg6 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg7 = (XMLCh *) (XMLCh *)0 ;
    XMLSSize_t arg8 ;
    XMLSSize_t arg9 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    void *argp4 ;
    int res4 = 0 ;
    long val8 ;
    int ecode8 = 0 ;
    long val9 ;
    int ecode9 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 9) || (items > 9)) {
      SWIG_croak("Usage: XercesDOMParser_error(self,errCode,msgDomain,errType,errorText,systemId,publicId,lineNum,colNum);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_error" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "XercesDOMParser_error" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"XercesDOMParser_error");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      res4 = SWIG_ConvertPtr(ST(3), &argp4, SWIGTYPE_p_XMLErrorReporter__ErrTypes,  0 );
      if (!SWIG_IsOK(res4)) {
        SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "XercesDOMParser_error" "', argument " "4"" of type '" "XMLErrorReporter::ErrTypes const""'"); 
      }  
      if (!argp4) {
        SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XercesDOMParser_error" "', argument " "4"" of type '" "XMLErrorReporter::ErrTypes const""'");
      } else {
        arg4 = *(reinterpret_cast< XMLErrorReporter::ErrTypes * >(argp4));
      }
    }
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"XercesDOMParser_error");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    
    if (ST(5) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",6,"XercesDOMParser_error");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg6 = Perl2XMLString(ST(5));
    }
    
    
    if (ST(6) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",7,"XercesDOMParser_error");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg7 = Perl2XMLString(ST(6));
    }
    
    ecode8 = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(ST(7), &val8);
    if (!SWIG_IsOK(ecode8)) {
      SWIG_exception_fail(SWIG_ArgError(ecode8), "in method '" "XercesDOMParser_error" "', argument " "8"" of type '" "XMLSSize_t""'");
    } 
    arg8 = static_cast< XMLSSize_t >(val8);
    ecode9 = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(ST(8), &val9);
    if (!SWIG_IsOK(ecode9)) {
      SWIG_exception_fail(SWIG_ArgError(ecode9), "in method '" "XercesDOMParser_error" "', argument " "9"" of type '" "XMLSSize_t""'");
    } 
    arg9 = static_cast< XMLSSize_t >(val9);
    {
      try 
      {
        (arg1)->error(arg2,(XMLCh const *)arg3,arg4,(XMLCh const *)arg5,(XMLCh const *)arg6,(XMLCh const *)arg7,arg8,arg9);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    
    delete[] arg3;
    
    
    delete[] arg5;
    
    
    delete[] arg6;
    
    
    delete[] arg7;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg5;
    
    
    delete[] arg6;
    
    
    delete[] arg7;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_resetErrors) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XercesDOMParser_resetErrors(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_resetErrors" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        (arg1)->resetErrors();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_loadGrammar__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    short arg3 ;
    bool arg4 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    bool val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: XercesDOMParser_loadGrammar(self,source,grammarType,toCache);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XercesDOMParser_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XercesDOMParser_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "XercesDOMParser_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    ecode4 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "XercesDOMParser_loadGrammar" "', argument " "4"" of type '" "bool""'");
    } 
    arg4 = static_cast< bool >(val4);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XERCES_CPP_NAMESPACE::InputSource const &)*arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_loadGrammar__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    short arg3 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: XercesDOMParser_loadGrammar(self,source,grammarType);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XercesDOMParser_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "XercesDOMParser_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "XercesDOMParser_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XERCES_CPP_NAMESPACE::InputSource const &)*arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_loadGrammar__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    short arg3 ;
    bool arg4 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    bool val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: XercesDOMParser_loadGrammar(self,systemId,grammarType,toCache);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XercesDOMParser_loadGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "XercesDOMParser_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    ecode4 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "XercesDOMParser_loadGrammar" "', argument " "4"" of type '" "bool""'");
    } 
    arg4 = static_cast< bool >(val4);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XMLCh const *)arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_loadGrammar__SWIG_3) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    short arg3 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: XercesDOMParser_loadGrammar(self,systemId,grammarType);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"XercesDOMParser_loadGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "XercesDOMParser_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XercesDOMParser_loadGrammar) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XercesDOMParser_loadGrammar__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XercesDOMParser_loadGrammar__SWIG_3); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XercesDOMParser_loadGrammar__SWIG_0); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XercesDOMParser_loadGrammar__SWIG_2); return;
    }
  }
  
  croak("No matching function for overloaded 'XercesDOMParser_loadGrammar'");
  XSRETURN(0);
}


XS(_wrap_XercesDOMParser_resetCachedGrammarPool) {
  {
    XERCES_CPP_NAMESPACE::XercesDOMParser *arg1 = (XERCES_CPP_NAMESPACE::XercesDOMParser *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XercesDOMParser_resetCachedGrammarPool(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "XercesDOMParser_resetCachedGrammarPool" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::XercesDOMParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::XercesDOMParser * >(argp1);
    {
      try 
      {
        (arg1)->resetCachedGrammarPool();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SAXParser__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::XMLValidator *arg1 = (XERCES_CPP_NAMESPACE::XMLValidator *) (XERCES_CPP_NAMESPACE::XMLValidator *)0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *arg2 = (XERCES_CPP_NAMESPACE::MemoryManager *) (XERCES_CPP_NAMESPACE::MemoryManager *)0 ;
    XERCES_CPP_NAMESPACE::XMLGrammarPool *arg3 = (XERCES_CPP_NAMESPACE::XMLGrammarPool *) (XERCES_CPP_NAMESPACE::XMLGrammarPool *)0 ;
    XERCES_CPP_NAMESPACE::SAXParser *result = 0 ;
    SV *temp1 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg2 = XERCES_CPP_NAMESPACE::XMLPlatformUtils::fgMemoryManager;
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: new_SAXParser(valToAdopt,gramPool);");
    }
    {
      temp1 = ST(0);
      if (SWIG_ConvertPtr(ST(0), (void **) &arg1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator,0) < 0) {
        SWIG_Perl_TypeError("_p_XERCES_CPP_NAMESPACE__XMLValidator",1,"new_SAXParser");
      }
    }
    res3 = SWIG_ConvertPtr(ST(1), &argp3,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarPool, 0 |  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "new_SAXParser" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLGrammarPool *const""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLGrammarPool * >(argp3);
    {
      SWIG_Disown(temp1);
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SAXParser *)new XERCES_CPP_NAMESPACE::SAXParser(arg1,arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SAXParser__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::XMLValidator *arg1 = (XERCES_CPP_NAMESPACE::XMLValidator *) (XERCES_CPP_NAMESPACE::XMLValidator *)0 ;
    XERCES_CPP_NAMESPACE::MemoryManager *arg2 = (XERCES_CPP_NAMESPACE::MemoryManager *) (XERCES_CPP_NAMESPACE::MemoryManager *)0 ;
    XERCES_CPP_NAMESPACE::SAXParser *result = 0 ;
    SV *temp1 ;
    int argvi = 0;
    dXSARGS;
    
    arg2 = XERCES_CPP_NAMESPACE::XMLPlatformUtils::fgMemoryManager;
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_SAXParser(valToAdopt);");
    }
    {
      temp1 = ST(0);
      if (SWIG_ConvertPtr(ST(0), (void **) &arg1, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator,0) < 0) {
        SWIG_Perl_TypeError("_p_XERCES_CPP_NAMESPACE__XMLValidator",1,"new_SAXParser");
      }
    }
    {
      SWIG_Disown(temp1);
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SAXParser *)new XERCES_CPP_NAMESPACE::SAXParser(arg1,arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_SAXParser__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_SAXParser();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SAXParser *)new XERCES_CPP_NAMESPACE::SAXParser();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_SAXParser) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarPool, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_SAXParser__SWIG_2); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_SAXParser__SWIG_1); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_SAXParser__SWIG_0); return;
    }
  }
  
  croak("No matching function for overloaded 'new_SAXParser'");
  XSRETURN(0);
}


XS(_wrap_delete_SAXParser) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SAXParser(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SAXParser" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getDocumentHandler) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::DocumentHandler *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getDocumentHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getDocumentHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DocumentHandler *)(arg1)->getDocumentHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DocumentHandler, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::EntityResolver *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getEntityResolver(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::EntityResolver *)(arg1)->getEntityResolver();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__EntityResolver, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getXMLEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::XMLEntityResolver *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getXMLEntityResolver(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getXMLEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLEntityResolver *)(arg1)->getXMLEntityResolver();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityResolver, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getErrorHandler) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::ErrorHandler *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getErrorHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getErrorHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::ErrorHandler *)(arg1)->getErrorHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getPSVIHandler) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::PSVIHandler *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getPSVIHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getPSVIHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::PSVIHandler *)(arg1)->getPSVIHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__PSVIHandler, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getValidator) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::XMLValidator *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getValidator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        {
          XERCES_CPP_NAMESPACE::XMLValidator const &_result_ref = ((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getValidator();
          result = (XERCES_CPP_NAMESPACE::XMLValidator *) &_result_ref;
        }
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getValidationScheme) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::SAXParser::ValSchemes result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getValidationScheme(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getValidationScheme" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SAXParser::ValSchemes)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getValidationScheme();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getDoSchema) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getDoSchema(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getDoSchema" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getDoSchema();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getValidationSchemaFullChecking) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getValidationSchemaFullChecking(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getValidationSchemaFullChecking" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getValidationSchemaFullChecking();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getIdentityConstraintChecking) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getIdentityConstraintChecking(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getIdentityConstraintChecking" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getIdentityConstraintChecking();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getErrorCount) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getErrorCount(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getErrorCount" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getErrorCount();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getDoNamespaces) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getDoNamespaces(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getDoNamespaces" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getDoNamespaces();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getExitOnFirstFatalError) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getExitOnFirstFatalError(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getExitOnFirstFatalError" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getExitOnFirstFatalError();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getValidationConstraintFatal) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getValidationConstraintFatal(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getValidationConstraintFatal" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getValidationConstraintFatal();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getExternalSchemaLocation) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getExternalSchemaLocation(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getExternalSchemaLocation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getExternalSchemaLocation();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getExternalNoNamespaceSchemaLocation) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getExternalNoNamespaceSchemaLocation(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getExternalNoNamespaceSchemaLocation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getExternalNoNamespaceSchemaLocation();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getSecurityManager) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    SecurityManager *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getSecurityManager(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getSecurityManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (SecurityManager *)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getSecurityManager();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_SecurityManager, 0 | 0); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getLoadExternalDTD) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getLoadExternalDTD(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getLoadExternalDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getLoadExternalDTD();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_isCachingGrammarFromParse) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_isCachingGrammarFromParse(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_isCachingGrammarFromParse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->isCachingGrammarFromParse();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_isUsingCachedGrammarInParse) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_isUsingCachedGrammarInParse(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_isUsingCachedGrammarInParse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->isUsingCachedGrammarInParse();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getCalculateSrcOfs) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getCalculateSrcOfs(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getCalculateSrcOfs" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getCalculateSrcOfs();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getStandardUriConformant) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getStandardUriConformant(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getStandardUriConformant" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getStandardUriConformant();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getGrammar) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_getGrammar(self,nameSpaceKey);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAXParser_getGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->getGrammar((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getRootGrammar) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getRootGrammar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getRootGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->getRootGrammar();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getURIText) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_getURIText(self,uriId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getURIText" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_getURIText" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getURIText(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getSrcOffset) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getSrcOffset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getSrcOffset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getSrcOffset();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getGenerateSyntheticAnnotations) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getGenerateSyntheticAnnotations(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getGenerateSyntheticAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getGenerateSyntheticAnnotations();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getValidateAnnotations) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getValidateAnnotations(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getValidateAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getValidateAnnotations();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getIgnoreCachedDTD) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getIgnoreCachedDTD(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getIgnoreCachedDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getIgnoreCachedDTD();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getIgnoreAnnotations) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getIgnoreAnnotations(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getIgnoreAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getIgnoreAnnotations();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getDisableDefaultEntityResolution) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getDisableDefaultEntityResolution(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getDisableDefaultEntityResolution" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getDisableDefaultEntityResolution();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_getSkipDTDValidation) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_getSkipDTDValidation(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_getSkipDTDValidation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAXParser const *)arg1)->getSkipDTDValidation();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setGenerateSyntheticAnnotations) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setGenerateSyntheticAnnotations(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setGenerateSyntheticAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setGenerateSyntheticAnnotations" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setGenerateSyntheticAnnotations(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setValidateAnnotations) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setValidateAnnotations(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setValidateAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setValidateAnnotations" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setValidateAnnotations(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setDoNamespaces) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setDoNamespaces(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setDoNamespaces" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setDoNamespaces" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setDoNamespaces(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setValidationScheme) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::SAXParser::ValSchemes arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setValidationScheme(self,newScheme);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setValidationScheme" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setValidationScheme" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::SAXParser::ValSchemes""'");
    } 
    arg2 = static_cast< XERCES_CPP_NAMESPACE::SAXParser::ValSchemes >(val2);
    {
      try 
      {
        (arg1)->setValidationScheme(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setDoSchema) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setDoSchema(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setDoSchema" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setDoSchema" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setDoSchema(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setValidationSchemaFullChecking) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setValidationSchemaFullChecking(self,schemaFullChecking);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setValidationSchemaFullChecking" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setValidationSchemaFullChecking" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setValidationSchemaFullChecking(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setIdentityConstraintChecking) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setIdentityConstraintChecking(self,identityConstraintChecking);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setIdentityConstraintChecking" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setIdentityConstraintChecking" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIdentityConstraintChecking(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setExitOnFirstFatalError) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setExitOnFirstFatalError(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setExitOnFirstFatalError" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setExitOnFirstFatalError" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setExitOnFirstFatalError(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setValidationConstraintFatal) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setValidationConstraintFatal(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setValidationConstraintFatal" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setValidationConstraintFatal" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setValidationConstraintFatal(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setExternalSchemaLocation) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setExternalSchemaLocation(self,schemaLocation);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setExternalSchemaLocation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAXParser_setExternalSchemaLocation");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setExternalSchemaLocation((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setExternalNoNamespaceSchemaLocation) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setExternalNoNamespaceSchemaLocation(self,noNamespaceSchemaLocation);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setExternalNoNamespaceSchemaLocation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAXParser_setExternalNoNamespaceSchemaLocation");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->setExternalNoNamespaceSchemaLocation((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setSecurityManager) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    SecurityManager *arg2 = (SecurityManager *) (SecurityManager *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setSecurityManager(self,securityManager);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setSecurityManager" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_SecurityManager, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_setSecurityManager" "', argument " "2"" of type '" "SecurityManager *const""'"); 
    }
    arg2 = reinterpret_cast< SecurityManager * >(argp2);
    {
      try 
      {
        (arg1)->setSecurityManager(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setLoadExternalDTD) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setLoadExternalDTD(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setLoadExternalDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setLoadExternalDTD" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setLoadExternalDTD(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_cacheGrammarFromParse) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_cacheGrammarFromParse(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_cacheGrammarFromParse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_cacheGrammarFromParse" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->cacheGrammarFromParse(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_useCachedGrammarInParse) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_useCachedGrammarInParse(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_useCachedGrammarInParse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_useCachedGrammarInParse" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->useCachedGrammarInParse(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setCalculateSrcOfs) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setCalculateSrcOfs(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setCalculateSrcOfs" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setCalculateSrcOfs" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setCalculateSrcOfs(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setStandardUriConformant) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setStandardUriConformant(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setStandardUriConformant" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setStandardUriConformant" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setStandardUriConformant(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_useScanner) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_useScanner(self,scannerName);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_useScanner" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAXParser_useScanner");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->useScanner((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setInputBufferSize) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    size_t arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    size_t val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setInputBufferSize(self,bufferSize);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setInputBufferSize" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_size_t SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setInputBufferSize" "', argument " "2"" of type '" "size_t""'");
    } 
    arg2 = static_cast< size_t >(val2);
    {
      try 
      {
        (arg1)->setInputBufferSize(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setIgnoreCachedDTD) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setIgnoreCachedDTD(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setIgnoreCachedDTD" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setIgnoreCachedDTD" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIgnoreCachedDTD(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setIgnoreAnnotations) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setIgnoreAnnotations(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setIgnoreAnnotations" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setIgnoreAnnotations" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setIgnoreAnnotations(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setDisableDefaultEntityResolution) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setDisableDefaultEntityResolution(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setDisableDefaultEntityResolution" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setDisableDefaultEntityResolution" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setDisableDefaultEntityResolution(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setSkipDTDValidation) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setSkipDTDValidation(self,newValue);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setSkipDTDValidation" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_setSkipDTDValidation" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setSkipDTDValidation(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_installAdvDocHandler) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLDocumentHandler *arg2 = (XMLDocumentHandler *) (XMLDocumentHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_installAdvDocHandler(self,toInstall);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_installAdvDocHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDocumentHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_installAdvDocHandler" "', argument " "2"" of type '" "XMLDocumentHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XMLDocumentHandler * >(argp2);
    {
      try 
      {
        (arg1)->installAdvDocHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_removeAdvDocHandler) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLDocumentHandler *arg2 = (XMLDocumentHandler *) (XMLDocumentHandler *)0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_removeAdvDocHandler(self,toRemove);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_removeAdvDocHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDocumentHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_removeAdvDocHandler" "', argument " "2"" of type '" "XMLDocumentHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XMLDocumentHandler * >(argp2);
    {
      try 
      {
        result = (bool)(arg1)->removeAdvDocHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_parseFirst__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg3 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAXParser_parseFirst(self,systemId,toFill);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_parseFirst" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAXParser_parseFirst");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    res3 = SWIG_ConvertPtr(ST(2), &argp3, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "SAXParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp3) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAXParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp3);
    {
      try 
      {
        result = (bool)(arg1)->parseFirst((XMLCh const *)arg2,*arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_parseFirst__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    char *arg2 = (char *) (char *)0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg3 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int res2 ;
    char *buf2 = 0 ;
    int alloc2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAXParser_parseFirst(self,systemId,toFill);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_parseFirst" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_AsCharPtrAndSize(ST(1), &buf2, NULL, &alloc2);
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_parseFirst" "', argument " "2"" of type '" "char const *const""'");
    }
    arg2 = buf2;
    res3 = SWIG_ConvertPtr(ST(2), &argp3, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "SAXParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp3) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAXParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp3);
    {
      try 
      {
        result = (bool)(arg1)->parseFirst((char const *)arg2,*arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    
    XSRETURN(argvi);
  fail:
    
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_parseFirst__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg3 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAXParser_parseFirst(self,source,toFill);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_parseFirst" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_parseFirst" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAXParser_parseFirst" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    res3 = SWIG_ConvertPtr(ST(2), &argp3, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "SAXParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp3) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAXParser_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp3);
    {
      try 
      {
        result = (bool)(arg1)->parseFirst((XERCES_CPP_NAMESPACE::InputSource const &)*arg2,*arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_parseFirst) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(2), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(2), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        int res = SWIG_AsCharPtrAndSize(ST(1), 0, NULL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(2), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAXParser_parseFirst__SWIG_2); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAXParser_parseFirst__SWIG_0); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAXParser_parseFirst__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'SAXParser_parseFirst'");
  XSRETURN(0);
}


XS(_wrap_SAXParser_parseNext) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg2 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_parseNext(self,token);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_parseNext" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_parseNext" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAXParser_parseNext" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp2);
    {
      try 
      {
        result = (bool)(arg1)->parseNext(*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_parseReset) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_parseReset(self,token);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_parseReset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_parseReset" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAXParser_parseReset" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp2);
    {
      try 
      {
        (arg1)->parseReset(*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_loadGrammar__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    short arg3 ;
    bool arg4 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    bool val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: SAXParser_loadGrammar(self,source,grammarType,toCache);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAXParser_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SAXParser_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    ecode4 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "SAXParser_loadGrammar" "', argument " "4"" of type '" "bool""'");
    } 
    arg4 = static_cast< bool >(val4);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XERCES_CPP_NAMESPACE::InputSource const &)*arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_loadGrammar__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    short arg3 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAXParser_loadGrammar(self,source,grammarType);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAXParser_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SAXParser_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XERCES_CPP_NAMESPACE::InputSource const &)*arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_loadGrammar__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    short arg3 ;
    bool arg4 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    bool val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: SAXParser_loadGrammar(self,systemId,grammarType,toCache);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAXParser_loadGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SAXParser_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    ecode4 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "SAXParser_loadGrammar" "', argument " "4"" of type '" "bool""'");
    } 
    arg4 = static_cast< bool >(val4);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XMLCh const *)arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_loadGrammar__SWIG_3) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    short arg3 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAXParser_loadGrammar(self,systemId,grammarType);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAXParser_loadGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SAXParser_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_loadGrammar) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAXParser_loadGrammar__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAXParser_loadGrammar__SWIG_3); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAXParser_loadGrammar__SWIG_0); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAXParser_loadGrammar__SWIG_2); return;
    }
  }
  
  croak("No matching function for overloaded 'SAXParser_loadGrammar'");
  XSRETURN(0);
}


XS(_wrap_SAXParser_resetCachedGrammarPool) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_resetCachedGrammarPool(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_resetCachedGrammarPool" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        (arg1)->resetCachedGrammarPool();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_parse__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_parse(self,source);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_parse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAXParser_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    {
      try 
      {
        (arg1)->parse((XERCES_CPP_NAMESPACE::InputSource const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_parse__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_parse(self,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_parse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAXParser_parse");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->parse((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_parse) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAXParser_parse__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAXParser_parse__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'SAXParser_parse'");
  XSRETURN(0);
}


XS(_wrap_SAXParser_setDocumentHandler) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::DocumentHandler *arg2 = (XERCES_CPP_NAMESPACE::DocumentHandler *) (XERCES_CPP_NAMESPACE::DocumentHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setDocumentHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setDocumentHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DocumentHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_setDocumentHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DocumentHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DocumentHandler * >(argp2);
    {
      try 
      {
        (arg1)->setDocumentHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setDTDHandler) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::DTDHandler *arg2 = (XERCES_CPP_NAMESPACE::DTDHandler *) (XERCES_CPP_NAMESPACE::DTDHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setDTDHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setDTDHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_setDTDHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DTDHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDHandler * >(argp2);
    {
      try 
      {
        (arg1)->setDTDHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setErrorHandler) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::ErrorHandler *arg2 = (XERCES_CPP_NAMESPACE::ErrorHandler *) (XERCES_CPP_NAMESPACE::ErrorHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setErrorHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setErrorHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_setErrorHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::ErrorHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::ErrorHandler * >(argp2);
    {
      try 
      {
        (arg1)->setErrorHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setPSVIHandler) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::PSVIHandler *arg2 = (XERCES_CPP_NAMESPACE::PSVIHandler *) (XERCES_CPP_NAMESPACE::PSVIHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setPSVIHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setPSVIHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__PSVIHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_setPSVIHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::PSVIHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::PSVIHandler * >(argp2);
    {
      try 
      {
        (arg1)->setPSVIHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::EntityResolver *arg2 = (XERCES_CPP_NAMESPACE::EntityResolver *) (XERCES_CPP_NAMESPACE::EntityResolver *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setEntityResolver(self,resolver);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__EntityResolver, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_setEntityResolver" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::EntityResolver *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::EntityResolver * >(argp2);
    {
      try 
      {
        (arg1)->setEntityResolver(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_setXMLEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    XERCES_CPP_NAMESPACE::XMLEntityResolver *arg2 = (XERCES_CPP_NAMESPACE::XMLEntityResolver *) (XERCES_CPP_NAMESPACE::XMLEntityResolver *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAXParser_setXMLEntityResolver(self,resolver);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_setXMLEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityResolver, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAXParser_setXMLEntityResolver" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLEntityResolver *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLEntityResolver * >(argp2);
    {
      try 
      {
        (arg1)->setXMLEntityResolver(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_error) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    unsigned int arg2 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    XMLErrorReporter::ErrTypes arg4 ;
    XMLCh *arg5 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg6 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg7 = (XMLCh *) (XMLCh *)0 ;
    XMLSSize_t arg8 ;
    XMLSSize_t arg9 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    void *argp4 ;
    int res4 = 0 ;
    long val8 ;
    int ecode8 = 0 ;
    long val9 ;
    int ecode9 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 9) || (items > 9)) {
      SWIG_croak("Usage: SAXParser_error(self,errCode,msgDomain,errType,errorText,systemId,publicId,lineNum,colNum);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_error" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAXParser_error" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"SAXParser_error");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      res4 = SWIG_ConvertPtr(ST(3), &argp4, SWIGTYPE_p_XMLErrorReporter__ErrTypes,  0 );
      if (!SWIG_IsOK(res4)) {
        SWIG_exception_fail(SWIG_ArgError(res4), "in method '" "SAXParser_error" "', argument " "4"" of type '" "XMLErrorReporter::ErrTypes const""'"); 
      }  
      if (!argp4) {
        SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAXParser_error" "', argument " "4"" of type '" "XMLErrorReporter::ErrTypes const""'");
      } else {
        arg4 = *(reinterpret_cast< XMLErrorReporter::ErrTypes * >(argp4));
      }
    }
    
    if (ST(4) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",5,"SAXParser_error");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg5 = Perl2XMLString(ST(4));
    }
    
    
    if (ST(5) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",6,"SAXParser_error");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg6 = Perl2XMLString(ST(5));
    }
    
    
    if (ST(6) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",7,"SAXParser_error");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg7 = Perl2XMLString(ST(6));
    }
    
    ecode8 = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(ST(7), &val8);
    if (!SWIG_IsOK(ecode8)) {
      SWIG_exception_fail(SWIG_ArgError(ecode8), "in method '" "SAXParser_error" "', argument " "8"" of type '" "XMLSSize_t""'");
    } 
    arg8 = static_cast< XMLSSize_t >(val8);
    ecode9 = SWIG_AsVal_long SWIG_PERL_CALL_ARGS_2(ST(8), &val9);
    if (!SWIG_IsOK(ecode9)) {
      SWIG_exception_fail(SWIG_ArgError(ecode9), "in method '" "SAXParser_error" "', argument " "9"" of type '" "XMLSSize_t""'");
    } 
    arg9 = static_cast< XMLSSize_t >(val9);
    {
      try 
      {
        (arg1)->error(arg2,(XMLCh const *)arg3,arg4,(XMLCh const *)arg5,(XMLCh const *)arg6,(XMLCh const *)arg7,arg8,arg9);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    
    delete[] arg3;
    
    
    delete[] arg5;
    
    
    delete[] arg6;
    
    
    delete[] arg7;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    delete[] arg3;
    
    
    delete[] arg5;
    
    
    delete[] arg6;
    
    
    delete[] arg7;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAXParser_resetErrors) {
  {
    XERCES_CPP_NAMESPACE::SAXParser *arg1 = (XERCES_CPP_NAMESPACE::SAXParser *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAXParser_resetErrors(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAXParser_resetErrors" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAXParser *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAXParser * >(argp1);
    {
      try 
      {
        (arg1)->resetErrors();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_delete_SAX2XMLReader) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_SAX2XMLReader(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_SAX2XMLReader" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getContentHandler) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::ContentHandler *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAX2XMLReader_getContentHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getContentHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::ContentHandler *)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getContentHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentHandler, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getDTDHandler) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::DTDHandler *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAX2XMLReader_getDTDHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getDTDHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DTDHandler *)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getDTDHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDHandler, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getFeature) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_getFeature(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getFeature" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAX2XMLReader_getFeature");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try {
        result = (bool)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getFeature((XMLCh const *)arg2);
        
      } 
      CATCH_SAX_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getProperty) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_getProperty(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getProperty" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAX2XMLReader_getProperty");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try {
        result = (void *)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getProperty((XMLCh const *)arg2);
        
      } 
      CATCH_SAX_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_void, 0 | 0); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setContentHandler) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::ContentHandler *arg2 = (XERCES_CPP_NAMESPACE::ContentHandler *) (XERCES_CPP_NAMESPACE::ContentHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_setContentHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setContentHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_setContentHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::ContentHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::ContentHandler * >(argp2);
    {
      try 
      {
        (arg1)->setContentHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setDTDHandler) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::DTDHandler *arg2 = (XERCES_CPP_NAMESPACE::DTDHandler *) (XERCES_CPP_NAMESPACE::DTDHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_setDTDHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setDTDHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_setDTDHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DTDHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DTDHandler * >(argp2);
    {
      try 
      {
        (arg1)->setDTDHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setEntityResolver) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::EntityResolver *arg2 = (XERCES_CPP_NAMESPACE::EntityResolver *) (XERCES_CPP_NAMESPACE::EntityResolver *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_setEntityResolver(self,resolver);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setEntityResolver" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__EntityResolver, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_setEntityResolver" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::EntityResolver *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::EntityResolver * >(argp2);
    {
      try 
      {
        (arg1)->setEntityResolver(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setErrorHandler) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::ErrorHandler *arg2 = (XERCES_CPP_NAMESPACE::ErrorHandler *) (XERCES_CPP_NAMESPACE::ErrorHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_setErrorHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setErrorHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_setErrorHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::ErrorHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::ErrorHandler * >(argp2);
    {
      try 
      {
        (arg1)->setErrorHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setFeature) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    bool arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAX2XMLReader_setFeature(self,name,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setFeature" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAX2XMLReader_setFeature");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SAX2XMLReader_setFeature" "', argument " "3"" of type '" "bool""'");
    } 
    arg3 = static_cast< bool >(val3);
    {
      try {
        (arg1)->setFeature((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_SAX_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setProperty) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *arg3 = (void *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAX2XMLReader_setProperty(self,name,value);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setProperty" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAX2XMLReader_setProperty");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      // now check the value
      if (ST(2) == &PL_sv_undef) {
        SWIG_Perl_NullRef("perl-string",3,"SAX2XMLReader_setProperty");
        goto fail;
      } else {
        // we convert *everything* into a string that isn't undef
        arg3 = Perl2XMLString(ST(2));
      }
    }
    {
      if (XMLString::compareIStringASCII(arg2, XMLUni::fgXercesSecurityManager) == 0) {
        makeSAXNotSupportedException(SAXNotSupportedException("Setting security manager not supported"));
        goto fail;
      }
    }
    {
      try {
        (arg1)->setProperty((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_SAX_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_parse__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_parse(self,source);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_parse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAX2XMLReader_parse" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    {
      try 
      {
        (arg1)->parse((XERCES_CPP_NAMESPACE::InputSource const &)*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_parse__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_parse(self,systemId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_parse" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAX2XMLReader_parse");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->parse((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_parse) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 2) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAX2XMLReader_parse__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAX2XMLReader_parse__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'SAX2XMLReader_parse'");
  XSRETURN(0);
}


XS(_wrap_SAX2XMLReader_getDeclarationHandler) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::DeclHandler *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAX2XMLReader_getDeclarationHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getDeclarationHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::DeclHandler *)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getDeclarationHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__DeclHandler, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getLexicalHandler) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::LexicalHandler *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAX2XMLReader_getLexicalHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getLexicalHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::LexicalHandler *)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getLexicalHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setDeclarationHandler) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::DeclHandler *arg2 = (XERCES_CPP_NAMESPACE::DeclHandler *) (XERCES_CPP_NAMESPACE::DeclHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_setDeclarationHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setDeclarationHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DeclHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_setDeclarationHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DeclHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DeclHandler * >(argp2);
    {
      try 
      {
        (arg1)->setDeclarationHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setLexicalHandler) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::LexicalHandler *arg2 = (XERCES_CPP_NAMESPACE::LexicalHandler *) (XERCES_CPP_NAMESPACE::LexicalHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_setLexicalHandler(self,handler);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setLexicalHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_setLexicalHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::LexicalHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::LexicalHandler * >(argp2);
    {
      try 
      {
        (arg1)->setLexicalHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getValidator) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::XMLValidator *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAX2XMLReader_getValidator(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::XMLValidator *)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getValidator();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getErrorCount) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAX2XMLReader_getErrorCount(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getErrorCount" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        result = (int)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getErrorCount();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getExitOnFirstFatalError) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAX2XMLReader_getExitOnFirstFatalError(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getExitOnFirstFatalError" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getExitOnFirstFatalError();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getValidationConstraintFatal) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAX2XMLReader_getValidationConstraintFatal(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getValidationConstraintFatal" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        result = (bool)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getValidationConstraintFatal();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getGrammar) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_getGrammar(self,nameSpaceKey);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAX2XMLReader_getGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->getGrammar((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getRootGrammar) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAX2XMLReader_getRootGrammar(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getRootGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->getRootGrammar();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getURIText) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    unsigned int arg2 ;
    XMLCh *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_getURIText(self,uriId);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getURIText" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    ecode2 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAX2XMLReader_getURIText" "', argument " "2"" of type '" "unsigned int""'");
    } 
    arg2 = static_cast< unsigned int >(val2);
    {
      try 
      {
        result = (XMLCh *)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getURIText(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    ST(argvi) = XMLString2Perl(result);
    ++argvi;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_getSrcOffset) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    unsigned int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAX2XMLReader_getSrcOffset(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_getSrcOffset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader const *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        result = (unsigned int)((XERCES_CPP_NAMESPACE::SAX2XMLReader const *)arg1)->getSrcOffset();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_unsigned_SS_int  SWIG_PERL_CALL_ARGS_1(static_cast< unsigned int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setValidator) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::XMLValidator *arg2 = (XERCES_CPP_NAMESPACE::XMLValidator *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_setValidator(self,valueToAdopt);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setValidator" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_setValidator" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLValidator *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLValidator * >(argp2);
    {
      try 
      {
        (arg1)->setValidator(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setExitOnFirstFatalError) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_setExitOnFirstFatalError(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setExitOnFirstFatalError" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAX2XMLReader_setExitOnFirstFatalError" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setExitOnFirstFatalError(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setValidationConstraintFatal) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    bool arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    bool val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_setValidationConstraintFatal(self,newState);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setValidationConstraintFatal" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    ecode2 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAX2XMLReader_setValidationConstraintFatal" "', argument " "2"" of type '" "bool""'");
    } 
    arg2 = static_cast< bool >(val2);
    {
      try 
      {
        (arg1)->setValidationConstraintFatal(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_parseFirst__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg3 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAX2XMLReader_parseFirst(self,systemId,toFill);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_parseFirst" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAX2XMLReader_parseFirst");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    res3 = SWIG_ConvertPtr(ST(2), &argp3, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "SAX2XMLReader_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp3) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAX2XMLReader_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp3);
    {
      try 
      {
        result = (bool)(arg1)->parseFirst((XMLCh const *)arg2,*arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_parseFirst__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    char *arg2 = (char *) (char *)0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg3 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int res2 ;
    char *buf2 = 0 ;
    int alloc2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAX2XMLReader_parseFirst(self,systemId,toFill);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_parseFirst" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_AsCharPtrAndSize(ST(1), &buf2, NULL, &alloc2);
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_parseFirst" "', argument " "2"" of type '" "char const *const""'");
    }
    arg2 = buf2;
    res3 = SWIG_ConvertPtr(ST(2), &argp3, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "SAX2XMLReader_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp3) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAX2XMLReader_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp3);
    {
      try 
      {
        result = (bool)(arg1)->parseFirst((char const *)arg2,*arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    
    XSRETURN(argvi);
  fail:
    
    if (alloc2 == SWIG_NEWOBJ) delete[] buf2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_parseFirst__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg3 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    void *argp3 = 0 ;
    int res3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAX2XMLReader_parseFirst(self,source,toFill);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_parseFirst" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_parseFirst" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAX2XMLReader_parseFirst" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    res3 = SWIG_ConvertPtr(ST(2), &argp3, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res3)) {
      SWIG_exception_fail(SWIG_ArgError(res3), "in method '" "SAX2XMLReader_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp3) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAX2XMLReader_parseFirst" "', argument " "3"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg3 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp3);
    {
      try 
      {
        result = (bool)(arg1)->parseFirst((XERCES_CPP_NAMESPACE::InputSource const &)*arg2,*arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_parseFirst) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(2), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(2), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        int res = SWIG_AsCharPtrAndSize(ST(1), 0, NULL, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(2), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAX2XMLReader_parseFirst__SWIG_2); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAX2XMLReader_parseFirst__SWIG_0); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAX2XMLReader_parseFirst__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'SAX2XMLReader_parseFirst'");
  XSRETURN(0);
}


XS(_wrap_SAX2XMLReader_parseNext) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg2 = 0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_parseNext(self,token);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_parseNext" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_parseNext" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAX2XMLReader_parseNext" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp2);
    {
      try 
      {
        result = (bool)(arg1)->parseNext(*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_parseReset) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::XMLPScanToken *arg2 = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_parseReset(self,token);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_parseReset" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_parseReset" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAX2XMLReader_parseReset" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLPScanToken &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLPScanToken * >(argp2);
    {
      try 
      {
        (arg1)->parseReset(*arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_loadGrammar__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    short arg3 ;
    bool arg4 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    bool val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: SAX2XMLReader_loadGrammar(self,source,grammarType,toCache);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAX2XMLReader_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    ecode4 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "4"" of type '" "bool""'");
    } 
    arg4 = static_cast< bool >(val4);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XERCES_CPP_NAMESPACE::InputSource const &)*arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_loadGrammar__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::InputSource *arg2 = 0 ;
    short arg3 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 ;
    int res2 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAX2XMLReader_loadGrammar(self,source,grammarType);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource,  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    if (!argp2) {
      SWIG_exception_fail(SWIG_ValueError, "invalid null reference " "in method '" "SAX2XMLReader_loadGrammar" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::InputSource const &""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::InputSource * >(argp2);
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XERCES_CPP_NAMESPACE::InputSource const &)*arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_loadGrammar__SWIG_2) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    short arg3 ;
    bool arg4 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    bool val4 ;
    int ecode4 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 4) || (items > 4)) {
      SWIG_croak("Usage: SAX2XMLReader_loadGrammar(self,systemId,grammarType,toCache);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAX2XMLReader_loadGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    ecode4 = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), &val4);
    if (!SWIG_IsOK(ecode4)) {
      SWIG_exception_fail(SWIG_ArgError(ecode4), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "4"" of type '" "bool""'");
    } 
    arg4 = static_cast< bool >(val4);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XMLCh const *)arg2,arg3,arg4);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_loadGrammar__SWIG_3) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    short arg3 ;
    XERCES_CPP_NAMESPACE::Grammar *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    short val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: SAX2XMLReader_loadGrammar(self,systemId,grammarType);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"SAX2XMLReader_loadGrammar");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "SAX2XMLReader_loadGrammar" "', argument " "3"" of type '" "short""'");
    } 
    arg3 = static_cast< short >(val3);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::Grammar *)(arg1)->loadGrammar((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIG_TypeDynamicCast(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, SWIG_as_voidptrptr(&result)), 0 | SWIG_SHADOW); argvi++ ;
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_loadGrammar) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_1;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_1:
    
    if (items == 3) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(1), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
    if (items == 4) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          _v = SvOK(ST(1)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_short SWIG_PERL_CALL_ARGS_2(ST(2), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      {
        {
          int res = SWIG_AsVal_bool SWIG_PERL_CALL_ARGS_2(ST(3), NULL);
          _v = SWIG_CheckState(res);
        }
      }
      if (!_v) goto check_4;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 4;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_4:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAX2XMLReader_loadGrammar__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAX2XMLReader_loadGrammar__SWIG_3); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAX2XMLReader_loadGrammar__SWIG_0); return;
    case 4:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_SAX2XMLReader_loadGrammar__SWIG_2); return;
    }
  }
  
  croak("No matching function for overloaded 'SAX2XMLReader_loadGrammar'");
  XSRETURN(0);
}


XS(_wrap_SAX2XMLReader_resetCachedGrammarPool) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: SAX2XMLReader_resetCachedGrammarPool(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_resetCachedGrammarPool" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    {
      try 
      {
        (arg1)->resetCachedGrammarPool();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_setInputBufferSize) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    size_t arg2 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    size_t val2 ;
    int ecode2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_setInputBufferSize(self,bufferSize);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_setInputBufferSize" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    ecode2 = SWIG_AsVal_size_t SWIG_PERL_CALL_ARGS_2(ST(1), &val2);
    if (!SWIG_IsOK(ecode2)) {
      SWIG_exception_fail(SWIG_ArgError(ecode2), "in method '" "SAX2XMLReader_setInputBufferSize" "', argument " "2"" of type '" "size_t""'");
    } 
    arg2 = static_cast< size_t >(val2);
    {
      try 
      {
        (arg1)->setInputBufferSize(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_installAdvDocHandler) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::XMLDocumentHandler *arg2 = (XERCES_CPP_NAMESPACE::XMLDocumentHandler *) (XERCES_CPP_NAMESPACE::XMLDocumentHandler *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_installAdvDocHandler(self,toInstall);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_installAdvDocHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDocumentHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_installAdvDocHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLDocumentHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLDocumentHandler * >(argp2);
    {
      try 
      {
        (arg1)->installAdvDocHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_SAX2XMLReader_removeAdvDocHandler) {
  {
    XERCES_CPP_NAMESPACE::SAX2XMLReader *arg1 = (XERCES_CPP_NAMESPACE::SAX2XMLReader *) 0 ;
    XERCES_CPP_NAMESPACE::XMLDocumentHandler *arg2 = (XERCES_CPP_NAMESPACE::XMLDocumentHandler *) (XERCES_CPP_NAMESPACE::XMLDocumentHandler *)0 ;
    bool result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: SAX2XMLReader_removeAdvDocHandler(self,toRemove);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "SAX2XMLReader_removeAdvDocHandler" "', argument " "1"" of type '" "XERCES_CPP_NAMESPACE::SAX2XMLReader *""'"); 
    }
    arg1 = reinterpret_cast< XERCES_CPP_NAMESPACE::SAX2XMLReader * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDocumentHandler, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "SAX2XMLReader_removeAdvDocHandler" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLDocumentHandler *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLDocumentHandler * >(argp2);
    {
      try 
      {
        result = (bool)(arg1)->removeAdvDocHandler(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_bool  SWIG_PERL_CALL_ARGS_1(static_cast< bool >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLReaderFactory_createXMLReader__SWIG_0) {
  {
    XERCES_CPP_NAMESPACE::MemoryManager *arg1 = (XERCES_CPP_NAMESPACE::MemoryManager *) (XERCES_CPP_NAMESPACE::MemoryManager *)0 ;
    XERCES_CPP_NAMESPACE::XMLGrammarPool *arg2 = (XERCES_CPP_NAMESPACE::XMLGrammarPool *) (XERCES_CPP_NAMESPACE::XMLGrammarPool *)0 ;
    XERCES_CPP_NAMESPACE::SAX2XMLReader *result = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg1 = XERCES_CPP_NAMESPACE::XMLPlatformUtils::fgMemoryManager;
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLReaderFactory_createXMLReader(gramPool);");
    }
    res2 = SWIG_ConvertPtr(ST(0), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarPool, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "XMLReaderFactory_createXMLReader" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::XMLGrammarPool *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::XMLGrammarPool * >(argp2);
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SAX2XMLReader *)XERCES_CPP_NAMESPACE::XMLReaderFactory::createXMLReader(arg1,arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLReaderFactory_createXMLReader__SWIG_1) {
  {
    XERCES_CPP_NAMESPACE::MemoryManager *arg1 = (XERCES_CPP_NAMESPACE::MemoryManager *) (XERCES_CPP_NAMESPACE::MemoryManager *)0 ;
    XERCES_CPP_NAMESPACE::SAX2XMLReader *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    arg1 = XERCES_CPP_NAMESPACE::XMLPlatformUtils::fgMemoryManager;
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: XMLReaderFactory_createXMLReader();");
    }
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SAX2XMLReader *)XERCES_CPP_NAMESPACE::XMLReaderFactory::createXMLReader(arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLReaderFactory_createXMLReader__SWIG_2) {
  {
    XMLCh *arg1 = (XMLCh *) 0 ;
    XERCES_CPP_NAMESPACE::SAX2XMLReader *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: XMLReaderFactory_createXMLReader(className);");
    }
    
    if (ST(0) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",1,"XMLReaderFactory_createXMLReader");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg1 = Perl2XMLString(ST(0));
    }
    
    {
      try 
      {
        result = (XERCES_CPP_NAMESPACE::SAX2XMLReader *)XERCES_CPP_NAMESPACE::XMLReaderFactory::createXMLReader((unsigned short const *)arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    delete[] arg1;
    
    XSRETURN(argvi);
  fail:
    
    delete[] arg1;
    
    SWIG_croak_null();
  }
}


XS(_wrap_XMLReaderFactory_createXMLReader) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        void *vptr = 0;
        int res = SWIG_ConvertPtr(ST(0), &vptr, SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarPool, 0);
        _v = SWIG_CheckState(res);
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0; 
        }
      }
      if (!_v) goto check_3;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 3;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_3:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLReaderFactory_createXMLReader__SWIG_1); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLReaderFactory_createXMLReader__SWIG_0); return;
    case 3:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_XMLReaderFactory_createXMLReader__SWIG_2); return;
    }
  }
  
  croak("No matching function for overloaded 'XMLReaderFactory_createXMLReader'");
  XSRETURN(0);
}


XS(_wrap_new_PerlCallbackHandler__SWIG_0) {
  {
    PerlCallbackHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_PerlCallbackHandler();");
    }
    {
      try 
      {
        result = (PerlCallbackHandler *)new PerlCallbackHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlCallbackHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlCallbackHandler__SWIG_1) {
  {
    SV *arg1 = (SV *) 0 ;
    PerlCallbackHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_PerlCallbackHandler(SV *);");
    }
    {
      arg1 = ST(0);
    }
    {
      try 
      {
        result = (PerlCallbackHandler *)new PerlCallbackHandler(arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlCallbackHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlCallbackHandler) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0;
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlCallbackHandler__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlCallbackHandler__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_PerlCallbackHandler'");
  XSRETURN(0);
}


XS(_wrap_delete_PerlCallbackHandler) {
  {
    PerlCallbackHandler *arg1 = (PerlCallbackHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_PerlCallbackHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlCallbackHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_PerlCallbackHandler" "', argument " "1"" of type '" "PerlCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlCallbackHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlCallbackHandler_type) {
  {
    PerlCallbackHandler *arg1 = (PerlCallbackHandler *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: PerlCallbackHandler_type(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlCallbackHandler_type" "', argument " "1"" of type '" "PerlCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlCallbackHandler * >(argp1);
    {
      try 
      {
        result = (int)(arg1)->type();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlCallbackHandler_set_callback_obj) {
  {
    PerlCallbackHandler *arg1 = (PerlCallbackHandler *) 0 ;
    SV *arg2 = (SV *) 0 ;
    SV *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: PerlCallbackHandler_set_callback_obj(self,SV *);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlCallbackHandler_set_callback_obj" "', argument " "1"" of type '" "PerlCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlCallbackHandler * >(argp1);
    {
      arg2 = ST(1);
    }
    {
      try 
      {
        result = (SV *)(arg1)->set_callback_obj(arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = result; argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlCallbackHandler_XMLString2Perl) {
  {
    PerlCallbackHandler *arg1 = (PerlCallbackHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) 0 ;
    SV *result = 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: PerlCallbackHandler_XMLString2Perl(self,XMLCh const *);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlCallbackHandler_XMLString2Perl" "', argument " "1"" of type '" "PerlCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlCallbackHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"PerlCallbackHandler_XMLString2Perl");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        result = (SV *)(arg1)->XMLString2Perl((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = result; argvi++ ;
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlErrorCallbackHandler__SWIG_0) {
  {
    PerlErrorCallbackHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_PerlErrorCallbackHandler();");
    }
    {
      try 
      {
        result = (PerlErrorCallbackHandler *)new PerlErrorCallbackHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlErrorCallbackHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlErrorCallbackHandler__SWIG_1) {
  {
    SV *arg1 = (SV *) 0 ;
    PerlErrorCallbackHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_PerlErrorCallbackHandler(obj);");
    }
    {
      arg1 = ST(0);
    }
    {
      try 
      {
        result = (PerlErrorCallbackHandler *)new PerlErrorCallbackHandler(arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlErrorCallbackHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlErrorCallbackHandler) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0;
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlErrorCallbackHandler__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlErrorCallbackHandler__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_PerlErrorCallbackHandler'");
  XSRETURN(0);
}


XS(_wrap_delete_PerlErrorCallbackHandler) {
  {
    PerlErrorCallbackHandler *arg1 = (PerlErrorCallbackHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_PerlErrorCallbackHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlErrorCallbackHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_PerlErrorCallbackHandler" "', argument " "1"" of type '" "PerlErrorCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlErrorCallbackHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlErrorCallbackHandler_type) {
  {
    PerlErrorCallbackHandler *arg1 = (PerlErrorCallbackHandler *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: PerlErrorCallbackHandler_type(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlErrorCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlErrorCallbackHandler_type" "', argument " "1"" of type '" "PerlErrorCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlErrorCallbackHandler * >(argp1);
    {
      try 
      {
        result = (int)(arg1)->type();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlErrorCallbackHandler_resetErrors) {
  {
    PerlErrorCallbackHandler *arg1 = (PerlErrorCallbackHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: PerlErrorCallbackHandler_resetErrors(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlErrorCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlErrorCallbackHandler_resetErrors" "', argument " "1"" of type '" "PerlErrorCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlErrorCallbackHandler * >(argp1);
    {
      try 
      {
        (arg1)->resetErrors();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlEntityResolverHandler__SWIG_0) {
  {
    PerlEntityResolverHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_PerlEntityResolverHandler();");
    }
    {
      try 
      {
        result = (PerlEntityResolverHandler *)new PerlEntityResolverHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlEntityResolverHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlEntityResolverHandler__SWIG_1) {
  {
    SV *arg1 = (SV *) 0 ;
    PerlEntityResolverHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_PerlEntityResolverHandler(obj);");
    }
    {
      arg1 = ST(0);
    }
    {
      try 
      {
        result = (PerlEntityResolverHandler *)new PerlEntityResolverHandler(arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlEntityResolverHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlEntityResolverHandler) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0;
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlEntityResolverHandler__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlEntityResolverHandler__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_PerlEntityResolverHandler'");
  XSRETURN(0);
}


XS(_wrap_delete_PerlEntityResolverHandler) {
  {
    PerlEntityResolverHandler *arg1 = (PerlEntityResolverHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_PerlEntityResolverHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlEntityResolverHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_PerlEntityResolverHandler" "', argument " "1"" of type '" "PerlEntityResolverHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlEntityResolverHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlEntityResolverHandler_type) {
  {
    PerlEntityResolverHandler *arg1 = (PerlEntityResolverHandler *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: PerlEntityResolverHandler_type(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlEntityResolverHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlEntityResolverHandler_type" "', argument " "1"" of type '" "PerlEntityResolverHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlEntityResolverHandler * >(argp1);
    {
      try 
      {
        result = (int)(arg1)->type();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlNodeFilterCallbackHandler__SWIG_0) {
  {
    PerlNodeFilterCallbackHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_PerlNodeFilterCallbackHandler();");
    }
    {
      try 
      {
        result = (PerlNodeFilterCallbackHandler *)new PerlNodeFilterCallbackHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlNodeFilterCallbackHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlNodeFilterCallbackHandler__SWIG_1) {
  {
    SV *arg1 = (SV *) 0 ;
    PerlNodeFilterCallbackHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_PerlNodeFilterCallbackHandler(obj);");
    }
    {
      arg1 = ST(0);
    }
    {
      try 
      {
        result = (PerlNodeFilterCallbackHandler *)new PerlNodeFilterCallbackHandler(arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlNodeFilterCallbackHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlNodeFilterCallbackHandler) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0;
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlNodeFilterCallbackHandler__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlNodeFilterCallbackHandler__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_PerlNodeFilterCallbackHandler'");
  XSRETURN(0);
}


XS(_wrap_delete_PerlNodeFilterCallbackHandler) {
  {
    PerlNodeFilterCallbackHandler *arg1 = (PerlNodeFilterCallbackHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_PerlNodeFilterCallbackHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlNodeFilterCallbackHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_PerlNodeFilterCallbackHandler" "', argument " "1"" of type '" "PerlNodeFilterCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlNodeFilterCallbackHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlNodeFilterCallbackHandler_type) {
  {
    PerlNodeFilterCallbackHandler *arg1 = (PerlNodeFilterCallbackHandler *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: PerlNodeFilterCallbackHandler_type(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlNodeFilterCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlNodeFilterCallbackHandler_type" "', argument " "1"" of type '" "PerlNodeFilterCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlNodeFilterCallbackHandler * >(argp1);
    {
      try 
      {
        result = (int)(arg1)->type();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlNodeFilterCallbackHandler_acceptNode) {
  {
    PerlNodeFilterCallbackHandler *arg1 = (PerlNodeFilterCallbackHandler *) 0 ;
    XERCES_CPP_NAMESPACE::DOMNode *arg2 = (XERCES_CPP_NAMESPACE::DOMNode *) 0 ;
    short result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: PerlNodeFilterCallbackHandler_acceptNode(self,node);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlNodeFilterCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlNodeFilterCallbackHandler_acceptNode" "', argument " "1"" of type '" "PerlNodeFilterCallbackHandler const *""'"); 
    }
    arg1 = reinterpret_cast< PerlNodeFilterCallbackHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "PerlNodeFilterCallbackHandler_acceptNode" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::DOMNode const *""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::DOMNode * >(argp2);
    {
      try 
      {
        result = (short)((PerlNodeFilterCallbackHandler const *)arg1)->acceptNode((XERCES_CPP_NAMESPACE::DOMNode const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_short  SWIG_PERL_CALL_ARGS_1(static_cast< short >(result)); argvi++ ;
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlDocumentCallbackHandler__SWIG_0) {
  {
    PerlDocumentCallbackHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_PerlDocumentCallbackHandler();");
    }
    {
      try 
      {
        result = (PerlDocumentCallbackHandler *)new PerlDocumentCallbackHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlDocumentCallbackHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlDocumentCallbackHandler__SWIG_1) {
  {
    SV *arg1 = (SV *) 0 ;
    PerlDocumentCallbackHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_PerlDocumentCallbackHandler(obj);");
    }
    {
      arg1 = ST(0);
    }
    {
      try 
      {
        result = (PerlDocumentCallbackHandler *)new PerlDocumentCallbackHandler(arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlDocumentCallbackHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlDocumentCallbackHandler) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0;
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlDocumentCallbackHandler__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlDocumentCallbackHandler__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_PerlDocumentCallbackHandler'");
  XSRETURN(0);
}


XS(_wrap_delete_PerlDocumentCallbackHandler) {
  {
    PerlDocumentCallbackHandler *arg1 = (PerlDocumentCallbackHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_PerlDocumentCallbackHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlDocumentCallbackHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_PerlDocumentCallbackHandler" "', argument " "1"" of type '" "PerlDocumentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlDocumentCallbackHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlDocumentCallbackHandler_type) {
  {
    PerlDocumentCallbackHandler *arg1 = (PerlDocumentCallbackHandler *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: PerlDocumentCallbackHandler_type(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlDocumentCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlDocumentCallbackHandler_type" "', argument " "1"" of type '" "PerlDocumentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlDocumentCallbackHandler * >(argp1);
    {
      try 
      {
        result = (int)(arg1)->type();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlDocumentCallbackHandler_characters) {
  {
    PerlDocumentCallbackHandler *arg1 = (PerlDocumentCallbackHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: PerlDocumentCallbackHandler_characters(self,chars,length);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlDocumentCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlDocumentCallbackHandler_characters" "', argument " "1"" of type '" "PerlDocumentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlDocumentCallbackHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"PerlDocumentCallbackHandler_characters");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "PerlDocumentCallbackHandler_characters" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->characters((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlDocumentCallbackHandler_processingInstruction) {
  {
    PerlDocumentCallbackHandler *arg1 = (PerlDocumentCallbackHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: PerlDocumentCallbackHandler_processingInstruction(self,target,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlDocumentCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlDocumentCallbackHandler_processingInstruction" "', argument " "1"" of type '" "PerlDocumentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlDocumentCallbackHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"PerlDocumentCallbackHandler_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"PerlDocumentCallbackHandler_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->processingInstruction((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlDocumentCallbackHandler_setDocumentLocator) {
  {
    PerlDocumentCallbackHandler *arg1 = (PerlDocumentCallbackHandler *) 0 ;
    XERCES_CPP_NAMESPACE::Locator *arg2 = (XERCES_CPP_NAMESPACE::Locator *) (XERCES_CPP_NAMESPACE::Locator *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: PerlDocumentCallbackHandler_setDocumentLocator(self,locator);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlDocumentCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlDocumentCallbackHandler_setDocumentLocator" "', argument " "1"" of type '" "PerlDocumentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlDocumentCallbackHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "PerlDocumentCallbackHandler_setDocumentLocator" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::Locator const *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::Locator * >(argp2);
    {
      try 
      {
        (arg1)->setDocumentLocator((XERCES_CPP_NAMESPACE::Locator const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlContentCallbackHandler__SWIG_0) {
  {
    PerlContentCallbackHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 0) || (items > 0)) {
      SWIG_croak("Usage: new_PerlContentCallbackHandler();");
    }
    {
      try 
      {
        result = (PerlContentCallbackHandler *)new PerlContentCallbackHandler();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlContentCallbackHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    XSRETURN(argvi);
  fail:
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlContentCallbackHandler__SWIG_1) {
  {
    SV *arg1 = (SV *) 0 ;
    PerlContentCallbackHandler *result = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: new_PerlContentCallbackHandler(obj);");
    }
    {
      arg1 = ST(0);
    }
    {
      try 
      {
        result = (PerlContentCallbackHandler *)new PerlContentCallbackHandler(arg1);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_NewPointerObj(SWIG_as_voidptr(result), SWIGTYPE_p_PerlContentCallbackHandler, SWIG_OWNER | SWIG_SHADOW); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_new_PerlContentCallbackHandler) {
  dXSARGS;
  
  {
    unsigned long _index = 0;
    SWIG_TypeRank _rank = 0; 
    if (items == 0) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 1;
        if (_rank == _rankm) goto dispatch;
      }
    }
    if (items == 1) {
      SWIG_TypeRank _ranki = 0;
      SWIG_TypeRank _rankm = 0;
      SWIG_TypeRank _pi = 1;
      int _v = 0;
      {
        {
          _v = SvOK(ST(0)) ? 1 : 0;
        }
      }
      if (!_v) goto check_2;
      _ranki += _v*_pi;
      _rankm += _pi;
      _pi *= SWIG_MAXCASTRANK;
      if (!_index || (_ranki < _rank)) {
        _rank = _ranki; _index = 2;
        if (_rank == _rankm) goto dispatch;
      }
    }
  check_2:
    
  dispatch:
    switch(_index) {
    case 1:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlContentCallbackHandler__SWIG_0); return;
    case 2:
      (*PL_markstack_ptr++);SWIG_CALLXS(_wrap_new_PerlContentCallbackHandler__SWIG_1); return;
    }
  }
  
  croak("No matching function for overloaded 'new_PerlContentCallbackHandler'");
  XSRETURN(0);
}


XS(_wrap_delete_PerlContentCallbackHandler) {
  {
    PerlContentCallbackHandler *arg1 = (PerlContentCallbackHandler *) 0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: delete_PerlContentCallbackHandler(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlContentCallbackHandler, SWIG_POINTER_DISOWN |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "delete_PerlContentCallbackHandler" "', argument " "1"" of type '" "PerlContentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlContentCallbackHandler * >(argp1);
    {
      try 
      {
        delete arg1;
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlContentCallbackHandler_type) {
  {
    PerlContentCallbackHandler *arg1 = (PerlContentCallbackHandler *) 0 ;
    int result;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 1) || (items > 1)) {
      SWIG_croak("Usage: PerlContentCallbackHandler_type(self);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlContentCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlContentCallbackHandler_type" "', argument " "1"" of type '" "PerlContentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlContentCallbackHandler * >(argp1);
    {
      try 
      {
        result = (int)(arg1)->type();
        
      } 
      CATCH_DOM_EXCEPTION
    }
    ST(argvi) = SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(result)); argvi++ ;
    
    XSRETURN(argvi);
  fail:
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlContentCallbackHandler_characters) {
  {
    PerlContentCallbackHandler *arg1 = (PerlContentCallbackHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    unsigned int arg3 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    unsigned int val3 ;
    int ecode3 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: PerlContentCallbackHandler_characters(self,chars,length);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlContentCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlContentCallbackHandler_characters" "', argument " "1"" of type '" "PerlContentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlContentCallbackHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"PerlContentCallbackHandler_characters");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    ecode3 = SWIG_AsVal_unsigned_SS_int SWIG_PERL_CALL_ARGS_2(ST(2), &val3);
    if (!SWIG_IsOK(ecode3)) {
      SWIG_exception_fail(SWIG_ArgError(ecode3), "in method '" "PerlContentCallbackHandler_characters" "', argument " "3"" of type '" "unsigned int""'");
    } 
    arg3 = static_cast< unsigned int >(val3);
    {
      try 
      {
        (arg1)->characters((XMLCh const *)arg2,arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlContentCallbackHandler_processingInstruction) {
  {
    PerlContentCallbackHandler *arg1 = (PerlContentCallbackHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: PerlContentCallbackHandler_processingInstruction(self,target,data);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlContentCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlContentCallbackHandler_processingInstruction" "', argument " "1"" of type '" "PerlContentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlContentCallbackHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"PerlContentCallbackHandler_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"PerlContentCallbackHandler_processingInstruction");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->processingInstruction((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlContentCallbackHandler_setDocumentLocator) {
  {
    PerlContentCallbackHandler *arg1 = (PerlContentCallbackHandler *) 0 ;
    XERCES_CPP_NAMESPACE::Locator *arg2 = (XERCES_CPP_NAMESPACE::Locator *) (XERCES_CPP_NAMESPACE::Locator *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    void *argp2 = 0 ;
    int res2 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: PerlContentCallbackHandler_setDocumentLocator(self,locator);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlContentCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlContentCallbackHandler_setDocumentLocator" "', argument " "1"" of type '" "PerlContentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlContentCallbackHandler * >(argp1);
    res2 = SWIG_ConvertPtr(ST(1), &argp2,SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, 0 |  0 );
    if (!SWIG_IsOK(res2)) {
      SWIG_exception_fail(SWIG_ArgError(res2), "in method '" "PerlContentCallbackHandler_setDocumentLocator" "', argument " "2"" of type '" "XERCES_CPP_NAMESPACE::Locator const *const""'"); 
    }
    arg2 = reinterpret_cast< XERCES_CPP_NAMESPACE::Locator * >(argp2);
    {
      try 
      {
        (arg1)->setDocumentLocator((XERCES_CPP_NAMESPACE::Locator const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    XSRETURN(argvi);
  fail:
    
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlContentCallbackHandler_startPrefixMapping) {
  {
    PerlContentCallbackHandler *arg1 = (PerlContentCallbackHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    XMLCh *arg3 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 3) || (items > 3)) {
      SWIG_croak("Usage: PerlContentCallbackHandler_startPrefixMapping(self,prefix,uri);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlContentCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlContentCallbackHandler_startPrefixMapping" "', argument " "1"" of type '" "PerlContentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlContentCallbackHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"PerlContentCallbackHandler_startPrefixMapping");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    
    if (ST(2) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",3,"PerlContentCallbackHandler_startPrefixMapping");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg3 = Perl2XMLString(ST(2));
    }
    
    {
      try 
      {
        (arg1)->startPrefixMapping((XMLCh const *)arg2,(XMLCh const *)arg3);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    
    delete[] arg3;
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlContentCallbackHandler_endPrefixMapping) {
  {
    PerlContentCallbackHandler *arg1 = (PerlContentCallbackHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: PerlContentCallbackHandler_endPrefixMapping(self,prefix);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlContentCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlContentCallbackHandler_endPrefixMapping" "', argument " "1"" of type '" "PerlContentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlContentCallbackHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"PerlContentCallbackHandler_endPrefixMapping");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->endPrefixMapping((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}


XS(_wrap_PerlContentCallbackHandler_skippedEntity) {
  {
    PerlContentCallbackHandler *arg1 = (PerlContentCallbackHandler *) 0 ;
    XMLCh *arg2 = (XMLCh *) (XMLCh *)0 ;
    void *argp1 = 0 ;
    int res1 = 0 ;
    int argvi = 0;
    dXSARGS;
    
    if ((items < 2) || (items > 2)) {
      SWIG_croak("Usage: PerlContentCallbackHandler_skippedEntity(self,name);");
    }
    res1 = SWIG_ConvertPtr(ST(0), &argp1,SWIGTYPE_p_PerlContentCallbackHandler, 0 |  0 );
    if (!SWIG_IsOK(res1)) {
      SWIG_exception_fail(SWIG_ArgError(res1), "in method '" "PerlContentCallbackHandler_skippedEntity" "', argument " "1"" of type '" "PerlContentCallbackHandler *""'"); 
    }
    arg1 = reinterpret_cast< PerlContentCallbackHandler * >(argp1);
    
    if (ST(1) == &PL_sv_undef) {
      SWIG_Perl_NullRef("perl-string",2,"PerlContentCallbackHandler_skippedEntity");
      goto fail;
    } else {
      // we convert *everything* into a string that isn't undef
      arg2 = Perl2XMLString(ST(1));
    }
    
    {
      try 
      {
        (arg1)->skippedEntity((XMLCh const *)arg2);
        
      } 
      CATCH_DOM_EXCEPTION
    }
    
    
    
    delete[] arg2;
    
    XSRETURN(argvi);
  fail:
    
    
    delete[] arg2;
    
    SWIG_croak_null();
  }
}



/* -------- TYPE CONVERSION AND EQUIVALENCE RULES (BEGIN) -------- */

static void *_p_XERCES_CPP_NAMESPACE__DOMCDATASectionTo_p_XERCES_CPP_NAMESPACE__DOMText(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMText *)  ((XERCES_CPP_NAMESPACE::DOMCDATASection *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *)  ((XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_tTo_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *)  ((XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *)  ((XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMImplementationTo_p_XERCES_CPP_NAMESPACE__DOMImplementationLS(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMImplementationLS *)  ((XERCES_CPP_NAMESPACE::DOMImplementation *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDValidatorTo_p_XERCES_CPP_NAMESPACE__XMLValidator(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLValidator *)  ((XERCES_CPP_NAMESPACE::DTDValidator *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SchemaValidatorTo_p_XERCES_CPP_NAMESPACE__XMLValidator(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLValidator *)  ((XERCES_CPP_NAMESPACE::SchemaValidator *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMWriterFilterTo_p_XERCES_CPP_NAMESPACE__DOMNodeFilter(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNodeFilter *)  ((XERCES_CPP_NAMESPACE::DOMWriterFilter *) x));
}
static void *_p_PerlNodeFilterCallbackHandlerTo_p_XERCES_CPP_NAMESPACE__DOMNodeFilter(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNodeFilter *)  ((PerlNodeFilterCallbackHandler *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SAXParserTo_p_XERCES_CPP_NAMESPACE__Parser(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::Parser *)  ((XERCES_CPP_NAMESPACE::SAXParser *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLSchemaDescriptionTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLGrammarDescription *) ((XERCES_CPP_NAMESPACE::XMLSchemaDescription *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLGrammarDescriptionTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLGrammarDescription *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLDTDDescriptionTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLGrammarDescription *) ((XERCES_CPP_NAMESPACE::XMLDTDDescription *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SchemaElementDeclTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLElementDecl *) ((XERCES_CPP_NAMESPACE::SchemaElementDecl *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDElementDeclTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLElementDecl *) ((XERCES_CPP_NAMESPACE::DTDElementDecl *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLElementDeclTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLElementDecl *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SchemaValidatorTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLValidator *) ((XERCES_CPP_NAMESPACE::SchemaValidator *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDValidatorTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLValidator *) ((XERCES_CPP_NAMESPACE::DTDValidator *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLValidatorTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLValidator *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLPScanTokenTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLPScanToken *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDAttDefTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLAttDef *) ((XERCES_CPP_NAMESPACE::DTDAttDef *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLAttDefTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLAttDef *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SAXParserTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::SAXParser *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLNotationDeclTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLNotationDecl *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLFormatTarget *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__StdOutFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLFormatTarget *) ((XERCES_CPP_NAMESPACE::StdOutFormatTarget *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__LocalFileFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLFormatTarget *) ((XERCES_CPP_NAMESPACE::LocalFileFormatTarget *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__MemBufFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLFormatTarget *) ((XERCES_CPP_NAMESPACE::MemBufFormatTarget *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLURLTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLURL *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__LocalFileInputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::InputSource *) ((XERCES_CPP_NAMESPACE::LocalFileInputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__InputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::InputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__StdInInputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::InputSource *) ((XERCES_CPP_NAMESPACE::StdInInputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__URLInputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::InputSource *) ((XERCES_CPP_NAMESPACE::URLInputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__MemBufInputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::InputSource *) ((XERCES_CPP_NAMESPACE::MemBufInputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::InputSource *) ((XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SchemaAttDefTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLAttDef *) ((XERCES_CPP_NAMESPACE::SchemaAttDef *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__AbstractDOMParserTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::AbstractDOMParser *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XercesDOMParserTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::AbstractDOMParser *) ((XERCES_CPP_NAMESPACE::XercesDOMParser *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLExceptionTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLException *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLContentModelTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLContentModel *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__QNameTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::QName *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SchemaGrammarTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::Grammar *) ((XERCES_CPP_NAMESPACE::SchemaGrammar *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDGrammarTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::Grammar *) ((XERCES_CPP_NAMESPACE::DTDGrammar *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__GrammarTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::Grammar *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SAXExceptionTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::SAXException *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SAXNotSupportedExceptionTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::SAXException *) ((XERCES_CPP_NAMESPACE::SAXNotSupportedException *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SAXNotRecognizedExceptionTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::SAXException *) ((XERCES_CPP_NAMESPACE::SAXNotRecognizedException *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SAXParseExceptionTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::SAXException *) ((XERCES_CPP_NAMESPACE::SAXParseException *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SchemaAttDefListTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLAttDefList *) ((XERCES_CPP_NAMESPACE::SchemaAttDefList *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDAttDefListTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLAttDefList *) ((XERCES_CPP_NAMESPACE::DTDAttDefList *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLAttDefListTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLAttDefList *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLUriTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLUri *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLFormatterTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLFormatter *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDEntityDeclTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *) (XERCES_CPP_NAMESPACE::XMLEntityDecl *) ((XERCES_CPP_NAMESPACE::DTDEntityDecl *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLEntityDeclTo_p_XERCES_CPP_NAMESPACE__XMemory(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMemory *)  ((XERCES_CPP_NAMESPACE::XMLEntityDecl *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SAXParserTo_p_XMLErrorReporter(void *x) {
    return (void *)((XMLErrorReporter *)  ((XERCES_CPP_NAMESPACE::SAXParser *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__AbstractDOMParserTo_p_XMLErrorReporter(void *x) {
    return (void *)((XMLErrorReporter *)  ((XERCES_CPP_NAMESPACE::AbstractDOMParser *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDElementDeclTo_p_XERCES_CPP_NAMESPACE__XMLElementDecl(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLElementDecl *)  ((XERCES_CPP_NAMESPACE::DTDElementDecl *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SchemaElementDeclTo_p_XERCES_CPP_NAMESPACE__XMLElementDecl(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLElementDecl *)  ((XERCES_CPP_NAMESPACE::SchemaElementDecl *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XercesDOMParserTo_p_XERCES_CPP_NAMESPACE__AbstractDOMParser(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::AbstractDOMParser *)  ((XERCES_CPP_NAMESPACE::XercesDOMParser *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLDTDDescriptionTo_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLGrammarDescription *)  ((XERCES_CPP_NAMESPACE::XMLDTDDescription *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XMLSchemaDescriptionTo_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLGrammarDescription *)  ((XERCES_CPP_NAMESPACE::XMLSchemaDescription *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDGrammarTo_p_XERCES_CPP_NAMESPACE__Grammar(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::Grammar *)  ((XERCES_CPP_NAMESPACE::DTDGrammar *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SchemaGrammarTo_p_XERCES_CPP_NAMESPACE__Grammar(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::Grammar *)  ((XERCES_CPP_NAMESPACE::SchemaGrammar *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SchemaAttDefTo_p_XERCES_CPP_NAMESPACE__XMLAttDef(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLAttDef *)  ((XERCES_CPP_NAMESPACE::SchemaAttDef *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDAttDefTo_p_XERCES_CPP_NAMESPACE__XMLAttDef(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLAttDef *)  ((XERCES_CPP_NAMESPACE::DTDAttDef *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__StdOutFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMLFormatTarget(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLFormatTarget *)  ((XERCES_CPP_NAMESPACE::StdOutFormatTarget *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__LocalFileFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMLFormatTarget(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLFormatTarget *)  ((XERCES_CPP_NAMESPACE::LocalFileFormatTarget *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__MemBufFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMLFormatTarget(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLFormatTarget *)  ((XERCES_CPP_NAMESPACE::MemBufFormatTarget *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__Wrapper4InputSourceTo_p_XERCES_CPP_NAMESPACE__DOMInputSource(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMInputSource *)  ((XERCES_CPP_NAMESPACE::Wrapper4InputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__LocalFileInputSourceTo_p_XERCES_CPP_NAMESPACE__InputSource(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::InputSource *)  ((XERCES_CPP_NAMESPACE::LocalFileInputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__StdInInputSourceTo_p_XERCES_CPP_NAMESPACE__InputSource(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::InputSource *)  ((XERCES_CPP_NAMESPACE::StdInInputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__URLInputSourceTo_p_XERCES_CPP_NAMESPACE__InputSource(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::InputSource *)  ((XERCES_CPP_NAMESPACE::URLInputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__MemBufInputSourceTo_p_XERCES_CPP_NAMESPACE__InputSource(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::InputSource *)  ((XERCES_CPP_NAMESPACE::MemBufInputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSourceTo_p_XERCES_CPP_NAMESPACE__InputSource(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::InputSource *)  ((XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDAttDefListTo_p_XERCES_CPP_NAMESPACE__XMLAttDefList(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLAttDefList *)  ((XERCES_CPP_NAMESPACE::DTDAttDefList *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SchemaAttDefListTo_p_XERCES_CPP_NAMESPACE__XMLAttDefList(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLAttDefList *)  ((XERCES_CPP_NAMESPACE::SchemaAttDefList *) x));
}
static void *_p_PerlErrorCallbackHandlerTo_p_PerlCallbackHandler(void *x) {
    return (void *)((PerlCallbackHandler *)  ((PerlErrorCallbackHandler *) x));
}
static void *_p_PerlEntityResolverHandlerTo_p_PerlCallbackHandler(void *x) {
    return (void *)((PerlCallbackHandler *)  ((PerlEntityResolverHandler *) x));
}
static void *_p_PerlNodeFilterCallbackHandlerTo_p_PerlCallbackHandler(void *x) {
    return (void *)((PerlCallbackHandler *)  ((PerlNodeFilterCallbackHandler *) x));
}
static void *_p_PerlDocumentCallbackHandlerTo_p_PerlCallbackHandler(void *x) {
    return (void *)((PerlCallbackHandler *)  ((PerlDocumentCallbackHandler *) x));
}
static void *_p_PerlContentCallbackHandlerTo_p_PerlCallbackHandler(void *x) {
    return (void *)((PerlCallbackHandler *)  ((PerlContentCallbackHandler *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__AbstractDOMParserTo_p_XERCES_CPP_NAMESPACE__PSVIHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::PSVIHandler *)  ((XERCES_CPP_NAMESPACE::AbstractDOMParser *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__XercesDOMParserTo_p_XERCES_CPP_NAMESPACE__PSVIHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::PSVIHandler *) (XERCES_CPP_NAMESPACE::AbstractDOMParser *) ((XERCES_CPP_NAMESPACE::XercesDOMParser *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__DeclHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DeclHandler *)  ((XERCES_CPP_NAMESPACE::DefaultHandler *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__LexicalHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::LexicalHandler *)  ((XERCES_CPP_NAMESPACE::DefaultHandler *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__ContentHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::ContentHandler *)  ((XERCES_CPP_NAMESPACE::DefaultHandler *) x));
}
static void *_p_PerlContentCallbackHandlerTo_p_XERCES_CPP_NAMESPACE__ContentHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::ContentHandler *)  ((PerlContentCallbackHandler *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__HandlerBaseTo_p_XERCES_CPP_NAMESPACE__ErrorHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::ErrorHandler *)  ((XERCES_CPP_NAMESPACE::HandlerBase *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__ErrorHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::ErrorHandler *)  ((XERCES_CPP_NAMESPACE::DefaultHandler *) x));
}
static void *_p_PerlErrorCallbackHandlerTo_p_XERCES_CPP_NAMESPACE__ErrorHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::ErrorHandler *)  ((PerlErrorCallbackHandler *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__HandlerBaseTo_p_XERCES_CPP_NAMESPACE__DocumentHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DocumentHandler *)  ((XERCES_CPP_NAMESPACE::HandlerBase *) x));
}
static void *_p_PerlDocumentCallbackHandlerTo_p_XERCES_CPP_NAMESPACE__DocumentHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DocumentHandler *)  ((PerlDocumentCallbackHandler *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__HandlerBaseTo_p_XERCES_CPP_NAMESPACE__DTDHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DTDHandler *)  ((XERCES_CPP_NAMESPACE::HandlerBase *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__DTDHandler(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DTDHandler *)  ((XERCES_CPP_NAMESPACE::DefaultHandler *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SAXNotSupportedExceptionTo_p_XERCES_CPP_NAMESPACE__SAXException(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::SAXException *)  ((XERCES_CPP_NAMESPACE::SAXNotSupportedException *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SAXNotRecognizedExceptionTo_p_XERCES_CPP_NAMESPACE__SAXException(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::SAXException *)  ((XERCES_CPP_NAMESPACE::SAXNotRecognizedException *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__SAXParseExceptionTo_p_XERCES_CPP_NAMESPACE__SAXException(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::SAXException *)  ((XERCES_CPP_NAMESPACE::SAXParseException *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMRangeExceptionTo_p_XERCES_CPP_NAMESPACE__DOMException(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMException *)  ((XERCES_CPP_NAMESPACE::DOMRangeException *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DTDEntityDeclTo_p_XERCES_CPP_NAMESPACE__XMLEntityDecl(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::XMLEntityDecl *)  ((XERCES_CPP_NAMESPACE::DTDEntityDecl *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMElementTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *)  ((XERCES_CPP_NAMESPACE::DOMElement *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMDocumentFragmentTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *)  ((XERCES_CPP_NAMESPACE::DOMDocumentFragment *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMAttrTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *)  ((XERCES_CPP_NAMESPACE::DOMAttr *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMDocumentTypeTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *)  ((XERCES_CPP_NAMESPACE::DOMDocumentType *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMCharacterDataTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *)  ((XERCES_CPP_NAMESPACE::DOMCharacterData *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMTextTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *) (XERCES_CPP_NAMESPACE::DOMCharacterData *) ((XERCES_CPP_NAMESPACE::DOMText *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMCommentTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *) (XERCES_CPP_NAMESPACE::DOMCharacterData *) ((XERCES_CPP_NAMESPACE::DOMComment *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMProcessingInstructionTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *)  ((XERCES_CPP_NAMESPACE::DOMProcessingInstruction *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMEntityTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *)  ((XERCES_CPP_NAMESPACE::DOMEntity *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMEntityReferenceTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *)  ((XERCES_CPP_NAMESPACE::DOMEntityReference *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMDocumentTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *)  ((XERCES_CPP_NAMESPACE::DOMDocument *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMCDATASectionTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *) (XERCES_CPP_NAMESPACE::DOMCharacterData *)(XERCES_CPP_NAMESPACE::DOMText *) ((XERCES_CPP_NAMESPACE::DOMCDATASection *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMNotationTo_p_XERCES_CPP_NAMESPACE__DOMNode(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMNode *)  ((XERCES_CPP_NAMESPACE::DOMNotation *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMDocumentTo_p_XERCES_CPP_NAMESPACE__DOMDocumentRange(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMDocumentRange *)  ((XERCES_CPP_NAMESPACE::DOMDocument *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMDocumentTo_p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMDocumentTraversal *)  ((XERCES_CPP_NAMESPACE::DOMDocument *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__HandlerBaseTo_p_XERCES_CPP_NAMESPACE__EntityResolver(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::EntityResolver *)  ((XERCES_CPP_NAMESPACE::HandlerBase *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__EntityResolver(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::EntityResolver *)  ((XERCES_CPP_NAMESPACE::DefaultHandler *) x));
}
static void *_p_PerlEntityResolverHandlerTo_p_XERCES_CPP_NAMESPACE__EntityResolver(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::EntityResolver *)  ((PerlEntityResolverHandler *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMTextTo_p_XERCES_CPP_NAMESPACE__DOMCharacterData(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMCharacterData *)  ((XERCES_CPP_NAMESPACE::DOMText *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMCommentTo_p_XERCES_CPP_NAMESPACE__DOMCharacterData(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMCharacterData *)  ((XERCES_CPP_NAMESPACE::DOMComment *) x));
}
static void *_p_XERCES_CPP_NAMESPACE__DOMCDATASectionTo_p_XERCES_CPP_NAMESPACE__DOMCharacterData(void *x) {
    return (void *)((XERCES_CPP_NAMESPACE::DOMCharacterData *) (XERCES_CPP_NAMESPACE::DOMText *) ((XERCES_CPP_NAMESPACE::DOMCDATASection *) x));
}
static swig_type_info _swigt__p_DatatypeValidatorFactory = {"_p_DatatypeValidatorFactory", "DatatypeValidatorFactory *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_IdentityConstraint = {"_p_IdentityConstraint", "IdentityConstraint *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_PSVIAttributeList = {"_p_PSVIAttributeList", "PSVIAttributeList *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_PSVIDefs__Complexity = {"_p_PSVIDefs__Complexity", "PSVIDefs::Complexity *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_PSVIDefs__PSVIScope = {"_p_PSVIDefs__PSVIScope", "PSVIDefs::PSVIScope *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_PSVIDefs__Validation = {"_p_PSVIDefs__Validation", "PSVIDefs::Validation *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_PSVIDefs__Validity = {"_p_PSVIDefs__Validity", "PSVIDefs::Validity *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_PSVIElement = {"_p_PSVIElement", "PSVIElement *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_PanicHandler = {"_p_PanicHandler", "PanicHandler *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_PanicHandler__PanicReasons = {"_p_PanicHandler__PanicReasons", "PanicHandler::PanicReasons *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_PerlCallbackHandler = {"_p_PerlCallbackHandler", "PerlCallbackHandler *", 0, 0, (void*)"XML::Xerces::PerlCallbackHandler", 0};
static swig_type_info _swigt__p_PerlContentCallbackHandler = {"_p_PerlContentCallbackHandler", "PerlContentCallbackHandler *", 0, 0, (void*)"XML::Xerces::PerlContentCallbackHandler", 0};
static swig_type_info _swigt__p_PerlDocumentCallbackHandler = {"_p_PerlDocumentCallbackHandler", "PerlDocumentCallbackHandler *", 0, 0, (void*)"XML::Xerces::PerlDocumentCallbackHandler", 0};
static swig_type_info _swigt__p_PerlEntityResolverHandler = {"_p_PerlEntityResolverHandler", "PerlEntityResolverHandler *", 0, 0, (void*)"XML::Xerces::PerlEntityResolverHandler", 0};
static swig_type_info _swigt__p_PerlErrorCallbackHandler = {"_p_PerlErrorCallbackHandler", "PerlErrorCallbackHandler *", 0, 0, (void*)"XML::Xerces::PerlErrorCallbackHandler", 0};
static swig_type_info _swigt__p_PerlNodeFilterCallbackHandler = {"_p_PerlNodeFilterCallbackHandler", "PerlNodeFilterCallbackHandler *", 0, 0, (void*)"XML::Xerces::PerlNodeFilterCallbackHandler", 0};
static swig_type_info _swigt__p_RefArrayVectorOfTunsigned_short_t = {"_p_RefArrayVectorOfTunsigned_short_t", "RefArrayVectorOf<unsigned short > *|RefArrayVectorOf<XMLCh > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_RefHash2KeysTableOfTValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t_t = {"_p_RefHash2KeysTableOfTValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t_t", "RefHash2KeysTableOf<ValueVectorOf<XERCES_CPP_NAMESPACE::SchemaElementDecl * > > *|RefHash2KeysTableOf<XERCES_CPP_NAMESPACE::ElemVector > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__ComplexTypeInfo_t = {"_p_RefHashTableOfTXERCES_CPP_NAMESPACE__ComplexTypeInfo_t", "RefHashTableOf<XERCES_CPP_NAMESPACE::ComplexTypeInfo > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XMLAttDef_t = {"_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XMLAttDef_t", "RefHashTableOf<XERCES_CPP_NAMESPACE::XMLAttDef > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XSAnnotation_t = {"_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XSAnnotation_t", "RefHashTableOf<XERCES_CPP_NAMESPACE::XSAnnotation > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesAttGroupInfo_t = {"_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesAttGroupInfo_t", "RefHashTableOf<XERCES_CPP_NAMESPACE::XercesAttGroupInfo > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesGroupInfo_t = {"_p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesGroupInfo_t", "RefHashTableOf<XERCES_CPP_NAMESPACE::XercesGroupInfo > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_RefHashTableOfTXMLRefInfo_t = {"_p_RefHashTableOfTXMLRefInfo_t", "RefHashTableOf<XMLRefInfo > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_SecurityManager = {"_p_SecurityManager", "SecurityManager *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_ValidationContext = {"_p_ValidationContext", "ValidationContext *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_ValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t = {"_p_ValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t", "ValueVectorOf<XERCES_CPP_NAMESPACE::SchemaElementDecl * > *|XERCES_CPP_NAMESPACE::ElemVector *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_ValueVectorOfTunsigned_int_t = {"_p_ValueVectorOfTunsigned_int_t", "ValueVectorOf<unsigned int > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__AbstractDOMParser = {"_p_XERCES_CPP_NAMESPACE__AbstractDOMParser", "XERCES_CPP_NAMESPACE::AbstractDOMParser *", 0, 0, (void*)"XML::Xerces::AbstractDOMParser", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__AttributeList = {"_p_XERCES_CPP_NAMESPACE__AttributeList", "XERCES_CPP_NAMESPACE::AttributeList *", 0, 0, (void*)"XML::Xerces::AttributeList", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__Attributes = {"_p_XERCES_CPP_NAMESPACE__Attributes", "XERCES_CPP_NAMESPACE::Attributes *", 0, 0, (void*)"XML::Xerces::Attributes", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__BinInputStream = {"_p_XERCES_CPP_NAMESPACE__BinInputStream", "XERCES_CPP_NAMESPACE::BinInputStream *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__ComplexTypeInfo = {"_p_XERCES_CPP_NAMESPACE__ComplexTypeInfo", "XERCES_CPP_NAMESPACE::ComplexTypeInfo *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__ContentHandler = {"_p_XERCES_CPP_NAMESPACE__ContentHandler", "XERCES_CPP_NAMESPACE::ContentHandler *", 0, 0, (void*)"XML::Xerces::ContentHandler", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__ContentSpecNode = {"_p_XERCES_CPP_NAMESPACE__ContentSpecNode", "XERCES_CPP_NAMESPACE::ContentSpecNode *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMAttr = {"_p_XERCES_CPP_NAMESPACE__DOMAttr", "XERCES_CPP_NAMESPACE::DOMAttr *", 0, 0, (void*)"XML::Xerces::DOMAttr", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMBuilder = {"_p_XERCES_CPP_NAMESPACE__DOMBuilder", "XERCES_CPP_NAMESPACE::DOMBuilder *", 0, 0, (void*)"XML::Xerces::DOMBuilder", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMBuilderFilter = {"_p_XERCES_CPP_NAMESPACE__DOMBuilderFilter", "XERCES_CPP_NAMESPACE::DOMBuilderFilter *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMCDATASection = {"_p_XERCES_CPP_NAMESPACE__DOMCDATASection", "XERCES_CPP_NAMESPACE::DOMCDATASection *", 0, 0, (void*)"XML::Xerces::DOMCDATASection", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMCharacterData = {"_p_XERCES_CPP_NAMESPACE__DOMCharacterData", "XERCES_CPP_NAMESPACE::DOMCharacterData *", 0, 0, (void*)"XML::Xerces::DOMCharacterData", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMComment = {"_p_XERCES_CPP_NAMESPACE__DOMComment", "XERCES_CPP_NAMESPACE::DOMComment *", 0, 0, (void*)"XML::Xerces::DOMComment", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMConfiguration = {"_p_XERCES_CPP_NAMESPACE__DOMConfiguration", "XERCES_CPP_NAMESPACE::DOMConfiguration *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMDocument = {"_p_XERCES_CPP_NAMESPACE__DOMDocument", "XERCES_CPP_NAMESPACE::DOMDocument *", 0, 0, (void*)"XML::Xerces::DOMDocument", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentFragment = {"_p_XERCES_CPP_NAMESPACE__DOMDocumentFragment", "XERCES_CPP_NAMESPACE::DOMDocumentFragment *", 0, 0, (void*)"XML::Xerces::DOMDocumentFragment", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentRange = {"_p_XERCES_CPP_NAMESPACE__DOMDocumentRange", "XERCES_CPP_NAMESPACE::DOMDocumentRange *", 0, 0, (void*)"XML::Xerces::DOMDocumentRange", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal = {"_p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal", "XERCES_CPP_NAMESPACE::DOMDocumentTraversal *", 0, 0, (void*)"XML::Xerces::DOMDocumentTraversal", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentType = {"_p_XERCES_CPP_NAMESPACE__DOMDocumentType", "XERCES_CPP_NAMESPACE::DOMDocumentType *", 0, 0, (void*)"XML::Xerces::DOMDocumentType", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMElement = {"_p_XERCES_CPP_NAMESPACE__DOMElement", "XERCES_CPP_NAMESPACE::DOMElement *", 0, 0, (void*)"XML::Xerces::DOMElement", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMEntity = {"_p_XERCES_CPP_NAMESPACE__DOMEntity", "XERCES_CPP_NAMESPACE::DOMEntity *", 0, 0, (void*)"XML::Xerces::DOMEntity", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMEntityReference = {"_p_XERCES_CPP_NAMESPACE__DOMEntityReference", "XERCES_CPP_NAMESPACE::DOMEntityReference *", 0, 0, (void*)"XML::Xerces::DOMEntityReference", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMEntityResolver = {"_p_XERCES_CPP_NAMESPACE__DOMEntityResolver", "XERCES_CPP_NAMESPACE::DOMEntityResolver *", 0, 0, (void*)"XML::Xerces::DOMEntityResolver", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMError = {"_p_XERCES_CPP_NAMESPACE__DOMError", "XERCES_CPP_NAMESPACE::DOMError *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMErrorHandler = {"_p_XERCES_CPP_NAMESPACE__DOMErrorHandler", "XERCES_CPP_NAMESPACE::DOMErrorHandler *", 0, 0, (void*)"XML::Xerces::DOMErrorHandler", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMException = {"_p_XERCES_CPP_NAMESPACE__DOMException", "XERCES_CPP_NAMESPACE::DOMException *", 0, 0, (void*)"XML::Xerces::DOMException", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMImplementation = {"_p_XERCES_CPP_NAMESPACE__DOMImplementation", "XERCES_CPP_NAMESPACE::DOMImplementation *", 0, 0, (void*)"XML::Xerces::DOMImplementation", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMImplementationLS = {"_p_XERCES_CPP_NAMESPACE__DOMImplementationLS", "XERCES_CPP_NAMESPACE::DOMImplementationLS *", 0, 0, (void*)"XML::Xerces::DOMImplementationLS", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMImplementationRegistry = {"_p_XERCES_CPP_NAMESPACE__DOMImplementationRegistry", "XERCES_CPP_NAMESPACE::DOMImplementationRegistry *", 0, 0, (void*)"XML::Xerces::DOMImplementationRegistry", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMImplementationSource = {"_p_XERCES_CPP_NAMESPACE__DOMImplementationSource", "XERCES_CPP_NAMESPACE::DOMImplementationSource *", 0, 0, (void*)"XML::Xerces::DOMImplementationSource", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMInputSource = {"_p_XERCES_CPP_NAMESPACE__DOMInputSource", "XERCES_CPP_NAMESPACE::DOMInputSource *", 0, 0, (void*)"XML::Xerces::DOMInputSource", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMLocator = {"_p_XERCES_CPP_NAMESPACE__DOMLocator", "XERCES_CPP_NAMESPACE::DOMLocator *", 0, 0, (void*)"XML::Xerces::DOMLocator", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap = {"_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap", "XERCES_CPP_NAMESPACE::DOMNamedNodeMap *", 0, 0, (void*)"XML::Xerces::DOMNamedNodeMap", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMNode = {"_p_XERCES_CPP_NAMESPACE__DOMNode", "XERCES_CPP_NAMESPACE::DOMNode *", 0, 0, (void*)"XML::Xerces::DOMNode", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMNodeFilter = {"_p_XERCES_CPP_NAMESPACE__DOMNodeFilter", "XERCES_CPP_NAMESPACE::DOMNodeFilter *", 0, 0, (void*)"XML::Xerces::DOMNodeFilter", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMNodeIterator = {"_p_XERCES_CPP_NAMESPACE__DOMNodeIterator", "XERCES_CPP_NAMESPACE::DOMNodeIterator *", 0, 0, (void*)"XML::Xerces::DOMNodeIterator", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMNodeList = {"_p_XERCES_CPP_NAMESPACE__DOMNodeList", "XERCES_CPP_NAMESPACE::DOMNodeList *", 0, 0, (void*)"XML::Xerces::DOMNodeList", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMNotation = {"_p_XERCES_CPP_NAMESPACE__DOMNotation", "XERCES_CPP_NAMESPACE::DOMNotation *", 0, 0, (void*)"XML::Xerces::DOMNotation", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction = {"_p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction", "XERCES_CPP_NAMESPACE::DOMProcessingInstruction *", 0, 0, (void*)"XML::Xerces::DOMProcessingInstruction", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMRange = {"_p_XERCES_CPP_NAMESPACE__DOMRange", "XERCES_CPP_NAMESPACE::DOMRange *", 0, 0, (void*)"XML::Xerces::DOMRange", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMRangeException = {"_p_XERCES_CPP_NAMESPACE__DOMRangeException", "XERCES_CPP_NAMESPACE::DOMRangeException *", 0, 0, (void*)"XML::Xerces::DOMRangeException", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMText = {"_p_XERCES_CPP_NAMESPACE__DOMText", "XERCES_CPP_NAMESPACE::DOMText *", 0, 0, (void*)"XML::Xerces::DOMText", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMTreeWalker = {"_p_XERCES_CPP_NAMESPACE__DOMTreeWalker", "XERCES_CPP_NAMESPACE::DOMTreeWalker *", 0, 0, (void*)"XML::Xerces::DOMTreeWalker", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMTypeInfo = {"_p_XERCES_CPP_NAMESPACE__DOMTypeInfo", "XERCES_CPP_NAMESPACE::DOMTypeInfo *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMUserDataHandler = {"_p_XERCES_CPP_NAMESPACE__DOMUserDataHandler", "XERCES_CPP_NAMESPACE::DOMUserDataHandler *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMWriter = {"_p_XERCES_CPP_NAMESPACE__DOMWriter", "XERCES_CPP_NAMESPACE::DOMWriter *", 0, 0, (void*)"XML::Xerces::DOMWriter", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DOMWriterFilter = {"_p_XERCES_CPP_NAMESPACE__DOMWriterFilter", "XERCES_CPP_NAMESPACE::DOMWriterFilter *", 0, 0, (void*)"XML::Xerces::DOMWriterFilter", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DTDAttDef = {"_p_XERCES_CPP_NAMESPACE__DTDAttDef", "XERCES_CPP_NAMESPACE::DTDAttDef *", 0, 0, (void*)"XML::Xerces::DTDAttDef", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DTDAttDefList = {"_p_XERCES_CPP_NAMESPACE__DTDAttDefList", "XERCES_CPP_NAMESPACE::DTDAttDefList *", 0, 0, (void*)"XML::Xerces::DTDAttDefList", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DTDElementDecl = {"_p_XERCES_CPP_NAMESPACE__DTDElementDecl", "XERCES_CPP_NAMESPACE::DTDElementDecl *", 0, 0, (void*)"XML::Xerces::DTDElementDecl", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DTDEntityDecl = {"_p_XERCES_CPP_NAMESPACE__DTDEntityDecl", "XERCES_CPP_NAMESPACE::DTDEntityDecl *", 0, 0, (void*)"XML::Xerces::DTDEntityDecl", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DTDGrammar = {"_p_XERCES_CPP_NAMESPACE__DTDGrammar", "XERCES_CPP_NAMESPACE::DTDGrammar *", 0, 0, (void*)"XML::Xerces::DTDGrammar", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DTDHandler = {"_p_XERCES_CPP_NAMESPACE__DTDHandler", "XERCES_CPP_NAMESPACE::DTDHandler *", 0, 0, (void*)"XML::Xerces::DTDHandler", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DTDValidator = {"_p_XERCES_CPP_NAMESPACE__DTDValidator", "XERCES_CPP_NAMESPACE::DTDValidator *", 0, 0, (void*)"XML::Xerces::DTDValidator", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DatatypeValidator = {"_p_XERCES_CPP_NAMESPACE__DatatypeValidator", "XERCES_CPP_NAMESPACE::DatatypeValidator *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DeclHandler = {"_p_XERCES_CPP_NAMESPACE__DeclHandler", "XERCES_CPP_NAMESPACE::DeclHandler *", 0, 0, (void*)"XML::Xerces::DeclHandler", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DefaultHandler = {"_p_XERCES_CPP_NAMESPACE__DefaultHandler", "XERCES_CPP_NAMESPACE::DefaultHandler *", 0, 0, (void*)"XML::Xerces::DefaultHandler", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__DocumentHandler = {"_p_XERCES_CPP_NAMESPACE__DocumentHandler", "XERCES_CPP_NAMESPACE::DocumentHandler *", 0, 0, (void*)"XML::Xerces::DocumentHandler", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__EntityResolver = {"_p_XERCES_CPP_NAMESPACE__EntityResolver", "XERCES_CPP_NAMESPACE::EntityResolver *", 0, 0, (void*)"XML::Xerces::EntityResolver", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__ErrorHandler = {"_p_XERCES_CPP_NAMESPACE__ErrorHandler", "XERCES_CPP_NAMESPACE::ErrorHandler *", 0, 0, (void*)"XML::Xerces::ErrorHandler", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__Grammar = {"_p_XERCES_CPP_NAMESPACE__Grammar", "XERCES_CPP_NAMESPACE::Grammar *", 0, 0, (void*)"XML::Xerces::Grammar", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__GrammarResolver = {"_p_XERCES_CPP_NAMESPACE__GrammarResolver", "XERCES_CPP_NAMESPACE::GrammarResolver *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__HandlerBase = {"_p_XERCES_CPP_NAMESPACE__HandlerBase", "XERCES_CPP_NAMESPACE::HandlerBase *", 0, 0, (void*)"XML::Xerces::HandlerBase", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__InputSource = {"_p_XERCES_CPP_NAMESPACE__InputSource", "XERCES_CPP_NAMESPACE::InputSource *", 0, 0, (void*)"XML::Xerces::InputSource", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__LexicalHandler = {"_p_XERCES_CPP_NAMESPACE__LexicalHandler", "XERCES_CPP_NAMESPACE::LexicalHandler *", 0, 0, (void*)"XML::Xerces::LexicalHandler", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget = {"_p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget", "XERCES_CPP_NAMESPACE::LocalFileFormatTarget *", 0, 0, (void*)"XML::Xerces::LocalFileFormatTarget", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__LocalFileInputSource = {"_p_XERCES_CPP_NAMESPACE__LocalFileInputSource", "XERCES_CPP_NAMESPACE::LocalFileInputSource *", 0, 0, (void*)"XML::Xerces::LocalFileInputSource", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__Locator = {"_p_XERCES_CPP_NAMESPACE__Locator", "XERCES_CPP_NAMESPACE::Locator *", 0, 0, (void*)"XML::Xerces::Locator", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__MemBufFormatTarget = {"_p_XERCES_CPP_NAMESPACE__MemBufFormatTarget", "XERCES_CPP_NAMESPACE::MemBufFormatTarget *", 0, 0, (void*)"XML::Xerces::MemBufFormatTarget", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__MemBufInputSource = {"_p_XERCES_CPP_NAMESPACE__MemBufInputSource", "XERCES_CPP_NAMESPACE::MemBufInputSource *", 0, 0, (void*)"XML::Xerces::MemBufInputSource", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__MemoryManager = {"_p_XERCES_CPP_NAMESPACE__MemoryManager", "XERCES_CPP_NAMESPACE::MemoryManager *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t = {"_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t", "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *", 0, 0, (void*)"XML::Xerces::DTDElementDeclEnumerator", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t = {"_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t", "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *", 0, 0, (void*)"XML::Xerces::DTDEntityDeclEnumerator", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__XMLNotationDecl_t = {"_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__XMLNotationDecl_t", "XERCES_CPP_NAMESPACE::NameIdPoolEnumerator<XERCES_CPP_NAMESPACE::XMLNotationDecl > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t = {"_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t", "XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDElementDecl > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t = {"_p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t", "XERCES_CPP_NAMESPACE::NameIdPool<XERCES_CPP_NAMESPACE::DTDEntityDecl > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__NamespaceScope = {"_p_XERCES_CPP_NAMESPACE__NamespaceScope", "XERCES_CPP_NAMESPACE::NamespaceScope *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__PSVIHandler = {"_p_XERCES_CPP_NAMESPACE__PSVIHandler", "XERCES_CPP_NAMESPACE::PSVIHandler *", 0, 0, (void*)"XML::Xerces::PSVIHandler", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__Parser = {"_p_XERCES_CPP_NAMESPACE__Parser", "XERCES_CPP_NAMESPACE::Parser *", 0, 0, (void*)"XML::Xerces::Parser", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__QName = {"_p_XERCES_CPP_NAMESPACE__QName", "XERCES_CPP_NAMESPACE::QName *", 0, 0, (void*)"XML::Xerces::QName", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t = {"_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t", "XERCES_CPP_NAMESPACE::RefHash3KeysIdPoolEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *", 0, 0, (void*)"XML::Xerces::SchemaElementDeclEnumerator", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t = {"_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t", "XERCES_CPP_NAMESPACE::RefHash3KeysIdPool<XERCES_CPP_NAMESPACE::SchemaElementDecl > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__SAX2XMLReader = {"_p_XERCES_CPP_NAMESPACE__SAX2XMLReader", "XERCES_CPP_NAMESPACE::SAX2XMLReader *", 0, 0, (void*)"XML::Xerces::SAX2XMLReader", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__SAXException = {"_p_XERCES_CPP_NAMESPACE__SAXException", "XERCES_CPP_NAMESPACE::SAXException *", 0, 0, (void*)"XML::Xerces::SAXException", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException = {"_p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException", "XERCES_CPP_NAMESPACE::SAXNotRecognizedException *", 0, 0, (void*)"XML::Xerces::SAXNotRecognizedException", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__SAXNotSupportedException = {"_p_XERCES_CPP_NAMESPACE__SAXNotSupportedException", "XERCES_CPP_NAMESPACE::SAXNotSupportedException *", 0, 0, (void*)"XML::Xerces::SAXNotSupportedException", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__SAXParseException = {"_p_XERCES_CPP_NAMESPACE__SAXParseException", "XERCES_CPP_NAMESPACE::SAXParseException *", 0, 0, (void*)"XML::Xerces::SAXParseException", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__SAXParser = {"_p_XERCES_CPP_NAMESPACE__SAXParser", "XERCES_CPP_NAMESPACE::SAXParser *", 0, 0, (void*)"XML::Xerces::SAXParser", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__SchemaAttDef = {"_p_XERCES_CPP_NAMESPACE__SchemaAttDef", "XERCES_CPP_NAMESPACE::SchemaAttDef *", 0, 0, (void*)"XML::Xerces::SchemaAttDef", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__SchemaAttDefList = {"_p_XERCES_CPP_NAMESPACE__SchemaAttDefList", "XERCES_CPP_NAMESPACE::SchemaAttDefList *", 0, 0, (void*)"XML::Xerces::SchemaAttDefList", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__SchemaElementDecl = {"_p_XERCES_CPP_NAMESPACE__SchemaElementDecl", "XERCES_CPP_NAMESPACE::SchemaElementDecl *", 0, 0, (void*)"XML::Xerces::SchemaElementDecl", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__SchemaGrammar = {"_p_XERCES_CPP_NAMESPACE__SchemaGrammar", "XERCES_CPP_NAMESPACE::SchemaGrammar *", 0, 0, (void*)"XML::Xerces::SchemaGrammar", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__SchemaValidator = {"_p_XERCES_CPP_NAMESPACE__SchemaValidator", "XERCES_CPP_NAMESPACE::SchemaValidator *", 0, 0, (void*)"XML::Xerces::SchemaValidator", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__StdInInputSource = {"_p_XERCES_CPP_NAMESPACE__StdInInputSource", "XERCES_CPP_NAMESPACE::StdInInputSource *", 0, 0, (void*)"XML::Xerces::StdInInputSource", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__StdOutFormatTarget = {"_p_XERCES_CPP_NAMESPACE__StdOutFormatTarget", "XERCES_CPP_NAMESPACE::StdOutFormatTarget *", 0, 0, (void*)"XML::Xerces::StdOutFormatTarget", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__URLInputSource = {"_p_XERCES_CPP_NAMESPACE__URLInputSource", "XERCES_CPP_NAMESPACE::URLInputSource *", 0, 0, (void*)"XML::Xerces::URLInputSource", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource = {"_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource", "XERCES_CPP_NAMESPACE::Wrapper4DOMInputSource *", 0, 0, (void*)"XML::Xerces::Wrapper4DOMInputSource", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__Wrapper4InputSource = {"_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource", "XERCES_CPP_NAMESPACE::Wrapper4InputSource *", 0, 0, (void*)"XML::Xerces::Wrapper4InputSource", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLAttDef = {"_p_XERCES_CPP_NAMESPACE__XMLAttDef", "XERCES_CPP_NAMESPACE::XMLAttDef *", 0, 0, (void*)"XML::Xerces::XMLAttDef", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLAttDefList = {"_p_XERCES_CPP_NAMESPACE__XMLAttDefList", "XERCES_CPP_NAMESPACE::XMLAttDefList *", 0, 0, (void*)"XML::Xerces::XMLAttDefList", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLContentModel = {"_p_XERCES_CPP_NAMESPACE__XMLContentModel", "XERCES_CPP_NAMESPACE::XMLContentModel *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLDTDDescription = {"_p_XERCES_CPP_NAMESPACE__XMLDTDDescription", "XERCES_CPP_NAMESPACE::XMLDTDDescription *", 0, 0, (void*)"XML::Xerces::XMLDTDDescription", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLDeleter = {"_p_XERCES_CPP_NAMESPACE__XMLDeleter", "XERCES_CPP_NAMESPACE::XMLDeleter *", 0, 0, (void*)"XML::Xerces::XMLDeleter", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLDocumentHandler = {"_p_XERCES_CPP_NAMESPACE__XMLDocumentHandler", "XERCES_CPP_NAMESPACE::XMLDocumentHandler *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLElementDecl = {"_p_XERCES_CPP_NAMESPACE__XMLElementDecl", "XERCES_CPP_NAMESPACE::XMLElementDecl *", 0, 0, (void*)"XML::Xerces::XMLElementDecl", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLEntityDecl = {"_p_XERCES_CPP_NAMESPACE__XMLEntityDecl", "XERCES_CPP_NAMESPACE::XMLEntityDecl *", 0, 0, (void*)"XML::Xerces::XMLEntityDecl", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLEntityResolver = {"_p_XERCES_CPP_NAMESPACE__XMLEntityResolver", "XERCES_CPP_NAMESPACE::XMLEntityResolver *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t = {"_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t", "XERCES_CPP_NAMESPACE::XMLEnumerator<XERCES_CPP_NAMESPACE::DTDElementDecl > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t = {"_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t", "XERCES_CPP_NAMESPACE::XMLEnumerator<XERCES_CPP_NAMESPACE::DTDEntityDecl > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t = {"_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t", "XERCES_CPP_NAMESPACE::XMLEnumerator<XERCES_CPP_NAMESPACE::SchemaElementDecl > *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLException = {"_p_XERCES_CPP_NAMESPACE__XMLException", "XERCES_CPP_NAMESPACE::XMLException *", 0, 0, (void*)"XML::Xerces::XMLException", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLExcepts = {"_p_XERCES_CPP_NAMESPACE__XMLExcepts", "XERCES_CPP_NAMESPACE::XMLExcepts *", 0, 0, (void*)"XML::Xerces::XMLExcepts", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLFormatTarget = {"_p_XERCES_CPP_NAMESPACE__XMLFormatTarget", "XERCES_CPP_NAMESPACE::XMLFormatTarget *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLFormatter = {"_p_XERCES_CPP_NAMESPACE__XMLFormatter", "XERCES_CPP_NAMESPACE::XMLFormatter *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLGrammarDescription = {"_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription", "XERCES_CPP_NAMESPACE::XMLGrammarDescription *", 0, 0, (void*)"XML::Xerces::XMLGrammarDescription", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLGrammarPool = {"_p_XERCES_CPP_NAMESPACE__XMLGrammarPool", "XERCES_CPP_NAMESPACE::XMLGrammarPool *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLNotationDecl = {"_p_XERCES_CPP_NAMESPACE__XMLNotationDecl", "XERCES_CPP_NAMESPACE::XMLNotationDecl *", 0, 0, (void*)"XML::Xerces::XMLNotationDecl", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLPScanToken = {"_p_XERCES_CPP_NAMESPACE__XMLPScanToken", "XERCES_CPP_NAMESPACE::XMLPScanToken *", 0, 0, (void*)"XML::Xerces::XMLPScanToken", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLPlatformUtils = {"_p_XERCES_CPP_NAMESPACE__XMLPlatformUtils", "XERCES_CPP_NAMESPACE::XMLPlatformUtils *", 0, 0, (void*)"XML::Xerces::XMLPlatformUtils", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLReaderFactory = {"_p_XERCES_CPP_NAMESPACE__XMLReaderFactory", "XERCES_CPP_NAMESPACE::XMLReaderFactory *", 0, 0, (void*)"XML::Xerces::XMLReaderFactory", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLSchemaDescription = {"_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription", "XERCES_CPP_NAMESPACE::XMLSchemaDescription *", 0, 0, (void*)"XML::Xerces::XMLSchemaDescription", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLURL = {"_p_XERCES_CPP_NAMESPACE__XMLURL", "XERCES_CPP_NAMESPACE::XMLURL *", 0, 0, (void*)"XML::Xerces::XMLURL", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLUni = {"_p_XERCES_CPP_NAMESPACE__XMLUni", "XERCES_CPP_NAMESPACE::XMLUni *", 0, 0, (void*)"XML::Xerces::XMLUni", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLUri = {"_p_XERCES_CPP_NAMESPACE__XMLUri", "XERCES_CPP_NAMESPACE::XMLUri *", 0, 0, (void*)"XML::Xerces::XMLUri", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMLValidator = {"_p_XERCES_CPP_NAMESPACE__XMLValidator", "XERCES_CPP_NAMESPACE::XMLValidator *", 0, 0, (void*)"XML::Xerces::XMLValidator", 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XMemory = {"_p_XERCES_CPP_NAMESPACE__XMemory", "XERCES_CPP_NAMESPACE::XMemory *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XSAnnotation = {"_p_XERCES_CPP_NAMESPACE__XSAnnotation", "XERCES_CPP_NAMESPACE::XSAnnotation *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XERCES_CPP_NAMESPACE__XercesDOMParser = {"_p_XERCES_CPP_NAMESPACE__XercesDOMParser", "XERCES_CPP_NAMESPACE::XercesDOMParser *", 0, 0, (void*)"XML::Xerces::XercesDOMParser", 0};
static swig_type_info _swigt__p_XMLBuffer = {"_p_XMLBuffer", "XMLBuffer *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XMLErrorReporter = {"_p_XMLErrorReporter", "XMLErrorReporter *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XMLErrorReporter__ErrTypes = {"_p_XMLErrorReporter__ErrTypes", "XMLErrorReporter::ErrTypes *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_XSerializeEngine = {"_p_XSerializeEngine", "XSerializeEngine *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_a_32__unsigned_short = {"_p_a_32__unsigned_short", "unsigned short (*)[32]|XMLCh (*)[32]", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_bool = {"_p_bool", "bool *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_char = {"_p_char", "char *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_int = {"_p_int", "int *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_long = {"_p_long", "long *|XMLSSize_t *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_p_void = {"_p_p_void", "void **", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_unsigned_char = {"_p_unsigned_char", "unsigned char *|XMLByte *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_unsigned_int = {"_p_unsigned_int", "unsigned int *|UCS4Ch *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_unsigned_long = {"_p_unsigned_long", "unsigned long *|XMLSize_t *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_unsigned_short = {"_p_unsigned_short", "unsigned short *|UTF16Ch *", 0, 0, (void*)0, 0};
static swig_type_info _swigt__p_void = {"_p_void", "void *", 0, 0, (void*)0, 0};

static swig_type_info *swig_type_initial[] = {
  &_swigt__p_DatatypeValidatorFactory,
  &_swigt__p_IdentityConstraint,
  &_swigt__p_PSVIAttributeList,
  &_swigt__p_PSVIDefs__Complexity,
  &_swigt__p_PSVIDefs__PSVIScope,
  &_swigt__p_PSVIDefs__Validation,
  &_swigt__p_PSVIDefs__Validity,
  &_swigt__p_PSVIElement,
  &_swigt__p_PanicHandler,
  &_swigt__p_PanicHandler__PanicReasons,
  &_swigt__p_PerlCallbackHandler,
  &_swigt__p_PerlContentCallbackHandler,
  &_swigt__p_PerlDocumentCallbackHandler,
  &_swigt__p_PerlEntityResolverHandler,
  &_swigt__p_PerlErrorCallbackHandler,
  &_swigt__p_PerlNodeFilterCallbackHandler,
  &_swigt__p_RefArrayVectorOfTunsigned_short_t,
  &_swigt__p_RefHash2KeysTableOfTValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t_t,
  &_swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__ComplexTypeInfo_t,
  &_swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XMLAttDef_t,
  &_swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XSAnnotation_t,
  &_swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesAttGroupInfo_t,
  &_swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesGroupInfo_t,
  &_swigt__p_RefHashTableOfTXMLRefInfo_t,
  &_swigt__p_SecurityManager,
  &_swigt__p_ValidationContext,
  &_swigt__p_ValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t,
  &_swigt__p_ValueVectorOfTunsigned_int_t,
  &_swigt__p_XERCES_CPP_NAMESPACE__AbstractDOMParser,
  &_swigt__p_XERCES_CPP_NAMESPACE__AttributeList,
  &_swigt__p_XERCES_CPP_NAMESPACE__Attributes,
  &_swigt__p_XERCES_CPP_NAMESPACE__BinInputStream,
  &_swigt__p_XERCES_CPP_NAMESPACE__ComplexTypeInfo,
  &_swigt__p_XERCES_CPP_NAMESPACE__ContentHandler,
  &_swigt__p_XERCES_CPP_NAMESPACE__ContentSpecNode,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMAttr,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMBuilder,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMBuilderFilter,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMCDATASection,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMCharacterData,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMComment,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMConfiguration,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMDocument,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentFragment,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentRange,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentType,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMElement,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMEntity,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMEntityReference,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMEntityResolver,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMError,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMErrorHandler,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMException,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMImplementation,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMImplementationLS,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMImplementationRegistry,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMImplementationSource,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMInputSource,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMLocator,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMNode,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMNodeFilter,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMNodeIterator,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMNodeList,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMNotation,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMRange,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMRangeException,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMText,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMTreeWalker,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMTypeInfo,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMUserDataHandler,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMWriter,
  &_swigt__p_XERCES_CPP_NAMESPACE__DOMWriterFilter,
  &_swigt__p_XERCES_CPP_NAMESPACE__DTDAttDef,
  &_swigt__p_XERCES_CPP_NAMESPACE__DTDAttDefList,
  &_swigt__p_XERCES_CPP_NAMESPACE__DTDElementDecl,
  &_swigt__p_XERCES_CPP_NAMESPACE__DTDEntityDecl,
  &_swigt__p_XERCES_CPP_NAMESPACE__DTDGrammar,
  &_swigt__p_XERCES_CPP_NAMESPACE__DTDHandler,
  &_swigt__p_XERCES_CPP_NAMESPACE__DTDValidator,
  &_swigt__p_XERCES_CPP_NAMESPACE__DatatypeValidator,
  &_swigt__p_XERCES_CPP_NAMESPACE__DeclHandler,
  &_swigt__p_XERCES_CPP_NAMESPACE__DefaultHandler,
  &_swigt__p_XERCES_CPP_NAMESPACE__DocumentHandler,
  &_swigt__p_XERCES_CPP_NAMESPACE__EntityResolver,
  &_swigt__p_XERCES_CPP_NAMESPACE__ErrorHandler,
  &_swigt__p_XERCES_CPP_NAMESPACE__Grammar,
  &_swigt__p_XERCES_CPP_NAMESPACE__GrammarResolver,
  &_swigt__p_XERCES_CPP_NAMESPACE__HandlerBase,
  &_swigt__p_XERCES_CPP_NAMESPACE__InputSource,
  &_swigt__p_XERCES_CPP_NAMESPACE__LexicalHandler,
  &_swigt__p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget,
  &_swigt__p_XERCES_CPP_NAMESPACE__LocalFileInputSource,
  &_swigt__p_XERCES_CPP_NAMESPACE__Locator,
  &_swigt__p_XERCES_CPP_NAMESPACE__MemBufFormatTarget,
  &_swigt__p_XERCES_CPP_NAMESPACE__MemBufInputSource,
  &_swigt__p_XERCES_CPP_NAMESPACE__MemoryManager,
  &_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t,
  &_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t,
  &_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__XMLNotationDecl_t,
  &_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t,
  &_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t,
  &_swigt__p_XERCES_CPP_NAMESPACE__NamespaceScope,
  &_swigt__p_XERCES_CPP_NAMESPACE__PSVIHandler,
  &_swigt__p_XERCES_CPP_NAMESPACE__Parser,
  &_swigt__p_XERCES_CPP_NAMESPACE__QName,
  &_swigt__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t,
  &_swigt__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t,
  &_swigt__p_XERCES_CPP_NAMESPACE__SAX2XMLReader,
  &_swigt__p_XERCES_CPP_NAMESPACE__SAXException,
  &_swigt__p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException,
  &_swigt__p_XERCES_CPP_NAMESPACE__SAXNotSupportedException,
  &_swigt__p_XERCES_CPP_NAMESPACE__SAXParseException,
  &_swigt__p_XERCES_CPP_NAMESPACE__SAXParser,
  &_swigt__p_XERCES_CPP_NAMESPACE__SchemaAttDef,
  &_swigt__p_XERCES_CPP_NAMESPACE__SchemaAttDefList,
  &_swigt__p_XERCES_CPP_NAMESPACE__SchemaElementDecl,
  &_swigt__p_XERCES_CPP_NAMESPACE__SchemaGrammar,
  &_swigt__p_XERCES_CPP_NAMESPACE__SchemaValidator,
  &_swigt__p_XERCES_CPP_NAMESPACE__StdInInputSource,
  &_swigt__p_XERCES_CPP_NAMESPACE__StdOutFormatTarget,
  &_swigt__p_XERCES_CPP_NAMESPACE__URLInputSource,
  &_swigt__p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource,
  &_swigt__p_XERCES_CPP_NAMESPACE__Wrapper4InputSource,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLAttDef,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLAttDefList,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLContentModel,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLDTDDescription,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLDeleter,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLDocumentHandler,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLElementDecl,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLEntityDecl,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLEntityResolver,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLException,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLExcepts,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLFormatTarget,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLFormatter,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLGrammarDescription,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLGrammarPool,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLNotationDecl,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLPScanToken,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLPlatformUtils,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLReaderFactory,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLSchemaDescription,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLURL,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLUni,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLUri,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMLValidator,
  &_swigt__p_XERCES_CPP_NAMESPACE__XMemory,
  &_swigt__p_XERCES_CPP_NAMESPACE__XSAnnotation,
  &_swigt__p_XERCES_CPP_NAMESPACE__XercesDOMParser,
  &_swigt__p_XMLBuffer,
  &_swigt__p_XMLErrorReporter,
  &_swigt__p_XMLErrorReporter__ErrTypes,
  &_swigt__p_XSerializeEngine,
  &_swigt__p_a_32__unsigned_short,
  &_swigt__p_bool,
  &_swigt__p_char,
  &_swigt__p_int,
  &_swigt__p_long,
  &_swigt__p_p_void,
  &_swigt__p_unsigned_char,
  &_swigt__p_unsigned_int,
  &_swigt__p_unsigned_long,
  &_swigt__p_unsigned_short,
  &_swigt__p_void,
};

static swig_cast_info _swigc__p_DatatypeValidatorFactory[] = {  {&_swigt__p_DatatypeValidatorFactory, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_IdentityConstraint[] = {  {&_swigt__p_IdentityConstraint, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PSVIAttributeList[] = {  {&_swigt__p_PSVIAttributeList, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PSVIDefs__Complexity[] = {  {&_swigt__p_PSVIDefs__Complexity, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PSVIDefs__PSVIScope[] = {  {&_swigt__p_PSVIDefs__PSVIScope, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PSVIDefs__Validation[] = {  {&_swigt__p_PSVIDefs__Validation, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PSVIDefs__Validity[] = {  {&_swigt__p_PSVIDefs__Validity, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PSVIElement[] = {  {&_swigt__p_PSVIElement, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PanicHandler[] = {  {&_swigt__p_PanicHandler, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PanicHandler__PanicReasons[] = {  {&_swigt__p_PanicHandler__PanicReasons, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PerlCallbackHandler[] = {  {&_swigt__p_PerlCallbackHandler, 0, 0, 0},  {&_swigt__p_PerlErrorCallbackHandler, _p_PerlErrorCallbackHandlerTo_p_PerlCallbackHandler, 0, 0},  {&_swigt__p_PerlEntityResolverHandler, _p_PerlEntityResolverHandlerTo_p_PerlCallbackHandler, 0, 0},  {&_swigt__p_PerlNodeFilterCallbackHandler, _p_PerlNodeFilterCallbackHandlerTo_p_PerlCallbackHandler, 0, 0},  {&_swigt__p_PerlDocumentCallbackHandler, _p_PerlDocumentCallbackHandlerTo_p_PerlCallbackHandler, 0, 0},  {&_swigt__p_PerlContentCallbackHandler, _p_PerlContentCallbackHandlerTo_p_PerlCallbackHandler, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PerlContentCallbackHandler[] = {  {&_swigt__p_PerlContentCallbackHandler, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PerlDocumentCallbackHandler[] = {  {&_swigt__p_PerlDocumentCallbackHandler, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PerlEntityResolverHandler[] = {  {&_swigt__p_PerlEntityResolverHandler, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PerlErrorCallbackHandler[] = {  {&_swigt__p_PerlErrorCallbackHandler, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_PerlNodeFilterCallbackHandler[] = {  {&_swigt__p_PerlNodeFilterCallbackHandler, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_RefArrayVectorOfTunsigned_short_t[] = {  {&_swigt__p_RefArrayVectorOfTunsigned_short_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_RefHash2KeysTableOfTValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t_t[] = {  {&_swigt__p_RefHash2KeysTableOfTValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_RefHashTableOfTXERCES_CPP_NAMESPACE__ComplexTypeInfo_t[] = {  {&_swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__ComplexTypeInfo_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XMLAttDef_t[] = {  {&_swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XMLAttDef_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XSAnnotation_t[] = {  {&_swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XSAnnotation_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesAttGroupInfo_t[] = {  {&_swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesAttGroupInfo_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesGroupInfo_t[] = {  {&_swigt__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesGroupInfo_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_RefHashTableOfTXMLRefInfo_t[] = {  {&_swigt__p_RefHashTableOfTXMLRefInfo_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_SecurityManager[] = {  {&_swigt__p_SecurityManager, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_ValidationContext[] = {  {&_swigt__p_ValidationContext, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_ValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t[] = {  {&_swigt__p_ValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_ValueVectorOfTunsigned_int_t[] = {  {&_swigt__p_ValueVectorOfTunsigned_int_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__AbstractDOMParser[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XercesDOMParser, _p_XERCES_CPP_NAMESPACE__XercesDOMParserTo_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__AttributeList[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__AttributeList, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__Attributes[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__Attributes, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__BinInputStream[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__BinInputStream, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__ComplexTypeInfo[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__ComplexTypeInfo, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__ContentHandler[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__ContentHandler, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DefaultHandler, _p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__ContentHandler, 0, 0},  {&_swigt__p_PerlContentCallbackHandler, _p_PerlContentCallbackHandlerTo_p_XERCES_CPP_NAMESPACE__ContentHandler, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__ContentSpecNode[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__ContentSpecNode, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMAttr[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMAttr, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMBuilder[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMBuilder, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMBuilderFilter[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMBuilderFilter, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMCDATASection[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMCDATASection, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMCharacterData[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMText, _p_XERCES_CPP_NAMESPACE__DOMTextTo_p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMComment, _p_XERCES_CPP_NAMESPACE__DOMCommentTo_p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMCDATASection, _p_XERCES_CPP_NAMESPACE__DOMCDATASectionTo_p_XERCES_CPP_NAMESPACE__DOMCharacterData, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMComment[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMComment, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMConfiguration[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMConfiguration, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMDocument[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMDocument, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMDocumentFragment[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentFragment, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMDocumentRange[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentRange, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMDocument, _p_XERCES_CPP_NAMESPACE__DOMDocumentTo_p_XERCES_CPP_NAMESPACE__DOMDocumentRange, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMDocument, _p_XERCES_CPP_NAMESPACE__DOMDocumentTo_p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMDocumentType[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentType, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMElement[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMElement, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMEntity[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMEntity, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMEntityReference[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMEntityReference, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMEntityResolver[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMEntityResolver, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMError[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMError, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMErrorHandler[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMErrorHandler, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMException[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMException, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMRangeException, _p_XERCES_CPP_NAMESPACE__DOMRangeExceptionTo_p_XERCES_CPP_NAMESPACE__DOMException, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMImplementation[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMImplementation, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMImplementationLS[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMImplementation, _p_XERCES_CPP_NAMESPACE__DOMImplementationTo_p_XERCES_CPP_NAMESPACE__DOMImplementationLS, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMImplementationLS, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMImplementationRegistry[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMImplementationRegistry, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMImplementationSource[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMImplementationSource, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMInputSource[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMInputSource, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, _p_XERCES_CPP_NAMESPACE__Wrapper4InputSourceTo_p_XERCES_CPP_NAMESPACE__DOMInputSource, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMLocator[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMLocator, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMNode[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMAttr, _p_XERCES_CPP_NAMESPACE__DOMAttrTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMNotation, _p_XERCES_CPP_NAMESPACE__DOMNotationTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMText, _p_XERCES_CPP_NAMESPACE__DOMTextTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentFragment, _p_XERCES_CPP_NAMESPACE__DOMDocumentFragmentTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMCDATASection, _p_XERCES_CPP_NAMESPACE__DOMCDATASectionTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMEntityReference, _p_XERCES_CPP_NAMESPACE__DOMEntityReferenceTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMEntity, _p_XERCES_CPP_NAMESPACE__DOMEntityTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMDocumentType, _p_XERCES_CPP_NAMESPACE__DOMDocumentTypeTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMCharacterData, _p_XERCES_CPP_NAMESPACE__DOMCharacterDataTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMComment, _p_XERCES_CPP_NAMESPACE__DOMCommentTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMDocument, _p_XERCES_CPP_NAMESPACE__DOMDocumentTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMElement, _p_XERCES_CPP_NAMESPACE__DOMElementTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction, _p_XERCES_CPP_NAMESPACE__DOMProcessingInstructionTo_p_XERCES_CPP_NAMESPACE__DOMNode, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMNodeFilter[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMWriterFilter, _p_XERCES_CPP_NAMESPACE__DOMWriterFilterTo_p_XERCES_CPP_NAMESPACE__DOMNodeFilter, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMNodeFilter, 0, 0, 0},  {&_swigt__p_PerlNodeFilterCallbackHandler, _p_PerlNodeFilterCallbackHandlerTo_p_XERCES_CPP_NAMESPACE__DOMNodeFilter, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMNodeIterator[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMNodeIterator, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMNodeList[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMNodeList, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMNotation[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMNotation, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMRange[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMRange, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMRangeException[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMRangeException, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMText[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMText, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMCDATASection, _p_XERCES_CPP_NAMESPACE__DOMCDATASectionTo_p_XERCES_CPP_NAMESPACE__DOMText, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMTreeWalker[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMTreeWalker, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMTypeInfo[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMTypeInfo, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMUserDataHandler[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMUserDataHandler, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMWriter[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMWriter, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DOMWriterFilter[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DOMWriterFilter, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DTDAttDef[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDAttDef, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DTDAttDefList[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDAttDefList, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DTDElementDecl[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDElementDecl, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DTDEntityDecl[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDEntityDecl, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DTDGrammar[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDGrammar, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DTDHandler[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__HandlerBase, _p_XERCES_CPP_NAMESPACE__HandlerBaseTo_p_XERCES_CPP_NAMESPACE__DTDHandler, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDHandler, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DefaultHandler, _p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__DTDHandler, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DTDValidator[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDValidator, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DatatypeValidator[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DatatypeValidator, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DeclHandler[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DeclHandler, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DefaultHandler, _p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__DeclHandler, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DefaultHandler[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__DefaultHandler, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__DocumentHandler[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__HandlerBase, _p_XERCES_CPP_NAMESPACE__HandlerBaseTo_p_XERCES_CPP_NAMESPACE__DocumentHandler, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DocumentHandler, 0, 0, 0},  {&_swigt__p_PerlDocumentCallbackHandler, _p_PerlDocumentCallbackHandlerTo_p_XERCES_CPP_NAMESPACE__DocumentHandler, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__EntityResolver[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__EntityResolver, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__HandlerBase, _p_XERCES_CPP_NAMESPACE__HandlerBaseTo_p_XERCES_CPP_NAMESPACE__EntityResolver, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DefaultHandler, _p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__EntityResolver, 0, 0},  {&_swigt__p_PerlEntityResolverHandler, _p_PerlEntityResolverHandlerTo_p_XERCES_CPP_NAMESPACE__EntityResolver, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__ErrorHandler[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__HandlerBase, _p_XERCES_CPP_NAMESPACE__HandlerBaseTo_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__ErrorHandler, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DefaultHandler, _p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0, 0},  {&_swigt__p_PerlErrorCallbackHandler, _p_PerlErrorCallbackHandlerTo_p_XERCES_CPP_NAMESPACE__ErrorHandler, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__Grammar[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__Grammar, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDGrammar, _p_XERCES_CPP_NAMESPACE__DTDGrammarTo_p_XERCES_CPP_NAMESPACE__Grammar, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaGrammar, _p_XERCES_CPP_NAMESPACE__SchemaGrammarTo_p_XERCES_CPP_NAMESPACE__Grammar, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__GrammarResolver[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__GrammarResolver, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__HandlerBase[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__HandlerBase, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__InputSource[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__InputSource, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__LocalFileInputSource, _p_XERCES_CPP_NAMESPACE__LocalFileInputSourceTo_p_XERCES_CPP_NAMESPACE__InputSource, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__StdInInputSource, _p_XERCES_CPP_NAMESPACE__StdInInputSourceTo_p_XERCES_CPP_NAMESPACE__InputSource, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__URLInputSource, _p_XERCES_CPP_NAMESPACE__URLInputSourceTo_p_XERCES_CPP_NAMESPACE__InputSource, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__MemBufInputSource, _p_XERCES_CPP_NAMESPACE__MemBufInputSourceTo_p_XERCES_CPP_NAMESPACE__InputSource, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, _p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSourceTo_p_XERCES_CPP_NAMESPACE__InputSource, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__LexicalHandler[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__LexicalHandler, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DefaultHandler, _p_XERCES_CPP_NAMESPACE__DefaultHandlerTo_p_XERCES_CPP_NAMESPACE__LexicalHandler, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__LocalFileInputSource[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__LocalFileInputSource, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__Locator[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__Locator, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__MemBufFormatTarget[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__MemBufFormatTarget, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__MemBufInputSource[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__MemBufInputSource, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__MemoryManager[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__MemoryManager, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__XMLNotationDecl_t[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__XMLNotationDecl_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__NamespaceScope[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__NamespaceScope, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__PSVIHandler[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__AbstractDOMParser, _p_XERCES_CPP_NAMESPACE__AbstractDOMParserTo_p_XERCES_CPP_NAMESPACE__PSVIHandler, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XercesDOMParser, _p_XERCES_CPP_NAMESPACE__XercesDOMParserTo_p_XERCES_CPP_NAMESPACE__PSVIHandler, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__PSVIHandler, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__Parser[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXParser, _p_XERCES_CPP_NAMESPACE__SAXParserTo_p_XERCES_CPP_NAMESPACE__Parser, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__Parser, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__QName[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__QName, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__SAX2XMLReader[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SAX2XMLReader, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__SAXException[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXException, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXNotSupportedException, _p_XERCES_CPP_NAMESPACE__SAXNotSupportedExceptionTo_p_XERCES_CPP_NAMESPACE__SAXException, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException, _p_XERCES_CPP_NAMESPACE__SAXNotRecognizedExceptionTo_p_XERCES_CPP_NAMESPACE__SAXException, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXParseException, _p_XERCES_CPP_NAMESPACE__SAXParseExceptionTo_p_XERCES_CPP_NAMESPACE__SAXException, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__SAXNotSupportedException[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXNotSupportedException, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__SAXParseException[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXParseException, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__SAXParser[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXParser, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__SchemaAttDef[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaAttDef, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__SchemaAttDefList[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaAttDefList, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__SchemaElementDecl[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaElementDecl, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__SchemaGrammar[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaGrammar, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__SchemaValidator[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaValidator, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__StdInInputSource[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__StdInInputSource, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__StdOutFormatTarget[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__StdOutFormatTarget, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__URLInputSource[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__URLInputSource, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__Wrapper4InputSource[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLAttDef[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaAttDef, _p_XERCES_CPP_NAMESPACE__SchemaAttDefTo_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLAttDef, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDAttDef, _p_XERCES_CPP_NAMESPACE__DTDAttDefTo_p_XERCES_CPP_NAMESPACE__XMLAttDef, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLAttDefList[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDAttDefList, _p_XERCES_CPP_NAMESPACE__DTDAttDefListTo_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaAttDefList, _p_XERCES_CPP_NAMESPACE__SchemaAttDefListTo_p_XERCES_CPP_NAMESPACE__XMLAttDefList, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLContentModel[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLContentModel, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLDTDDescription[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLDTDDescription, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLDeleter[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLDeleter, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLDocumentHandler[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLDocumentHandler, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLElementDecl[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDElementDecl, _p_XERCES_CPP_NAMESPACE__DTDElementDeclTo_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaElementDecl, _p_XERCES_CPP_NAMESPACE__SchemaElementDeclTo_p_XERCES_CPP_NAMESPACE__XMLElementDecl, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLEntityDecl[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDEntityDecl, _p_XERCES_CPP_NAMESPACE__DTDEntityDeclTo_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLEntityResolver[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLEntityResolver, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, _p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, _p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_tTo_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, _p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLException[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLException, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLExcepts[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLExcepts, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLFormatTarget[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLFormatTarget, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__StdOutFormatTarget, _p_XERCES_CPP_NAMESPACE__StdOutFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMLFormatTarget, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget, _p_XERCES_CPP_NAMESPACE__LocalFileFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMLFormatTarget, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__MemBufFormatTarget, _p_XERCES_CPP_NAMESPACE__MemBufFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMLFormatTarget, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLFormatter[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLFormatter, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLGrammarDescription[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLDTDDescription, _p_XERCES_CPP_NAMESPACE__XMLDTDDescriptionTo_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, _p_XERCES_CPP_NAMESPACE__XMLSchemaDescriptionTo_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLGrammarPool[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLGrammarPool, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLNotationDecl[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLNotationDecl, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLPScanToken[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLPScanToken, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLPlatformUtils[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLPlatformUtils, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLReaderFactory[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLReaderFactory, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLSchemaDescription[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLURL[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLURL, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLUni[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLUni, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLUri[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLUri, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMLValidator[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLValidator, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDValidator, _p_XERCES_CPP_NAMESPACE__DTDValidatorTo_p_XERCES_CPP_NAMESPACE__XMLValidator, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaValidator, _p_XERCES_CPP_NAMESPACE__SchemaValidatorTo_p_XERCES_CPP_NAMESPACE__XMLValidator, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XMemory[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLUri, _p_XERCES_CPP_NAMESPACE__XMLUriTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, _p_XERCES_CPP_NAMESPACE__XMLSchemaDescriptionTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, _p_XERCES_CPP_NAMESPACE__XMLGrammarDescriptionTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLDTDDescription, _p_XERCES_CPP_NAMESPACE__XMLDTDDescriptionTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaElementDecl, _p_XERCES_CPP_NAMESPACE__SchemaElementDeclTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDElementDecl, _p_XERCES_CPP_NAMESPACE__DTDElementDeclTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLElementDecl, _p_XERCES_CPP_NAMESPACE__XMLElementDeclTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaValidator, _p_XERCES_CPP_NAMESPACE__SchemaValidatorTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDValidator, _p_XERCES_CPP_NAMESPACE__DTDValidatorTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLValidator, _p_XERCES_CPP_NAMESPACE__XMLValidatorTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLPScanToken, _p_XERCES_CPP_NAMESPACE__XMLPScanTokenTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, _p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLAttDef, _p_XERCES_CPP_NAMESPACE__XMLAttDefTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDAttDef, _p_XERCES_CPP_NAMESPACE__DTDAttDefTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXParser, _p_XERCES_CPP_NAMESPACE__SAXParserTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLNotationDecl, _p_XERCES_CPP_NAMESPACE__XMLNotationDeclTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLFormatTarget, _p_XERCES_CPP_NAMESPACE__XMLFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__StdOutFormatTarget, _p_XERCES_CPP_NAMESPACE__StdOutFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget, _p_XERCES_CPP_NAMESPACE__LocalFileFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__MemBufFormatTarget, _p_XERCES_CPP_NAMESPACE__MemBufFormatTargetTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t, _p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, _p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__LocalFileInputSource, _p_XERCES_CPP_NAMESPACE__LocalFileInputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__InputSource, _p_XERCES_CPP_NAMESPACE__InputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__StdInInputSource, _p_XERCES_CPP_NAMESPACE__StdInInputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__URLInputSource, _p_XERCES_CPP_NAMESPACE__URLInputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__MemBufInputSource, _p_XERCES_CPP_NAMESPACE__MemBufInputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, _p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSourceTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaAttDef, _p_XERCES_CPP_NAMESPACE__SchemaAttDefTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__AbstractDOMParser, _p_XERCES_CPP_NAMESPACE__AbstractDOMParserTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XercesDOMParser, _p_XERCES_CPP_NAMESPACE__XercesDOMParserTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLURL, _p_XERCES_CPP_NAMESPACE__XMLURLTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLException, _p_XERCES_CPP_NAMESPACE__XMLExceptionTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLContentModel, _p_XERCES_CPP_NAMESPACE__XMLContentModelTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaGrammar, _p_XERCES_CPP_NAMESPACE__SchemaGrammarTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDGrammar, _p_XERCES_CPP_NAMESPACE__DTDGrammarTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__Grammar, _p_XERCES_CPP_NAMESPACE__GrammarTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXException, _p_XERCES_CPP_NAMESPACE__SAXExceptionTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXNotSupportedException, _p_XERCES_CPP_NAMESPACE__SAXNotSupportedExceptionTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException, _p_XERCES_CPP_NAMESPACE__SAXNotRecognizedExceptionTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXParseException, _p_XERCES_CPP_NAMESPACE__SAXParseExceptionTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, _p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, _p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, _p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_tTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMemory, 0, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__QName, _p_XERCES_CPP_NAMESPACE__QNameTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__SchemaAttDefList, _p_XERCES_CPP_NAMESPACE__SchemaAttDefListTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDAttDefList, _p_XERCES_CPP_NAMESPACE__DTDAttDefListTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLAttDefList, _p_XERCES_CPP_NAMESPACE__XMLAttDefListTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLFormatter, _p_XERCES_CPP_NAMESPACE__XMLFormatterTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__DTDEntityDecl, _p_XERCES_CPP_NAMESPACE__DTDEntityDeclTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XMLEntityDecl, _p_XERCES_CPP_NAMESPACE__XMLEntityDeclTo_p_XERCES_CPP_NAMESPACE__XMemory, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XSAnnotation[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XSAnnotation, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XERCES_CPP_NAMESPACE__XercesDOMParser[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XMLBuffer[] = {  {&_swigt__p_XMLBuffer, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XMLErrorReporter[] = {  {&_swigt__p_XERCES_CPP_NAMESPACE__SAXParser, _p_XERCES_CPP_NAMESPACE__SAXParserTo_p_XMLErrorReporter, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__AbstractDOMParser, _p_XERCES_CPP_NAMESPACE__AbstractDOMParserTo_p_XMLErrorReporter, 0, 0},  {&_swigt__p_XERCES_CPP_NAMESPACE__XercesDOMParser, 0, 0, 0},  {&_swigt__p_XMLErrorReporter, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XMLErrorReporter__ErrTypes[] = {  {&_swigt__p_XMLErrorReporter__ErrTypes, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_XSerializeEngine[] = {  {&_swigt__p_XSerializeEngine, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_a_32__unsigned_short[] = {  {&_swigt__p_a_32__unsigned_short, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_bool[] = {  {&_swigt__p_bool, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_char[] = {  {&_swigt__p_char, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_int[] = {  {&_swigt__p_int, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_long[] = {  {&_swigt__p_long, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_p_void[] = {  {&_swigt__p_p_void, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_unsigned_char[] = {  {&_swigt__p_unsigned_char, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_unsigned_int[] = {  {&_swigt__p_unsigned_int, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_unsigned_long[] = {  {&_swigt__p_unsigned_long, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_unsigned_short[] = {  {&_swigt__p_unsigned_short, 0, 0, 0},{0, 0, 0, 0}};
static swig_cast_info _swigc__p_void[] = {  {&_swigt__p_void, 0, 0, 0},{0, 0, 0, 0}};

static swig_cast_info *swig_cast_initial[] = {
  _swigc__p_DatatypeValidatorFactory,
  _swigc__p_IdentityConstraint,
  _swigc__p_PSVIAttributeList,
  _swigc__p_PSVIDefs__Complexity,
  _swigc__p_PSVIDefs__PSVIScope,
  _swigc__p_PSVIDefs__Validation,
  _swigc__p_PSVIDefs__Validity,
  _swigc__p_PSVIElement,
  _swigc__p_PanicHandler,
  _swigc__p_PanicHandler__PanicReasons,
  _swigc__p_PerlCallbackHandler,
  _swigc__p_PerlContentCallbackHandler,
  _swigc__p_PerlDocumentCallbackHandler,
  _swigc__p_PerlEntityResolverHandler,
  _swigc__p_PerlErrorCallbackHandler,
  _swigc__p_PerlNodeFilterCallbackHandler,
  _swigc__p_RefArrayVectorOfTunsigned_short_t,
  _swigc__p_RefHash2KeysTableOfTValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t_t,
  _swigc__p_RefHashTableOfTXERCES_CPP_NAMESPACE__ComplexTypeInfo_t,
  _swigc__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XMLAttDef_t,
  _swigc__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XSAnnotation_t,
  _swigc__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesAttGroupInfo_t,
  _swigc__p_RefHashTableOfTXERCES_CPP_NAMESPACE__XercesGroupInfo_t,
  _swigc__p_RefHashTableOfTXMLRefInfo_t,
  _swigc__p_SecurityManager,
  _swigc__p_ValidationContext,
  _swigc__p_ValueVectorOfTXERCES_CPP_NAMESPACE__SchemaElementDecl_p_t,
  _swigc__p_ValueVectorOfTunsigned_int_t,
  _swigc__p_XERCES_CPP_NAMESPACE__AbstractDOMParser,
  _swigc__p_XERCES_CPP_NAMESPACE__AttributeList,
  _swigc__p_XERCES_CPP_NAMESPACE__Attributes,
  _swigc__p_XERCES_CPP_NAMESPACE__BinInputStream,
  _swigc__p_XERCES_CPP_NAMESPACE__ComplexTypeInfo,
  _swigc__p_XERCES_CPP_NAMESPACE__ContentHandler,
  _swigc__p_XERCES_CPP_NAMESPACE__ContentSpecNode,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMAttr,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMBuilder,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMBuilderFilter,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMCDATASection,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMCharacterData,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMComment,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMConfiguration,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMDocument,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMDocumentFragment,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMDocumentRange,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMDocumentType,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMElement,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMEntity,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMEntityReference,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMEntityResolver,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMError,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMErrorHandler,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMException,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMImplementation,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMImplementationLS,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMImplementationRegistry,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMImplementationSource,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMInputSource,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMLocator,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMNode,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMNodeFilter,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMNodeIterator,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMNodeList,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMNotation,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMRange,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMRangeException,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMText,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMTreeWalker,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMTypeInfo,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMUserDataHandler,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMWriter,
  _swigc__p_XERCES_CPP_NAMESPACE__DOMWriterFilter,
  _swigc__p_XERCES_CPP_NAMESPACE__DTDAttDef,
  _swigc__p_XERCES_CPP_NAMESPACE__DTDAttDefList,
  _swigc__p_XERCES_CPP_NAMESPACE__DTDElementDecl,
  _swigc__p_XERCES_CPP_NAMESPACE__DTDEntityDecl,
  _swigc__p_XERCES_CPP_NAMESPACE__DTDGrammar,
  _swigc__p_XERCES_CPP_NAMESPACE__DTDHandler,
  _swigc__p_XERCES_CPP_NAMESPACE__DTDValidator,
  _swigc__p_XERCES_CPP_NAMESPACE__DatatypeValidator,
  _swigc__p_XERCES_CPP_NAMESPACE__DeclHandler,
  _swigc__p_XERCES_CPP_NAMESPACE__DefaultHandler,
  _swigc__p_XERCES_CPP_NAMESPACE__DocumentHandler,
  _swigc__p_XERCES_CPP_NAMESPACE__EntityResolver,
  _swigc__p_XERCES_CPP_NAMESPACE__ErrorHandler,
  _swigc__p_XERCES_CPP_NAMESPACE__Grammar,
  _swigc__p_XERCES_CPP_NAMESPACE__GrammarResolver,
  _swigc__p_XERCES_CPP_NAMESPACE__HandlerBase,
  _swigc__p_XERCES_CPP_NAMESPACE__InputSource,
  _swigc__p_XERCES_CPP_NAMESPACE__LexicalHandler,
  _swigc__p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget,
  _swigc__p_XERCES_CPP_NAMESPACE__LocalFileInputSource,
  _swigc__p_XERCES_CPP_NAMESPACE__Locator,
  _swigc__p_XERCES_CPP_NAMESPACE__MemBufFormatTarget,
  _swigc__p_XERCES_CPP_NAMESPACE__MemBufInputSource,
  _swigc__p_XERCES_CPP_NAMESPACE__MemoryManager,
  _swigc__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t,
  _swigc__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t,
  _swigc__p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__XMLNotationDecl_t,
  _swigc__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDElementDecl_t,
  _swigc__p_XERCES_CPP_NAMESPACE__NameIdPoolTXERCES_CPP_NAMESPACE__DTDEntityDecl_t,
  _swigc__p_XERCES_CPP_NAMESPACE__NamespaceScope,
  _swigc__p_XERCES_CPP_NAMESPACE__PSVIHandler,
  _swigc__p_XERCES_CPP_NAMESPACE__Parser,
  _swigc__p_XERCES_CPP_NAMESPACE__QName,
  _swigc__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t,
  _swigc__p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolTXERCES_CPP_NAMESPACE__SchemaElementDecl_t,
  _swigc__p_XERCES_CPP_NAMESPACE__SAX2XMLReader,
  _swigc__p_XERCES_CPP_NAMESPACE__SAXException,
  _swigc__p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException,
  _swigc__p_XERCES_CPP_NAMESPACE__SAXNotSupportedException,
  _swigc__p_XERCES_CPP_NAMESPACE__SAXParseException,
  _swigc__p_XERCES_CPP_NAMESPACE__SAXParser,
  _swigc__p_XERCES_CPP_NAMESPACE__SchemaAttDef,
  _swigc__p_XERCES_CPP_NAMESPACE__SchemaAttDefList,
  _swigc__p_XERCES_CPP_NAMESPACE__SchemaElementDecl,
  _swigc__p_XERCES_CPP_NAMESPACE__SchemaGrammar,
  _swigc__p_XERCES_CPP_NAMESPACE__SchemaValidator,
  _swigc__p_XERCES_CPP_NAMESPACE__StdInInputSource,
  _swigc__p_XERCES_CPP_NAMESPACE__StdOutFormatTarget,
  _swigc__p_XERCES_CPP_NAMESPACE__URLInputSource,
  _swigc__p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource,
  _swigc__p_XERCES_CPP_NAMESPACE__Wrapper4InputSource,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLAttDef,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLAttDefList,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLContentModel,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLDTDDescription,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLDeleter,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLDocumentHandler,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLElementDecl,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLEntityDecl,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLEntityResolver,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLException,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLExcepts,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLFormatTarget,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLFormatter,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLGrammarDescription,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLGrammarPool,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLNotationDecl,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLPScanToken,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLPlatformUtils,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLReaderFactory,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLSchemaDescription,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLURL,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLUni,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLUri,
  _swigc__p_XERCES_CPP_NAMESPACE__XMLValidator,
  _swigc__p_XERCES_CPP_NAMESPACE__XMemory,
  _swigc__p_XERCES_CPP_NAMESPACE__XSAnnotation,
  _swigc__p_XERCES_CPP_NAMESPACE__XercesDOMParser,
  _swigc__p_XMLBuffer,
  _swigc__p_XMLErrorReporter,
  _swigc__p_XMLErrorReporter__ErrTypes,
  _swigc__p_XSerializeEngine,
  _swigc__p_a_32__unsigned_short,
  _swigc__p_bool,
  _swigc__p_char,
  _swigc__p_int,
  _swigc__p_long,
  _swigc__p_p_void,
  _swigc__p_unsigned_char,
  _swigc__p_unsigned_int,
  _swigc__p_unsigned_long,
  _swigc__p_unsigned_short,
  _swigc__p_void,
};


/* -------- TYPE CONVERSION AND EQUIVALENCE RULES (END) -------- */

static swig_constant_info swig_constants[] = {
{0,0,0,0,0,0}
};
#ifdef __cplusplus
}
#endif
static swig_variable_info swig_variables[] = {
    { "XML::Xercesc::DEBUG_UTF8_OUT", MAGIC_CLASS _wrap_DEBUG_UTF8_OUT_set, MAGIC_CLASS _wrap_DEBUG_UTF8_OUT_get,0 },
    { "XML::Xercesc::DEBUG_UTF8_IN", MAGIC_CLASS _wrap_DEBUG_UTF8_IN_set, MAGIC_CLASS _wrap_DEBUG_UTF8_IN_get,0 },
    { "XML::Xercesc::XMLUni_fgAnyString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgAnyString_get,0 },
    { "XML::Xercesc::XMLUni_fgAttListString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgAttListString_get,0 },
    { "XML::Xercesc::XMLUni_fgCommentString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgCommentString_get,0 },
    { "XML::Xercesc::XMLUni_fgCDATAString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgCDATAString_get,0 },
    { "XML::Xercesc::XMLUni_fgDefaultString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDefaultString_get,0 },
    { "XML::Xercesc::XMLUni_fgDocTypeString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDocTypeString_get,0 },
    { "XML::Xercesc::XMLUni_fgEBCDICEncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgEBCDICEncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgElemString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgElemString_get,0 },
    { "XML::Xercesc::XMLUni_fgEmptyString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgEmptyString_get,0 },
    { "XML::Xercesc::XMLUni_fgEncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgEncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgEntitString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgEntitString_get,0 },
    { "XML::Xercesc::XMLUni_fgEntityString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgEntityString_get,0 },
    { "XML::Xercesc::XMLUni_fgEntitiesString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgEntitiesString_get,0 },
    { "XML::Xercesc::XMLUni_fgEnumerationString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgEnumerationString_get,0 },
    { "XML::Xercesc::XMLUni_fgExceptDomain", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgExceptDomain_get,0 },
    { "XML::Xercesc::XMLUni_fgFixedString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgFixedString_get,0 },
    { "XML::Xercesc::XMLUni_fgIBM037EncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIBM037EncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgIBM037EncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIBM037EncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgIBM1047EncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIBM1047EncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgIBM1047EncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIBM1047EncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgIBM1140EncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIBM1140EncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgIBM1140EncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIBM1140EncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgIBM1140EncodingString3", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIBM1140EncodingString3_get,0 },
    { "XML::Xercesc::XMLUni_fgIBM1140EncodingString4", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIBM1140EncodingString4_get,0 },
    { "XML::Xercesc::XMLUni_fgIESString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIESString_get,0 },
    { "XML::Xercesc::XMLUni_fgIDString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIDString_get,0 },
    { "XML::Xercesc::XMLUni_fgIDRefString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIDRefString_get,0 },
    { "XML::Xercesc::XMLUni_fgIDRefsString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIDRefsString_get,0 },
    { "XML::Xercesc::XMLUni_fgImpliedString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgImpliedString_get,0 },
    { "XML::Xercesc::XMLUni_fgIgnoreString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIgnoreString_get,0 },
    { "XML::Xercesc::XMLUni_fgIncludeString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIncludeString_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString3", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString3_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString4", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString4_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString5", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString5_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString6", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString6_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString7", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString7_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString8", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString8_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString9", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString9_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString10", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString10_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString11", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString11_get,0 },
    { "XML::Xercesc::XMLUni_fgISO88591EncodingString12", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgISO88591EncodingString12_get,0 },
    { "XML::Xercesc::XMLUni_fgLocalHostString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgLocalHostString_get,0 },
    { "XML::Xercesc::XMLUni_fgNoString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNoString_get,0 },
    { "XML::Xercesc::XMLUni_fgNotationString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNotationString_get,0 },
    { "XML::Xercesc::XMLUni_fgNDATAString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNDATAString_get,0 },
    { "XML::Xercesc::XMLUni_fgNmTokenString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNmTokenString_get,0 },
    { "XML::Xercesc::XMLUni_fgNmTokensString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNmTokensString_get,0 },
    { "XML::Xercesc::XMLUni_fgPCDATAString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgPCDATAString_get,0 },
    { "XML::Xercesc::XMLUni_fgPIString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgPIString_get,0 },
    { "XML::Xercesc::XMLUni_fgPubIDString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgPubIDString_get,0 },
    { "XML::Xercesc::XMLUni_fgRefString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgRefString_get,0 },
    { "XML::Xercesc::XMLUni_fgRequiredString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgRequiredString_get,0 },
    { "XML::Xercesc::XMLUni_fgStandaloneString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgStandaloneString_get,0 },
    { "XML::Xercesc::XMLUni_fgVersion1_0", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgVersion1_0_get,0 },
    { "XML::Xercesc::XMLUni_fgVersion1_1", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgVersion1_1_get,0 },
    { "XML::Xercesc::XMLUni_fgSysIDString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgSysIDString_get,0 },
    { "XML::Xercesc::XMLUni_fgUnknownURIName", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUnknownURIName_get,0 },
    { "XML::Xercesc::XMLUni_fgUCS4EncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUCS4EncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgUCS4EncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUCS4EncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgUCS4EncodingString3", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUCS4EncodingString3_get,0 },
    { "XML::Xercesc::XMLUni_fgUCS4BEncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUCS4BEncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgUCS4BEncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUCS4BEncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgUCS4LEncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUCS4LEncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgUCS4LEncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUCS4LEncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgUSASCIIEncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUSASCIIEncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgUSASCIIEncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUSASCIIEncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgUSASCIIEncodingString3", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUSASCIIEncodingString3_get,0 },
    { "XML::Xercesc::XMLUni_fgUSASCIIEncodingString4", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUSASCIIEncodingString4_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF8EncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF8EncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF8EncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF8EncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF16EncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF16EncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF16EncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF16EncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF16EncodingString3", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF16EncodingString3_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF16EncodingString4", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF16EncodingString4_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF16EncodingString5", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF16EncodingString5_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF16EncodingString6", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF16EncodingString6_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF16EncodingString7", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF16EncodingString7_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF16BEncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF16BEncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF16BEncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF16BEncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF16LEncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF16LEncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgUTF16LEncodingString2", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTF16LEncodingString2_get,0 },
    { "XML::Xercesc::XMLUni_fgVersionString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgVersionString_get,0 },
    { "XML::Xercesc::XMLUni_fgValidityDomain", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgValidityDomain_get,0 },
    { "XML::Xercesc::XMLUni_fgWin1252EncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgWin1252EncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLChEncodingString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLChEncodingString_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLDOMMsgDomain", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLDOMMsgDomain_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLString_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLStringSpace", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLStringSpace_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLStringHTab", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLStringHTab_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLStringCR", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLStringCR_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLStringLF", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLStringLF_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLStringSpaceU", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLStringSpaceU_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLStringHTabU", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLStringHTabU_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLStringCRU", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLStringCRU_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLStringLFU", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLStringLFU_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLDeclString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLDeclString_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLDeclStringSpace", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLDeclStringSpace_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLDeclStringHTab", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLDeclStringHTab_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLDeclStringLF", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLDeclStringLF_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLDeclStringCR", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLDeclStringCR_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLDeclStringSpaceU", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLDeclStringSpaceU_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLDeclStringHTabU", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLDeclStringHTabU_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLDeclStringLFU", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLDeclStringLFU_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLDeclStringCRU", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLDeclStringCRU_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLNSString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLNSString_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLNSColonString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLNSColonString_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLNSURIName", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLNSURIName_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLErrDomain", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLErrDomain_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLURIName", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLURIName_get,0 },
    { "XML::Xercesc::XMLUni_fgInfosetURIName", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgInfosetURIName_get,0 },
    { "XML::Xercesc::XMLUni_fgYesString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgYesString_get,0 },
    { "XML::Xercesc::XMLUni_fgZeroLenString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgZeroLenString_get,0 },
    { "XML::Xercesc::XMLUni_fgDTDEntityString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDTDEntityString_get,0 },
    { "XML::Xercesc::XMLUni_fgAmp", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgAmp_get,0 },
    { "XML::Xercesc::XMLUni_fgLT", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgLT_get,0 },
    { "XML::Xercesc::XMLUni_fgGT", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgGT_get,0 },
    { "XML::Xercesc::XMLUni_fgQuot", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgQuot_get,0 },
    { "XML::Xercesc::XMLUni_fgApos", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgApos_get,0 },
    { "XML::Xercesc::XMLUni_fgWFXMLScanner", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgWFXMLScanner_get,0 },
    { "XML::Xercesc::XMLUni_fgIGXMLScanner", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIGXMLScanner_get,0 },
    { "XML::Xercesc::XMLUni_fgSGXMLScanner", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgSGXMLScanner_get,0 },
    { "XML::Xercesc::XMLUni_fgDGXMLScanner", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDGXMLScanner_get,0 },
    { "XML::Xercesc::XMLUni_fgXSAXMLScanner", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXSAXMLScanner_get,0 },
    { "XML::Xercesc::XMLUni_fgCDataStart", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgCDataStart_get,0 },
    { "XML::Xercesc::XMLUni_fgCDataEnd", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgCDataEnd_get,0 },
    { "XML::Xercesc::XMLUni_fgArrayIndexOutOfBoundsException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgArrayIndexOutOfBoundsException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgEmptyStackException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgEmptyStackException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgIllegalArgumentException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIllegalArgumentException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgInvalidCastException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgInvalidCastException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgIOException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIOException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgNoSuchElementException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNoSuchElementException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgNullPointerException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNullPointerException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgXMLPlatformUtilsException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXMLPlatformUtilsException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgRuntimeException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgRuntimeException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgTranscodingException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgTranscodingException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgUnexpectedEOFException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUnexpectedEOFException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgUnsupportedEncodingException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUnsupportedEncodingException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgUTFDataFormatException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUTFDataFormatException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgNetAccessorException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNetAccessorException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgMalformedURLException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgMalformedURLException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgNumberFormatException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNumberFormatException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgParseException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgParseException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgInvalidDatatypeFacetException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgInvalidDatatypeFacetException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgInvalidDatatypeValueException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgInvalidDatatypeValueException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgSchemaDateTimeException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgSchemaDateTimeException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgXPathException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXPathException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgXSerializationException_Name", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXSerializationException_Name_get,0 },
    { "XML::Xercesc::XMLUni_fgNegINFString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNegINFString_get,0 },
    { "XML::Xercesc::XMLUni_fgNegZeroString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNegZeroString_get,0 },
    { "XML::Xercesc::XMLUni_fgPosZeroString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgPosZeroString_get,0 },
    { "XML::Xercesc::XMLUni_fgPosINFString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgPosINFString_get,0 },
    { "XML::Xercesc::XMLUni_fgNaNString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNaNString_get,0 },
    { "XML::Xercesc::XMLUni_fgEString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgEString_get,0 },
    { "XML::Xercesc::XMLUni_fgZeroString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgZeroString_get,0 },
    { "XML::Xercesc::XMLUni_fgNullString", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNullString_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesDynamic", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesDynamic_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesSchema", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesSchema_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesSchemaFullChecking", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesSchemaFullChecking_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesIdentityConstraintChecking", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesIdentityConstraintChecking_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesSchemaExternalSchemaLocation", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesSchemaExternalSchemaLocation_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesSchemaExternalNoNameSpaceSchemaLocation", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesSchemaExternalNoNameSpaceSchemaLocation_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesSecurityManager", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesSecurityManager_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesLoadExternalDTD", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesLoadExternalDTD_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesContinueAfterFatalError", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesContinueAfterFatalError_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesValidationErrorAsFatal", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesValidationErrorAsFatal_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesUserAdoptsDOMDocument", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesUserAdoptsDOMDocument_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesCacheGrammarFromParse", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesCacheGrammarFromParse_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesUseCachedGrammarInParse", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesUseCachedGrammarInParse_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesScannerName", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesScannerName_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesParserUseDocumentFromImplementation", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesParserUseDocumentFromImplementation_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesCalculateSrcOfs", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesCalculateSrcOfs_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesStandardUriConformant", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesStandardUriConformant_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesDOMHasPSVIInfo", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesDOMHasPSVIInfo_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesGenerateSyntheticAnnotations", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesGenerateSyntheticAnnotations_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesValidateAnnotations", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesValidateAnnotations_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesIgnoreCachedDTD", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesIgnoreCachedDTD_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesIgnoreAnnotations", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesIgnoreAnnotations_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesDisableDefaultEntityResolution", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesDisableDefaultEntityResolution_get,0 },
    { "XML::Xercesc::XMLUni_fgXercesSkipDTDValidation", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercesSkipDTDValidation_get,0 },
    { "XML::Xercesc::XMLUni_fgSAX2CoreValidation", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgSAX2CoreValidation_get,0 },
    { "XML::Xercesc::XMLUni_fgSAX2CoreNameSpaces", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgSAX2CoreNameSpaces_get,0 },
    { "XML::Xercesc::XMLUni_fgSAX2CoreNameSpacePrefixes", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgSAX2CoreNameSpacePrefixes_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMCanonicalForm", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMCanonicalForm_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMCDATASections", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMCDATASections_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMComments", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMComments_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMCharsetOverridesXMLEncoding", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMCharsetOverridesXMLEncoding_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMDatatypeNormalization", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMDatatypeNormalization_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMEntities", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMEntities_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMInfoset", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMInfoset_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMNamespaces", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMNamespaces_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMNamespaceDeclarations", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMNamespaceDeclarations_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMSupportedMediatypesOnly", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMSupportedMediatypesOnly_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMValidateIfSchema", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMValidateIfSchema_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMValidation", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMValidation_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMWhitespaceInElementContent", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMWhitespaceInElementContent_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMWRTCanonicalForm", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMWRTCanonicalForm_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMWRTDiscardDefaultContent", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMWRTDiscardDefaultContent_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMWRTEntities", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMWRTEntities_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMWRTFormatPrettyPrint", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMWRTFormatPrettyPrint_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMWRTNormalizeCharacters", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMWRTNormalizeCharacters_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMWRTSplitCdataSections", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMWRTSplitCdataSections_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMWRTValidation", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMWRTValidation_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMWRTWhitespaceInElementContent", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMWRTWhitespaceInElementContent_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMWRTBOM", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMWRTBOM_get,0 },
    { "XML::Xercesc::XMLUni_fgDOMXMLDeclaration", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDOMXMLDeclaration_get,0 },
    { "XML::Xercesc::XMLUni_fgXercescInterfacePSVITypeInfo", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercescInterfacePSVITypeInfo_get,0 },
    { "XML::Xercesc::XMLUni_fgXercescInterfaceDOMDocumentTypeImpl", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercescInterfaceDOMDocumentTypeImpl_get,0 },
    { "XML::Xercesc::XMLUni_fgXercescDefaultLocale", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgXercescDefaultLocale_get,0 },
    { "XML::Xercesc::XMLUni_fgDefErrMsg", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgDefErrMsg_get,0 },
    { "XML::Xercesc::XMLUni_fgValueZero", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgValueZero_get,0 },
    { "XML::Xercesc::XMLUni_fgNegOne", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgNegOne_get,0 },
    { "XML::Xercesc::XMLUni_fgValueOne", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgValueOne_get,0 },
    { "XML::Xercesc::XMLUni_fgLongMaxInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgLongMaxInc_get,0 },
    { "XML::Xercesc::XMLUni_fgLongMinInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgLongMinInc_get,0 },
    { "XML::Xercesc::XMLUni_fgIntMaxInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIntMaxInc_get,0 },
    { "XML::Xercesc::XMLUni_fgIntMinInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgIntMinInc_get,0 },
    { "XML::Xercesc::XMLUni_fgShortMaxInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgShortMaxInc_get,0 },
    { "XML::Xercesc::XMLUni_fgShortMinInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgShortMinInc_get,0 },
    { "XML::Xercesc::XMLUni_fgByteMaxInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgByteMaxInc_get,0 },
    { "XML::Xercesc::XMLUni_fgByteMinInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgByteMinInc_get,0 },
    { "XML::Xercesc::XMLUni_fgULongMaxInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgULongMaxInc_get,0 },
    { "XML::Xercesc::XMLUni_fgUIntMaxInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUIntMaxInc_get,0 },
    { "XML::Xercesc::XMLUni_fgUShortMaxInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUShortMaxInc_get,0 },
    { "XML::Xercesc::XMLUni_fgUByteMaxInc", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgUByteMaxInc_get,0 },
    { "XML::Xercesc::XMLUni_fgLangPattern", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgLangPattern_get,0 },
    { "XML::Xercesc::XMLUni_fgBooleanValueSpace", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgBooleanValueSpace_get,&SWIGTYPE_p_a_32__unsigned_short },
    { "XML::Xercesc::XMLUni_fgBooleanValueSpaceArraySize", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLUni_fgBooleanValueSpaceArraySize_get,0 },
    { "XML::Xercesc::XMLElementDecl_fgInvalidElemId", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLElementDecl_fgInvalidElemId_get,0 },
    { "XML::Xercesc::XMLElementDecl_fgPCDataElemId", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLElementDecl_fgPCDataElemId_get,0 },
    { "XML::Xercesc::XMLElementDecl_fgPCDataElemName", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLElementDecl_fgPCDataElemName_get,0 },
    { "XML::Xercesc::XMLAttDef_fgInvalidAttrId", MAGIC_CLASS swig_magic_readonly, MAGIC_CLASS _wrap_XMLAttDef_fgInvalidAttrId_get,0 },
{0,0,0,0}
};
static swig_command_info swig_commands[] = {
{"XML::Xercesc::delete_XMLDeleter", _wrap_delete_XMLDeleter},
{"XML::Xercesc::XMLPlatformUtils_Initialize", _wrap_XMLPlatformUtils_Initialize},
{"XML::Xercesc::XMLPlatformUtils_Terminate", _wrap_XMLPlatformUtils_Terminate},
{"XML::Xercesc::XMLPlatformUtils_panic", _wrap_XMLPlatformUtils_panic},
{"XML::Xercesc::delete_XMLPlatformUtils", _wrap_delete_XMLPlatformUtils},
{"XML::Xercesc::XMLURL_lookupByName", _wrap_XMLURL_lookupByName},
{"XML::Xercesc::XMLURL_parse", _wrap_XMLURL_parse},
{"XML::Xercesc::new_XMLURL", _wrap_new_XMLURL},
{"XML::Xercesc::delete_XMLURL", _wrap_delete_XMLURL},
{"XML::Xercesc::XMLURL___eq__", _wrap_XMLURL___eq__},
{"XML::Xercesc::XMLURL___ne__", _wrap_XMLURL___ne__},
{"XML::Xercesc::XMLURL_getFragment", _wrap_XMLURL_getFragment},
{"XML::Xercesc::XMLURL_getHost", _wrap_XMLURL_getHost},
{"XML::Xercesc::XMLURL_getPassword", _wrap_XMLURL_getPassword},
{"XML::Xercesc::XMLURL_getPath", _wrap_XMLURL_getPath},
{"XML::Xercesc::XMLURL_getPortNum", _wrap_XMLURL_getPortNum},
{"XML::Xercesc::XMLURL_getProtocol", _wrap_XMLURL_getProtocol},
{"XML::Xercesc::XMLURL_getProtocolName", _wrap_XMLURL_getProtocolName},
{"XML::Xercesc::XMLURL_getQuery", _wrap_XMLURL_getQuery},
{"XML::Xercesc::XMLURL_getURLText", _wrap_XMLURL_getURLText},
{"XML::Xercesc::XMLURL_getUser", _wrap_XMLURL_getUser},
{"XML::Xercesc::XMLURL_getMemoryManager", _wrap_XMLURL_getMemoryManager},
{"XML::Xercesc::XMLURL_setURL", _wrap_XMLURL_setURL},
{"XML::Xercesc::XMLURL_isRelative", _wrap_XMLURL_isRelative},
{"XML::Xercesc::XMLURL_hasInvalidChar", _wrap_XMLURL_hasInvalidChar},
{"XML::Xercesc::XMLURL_makeNewStream", _wrap_XMLURL_makeNewStream},
{"XML::Xercesc::XMLURL_makeRelativeTo", _wrap_XMLURL_makeRelativeTo},
{"XML::Xercesc::delete_XMLUri", _wrap_delete_XMLUri},
{"XML::Xercesc::XMLUri_getUriText", _wrap_XMLUri_getUriText},
{"XML::Xercesc::XMLUri_getScheme", _wrap_XMLUri_getScheme},
{"XML::Xercesc::XMLUri_getUserInfo", _wrap_XMLUri_getUserInfo},
{"XML::Xercesc::XMLUri_getHost", _wrap_XMLUri_getHost},
{"XML::Xercesc::XMLUri_getPort", _wrap_XMLUri_getPort},
{"XML::Xercesc::XMLUri_getRegBasedAuthority", _wrap_XMLUri_getRegBasedAuthority},
{"XML::Xercesc::XMLUri_getPath", _wrap_XMLUri_getPath},
{"XML::Xercesc::XMLUri_getQueryString", _wrap_XMLUri_getQueryString},
{"XML::Xercesc::XMLUri_getFragment", _wrap_XMLUri_getFragment},
{"XML::Xercesc::XMLUri_setScheme", _wrap_XMLUri_setScheme},
{"XML::Xercesc::XMLUri_setUserInfo", _wrap_XMLUri_setUserInfo},
{"XML::Xercesc::XMLUri_setHost", _wrap_XMLUri_setHost},
{"XML::Xercesc::XMLUri_setPort", _wrap_XMLUri_setPort},
{"XML::Xercesc::XMLUri_setRegBasedAuthority", _wrap_XMLUri_setRegBasedAuthority},
{"XML::Xercesc::XMLUri_setPath", _wrap_XMLUri_setPath},
{"XML::Xercesc::XMLUri_setQueryString", _wrap_XMLUri_setQueryString},
{"XML::Xercesc::XMLUri_setFragment", _wrap_XMLUri_setFragment},
{"XML::Xercesc::XMLUri_isURIString", _wrap_XMLUri_isURIString},
{"XML::Xercesc::XMLUri_isValidURI", _wrap_XMLUri_isValidURI},
{"XML::Xercesc::XMLUri_normalizeURI", _wrap_XMLUri_normalizeURI},
{"XML::Xercesc::new_XMLUri", _wrap_new_XMLUri},
{"XML::Xercesc::delete_XMLExcepts", _wrap_delete_XMLExcepts},
{"XML::Xercesc::delete_XMLException", _wrap_delete_XMLException},
{"XML::Xercesc::XMLException_getType", _wrap_XMLException_getType},
{"XML::Xercesc::XMLException_getCode", _wrap_XMLException_getCode},
{"XML::Xercesc::XMLException_getMessage", _wrap_XMLException_getMessage},
{"XML::Xercesc::XMLException_getSrcFile", _wrap_XMLException_getSrcFile},
{"XML::Xercesc::XMLException_getSrcLine", _wrap_XMLException_getSrcLine},
{"XML::Xercesc::XMLException_getErrorType", _wrap_XMLException_getErrorType},
{"XML::Xercesc::XMLException_setPosition", _wrap_XMLException_setPosition},
{"XML::Xercesc::XMLException_reinitMsgMutex", _wrap_XMLException_reinitMsgMutex},
{"XML::Xercesc::XMLException_reinitMsgLoader", _wrap_XMLException_reinitMsgLoader},
{"XML::Xercesc::delete_XMLUni", _wrap_delete_XMLUni},
{"XML::Xercesc::new_QName", _wrap_new_QName},
{"XML::Xercesc::delete_QName", _wrap_delete_QName},
{"XML::Xercesc::QName_getPrefix", _wrap_QName_getPrefix},
{"XML::Xercesc::QName_getLocalPart", _wrap_QName_getLocalPart},
{"XML::Xercesc::QName_getURI", _wrap_QName_getURI},
{"XML::Xercesc::QName_getRawName", _wrap_QName_getRawName},
{"XML::Xercesc::QName_getMemoryManager", _wrap_QName_getMemoryManager},
{"XML::Xercesc::QName_setName", _wrap_QName_setName},
{"XML::Xercesc::QName_setPrefix", _wrap_QName_setPrefix},
{"XML::Xercesc::QName_setLocalPart", _wrap_QName_setLocalPart},
{"XML::Xercesc::QName_setNPrefix", _wrap_QName_setNPrefix},
{"XML::Xercesc::QName_setNLocalPart", _wrap_QName_setNLocalPart},
{"XML::Xercesc::QName_setURI", _wrap_QName_setURI},
{"XML::Xercesc::QName_setValues", _wrap_QName_setValues},
{"XML::Xercesc::QName___eq__", _wrap_QName___eq__},
{"XML::Xercesc::QName_cleanUp", _wrap_QName_cleanUp},
{"XML::Xercesc::delete_XMLElementDecl", _wrap_delete_XMLElementDecl},
{"XML::Xercesc::XMLElementDecl_findAttr", _wrap_XMLElementDecl_findAttr},
{"XML::Xercesc::XMLElementDecl_getAttDefList", _wrap_XMLElementDecl_getAttDefList},
{"XML::Xercesc::XMLElementDecl_getCharDataOpts", _wrap_XMLElementDecl_getCharDataOpts},
{"XML::Xercesc::XMLElementDecl_hasAttDefs", _wrap_XMLElementDecl_hasAttDefs},
{"XML::Xercesc::XMLElementDecl_resetDefs", _wrap_XMLElementDecl_resetDefs},
{"XML::Xercesc::XMLElementDecl_getContentSpec", _wrap_XMLElementDecl_getContentSpec},
{"XML::Xercesc::XMLElementDecl_setContentSpec", _wrap_XMLElementDecl_setContentSpec},
{"XML::Xercesc::XMLElementDecl_getContentModel", _wrap_XMLElementDecl_getContentModel},
{"XML::Xercesc::XMLElementDecl_setContentModel", _wrap_XMLElementDecl_setContentModel},
{"XML::Xercesc::XMLElementDecl_getFormattedContentModel", _wrap_XMLElementDecl_getFormattedContentModel},
{"XML::Xercesc::XMLElementDecl_getBaseName", _wrap_XMLElementDecl_getBaseName},
{"XML::Xercesc::XMLElementDecl_getURI", _wrap_XMLElementDecl_getURI},
{"XML::Xercesc::XMLElementDecl_getElementName", _wrap_XMLElementDecl_getElementName},
{"XML::Xercesc::XMLElementDecl_getFullName", _wrap_XMLElementDecl_getFullName},
{"XML::Xercesc::XMLElementDecl_getCreateReason", _wrap_XMLElementDecl_getCreateReason},
{"XML::Xercesc::XMLElementDecl_getId", _wrap_XMLElementDecl_getId},
{"XML::Xercesc::XMLElementDecl_getDOMTypeInfoUri", _wrap_XMLElementDecl_getDOMTypeInfoUri},
{"XML::Xercesc::XMLElementDecl_getDOMTypeInfoName", _wrap_XMLElementDecl_getDOMTypeInfoName},
{"XML::Xercesc::XMLElementDecl_isDeclared", _wrap_XMLElementDecl_isDeclared},
{"XML::Xercesc::XMLElementDecl_isExternal", _wrap_XMLElementDecl_isExternal},
{"XML::Xercesc::XMLElementDecl_getMemoryManager", _wrap_XMLElementDecl_getMemoryManager},
{"XML::Xercesc::XMLElementDecl_setElementName", _wrap_XMLElementDecl_setElementName},
{"XML::Xercesc::XMLElementDecl_setCreateReason", _wrap_XMLElementDecl_setCreateReason},
{"XML::Xercesc::XMLElementDecl_setId", _wrap_XMLElementDecl_setId},
{"XML::Xercesc::XMLElementDecl_setExternalElemDeclaration", _wrap_XMLElementDecl_setExternalElemDeclaration},
{"XML::Xercesc::XMLElementDecl_getObjectType", _wrap_XMLElementDecl_getObjectType},
{"XML::Xercesc::XMLElementDecl_storeElementDecl", _wrap_XMLElementDecl_storeElementDecl},
{"XML::Xercesc::XMLElementDecl_loadElementDecl", _wrap_XMLElementDecl_loadElementDecl},
{"XML::Xercesc::delete_XMLEntityDecl", _wrap_delete_XMLEntityDecl},
{"XML::Xercesc::XMLEntityDecl_getDeclaredInIntSubset", _wrap_XMLEntityDecl_getDeclaredInIntSubset},
{"XML::Xercesc::XMLEntityDecl_getIsParameter", _wrap_XMLEntityDecl_getIsParameter},
{"XML::Xercesc::XMLEntityDecl_getIsSpecialChar", _wrap_XMLEntityDecl_getIsSpecialChar},
{"XML::Xercesc::XMLEntityDecl_getId", _wrap_XMLEntityDecl_getId},
{"XML::Xercesc::XMLEntityDecl_getName", _wrap_XMLEntityDecl_getName},
{"XML::Xercesc::XMLEntityDecl_getNotationName", _wrap_XMLEntityDecl_getNotationName},
{"XML::Xercesc::XMLEntityDecl_getPublicId", _wrap_XMLEntityDecl_getPublicId},
{"XML::Xercesc::XMLEntityDecl_getSystemId", _wrap_XMLEntityDecl_getSystemId},
{"XML::Xercesc::XMLEntityDecl_getBaseURI", _wrap_XMLEntityDecl_getBaseURI},
{"XML::Xercesc::XMLEntityDecl_getValue", _wrap_XMLEntityDecl_getValue},
{"XML::Xercesc::XMLEntityDecl_getValueLen", _wrap_XMLEntityDecl_getValueLen},
{"XML::Xercesc::XMLEntityDecl_isExternal", _wrap_XMLEntityDecl_isExternal},
{"XML::Xercesc::XMLEntityDecl_isUnparsed", _wrap_XMLEntityDecl_isUnparsed},
{"XML::Xercesc::XMLEntityDecl_getMemoryManager", _wrap_XMLEntityDecl_getMemoryManager},
{"XML::Xercesc::XMLEntityDecl_setName", _wrap_XMLEntityDecl_setName},
{"XML::Xercesc::XMLEntityDecl_setNotationName", _wrap_XMLEntityDecl_setNotationName},
{"XML::Xercesc::XMLEntityDecl_setPublicId", _wrap_XMLEntityDecl_setPublicId},
{"XML::Xercesc::XMLEntityDecl_setSystemId", _wrap_XMLEntityDecl_setSystemId},
{"XML::Xercesc::XMLEntityDecl_setBaseURI", _wrap_XMLEntityDecl_setBaseURI},
{"XML::Xercesc::XMLEntityDecl_setValue", _wrap_XMLEntityDecl_setValue},
{"XML::Xercesc::XMLEntityDecl_setId", _wrap_XMLEntityDecl_setId},
{"XML::Xercesc::XMLEntityDecl_getKey", _wrap_XMLEntityDecl_getKey},
{"XML::Xercesc::new_XMLNotationDecl", _wrap_new_XMLNotationDecl},
{"XML::Xercesc::delete_XMLNotationDecl", _wrap_delete_XMLNotationDecl},
{"XML::Xercesc::XMLNotationDecl_getId", _wrap_XMLNotationDecl_getId},
{"XML::Xercesc::XMLNotationDecl_getName", _wrap_XMLNotationDecl_getName},
{"XML::Xercesc::XMLNotationDecl_getPublicId", _wrap_XMLNotationDecl_getPublicId},
{"XML::Xercesc::XMLNotationDecl_getSystemId", _wrap_XMLNotationDecl_getSystemId},
{"XML::Xercesc::XMLNotationDecl_getBaseURI", _wrap_XMLNotationDecl_getBaseURI},
{"XML::Xercesc::XMLNotationDecl_getNameSpaceId", _wrap_XMLNotationDecl_getNameSpaceId},
{"XML::Xercesc::XMLNotationDecl_getMemoryManager", _wrap_XMLNotationDecl_getMemoryManager},
{"XML::Xercesc::XMLNotationDecl_setId", _wrap_XMLNotationDecl_setId},
{"XML::Xercesc::XMLNotationDecl_setName", _wrap_XMLNotationDecl_setName},
{"XML::Xercesc::XMLNotationDecl_setPublicId", _wrap_XMLNotationDecl_setPublicId},
{"XML::Xercesc::XMLNotationDecl_setSystemId", _wrap_XMLNotationDecl_setSystemId},
{"XML::Xercesc::XMLNotationDecl_setBaseURI", _wrap_XMLNotationDecl_setBaseURI},
{"XML::Xercesc::XMLNotationDecl_setNameSpaceId", _wrap_XMLNotationDecl_setNameSpaceId},
{"XML::Xercesc::XMLNotationDecl_getKey", _wrap_XMLNotationDecl_getKey},
{"XML::Xercesc::delete_XMLAttDefList", _wrap_delete_XMLAttDefList},
{"XML::Xercesc::XMLAttDefList_hasMoreElements", _wrap_XMLAttDefList_hasMoreElements},
{"XML::Xercesc::XMLAttDefList_isEmpty", _wrap_XMLAttDefList_isEmpty},
{"XML::Xercesc::XMLAttDefList_findAttDef", _wrap_XMLAttDefList_findAttDef},
{"XML::Xercesc::XMLAttDefList_nextElement", _wrap_XMLAttDefList_nextElement},
{"XML::Xercesc::XMLAttDefList_Reset", _wrap_XMLAttDefList_Reset},
{"XML::Xercesc::XMLAttDefList_getAttDefCount", _wrap_XMLAttDefList_getAttDefCount},
{"XML::Xercesc::XMLAttDefList_getAttDef", _wrap_XMLAttDefList_getAttDef},
{"XML::Xercesc::XMLAttDefList_getMemoryManager", _wrap_XMLAttDefList_getMemoryManager},
{"XML::Xercesc::XMLAttDef_getAttTypeString", _wrap_XMLAttDef_getAttTypeString},
{"XML::Xercesc::XMLAttDef_getDefAttTypeString", _wrap_XMLAttDef_getDefAttTypeString},
{"XML::Xercesc::delete_XMLAttDef", _wrap_delete_XMLAttDef},
{"XML::Xercesc::XMLAttDef_getFullName", _wrap_XMLAttDef_getFullName},
{"XML::Xercesc::XMLAttDef_reset", _wrap_XMLAttDef_reset},
{"XML::Xercesc::XMLAttDef_getDefaultType", _wrap_XMLAttDef_getDefaultType},
{"XML::Xercesc::XMLAttDef_getEnumeration", _wrap_XMLAttDef_getEnumeration},
{"XML::Xercesc::XMLAttDef_getId", _wrap_XMLAttDef_getId},
{"XML::Xercesc::XMLAttDef_getProvided", _wrap_XMLAttDef_getProvided},
{"XML::Xercesc::XMLAttDef_getType", _wrap_XMLAttDef_getType},
{"XML::Xercesc::XMLAttDef_getValue", _wrap_XMLAttDef_getValue},
{"XML::Xercesc::XMLAttDef_getCreateReason", _wrap_XMLAttDef_getCreateReason},
{"XML::Xercesc::XMLAttDef_isExternal", _wrap_XMLAttDef_isExternal},
{"XML::Xercesc::XMLAttDef_getMemoryManager", _wrap_XMLAttDef_getMemoryManager},
{"XML::Xercesc::XMLAttDef_getDOMTypeInfoUri", _wrap_XMLAttDef_getDOMTypeInfoUri},
{"XML::Xercesc::XMLAttDef_getDOMTypeInfoName", _wrap_XMLAttDef_getDOMTypeInfoName},
{"XML::Xercesc::XMLAttDef_setDefaultType", _wrap_XMLAttDef_setDefaultType},
{"XML::Xercesc::XMLAttDef_setId", _wrap_XMLAttDef_setId},
{"XML::Xercesc::XMLAttDef_setProvided", _wrap_XMLAttDef_setProvided},
{"XML::Xercesc::XMLAttDef_setType", _wrap_XMLAttDef_setType},
{"XML::Xercesc::XMLAttDef_setValue", _wrap_XMLAttDef_setValue},
{"XML::Xercesc::XMLAttDef_setEnumeration", _wrap_XMLAttDef_setEnumeration},
{"XML::Xercesc::XMLAttDef_setCreateReason", _wrap_XMLAttDef_setCreateReason},
{"XML::Xercesc::XMLAttDef_setExternalAttDeclaration", _wrap_XMLAttDef_setExternalAttDeclaration},
{"XML::Xercesc::delete_XMLValidator", _wrap_delete_XMLValidator},
{"XML::Xercesc::XMLValidator_getGrammar", _wrap_XMLValidator_getGrammar},
{"XML::Xercesc::XMLValidator_setGrammar", _wrap_XMLValidator_setGrammar},
{"XML::Xercesc::delete_Grammar", _wrap_delete_Grammar},
{"XML::Xercesc::Grammar_getGrammarType", _wrap_Grammar_getGrammarType},
{"XML::Xercesc::Grammar_getTargetNamespace", _wrap_Grammar_getTargetNamespace},
{"XML::Xercesc::Grammar_getValidated", _wrap_Grammar_getValidated},
{"XML::Xercesc::Grammar_findOrAddElemDecl", _wrap_Grammar_findOrAddElemDecl},
{"XML::Xercesc::Grammar_getElemId", _wrap_Grammar_getElemId},
{"XML::Xercesc::Grammar_getElemDecl", _wrap_Grammar_getElemDecl},
{"XML::Xercesc::Grammar_getNotationDecl", _wrap_Grammar_getNotationDecl},
{"XML::Xercesc::Grammar_putElemDecl", _wrap_Grammar_putElemDecl},
{"XML::Xercesc::Grammar_putNotationDecl", _wrap_Grammar_putNotationDecl},
{"XML::Xercesc::Grammar_setValidated", _wrap_Grammar_setValidated},
{"XML::Xercesc::Grammar_reset", _wrap_Grammar_reset},
{"XML::Xercesc::Grammar_setGrammarDescription", _wrap_Grammar_setGrammarDescription},
{"XML::Xercesc::Grammar_getGrammarDescription", _wrap_Grammar_getGrammarDescription},
{"XML::Xercesc::Grammar_storeGrammar", _wrap_Grammar_storeGrammar},
{"XML::Xercesc::Grammar_loadGrammar", _wrap_Grammar_loadGrammar},
{"XML::Xercesc::delete_XMLGrammarDescription", _wrap_delete_XMLGrammarDescription},
{"XML::Xercesc::XMLGrammarDescription_getGrammarType", _wrap_XMLGrammarDescription_getGrammarType},
{"XML::Xercesc::XMLGrammarDescription_getGrammarKey", _wrap_XMLGrammarDescription_getGrammarKey},
{"XML::Xercesc::XMLGrammarDescription_getMemoryManager", _wrap_XMLGrammarDescription_getMemoryManager},
{"XML::Xercesc::delete_XMLDTDDescription", _wrap_delete_XMLDTDDescription},
{"XML::Xercesc::XMLDTDDescription_getGrammarType", _wrap_XMLDTDDescription_getGrammarType},
{"XML::Xercesc::XMLDTDDescription_getRootName", _wrap_XMLDTDDescription_getRootName},
{"XML::Xercesc::XMLDTDDescription_getSystemId", _wrap_XMLDTDDescription_getSystemId},
{"XML::Xercesc::XMLDTDDescription_setRootName", _wrap_XMLDTDDescription_setRootName},
{"XML::Xercesc::XMLDTDDescription_setSystemId", _wrap_XMLDTDDescription_setSystemId},
{"XML::Xercesc::delete_XMLSchemaDescription", _wrap_delete_XMLSchemaDescription},
{"XML::Xercesc::XMLSchemaDescription_getGrammarType", _wrap_XMLSchemaDescription_getGrammarType},
{"XML::Xercesc::XMLSchemaDescription_getContextType", _wrap_XMLSchemaDescription_getContextType},
{"XML::Xercesc::XMLSchemaDescription_getTargetNamespace", _wrap_XMLSchemaDescription_getTargetNamespace},
{"XML::Xercesc::XMLSchemaDescription_getLocationHints", _wrap_XMLSchemaDescription_getLocationHints},
{"XML::Xercesc::XMLSchemaDescription_getTriggeringComponent", _wrap_XMLSchemaDescription_getTriggeringComponent},
{"XML::Xercesc::XMLSchemaDescription_getEnclosingElementName", _wrap_XMLSchemaDescription_getEnclosingElementName},
{"XML::Xercesc::XMLSchemaDescription_getAttributes", _wrap_XMLSchemaDescription_getAttributes},
{"XML::Xercesc::XMLSchemaDescription_setContextType", _wrap_XMLSchemaDescription_setContextType},
{"XML::Xercesc::XMLSchemaDescription_setTargetNamespace", _wrap_XMLSchemaDescription_setTargetNamespace},
{"XML::Xercesc::XMLSchemaDescription_setLocationHints", _wrap_XMLSchemaDescription_setLocationHints},
{"XML::Xercesc::XMLSchemaDescription_setTriggeringComponent", _wrap_XMLSchemaDescription_setTriggeringComponent},
{"XML::Xercesc::XMLSchemaDescription_setEnclosingElementName", _wrap_XMLSchemaDescription_setEnclosingElementName},
{"XML::Xercesc::XMLSchemaDescription_setAttributes", _wrap_XMLSchemaDescription_setAttributes},
{"XML::Xercesc::delete_DTDElementDecl", _wrap_delete_DTDElementDecl},
{"XML::Xercesc::DTDElementDecl_findAttr", _wrap_DTDElementDecl_findAttr},
{"XML::Xercesc::DTDElementDecl_getAttDefList", _wrap_DTDElementDecl_getAttDefList},
{"XML::Xercesc::DTDElementDecl_getCharDataOpts", _wrap_DTDElementDecl_getCharDataOpts},
{"XML::Xercesc::DTDElementDecl_hasAttDefs", _wrap_DTDElementDecl_hasAttDefs},
{"XML::Xercesc::DTDElementDecl_resetDefs", _wrap_DTDElementDecl_resetDefs},
{"XML::Xercesc::DTDElementDecl_getContentSpec", _wrap_DTDElementDecl_getContentSpec},
{"XML::Xercesc::DTDElementDecl_setContentSpec", _wrap_DTDElementDecl_setContentSpec},
{"XML::Xercesc::DTDElementDecl_getContentModel", _wrap_DTDElementDecl_getContentModel},
{"XML::Xercesc::DTDElementDecl_setContentModel", _wrap_DTDElementDecl_setContentModel},
{"XML::Xercesc::DTDElementDecl_getFormattedContentModel", _wrap_DTDElementDecl_getFormattedContentModel},
{"XML::Xercesc::DTDElementDecl_getKey", _wrap_DTDElementDecl_getKey},
{"XML::Xercesc::DTDElementDecl_getAttDef", _wrap_DTDElementDecl_getAttDef},
{"XML::Xercesc::DTDElementDecl_getModelType", _wrap_DTDElementDecl_getModelType},
{"XML::Xercesc::DTDElementDecl_getDOMTypeInfoName", _wrap_DTDElementDecl_getDOMTypeInfoName},
{"XML::Xercesc::DTDElementDecl_getDOMTypeInfoUri", _wrap_DTDElementDecl_getDOMTypeInfoUri},
{"XML::Xercesc::DTDElementDecl_addAttDef", _wrap_DTDElementDecl_addAttDef},
{"XML::Xercesc::DTDElementDecl_setModelType", _wrap_DTDElementDecl_setModelType},
{"XML::Xercesc::DTDElementDecl_getObjectType", _wrap_DTDElementDecl_getObjectType},
{"XML::Xercesc::new_DTDElementDeclEnumerator", _wrap_new_DTDElementDeclEnumerator},
{"XML::Xercesc::delete_DTDElementDeclEnumerator", _wrap_delete_DTDElementDeclEnumerator},
{"XML::Xercesc::DTDElementDeclEnumerator_hasMoreElements", _wrap_DTDElementDeclEnumerator_hasMoreElements},
{"XML::Xercesc::DTDElementDeclEnumerator_nextElement", _wrap_DTDElementDeclEnumerator_nextElement},
{"XML::Xercesc::DTDElementDeclEnumerator_Reset", _wrap_DTDElementDeclEnumerator_Reset},
{"XML::Xercesc::DTDElementDeclEnumerator_size", _wrap_DTDElementDeclEnumerator_size},
{"XML::Xercesc::delete_DTDEntityDecl", _wrap_delete_DTDEntityDecl},
{"XML::Xercesc::DTDEntityDecl_getDeclaredInIntSubset", _wrap_DTDEntityDecl_getDeclaredInIntSubset},
{"XML::Xercesc::DTDEntityDecl_getIsParameter", _wrap_DTDEntityDecl_getIsParameter},
{"XML::Xercesc::DTDEntityDecl_getIsSpecialChar", _wrap_DTDEntityDecl_getIsSpecialChar},
{"XML::Xercesc::DTDEntityDecl_setDeclaredInIntSubset", _wrap_DTDEntityDecl_setDeclaredInIntSubset},
{"XML::Xercesc::DTDEntityDecl_setIsParameter", _wrap_DTDEntityDecl_setIsParameter},
{"XML::Xercesc::DTDEntityDecl_setIsSpecialChar", _wrap_DTDEntityDecl_setIsSpecialChar},
{"XML::Xercesc::new_DTDEntityDeclEnumerator", _wrap_new_DTDEntityDeclEnumerator},
{"XML::Xercesc::delete_DTDEntityDeclEnumerator", _wrap_delete_DTDEntityDeclEnumerator},
{"XML::Xercesc::DTDEntityDeclEnumerator_hasMoreElements", _wrap_DTDEntityDeclEnumerator_hasMoreElements},
{"XML::Xercesc::DTDEntityDeclEnumerator_nextElement", _wrap_DTDEntityDeclEnumerator_nextElement},
{"XML::Xercesc::DTDEntityDeclEnumerator_Reset", _wrap_DTDEntityDeclEnumerator_Reset},
{"XML::Xercesc::DTDEntityDeclEnumerator_size", _wrap_DTDEntityDeclEnumerator_size},
{"XML::Xercesc::delete_DTDAttDefList", _wrap_delete_DTDAttDefList},
{"XML::Xercesc::DTDAttDefList_hasMoreElements", _wrap_DTDAttDefList_hasMoreElements},
{"XML::Xercesc::DTDAttDefList_isEmpty", _wrap_DTDAttDefList_isEmpty},
{"XML::Xercesc::DTDAttDefList_findAttDef", _wrap_DTDAttDefList_findAttDef},
{"XML::Xercesc::DTDAttDefList_nextElement", _wrap_DTDAttDefList_nextElement},
{"XML::Xercesc::DTDAttDefList_Reset", _wrap_DTDAttDefList_Reset},
{"XML::Xercesc::DTDAttDefList_getAttDefCount", _wrap_DTDAttDefList_getAttDefCount},
{"XML::Xercesc::DTDAttDefList_getAttDef", _wrap_DTDAttDefList_getAttDef},
{"XML::Xercesc::delete_DTDAttDef", _wrap_delete_DTDAttDef},
{"XML::Xercesc::DTDAttDef_getFullName", _wrap_DTDAttDef_getFullName},
{"XML::Xercesc::DTDAttDef_reset", _wrap_DTDAttDef_reset},
{"XML::Xercesc::DTDAttDef_getElemId", _wrap_DTDAttDef_getElemId},
{"XML::Xercesc::DTDAttDef_getDOMTypeInfoName", _wrap_DTDAttDef_getDOMTypeInfoName},
{"XML::Xercesc::DTDAttDef_getDOMTypeInfoUri", _wrap_DTDAttDef_getDOMTypeInfoUri},
{"XML::Xercesc::DTDAttDef_setElemId", _wrap_DTDAttDef_setElemId},
{"XML::Xercesc::DTDAttDef_setName", _wrap_DTDAttDef_setName},
{"XML::Xercesc::new_DTDGrammar", _wrap_new_DTDGrammar},
{"XML::Xercesc::delete_DTDGrammar", _wrap_delete_DTDGrammar},
{"XML::Xercesc::DTDGrammar_getGrammarType", _wrap_DTDGrammar_getGrammarType},
{"XML::Xercesc::DTDGrammar_getTargetNamespace", _wrap_DTDGrammar_getTargetNamespace},
{"XML::Xercesc::DTDGrammar_findOrAddElemDecl", _wrap_DTDGrammar_findOrAddElemDecl},
{"XML::Xercesc::DTDGrammar_getElemId", _wrap_DTDGrammar_getElemId},
{"XML::Xercesc::DTDGrammar_getElemDecl", _wrap_DTDGrammar_getElemDecl},
{"XML::Xercesc::DTDGrammar_getNotationDecl", _wrap_DTDGrammar_getNotationDecl},
{"XML::Xercesc::DTDGrammar_getValidated", _wrap_DTDGrammar_getValidated},
{"XML::Xercesc::DTDGrammar_putElemDecl", _wrap_DTDGrammar_putElemDecl},
{"XML::Xercesc::DTDGrammar_putNotationDecl", _wrap_DTDGrammar_putNotationDecl},
{"XML::Xercesc::DTDGrammar_setValidated", _wrap_DTDGrammar_setValidated},
{"XML::Xercesc::DTDGrammar_reset", _wrap_DTDGrammar_reset},
{"XML::Xercesc::DTDGrammar_getRootElemId", _wrap_DTDGrammar_getRootElemId},
{"XML::Xercesc::DTDGrammar_getEntityDecl", _wrap_DTDGrammar_getEntityDecl},
{"XML::Xercesc::DTDGrammar_getEntityDeclPool", _wrap_DTDGrammar_getEntityDeclPool},
{"XML::Xercesc::DTDGrammar_getElemEnumerator", _wrap_DTDGrammar_getElemEnumerator},
{"XML::Xercesc::DTDGrammar_getEntityEnumerator", _wrap_DTDGrammar_getEntityEnumerator},
{"XML::Xercesc::DTDGrammar_getNotationEnumerator", _wrap_DTDGrammar_getNotationEnumerator},
{"XML::Xercesc::DTDGrammar_setRootElemId", _wrap_DTDGrammar_setRootElemId},
{"XML::Xercesc::DTDGrammar_setGrammarDescription", _wrap_DTDGrammar_setGrammarDescription},
{"XML::Xercesc::DTDGrammar_getGrammarDescription", _wrap_DTDGrammar_getGrammarDescription},
{"XML::Xercesc::DTDGrammar_putEntityDecl", _wrap_DTDGrammar_putEntityDecl},
{"XML::Xercesc::DTDGrammar_reinitDfltEntities", _wrap_DTDGrammar_reinitDfltEntities},
{"XML::Xercesc::new_DTDValidator", _wrap_new_DTDValidator},
{"XML::Xercesc::delete_DTDValidator", _wrap_delete_DTDValidator},
{"XML::Xercesc::DTDValidator_getGrammar", _wrap_DTDValidator_getGrammar},
{"XML::Xercesc::DTDValidator_setGrammar", _wrap_DTDValidator_setGrammar},
{"XML::Xercesc::delete_SchemaElementDecl", _wrap_delete_SchemaElementDecl},
{"XML::Xercesc::SchemaElementDecl_findAttr", _wrap_SchemaElementDecl_findAttr},
{"XML::Xercesc::SchemaElementDecl_getAttDefList", _wrap_SchemaElementDecl_getAttDefList},
{"XML::Xercesc::SchemaElementDecl_getCharDataOpts", _wrap_SchemaElementDecl_getCharDataOpts},
{"XML::Xercesc::SchemaElementDecl_hasAttDefs", _wrap_SchemaElementDecl_hasAttDefs},
{"XML::Xercesc::SchemaElementDecl_resetDefs", _wrap_SchemaElementDecl_resetDefs},
{"XML::Xercesc::SchemaElementDecl_getContentSpec", _wrap_SchemaElementDecl_getContentSpec},
{"XML::Xercesc::SchemaElementDecl_setContentSpec", _wrap_SchemaElementDecl_setContentSpec},
{"XML::Xercesc::SchemaElementDecl_getContentModel", _wrap_SchemaElementDecl_getContentModel},
{"XML::Xercesc::SchemaElementDecl_setContentModel", _wrap_SchemaElementDecl_setContentModel},
{"XML::Xercesc::SchemaElementDecl_getFormattedContentModel", _wrap_SchemaElementDecl_getFormattedContentModel},
{"XML::Xercesc::SchemaElementDecl_getAttDef", _wrap_SchemaElementDecl_getAttDef},
{"XML::Xercesc::SchemaElementDecl_getAttWildCard", _wrap_SchemaElementDecl_getAttWildCard},
{"XML::Xercesc::SchemaElementDecl_getModelType", _wrap_SchemaElementDecl_getModelType},
{"XML::Xercesc::SchemaElementDecl_getPSVIScope", _wrap_SchemaElementDecl_getPSVIScope},
{"XML::Xercesc::SchemaElementDecl_getDatatypeValidator", _wrap_SchemaElementDecl_getDatatypeValidator},
{"XML::Xercesc::SchemaElementDecl_getEnclosingScope", _wrap_SchemaElementDecl_getEnclosingScope},
{"XML::Xercesc::SchemaElementDecl_getFinalSet", _wrap_SchemaElementDecl_getFinalSet},
{"XML::Xercesc::SchemaElementDecl_getBlockSet", _wrap_SchemaElementDecl_getBlockSet},
{"XML::Xercesc::SchemaElementDecl_getMiscFlags", _wrap_SchemaElementDecl_getMiscFlags},
{"XML::Xercesc::SchemaElementDecl_getDefaultValue", _wrap_SchemaElementDecl_getDefaultValue},
{"XML::Xercesc::SchemaElementDecl_getComplexTypeInfo", _wrap_SchemaElementDecl_getComplexTypeInfo},
{"XML::Xercesc::SchemaElementDecl_isGlobalDecl", _wrap_SchemaElementDecl_isGlobalDecl},
{"XML::Xercesc::SchemaElementDecl_getSubstitutionGroupElem", _wrap_SchemaElementDecl_getSubstitutionGroupElem},
{"XML::Xercesc::SchemaElementDecl_getValidity", _wrap_SchemaElementDecl_getValidity},
{"XML::Xercesc::SchemaElementDecl_getValidationAttempted", _wrap_SchemaElementDecl_getValidationAttempted},
{"XML::Xercesc::SchemaElementDecl_getTypeType", _wrap_SchemaElementDecl_getTypeType},
{"XML::Xercesc::SchemaElementDecl_getTypeUri", _wrap_SchemaElementDecl_getTypeUri},
{"XML::Xercesc::SchemaElementDecl_getTypeName", _wrap_SchemaElementDecl_getTypeName},
{"XML::Xercesc::SchemaElementDecl_getTypeAnonymous", _wrap_SchemaElementDecl_getTypeAnonymous},
{"XML::Xercesc::SchemaElementDecl_isTypeDefinitionUnion", _wrap_SchemaElementDecl_isTypeDefinitionUnion},
{"XML::Xercesc::SchemaElementDecl_getMemberTypeUri", _wrap_SchemaElementDecl_getMemberTypeUri},
{"XML::Xercesc::SchemaElementDecl_getMemberTypeAnonymous", _wrap_SchemaElementDecl_getMemberTypeAnonymous},
{"XML::Xercesc::SchemaElementDecl_getMemberTypeName", _wrap_SchemaElementDecl_getMemberTypeName},
{"XML::Xercesc::SchemaElementDecl_getDOMTypeInfoUri", _wrap_SchemaElementDecl_getDOMTypeInfoUri},
{"XML::Xercesc::SchemaElementDecl_getDOMTypeInfoName", _wrap_SchemaElementDecl_getDOMTypeInfoName},
{"XML::Xercesc::SchemaElementDecl_setElemId", _wrap_SchemaElementDecl_setElemId},
{"XML::Xercesc::SchemaElementDecl_setModelType", _wrap_SchemaElementDecl_setModelType},
{"XML::Xercesc::SchemaElementDecl_setPSVIScope", _wrap_SchemaElementDecl_setPSVIScope},
{"XML::Xercesc::SchemaElementDecl_setDatatypeValidator", _wrap_SchemaElementDecl_setDatatypeValidator},
{"XML::Xercesc::SchemaElementDecl_setEnclosingScope", _wrap_SchemaElementDecl_setEnclosingScope},
{"XML::Xercesc::SchemaElementDecl_setFinalSet", _wrap_SchemaElementDecl_setFinalSet},
{"XML::Xercesc::SchemaElementDecl_setBlockSet", _wrap_SchemaElementDecl_setBlockSet},
{"XML::Xercesc::SchemaElementDecl_setMiscFlags", _wrap_SchemaElementDecl_setMiscFlags},
{"XML::Xercesc::SchemaElementDecl_setDefaultValue", _wrap_SchemaElementDecl_setDefaultValue},
{"XML::Xercesc::SchemaElementDecl_setComplexTypeInfo", _wrap_SchemaElementDecl_setComplexTypeInfo},
{"XML::Xercesc::SchemaElementDecl_setXsiComplexTypeInfo", _wrap_SchemaElementDecl_setXsiComplexTypeInfo},
{"XML::Xercesc::SchemaElementDecl_setXsiSimpleTypeInfo", _wrap_SchemaElementDecl_setXsiSimpleTypeInfo},
{"XML::Xercesc::SchemaElementDecl_setAttWildCard", _wrap_SchemaElementDecl_setAttWildCard},
{"XML::Xercesc::SchemaElementDecl_setSubstitutionGroupElem", _wrap_SchemaElementDecl_setSubstitutionGroupElem},
{"XML::Xercesc::SchemaElementDecl_setValidity", _wrap_SchemaElementDecl_setValidity},
{"XML::Xercesc::SchemaElementDecl_setValidationAttempted", _wrap_SchemaElementDecl_setValidationAttempted},
{"XML::Xercesc::SchemaElementDecl_updateValidityFromElement", _wrap_SchemaElementDecl_updateValidityFromElement},
{"XML::Xercesc::SchemaElementDecl_updateValidityFromAttribute", _wrap_SchemaElementDecl_updateValidityFromAttribute},
{"XML::Xercesc::SchemaElementDecl_reset", _wrap_SchemaElementDecl_reset},
{"XML::Xercesc::SchemaElementDecl_addIdentityConstraint", _wrap_SchemaElementDecl_addIdentityConstraint},
{"XML::Xercesc::SchemaElementDecl_getIdentityConstraintCount", _wrap_SchemaElementDecl_getIdentityConstraintCount},
{"XML::Xercesc::SchemaElementDecl_getIdentityConstraintAt", _wrap_SchemaElementDecl_getIdentityConstraintAt},
{"XML::Xercesc::SchemaElementDecl_getObjectType", _wrap_SchemaElementDecl_getObjectType},
{"XML::Xercesc::delete_SchemaElementDeclEnumerator", _wrap_delete_SchemaElementDeclEnumerator},
{"XML::Xercesc::new_SchemaElementDeclEnumerator", _wrap_new_SchemaElementDeclEnumerator},
{"XML::Xercesc::SchemaElementDeclEnumerator_hasMoreElements", _wrap_SchemaElementDeclEnumerator_hasMoreElements},
{"XML::Xercesc::SchemaElementDeclEnumerator_nextElement", _wrap_SchemaElementDeclEnumerator_nextElement},
{"XML::Xercesc::SchemaElementDeclEnumerator_Reset", _wrap_SchemaElementDeclEnumerator_Reset},
{"XML::Xercesc::SchemaElementDeclEnumerator_size", _wrap_SchemaElementDeclEnumerator_size},
{"XML::Xercesc::SchemaElementDeclEnumerator_resetKey", _wrap_SchemaElementDeclEnumerator_resetKey},
{"XML::Xercesc::SchemaElementDeclEnumerator_nextElementKey", _wrap_SchemaElementDeclEnumerator_nextElementKey},
{"XML::Xercesc::SchemaElementDeclEnumerator_hasMoreKeys", _wrap_SchemaElementDeclEnumerator_hasMoreKeys},
{"XML::Xercesc::new_SchemaGrammar", _wrap_new_SchemaGrammar},
{"XML::Xercesc::delete_SchemaGrammar", _wrap_delete_SchemaGrammar},
{"XML::Xercesc::SchemaGrammar_getGrammarType", _wrap_SchemaGrammar_getGrammarType},
{"XML::Xercesc::SchemaGrammar_getTargetNamespace", _wrap_SchemaGrammar_getTargetNamespace},
{"XML::Xercesc::SchemaGrammar_findOrAddElemDecl", _wrap_SchemaGrammar_findOrAddElemDecl},
{"XML::Xercesc::SchemaGrammar_getElemId", _wrap_SchemaGrammar_getElemId},
{"XML::Xercesc::SchemaGrammar_getElemDecl", _wrap_SchemaGrammar_getElemDecl},
{"XML::Xercesc::SchemaGrammar_getNotationDecl", _wrap_SchemaGrammar_getNotationDecl},
{"XML::Xercesc::SchemaGrammar_getValidated", _wrap_SchemaGrammar_getValidated},
{"XML::Xercesc::SchemaGrammar_putElemDecl", _wrap_SchemaGrammar_putElemDecl},
{"XML::Xercesc::SchemaGrammar_putNotationDecl", _wrap_SchemaGrammar_putNotationDecl},
{"XML::Xercesc::SchemaGrammar_setValidated", _wrap_SchemaGrammar_setValidated},
{"XML::Xercesc::SchemaGrammar_reset", _wrap_SchemaGrammar_reset},
{"XML::Xercesc::SchemaGrammar_getElemEnumerator", _wrap_SchemaGrammar_getElemEnumerator},
{"XML::Xercesc::SchemaGrammar_getNotationEnumerator", _wrap_SchemaGrammar_getNotationEnumerator},
{"XML::Xercesc::SchemaGrammar_getAttributeDeclRegistry", _wrap_SchemaGrammar_getAttributeDeclRegistry},
{"XML::Xercesc::SchemaGrammar_getComplexTypeRegistry", _wrap_SchemaGrammar_getComplexTypeRegistry},
{"XML::Xercesc::SchemaGrammar_getGroupInfoRegistry", _wrap_SchemaGrammar_getGroupInfoRegistry},
{"XML::Xercesc::SchemaGrammar_getAttGroupInfoRegistry", _wrap_SchemaGrammar_getAttGroupInfoRegistry},
{"XML::Xercesc::SchemaGrammar_getDatatypeRegistry", _wrap_SchemaGrammar_getDatatypeRegistry},
{"XML::Xercesc::SchemaGrammar_getNamespaceScope", _wrap_SchemaGrammar_getNamespaceScope},
{"XML::Xercesc::SchemaGrammar_getValidSubstitutionGroups", _wrap_SchemaGrammar_getValidSubstitutionGroups},
{"XML::Xercesc::SchemaGrammar_getIDRefList", _wrap_SchemaGrammar_getIDRefList},
{"XML::Xercesc::SchemaGrammar_getValidationContext", _wrap_SchemaGrammar_getValidationContext},
{"XML::Xercesc::SchemaGrammar_setTargetNamespace", _wrap_SchemaGrammar_setTargetNamespace},
{"XML::Xercesc::SchemaGrammar_setAttributeDeclRegistry", _wrap_SchemaGrammar_setAttributeDeclRegistry},
{"XML::Xercesc::SchemaGrammar_setComplexTypeRegistry", _wrap_SchemaGrammar_setComplexTypeRegistry},
{"XML::Xercesc::SchemaGrammar_setGroupInfoRegistry", _wrap_SchemaGrammar_setGroupInfoRegistry},
{"XML::Xercesc::SchemaGrammar_setAttGroupInfoRegistry", _wrap_SchemaGrammar_setAttGroupInfoRegistry},
{"XML::Xercesc::SchemaGrammar_setNamespaceScope", _wrap_SchemaGrammar_setNamespaceScope},
{"XML::Xercesc::SchemaGrammar_setValidSubstitutionGroups", _wrap_SchemaGrammar_setValidSubstitutionGroups},
{"XML::Xercesc::SchemaGrammar_setGrammarDescription", _wrap_SchemaGrammar_setGrammarDescription},
{"XML::Xercesc::SchemaGrammar_getGrammarDescription", _wrap_SchemaGrammar_getGrammarDescription},
{"XML::Xercesc::SchemaGrammar_putGroupElemDecl", _wrap_SchemaGrammar_putGroupElemDecl},
{"XML::Xercesc::SchemaGrammar_putAnnotation", _wrap_SchemaGrammar_putAnnotation},
{"XML::Xercesc::SchemaGrammar_addAnnotation", _wrap_SchemaGrammar_addAnnotation},
{"XML::Xercesc::SchemaGrammar_getAnnotation", _wrap_SchemaGrammar_getAnnotation},
{"XML::Xercesc::SchemaGrammar_getAnnotations", _wrap_SchemaGrammar_getAnnotations},
{"XML::Xercesc::new_SchemaValidator", _wrap_new_SchemaValidator},
{"XML::Xercesc::delete_SchemaValidator", _wrap_delete_SchemaValidator},
{"XML::Xercesc::SchemaValidator_getGrammar", _wrap_SchemaValidator_getGrammar},
{"XML::Xercesc::SchemaValidator_setGrammar", _wrap_SchemaValidator_setGrammar},
{"XML::Xercesc::SchemaValidator_normalizeWhiteSpace", _wrap_SchemaValidator_normalizeWhiteSpace},
{"XML::Xercesc::SchemaValidator_setGrammarResolver", _wrap_SchemaValidator_setGrammarResolver},
{"XML::Xercesc::SchemaValidator_setXsiType", _wrap_SchemaValidator_setXsiType},
{"XML::Xercesc::SchemaValidator_setNillable", _wrap_SchemaValidator_setNillable},
{"XML::Xercesc::SchemaValidator_setExitOnFirstFatal", _wrap_SchemaValidator_setExitOnFirstFatal},
{"XML::Xercesc::SchemaValidator_setDatatypeBuffer", _wrap_SchemaValidator_setDatatypeBuffer},
{"XML::Xercesc::SchemaValidator_clearDatatypeBuffer", _wrap_SchemaValidator_clearDatatypeBuffer},
{"XML::Xercesc::SchemaValidator_getCurrentTypeInfo", _wrap_SchemaValidator_getCurrentTypeInfo},
{"XML::Xercesc::SchemaValidator_getCurrentDatatypeValidator", _wrap_SchemaValidator_getCurrentDatatypeValidator},
{"XML::Xercesc::SchemaValidator_getMostRecentAttrValidator", _wrap_SchemaValidator_getMostRecentAttrValidator},
{"XML::Xercesc::SchemaValidator_getErrorOccurred", _wrap_SchemaValidator_getErrorOccurred},
{"XML::Xercesc::SchemaValidator_getIsElemSpecified", _wrap_SchemaValidator_getIsElemSpecified},
{"XML::Xercesc::SchemaValidator_getNormalizedValue", _wrap_SchemaValidator_getNormalizedValue},
{"XML::Xercesc::delete_SchemaAttDefList", _wrap_delete_SchemaAttDefList},
{"XML::Xercesc::SchemaAttDefList_hasMoreElements", _wrap_SchemaAttDefList_hasMoreElements},
{"XML::Xercesc::SchemaAttDefList_isEmpty", _wrap_SchemaAttDefList_isEmpty},
{"XML::Xercesc::SchemaAttDefList_findAttDef", _wrap_SchemaAttDefList_findAttDef},
{"XML::Xercesc::SchemaAttDefList_findAttDefLocalPart", _wrap_SchemaAttDefList_findAttDefLocalPart},
{"XML::Xercesc::SchemaAttDefList_nextElement", _wrap_SchemaAttDefList_nextElement},
{"XML::Xercesc::SchemaAttDefList_Reset", _wrap_SchemaAttDefList_Reset},
{"XML::Xercesc::SchemaAttDefList_getAttDefCount", _wrap_SchemaAttDefList_getAttDefCount},
{"XML::Xercesc::SchemaAttDefList_getAttDef", _wrap_SchemaAttDefList_getAttDef},
{"XML::Xercesc::delete_SchemaAttDef", _wrap_delete_SchemaAttDef},
{"XML::Xercesc::SchemaAttDef_getFullName", _wrap_SchemaAttDef_getFullName},
{"XML::Xercesc::SchemaAttDef_reset", _wrap_SchemaAttDef_reset},
{"XML::Xercesc::SchemaAttDef_getValidity", _wrap_SchemaAttDef_getValidity},
{"XML::Xercesc::SchemaAttDef_getValidationAttempted", _wrap_SchemaAttDef_getValidationAttempted},
{"XML::Xercesc::SchemaAttDef_getTypeType", _wrap_SchemaAttDef_getTypeType},
{"XML::Xercesc::SchemaAttDef_getTypeUri", _wrap_SchemaAttDef_getTypeUri},
{"XML::Xercesc::SchemaAttDef_getTypeName", _wrap_SchemaAttDef_getTypeName},
{"XML::Xercesc::SchemaAttDef_getTypeAnonymous", _wrap_SchemaAttDef_getTypeAnonymous},
{"XML::Xercesc::SchemaAttDef_isTypeDefinitionUnion", _wrap_SchemaAttDef_isTypeDefinitionUnion},
{"XML::Xercesc::SchemaAttDef_getMemberTypeUri", _wrap_SchemaAttDef_getMemberTypeUri},
{"XML::Xercesc::SchemaAttDef_getMemberTypeAnonymous", _wrap_SchemaAttDef_getMemberTypeAnonymous},
{"XML::Xercesc::SchemaAttDef_getMemberTypeName", _wrap_SchemaAttDef_getMemberTypeName},
{"XML::Xercesc::SchemaAttDef_getDOMTypeInfoUri", _wrap_SchemaAttDef_getDOMTypeInfoUri},
{"XML::Xercesc::SchemaAttDef_getDOMTypeInfoName", _wrap_SchemaAttDef_getDOMTypeInfoName},
{"XML::Xercesc::SchemaAttDef_getElemId", _wrap_SchemaAttDef_getElemId},
{"XML::Xercesc::SchemaAttDef_getAttName", _wrap_SchemaAttDef_getAttName},
{"XML::Xercesc::SchemaAttDef_getDatatypeValidator", _wrap_SchemaAttDef_getDatatypeValidator},
{"XML::Xercesc::SchemaAttDef_getNamespaceList", _wrap_SchemaAttDef_getNamespaceList},
{"XML::Xercesc::SchemaAttDef_getBaseAttDecl", _wrap_SchemaAttDef_getBaseAttDecl},
{"XML::Xercesc::SchemaAttDef_getPSVIScope", _wrap_SchemaAttDef_getPSVIScope},
{"XML::Xercesc::SchemaAttDef_getEnclosingCT", _wrap_SchemaAttDef_getEnclosingCT},
{"XML::Xercesc::SchemaAttDef_setElemId", _wrap_SchemaAttDef_setElemId},
{"XML::Xercesc::SchemaAttDef_setAttName", _wrap_SchemaAttDef_setAttName},
{"XML::Xercesc::SchemaAttDef_setDatatypeValidator", _wrap_SchemaAttDef_setDatatypeValidator},
{"XML::Xercesc::SchemaAttDef_setAnyDatatypeValidator", _wrap_SchemaAttDef_setAnyDatatypeValidator},
{"XML::Xercesc::SchemaAttDef_setBaseAttDecl", _wrap_SchemaAttDef_setBaseAttDecl},
{"XML::Xercesc::SchemaAttDef_setPSVIScope", _wrap_SchemaAttDef_setPSVIScope},
{"XML::Xercesc::SchemaAttDef_setMembertypeValidator", _wrap_SchemaAttDef_setMembertypeValidator},
{"XML::Xercesc::SchemaAttDef_setNamespaceList", _wrap_SchemaAttDef_setNamespaceList},
{"XML::Xercesc::SchemaAttDef_resetNamespaceList", _wrap_SchemaAttDef_resetNamespaceList},
{"XML::Xercesc::SchemaAttDef_setValidity", _wrap_SchemaAttDef_setValidity},
{"XML::Xercesc::SchemaAttDef_setValidationAttempted", _wrap_SchemaAttDef_setValidationAttempted},
{"XML::Xercesc::SchemaAttDef_setEnclosingCT", _wrap_SchemaAttDef_setEnclosingCT},
{"XML::Xercesc::delete_InputSource", _wrap_delete_InputSource},
{"XML::Xercesc::InputSource_makeStream", _wrap_InputSource_makeStream},
{"XML::Xercesc::InputSource_getEncoding", _wrap_InputSource_getEncoding},
{"XML::Xercesc::InputSource_getPublicId", _wrap_InputSource_getPublicId},
{"XML::Xercesc::InputSource_getSystemId", _wrap_InputSource_getSystemId},
{"XML::Xercesc::InputSource_getIssueFatalErrorIfNotFound", _wrap_InputSource_getIssueFatalErrorIfNotFound},
{"XML::Xercesc::InputSource_getMemoryManager", _wrap_InputSource_getMemoryManager},
{"XML::Xercesc::InputSource_setEncoding", _wrap_InputSource_setEncoding},
{"XML::Xercesc::InputSource_setPublicId", _wrap_InputSource_setPublicId},
{"XML::Xercesc::InputSource_setSystemId", _wrap_InputSource_setSystemId},
{"XML::Xercesc::InputSource_setIssueFatalErrorIfNotFound", _wrap_InputSource_setIssueFatalErrorIfNotFound},
{"XML::Xercesc::new_LocalFileInputSource", _wrap_new_LocalFileInputSource},
{"XML::Xercesc::delete_LocalFileInputSource", _wrap_delete_LocalFileInputSource},
{"XML::Xercesc::LocalFileInputSource_makeStream", _wrap_LocalFileInputSource_makeStream},
{"XML::Xercesc::new_StdInInputSource", _wrap_new_StdInInputSource},
{"XML::Xercesc::delete_StdInInputSource", _wrap_delete_StdInInputSource},
{"XML::Xercesc::StdInInputSource_makeStream", _wrap_StdInInputSource_makeStream},
{"XML::Xercesc::new_URLInputSource", _wrap_new_URLInputSource},
{"XML::Xercesc::delete_URLInputSource", _wrap_delete_URLInputSource},
{"XML::Xercesc::URLInputSource_makeStream", _wrap_URLInputSource_makeStream},
{"XML::Xercesc::URLInputSource_urlSrc", _wrap_URLInputSource_urlSrc},
{"XML::Xercesc::new_MemBufInputSource", _wrap_new_MemBufInputSource},
{"XML::Xercesc::delete_MemBufInputSource", _wrap_delete_MemBufInputSource},
{"XML::Xercesc::MemBufInputSource_makeStream", _wrap_MemBufInputSource_makeStream},
{"XML::Xercesc::MemBufInputSource_setCopyBufToStream", _wrap_MemBufInputSource_setCopyBufToStream},
{"XML::Xercesc::MemBufInputSource_resetMemBufInputSource", _wrap_MemBufInputSource_resetMemBufInputSource},
{"XML::Xercesc::delete_DOMException", _wrap_delete_DOMException},
{"XML::Xercesc::DOMException_getMessage", _wrap_DOMException_getMessage},
{"XML::Xercesc::DOMException_code_set", _wrap_DOMException_code_set},
{"XML::Xercesc::DOMException_code_get", _wrap_DOMException_code_get},
{"XML::Xercesc::DOMException_msg_set", _wrap_DOMException_msg_set},
{"XML::Xercesc::DOMException_msg_get", _wrap_DOMException_msg_get},
{"XML::Xercesc::delete_DOMNode", _wrap_delete_DOMNode},
{"XML::Xercesc::DOMNode_getNodeName", _wrap_DOMNode_getNodeName},
{"XML::Xercesc::DOMNode_getNodeValue", _wrap_DOMNode_getNodeValue},
{"XML::Xercesc::DOMNode_getNodeType", _wrap_DOMNode_getNodeType},
{"XML::Xercesc::DOMNode_getParentNode", _wrap_DOMNode_getParentNode},
{"XML::Xercesc::DOMNode_getChildNodes", _wrap_DOMNode_getChildNodes},
{"XML::Xercesc::DOMNode_getFirstChild", _wrap_DOMNode_getFirstChild},
{"XML::Xercesc::DOMNode_getLastChild", _wrap_DOMNode_getLastChild},
{"XML::Xercesc::DOMNode_getPreviousSibling", _wrap_DOMNode_getPreviousSibling},
{"XML::Xercesc::DOMNode_getNextSibling", _wrap_DOMNode_getNextSibling},
{"XML::Xercesc::DOMNode_getAttributes", _wrap_DOMNode_getAttributes},
{"XML::Xercesc::DOMNode_getOwnerDocument", _wrap_DOMNode_getOwnerDocument},
{"XML::Xercesc::DOMNode_cloneNode", _wrap_DOMNode_cloneNode},
{"XML::Xercesc::DOMNode_insertBefore", _wrap_DOMNode_insertBefore},
{"XML::Xercesc::DOMNode_replaceChild", _wrap_DOMNode_replaceChild},
{"XML::Xercesc::DOMNode_removeChild", _wrap_DOMNode_removeChild},
{"XML::Xercesc::DOMNode_appendChild", _wrap_DOMNode_appendChild},
{"XML::Xercesc::DOMNode_hasChildNodes", _wrap_DOMNode_hasChildNodes},
{"XML::Xercesc::DOMNode_setNodeValue", _wrap_DOMNode_setNodeValue},
{"XML::Xercesc::DOMNode_normalize", _wrap_DOMNode_normalize},
{"XML::Xercesc::DOMNode_isSupported", _wrap_DOMNode_isSupported},
{"XML::Xercesc::DOMNode_getNamespaceURI", _wrap_DOMNode_getNamespaceURI},
{"XML::Xercesc::DOMNode_getLocalName", _wrap_DOMNode_getLocalName},
{"XML::Xercesc::DOMNode_setPrefix", _wrap_DOMNode_setPrefix},
{"XML::Xercesc::DOMNode_hasAttributes", _wrap_DOMNode_hasAttributes},
{"XML::Xercesc::DOMNode_isSameNode", _wrap_DOMNode_isSameNode},
{"XML::Xercesc::DOMNode_isEqualNode", _wrap_DOMNode_isEqualNode},
{"XML::Xercesc::DOMNode_setUserData", _wrap_DOMNode_setUserData},
{"XML::Xercesc::DOMNode_getUserData", _wrap_DOMNode_getUserData},
{"XML::Xercesc::DOMNode_getBaseURI", _wrap_DOMNode_getBaseURI},
{"XML::Xercesc::DOMNode_compareTreePosition", _wrap_DOMNode_compareTreePosition},
{"XML::Xercesc::DOMNode_getTextContent", _wrap_DOMNode_getTextContent},
{"XML::Xercesc::DOMNode_setTextContent", _wrap_DOMNode_setTextContent},
{"XML::Xercesc::DOMNode_lookupNamespacePrefix", _wrap_DOMNode_lookupNamespacePrefix},
{"XML::Xercesc::DOMNode_isDefaultNamespace", _wrap_DOMNode_isDefaultNamespace},
{"XML::Xercesc::DOMNode_lookupNamespaceURI", _wrap_DOMNode_lookupNamespaceURI},
{"XML::Xercesc::DOMNode_getInterface", _wrap_DOMNode_getInterface},
{"XML::Xercesc::DOMNode_release", _wrap_DOMNode_release},
{"XML::Xercesc::DOMNode___eq__", _wrap_DOMNode___eq__},
{"XML::Xercesc::DOMNode___ne__", _wrap_DOMNode___ne__},
{"XML::Xercesc::delete_DOMAttr", _wrap_delete_DOMAttr},
{"XML::Xercesc::DOMAttr_getName", _wrap_DOMAttr_getName},
{"XML::Xercesc::DOMAttr_getSpecified", _wrap_DOMAttr_getSpecified},
{"XML::Xercesc::DOMAttr_getValue", _wrap_DOMAttr_getValue},
{"XML::Xercesc::DOMAttr_setValue", _wrap_DOMAttr_setValue},
{"XML::Xercesc::DOMAttr_getOwnerElement", _wrap_DOMAttr_getOwnerElement},
{"XML::Xercesc::DOMAttr_isId", _wrap_DOMAttr_isId},
{"XML::Xercesc::DOMAttr_getTypeInfo", _wrap_DOMAttr_getTypeInfo},
{"XML::Xercesc::delete_DOMElement", _wrap_delete_DOMElement},
{"XML::Xercesc::DOMElement_getTagName", _wrap_DOMElement_getTagName},
{"XML::Xercesc::DOMElement_getAttribute", _wrap_DOMElement_getAttribute},
{"XML::Xercesc::DOMElement_getAttributeNode", _wrap_DOMElement_getAttributeNode},
{"XML::Xercesc::DOMElement_getElementsByTagName", _wrap_DOMElement_getElementsByTagName},
{"XML::Xercesc::DOMElement_setAttribute", _wrap_DOMElement_setAttribute},
{"XML::Xercesc::DOMElement_setAttributeNode", _wrap_DOMElement_setAttributeNode},
{"XML::Xercesc::DOMElement_removeAttributeNode", _wrap_DOMElement_removeAttributeNode},
{"XML::Xercesc::DOMElement_removeAttribute", _wrap_DOMElement_removeAttribute},
{"XML::Xercesc::DOMElement_getAttributeNS", _wrap_DOMElement_getAttributeNS},
{"XML::Xercesc::DOMElement_setAttributeNS", _wrap_DOMElement_setAttributeNS},
{"XML::Xercesc::DOMElement_removeAttributeNS", _wrap_DOMElement_removeAttributeNS},
{"XML::Xercesc::DOMElement_getAttributeNodeNS", _wrap_DOMElement_getAttributeNodeNS},
{"XML::Xercesc::DOMElement_setAttributeNodeNS", _wrap_DOMElement_setAttributeNodeNS},
{"XML::Xercesc::DOMElement_getElementsByTagNameNS", _wrap_DOMElement_getElementsByTagNameNS},
{"XML::Xercesc::DOMElement_hasAttribute", _wrap_DOMElement_hasAttribute},
{"XML::Xercesc::DOMElement_hasAttributeNS", _wrap_DOMElement_hasAttributeNS},
{"XML::Xercesc::DOMElement_setIdAttribute", _wrap_DOMElement_setIdAttribute},
{"XML::Xercesc::DOMElement_setIdAttributeNS", _wrap_DOMElement_setIdAttributeNS},
{"XML::Xercesc::DOMElement_setIdAttributeNode", _wrap_DOMElement_setIdAttributeNode},
{"XML::Xercesc::DOMElement_getTypeInfo", _wrap_DOMElement_getTypeInfo},
{"XML::Xercesc::delete_DOMEntity", _wrap_delete_DOMEntity},
{"XML::Xercesc::DOMEntity_getPublicId", _wrap_DOMEntity_getPublicId},
{"XML::Xercesc::DOMEntity_getSystemId", _wrap_DOMEntity_getSystemId},
{"XML::Xercesc::DOMEntity_getNotationName", _wrap_DOMEntity_getNotationName},
{"XML::Xercesc::DOMEntity_getActualEncoding", _wrap_DOMEntity_getActualEncoding},
{"XML::Xercesc::DOMEntity_setActualEncoding", _wrap_DOMEntity_setActualEncoding},
{"XML::Xercesc::DOMEntity_getEncoding", _wrap_DOMEntity_getEncoding},
{"XML::Xercesc::DOMEntity_setEncoding", _wrap_DOMEntity_setEncoding},
{"XML::Xercesc::DOMEntity_getVersion", _wrap_DOMEntity_getVersion},
{"XML::Xercesc::DOMEntity_setVersion", _wrap_DOMEntity_setVersion},
{"XML::Xercesc::delete_DOMDocumentType", _wrap_delete_DOMDocumentType},
{"XML::Xercesc::DOMDocumentType_getName", _wrap_DOMDocumentType_getName},
{"XML::Xercesc::DOMDocumentType_getEntities", _wrap_DOMDocumentType_getEntities},
{"XML::Xercesc::DOMDocumentType_getNotations", _wrap_DOMDocumentType_getNotations},
{"XML::Xercesc::DOMDocumentType_getPublicId", _wrap_DOMDocumentType_getPublicId},
{"XML::Xercesc::DOMDocumentType_getSystemId", _wrap_DOMDocumentType_getSystemId},
{"XML::Xercesc::DOMDocumentType_getInternalSubset", _wrap_DOMDocumentType_getInternalSubset},
{"XML::Xercesc::delete_DOMCharacterData", _wrap_delete_DOMCharacterData},
{"XML::Xercesc::DOMCharacterData_getData", _wrap_DOMCharacterData_getData},
{"XML::Xercesc::DOMCharacterData_getLength", _wrap_DOMCharacterData_getLength},
{"XML::Xercesc::DOMCharacterData_substringData", _wrap_DOMCharacterData_substringData},
{"XML::Xercesc::DOMCharacterData_appendData", _wrap_DOMCharacterData_appendData},
{"XML::Xercesc::DOMCharacterData_insertData", _wrap_DOMCharacterData_insertData},
{"XML::Xercesc::DOMCharacterData_deleteData", _wrap_DOMCharacterData_deleteData},
{"XML::Xercesc::DOMCharacterData_replaceData", _wrap_DOMCharacterData_replaceData},
{"XML::Xercesc::DOMCharacterData_setData", _wrap_DOMCharacterData_setData},
{"XML::Xercesc::delete_DOMComment", _wrap_delete_DOMComment},
{"XML::Xercesc::delete_DOMText", _wrap_delete_DOMText},
{"XML::Xercesc::DOMText_splitText", _wrap_DOMText_splitText},
{"XML::Xercesc::DOMText_getIsWhitespaceInElementContent", _wrap_DOMText_getIsWhitespaceInElementContent},
{"XML::Xercesc::DOMText_getWholeText", _wrap_DOMText_getWholeText},
{"XML::Xercesc::DOMText_replaceWholeText", _wrap_DOMText_replaceWholeText},
{"XML::Xercesc::DOMText_isIgnorableWhitespace", _wrap_DOMText_isIgnorableWhitespace},
{"XML::Xercesc::delete_DOMCDATASection", _wrap_delete_DOMCDATASection},
{"XML::Xercesc::delete_DOMNodeList", _wrap_delete_DOMNodeList},
{"XML::Xercesc::DOMNodeList_item", _wrap_DOMNodeList_item},
{"XML::Xercesc::DOMNodeList_getLength", _wrap_DOMNodeList_getLength},
{"XML::Xercesc::delete_DOMNamedNodeMap", _wrap_delete_DOMNamedNodeMap},
{"XML::Xercesc::DOMNamedNodeMap_setNamedItem", _wrap_DOMNamedNodeMap_setNamedItem},
{"XML::Xercesc::DOMNamedNodeMap_item", _wrap_DOMNamedNodeMap_item},
{"XML::Xercesc::DOMNamedNodeMap_getNamedItem", _wrap_DOMNamedNodeMap_getNamedItem},
{"XML::Xercesc::DOMNamedNodeMap_getLength", _wrap_DOMNamedNodeMap_getLength},
{"XML::Xercesc::DOMNamedNodeMap_removeNamedItem", _wrap_DOMNamedNodeMap_removeNamedItem},
{"XML::Xercesc::DOMNamedNodeMap_getNamedItemNS", _wrap_DOMNamedNodeMap_getNamedItemNS},
{"XML::Xercesc::DOMNamedNodeMap_setNamedItemNS", _wrap_DOMNamedNodeMap_setNamedItemNS},
{"XML::Xercesc::DOMNamedNodeMap_removeNamedItemNS", _wrap_DOMNamedNodeMap_removeNamedItemNS},
{"XML::Xercesc::delete_DOMDocumentFragment", _wrap_delete_DOMDocumentFragment},
{"XML::Xercesc::delete_DOMEntityReference", _wrap_delete_DOMEntityReference},
{"XML::Xercesc::delete_DOMNotation", _wrap_delete_DOMNotation},
{"XML::Xercesc::DOMNotation_getPublicId", _wrap_DOMNotation_getPublicId},
{"XML::Xercesc::DOMNotation_getSystemId", _wrap_DOMNotation_getSystemId},
{"XML::Xercesc::delete_DOMProcessingInstruction", _wrap_delete_DOMProcessingInstruction},
{"XML::Xercesc::DOMProcessingInstruction_getTarget", _wrap_DOMProcessingInstruction_getTarget},
{"XML::Xercesc::DOMProcessingInstruction_getData", _wrap_DOMProcessingInstruction_getData},
{"XML::Xercesc::DOMProcessingInstruction_setData", _wrap_DOMProcessingInstruction_setData},
{"XML::Xercesc::delete_DOMDocumentRange", _wrap_delete_DOMDocumentRange},
{"XML::Xercesc::DOMDocumentRange_createRange", _wrap_DOMDocumentRange_createRange},
{"XML::Xercesc::delete_DOMDocumentTraversal", _wrap_delete_DOMDocumentTraversal},
{"XML::Xercesc::DOMDocumentTraversal_createNodeIterator", _wrap_DOMDocumentTraversal_createNodeIterator},
{"XML::Xercesc::DOMDocumentTraversal_createTreeWalker", _wrap_DOMDocumentTraversal_createTreeWalker},
{"XML::Xercesc::delete_DOMNodeIterator", _wrap_delete_DOMNodeIterator},
{"XML::Xercesc::DOMNodeIterator_getRoot", _wrap_DOMNodeIterator_getRoot},
{"XML::Xercesc::DOMNodeIterator_getWhatToShow", _wrap_DOMNodeIterator_getWhatToShow},
{"XML::Xercesc::DOMNodeIterator_getFilter", _wrap_DOMNodeIterator_getFilter},
{"XML::Xercesc::DOMNodeIterator_getExpandEntityReferences", _wrap_DOMNodeIterator_getExpandEntityReferences},
{"XML::Xercesc::DOMNodeIterator_nextNode", _wrap_DOMNodeIterator_nextNode},
{"XML::Xercesc::DOMNodeIterator_previousNode", _wrap_DOMNodeIterator_previousNode},
{"XML::Xercesc::DOMNodeIterator_detach", _wrap_DOMNodeIterator_detach},
{"XML::Xercesc::DOMNodeIterator_release", _wrap_DOMNodeIterator_release},
{"XML::Xercesc::delete_DOMNodeFilter", _wrap_delete_DOMNodeFilter},
{"XML::Xercesc::DOMNodeFilter_acceptNode", _wrap_DOMNodeFilter_acceptNode},
{"XML::Xercesc::delete_DOMRange", _wrap_delete_DOMRange},
{"XML::Xercesc::DOMRange_getStartContainer", _wrap_DOMRange_getStartContainer},
{"XML::Xercesc::DOMRange_getStartOffset", _wrap_DOMRange_getStartOffset},
{"XML::Xercesc::DOMRange_getEndContainer", _wrap_DOMRange_getEndContainer},
{"XML::Xercesc::DOMRange_getEndOffset", _wrap_DOMRange_getEndOffset},
{"XML::Xercesc::DOMRange_getCollapsed", _wrap_DOMRange_getCollapsed},
{"XML::Xercesc::DOMRange_getCommonAncestorContainer", _wrap_DOMRange_getCommonAncestorContainer},
{"XML::Xercesc::DOMRange_setStart", _wrap_DOMRange_setStart},
{"XML::Xercesc::DOMRange_setEnd", _wrap_DOMRange_setEnd},
{"XML::Xercesc::DOMRange_setStartBefore", _wrap_DOMRange_setStartBefore},
{"XML::Xercesc::DOMRange_setStartAfter", _wrap_DOMRange_setStartAfter},
{"XML::Xercesc::DOMRange_setEndBefore", _wrap_DOMRange_setEndBefore},
{"XML::Xercesc::DOMRange_setEndAfter", _wrap_DOMRange_setEndAfter},
{"XML::Xercesc::DOMRange_collapse", _wrap_DOMRange_collapse},
{"XML::Xercesc::DOMRange_selectNode", _wrap_DOMRange_selectNode},
{"XML::Xercesc::DOMRange_selectNodeContents", _wrap_DOMRange_selectNodeContents},
{"XML::Xercesc::DOMRange_compareBoundaryPoints", _wrap_DOMRange_compareBoundaryPoints},
{"XML::Xercesc::DOMRange_deleteContents", _wrap_DOMRange_deleteContents},
{"XML::Xercesc::DOMRange_extractContents", _wrap_DOMRange_extractContents},
{"XML::Xercesc::DOMRange_cloneContents", _wrap_DOMRange_cloneContents},
{"XML::Xercesc::DOMRange_insertNode", _wrap_DOMRange_insertNode},
{"XML::Xercesc::DOMRange_surroundContents", _wrap_DOMRange_surroundContents},
{"XML::Xercesc::DOMRange_cloneRange", _wrap_DOMRange_cloneRange},
{"XML::Xercesc::DOMRange_toString", _wrap_DOMRange_toString},
{"XML::Xercesc::DOMRange_detach", _wrap_DOMRange_detach},
{"XML::Xercesc::DOMRange_release", _wrap_DOMRange_release},
{"XML::Xercesc::delete_DOMRangeException", _wrap_delete_DOMRangeException},
{"XML::Xercesc::DOMRangeException_code_set", _wrap_DOMRangeException_code_set},
{"XML::Xercesc::DOMRangeException_code_get", _wrap_DOMRangeException_code_get},
{"XML::Xercesc::delete_DOMTreeWalker", _wrap_delete_DOMTreeWalker},
{"XML::Xercesc::DOMTreeWalker_getRoot", _wrap_DOMTreeWalker_getRoot},
{"XML::Xercesc::DOMTreeWalker_getWhatToShow", _wrap_DOMTreeWalker_getWhatToShow},
{"XML::Xercesc::DOMTreeWalker_getFilter", _wrap_DOMTreeWalker_getFilter},
{"XML::Xercesc::DOMTreeWalker_getExpandEntityReferences", _wrap_DOMTreeWalker_getExpandEntityReferences},
{"XML::Xercesc::DOMTreeWalker_getCurrentNode", _wrap_DOMTreeWalker_getCurrentNode},
{"XML::Xercesc::DOMTreeWalker_parentNode", _wrap_DOMTreeWalker_parentNode},
{"XML::Xercesc::DOMTreeWalker_firstChild", _wrap_DOMTreeWalker_firstChild},
{"XML::Xercesc::DOMTreeWalker_lastChild", _wrap_DOMTreeWalker_lastChild},
{"XML::Xercesc::DOMTreeWalker_previousSibling", _wrap_DOMTreeWalker_previousSibling},
{"XML::Xercesc::DOMTreeWalker_nextSibling", _wrap_DOMTreeWalker_nextSibling},
{"XML::Xercesc::DOMTreeWalker_previousNode", _wrap_DOMTreeWalker_previousNode},
{"XML::Xercesc::DOMTreeWalker_nextNode", _wrap_DOMTreeWalker_nextNode},
{"XML::Xercesc::DOMTreeWalker_setCurrentNode", _wrap_DOMTreeWalker_setCurrentNode},
{"XML::Xercesc::DOMTreeWalker_release", _wrap_DOMTreeWalker_release},
{"XML::Xercesc::delete_DOMImplementationLS", _wrap_delete_DOMImplementationLS},
{"XML::Xercesc::DOMImplementationLS_createDOMBuilder", _wrap_DOMImplementationLS_createDOMBuilder},
{"XML::Xercesc::DOMImplementationLS_createDOMWriter", _wrap_DOMImplementationLS_createDOMWriter},
{"XML::Xercesc::DOMImplementationLS_createDOMInputSource", _wrap_DOMImplementationLS_createDOMInputSource},
{"XML::Xercesc::delete_DOMImplementation", _wrap_delete_DOMImplementation},
{"XML::Xercesc::DOMImplementation_hasFeature", _wrap_DOMImplementation_hasFeature},
{"XML::Xercesc::DOMImplementation_createDocumentType", _wrap_DOMImplementation_createDocumentType},
{"XML::Xercesc::DOMImplementation_getInterface", _wrap_DOMImplementation_getInterface},
{"XML::Xercesc::DOMImplementation_createDocument", _wrap_DOMImplementation_createDocument},
{"XML::Xercesc::DOMImplementation_getImplementation", _wrap_DOMImplementation_getImplementation},
{"XML::Xercesc::delete_DOMImplementationSource", _wrap_delete_DOMImplementationSource},
{"XML::Xercesc::DOMImplementationSource_getDOMImplementation", _wrap_DOMImplementationSource_getDOMImplementation},
{"XML::Xercesc::DOMImplementationRegistry_getDOMImplementation", _wrap_DOMImplementationRegistry_getDOMImplementation},
{"XML::Xercesc::DOMImplementationRegistry_addSource", _wrap_DOMImplementationRegistry_addSource},
{"XML::Xercesc::delete_DOMImplementationRegistry", _wrap_delete_DOMImplementationRegistry},
{"XML::Xercesc::delete_DOMErrorHandler", _wrap_delete_DOMErrorHandler},
{"XML::Xercesc::DOMErrorHandler_handleError", _wrap_DOMErrorHandler_handleError},
{"XML::Xercesc::delete_DOMEntityResolver", _wrap_delete_DOMEntityResolver},
{"XML::Xercesc::delete_DOMDocument", _wrap_delete_DOMDocument},
{"XML::Xercesc::DOMDocument_createElement", _wrap_DOMDocument_createElement},
{"XML::Xercesc::DOMDocument_createDocumentFragment", _wrap_DOMDocument_createDocumentFragment},
{"XML::Xercesc::DOMDocument_createTextNode", _wrap_DOMDocument_createTextNode},
{"XML::Xercesc::DOMDocument_createComment", _wrap_DOMDocument_createComment},
{"XML::Xercesc::DOMDocument_createCDATASection", _wrap_DOMDocument_createCDATASection},
{"XML::Xercesc::DOMDocument_createProcessingInstruction", _wrap_DOMDocument_createProcessingInstruction},
{"XML::Xercesc::DOMDocument_createAttribute", _wrap_DOMDocument_createAttribute},
{"XML::Xercesc::DOMDocument_createEntityReference", _wrap_DOMDocument_createEntityReference},
{"XML::Xercesc::DOMDocument_getDoctype", _wrap_DOMDocument_getDoctype},
{"XML::Xercesc::DOMDocument_getImplementation", _wrap_DOMDocument_getImplementation},
{"XML::Xercesc::DOMDocument_getDocumentElement", _wrap_DOMDocument_getDocumentElement},
{"XML::Xercesc::DOMDocument_getElementsByTagName", _wrap_DOMDocument_getElementsByTagName},
{"XML::Xercesc::DOMDocument_importNode", _wrap_DOMDocument_importNode},
{"XML::Xercesc::DOMDocument_createAttributeNS", _wrap_DOMDocument_createAttributeNS},
{"XML::Xercesc::DOMDocument_getElementsByTagNameNS", _wrap_DOMDocument_getElementsByTagNameNS},
{"XML::Xercesc::DOMDocument_getElementById", _wrap_DOMDocument_getElementById},
{"XML::Xercesc::DOMDocument_getActualEncoding", _wrap_DOMDocument_getActualEncoding},
{"XML::Xercesc::DOMDocument_setActualEncoding", _wrap_DOMDocument_setActualEncoding},
{"XML::Xercesc::DOMDocument_getEncoding", _wrap_DOMDocument_getEncoding},
{"XML::Xercesc::DOMDocument_setEncoding", _wrap_DOMDocument_setEncoding},
{"XML::Xercesc::DOMDocument_getStandalone", _wrap_DOMDocument_getStandalone},
{"XML::Xercesc::DOMDocument_setStandalone", _wrap_DOMDocument_setStandalone},
{"XML::Xercesc::DOMDocument_getVersion", _wrap_DOMDocument_getVersion},
{"XML::Xercesc::DOMDocument_setVersion", _wrap_DOMDocument_setVersion},
{"XML::Xercesc::DOMDocument_getDocumentURI", _wrap_DOMDocument_getDocumentURI},
{"XML::Xercesc::DOMDocument_setDocumentURI", _wrap_DOMDocument_setDocumentURI},
{"XML::Xercesc::DOMDocument_getStrictErrorChecking", _wrap_DOMDocument_getStrictErrorChecking},
{"XML::Xercesc::DOMDocument_setStrictErrorChecking", _wrap_DOMDocument_setStrictErrorChecking},
{"XML::Xercesc::DOMDocument_renameNode", _wrap_DOMDocument_renameNode},
{"XML::Xercesc::DOMDocument_adoptNode", _wrap_DOMDocument_adoptNode},
{"XML::Xercesc::DOMDocument_normalizeDocument", _wrap_DOMDocument_normalizeDocument},
{"XML::Xercesc::DOMDocument_getDOMConfiguration", _wrap_DOMDocument_getDOMConfiguration},
{"XML::Xercesc::DOMDocument_createEntity", _wrap_DOMDocument_createEntity},
{"XML::Xercesc::DOMDocument_createDocumentType", _wrap_DOMDocument_createDocumentType},
{"XML::Xercesc::DOMDocument_createNotation", _wrap_DOMDocument_createNotation},
{"XML::Xercesc::DOMDocument_createElementNS", _wrap_DOMDocument_createElementNS},
{"XML::Xercesc::delete_DOMLocator", _wrap_delete_DOMLocator},
{"XML::Xercesc::DOMLocator_getLineNumber", _wrap_DOMLocator_getLineNumber},
{"XML::Xercesc::DOMLocator_getColumnNumber", _wrap_DOMLocator_getColumnNumber},
{"XML::Xercesc::DOMLocator_getOffset", _wrap_DOMLocator_getOffset},
{"XML::Xercesc::DOMLocator_getErrorNode", _wrap_DOMLocator_getErrorNode},
{"XML::Xercesc::DOMLocator_getURI", _wrap_DOMLocator_getURI},
{"XML::Xercesc::DOMLocator_setLineNumber", _wrap_DOMLocator_setLineNumber},
{"XML::Xercesc::DOMLocator_setColumnNumber", _wrap_DOMLocator_setColumnNumber},
{"XML::Xercesc::DOMLocator_setOffset", _wrap_DOMLocator_setOffset},
{"XML::Xercesc::DOMLocator_setErrorNode", _wrap_DOMLocator_setErrorNode},
{"XML::Xercesc::DOMLocator_setURI", _wrap_DOMLocator_setURI},
{"XML::Xercesc::delete_DOMInputSource", _wrap_delete_DOMInputSource},
{"XML::Xercesc::DOMInputSource_getEncoding", _wrap_DOMInputSource_getEncoding},
{"XML::Xercesc::DOMInputSource_getPublicId", _wrap_DOMInputSource_getPublicId},
{"XML::Xercesc::DOMInputSource_getSystemId", _wrap_DOMInputSource_getSystemId},
{"XML::Xercesc::DOMInputSource_getBaseURI", _wrap_DOMInputSource_getBaseURI},
{"XML::Xercesc::DOMInputSource_setEncoding", _wrap_DOMInputSource_setEncoding},
{"XML::Xercesc::DOMInputSource_setPublicId", _wrap_DOMInputSource_setPublicId},
{"XML::Xercesc::DOMInputSource_setSystemId", _wrap_DOMInputSource_setSystemId},
{"XML::Xercesc::DOMInputSource_setBaseURI", _wrap_DOMInputSource_setBaseURI},
{"XML::Xercesc::DOMInputSource_makeStream", _wrap_DOMInputSource_makeStream},
{"XML::Xercesc::DOMInputSource_setIssueFatalErrorIfNotFound", _wrap_DOMInputSource_setIssueFatalErrorIfNotFound},
{"XML::Xercesc::DOMInputSource_getIssueFatalErrorIfNotFound", _wrap_DOMInputSource_getIssueFatalErrorIfNotFound},
{"XML::Xercesc::DOMInputSource_release", _wrap_DOMInputSource_release},
{"XML::Xercesc::new_Wrapper4InputSource", _wrap_new_Wrapper4InputSource},
{"XML::Xercesc::delete_Wrapper4InputSource", _wrap_delete_Wrapper4InputSource},
{"XML::Xercesc::Wrapper4InputSource_makeStream", _wrap_Wrapper4InputSource_makeStream},
{"XML::Xercesc::Wrapper4InputSource_getEncoding", _wrap_Wrapper4InputSource_getEncoding},
{"XML::Xercesc::Wrapper4InputSource_getPublicId", _wrap_Wrapper4InputSource_getPublicId},
{"XML::Xercesc::Wrapper4InputSource_getSystemId", _wrap_Wrapper4InputSource_getSystemId},
{"XML::Xercesc::Wrapper4InputSource_getBaseURI", _wrap_Wrapper4InputSource_getBaseURI},
{"XML::Xercesc::Wrapper4InputSource_getIssueFatalErrorIfNotFound", _wrap_Wrapper4InputSource_getIssueFatalErrorIfNotFound},
{"XML::Xercesc::Wrapper4InputSource_setEncoding", _wrap_Wrapper4InputSource_setEncoding},
{"XML::Xercesc::Wrapper4InputSource_setPublicId", _wrap_Wrapper4InputSource_setPublicId},
{"XML::Xercesc::Wrapper4InputSource_setSystemId", _wrap_Wrapper4InputSource_setSystemId},
{"XML::Xercesc::Wrapper4InputSource_setBaseURI", _wrap_Wrapper4InputSource_setBaseURI},
{"XML::Xercesc::Wrapper4InputSource_setIssueFatalErrorIfNotFound", _wrap_Wrapper4InputSource_setIssueFatalErrorIfNotFound},
{"XML::Xercesc::Wrapper4InputSource_release", _wrap_Wrapper4InputSource_release},
{"XML::Xercesc::new_Wrapper4DOMInputSource", _wrap_new_Wrapper4DOMInputSource},
{"XML::Xercesc::delete_Wrapper4DOMInputSource", _wrap_delete_Wrapper4DOMInputSource},
{"XML::Xercesc::Wrapper4DOMInputSource_makeStream", _wrap_Wrapper4DOMInputSource_makeStream},
{"XML::Xercesc::Wrapper4DOMInputSource_getEncoding", _wrap_Wrapper4DOMInputSource_getEncoding},
{"XML::Xercesc::Wrapper4DOMInputSource_getPublicId", _wrap_Wrapper4DOMInputSource_getPublicId},
{"XML::Xercesc::Wrapper4DOMInputSource_getSystemId", _wrap_Wrapper4DOMInputSource_getSystemId},
{"XML::Xercesc::Wrapper4DOMInputSource_getIssueFatalErrorIfNotFound", _wrap_Wrapper4DOMInputSource_getIssueFatalErrorIfNotFound},
{"XML::Xercesc::Wrapper4DOMInputSource_setEncoding", _wrap_Wrapper4DOMInputSource_setEncoding},
{"XML::Xercesc::Wrapper4DOMInputSource_setPublicId", _wrap_Wrapper4DOMInputSource_setPublicId},
{"XML::Xercesc::Wrapper4DOMInputSource_setSystemId", _wrap_Wrapper4DOMInputSource_setSystemId},
{"XML::Xercesc::Wrapper4DOMInputSource_setIssueFatalErrorIfNotFound", _wrap_Wrapper4DOMInputSource_setIssueFatalErrorIfNotFound},
{"XML::Xercesc::delete_DOMBuilder", _wrap_delete_DOMBuilder},
{"XML::Xercesc::DOMBuilder_getErrorHandler", _wrap_DOMBuilder_getErrorHandler},
{"XML::Xercesc::DOMBuilder_getEntityResolver", _wrap_DOMBuilder_getEntityResolver},
{"XML::Xercesc::DOMBuilder_getFilter", _wrap_DOMBuilder_getFilter},
{"XML::Xercesc::DOMBuilder_setErrorHandler", _wrap_DOMBuilder_setErrorHandler},
{"XML::Xercesc::DOMBuilder_setEntityResolver", _wrap_DOMBuilder_setEntityResolver},
{"XML::Xercesc::DOMBuilder_setFilter", _wrap_DOMBuilder_setFilter},
{"XML::Xercesc::DOMBuilder_setFeature", _wrap_DOMBuilder_setFeature},
{"XML::Xercesc::DOMBuilder_getFeature", _wrap_DOMBuilder_getFeature},
{"XML::Xercesc::DOMBuilder_canSetFeature", _wrap_DOMBuilder_canSetFeature},
{"XML::Xercesc::DOMBuilder_parse", _wrap_DOMBuilder_parse},
{"XML::Xercesc::DOMBuilder_parseURI", _wrap_DOMBuilder_parseURI},
{"XML::Xercesc::DOMBuilder_parseWithContext", _wrap_DOMBuilder_parseWithContext},
{"XML::Xercesc::DOMBuilder_getProperty", _wrap_DOMBuilder_getProperty},
{"XML::Xercesc::DOMBuilder_setProperty", _wrap_DOMBuilder_setProperty},
{"XML::Xercesc::DOMBuilder_release", _wrap_DOMBuilder_release},
{"XML::Xercesc::DOMBuilder_resetDocumentPool", _wrap_DOMBuilder_resetDocumentPool},
{"XML::Xercesc::DOMBuilder_loadGrammar", _wrap_DOMBuilder_loadGrammar},
{"XML::Xercesc::DOMBuilder_getGrammar", _wrap_DOMBuilder_getGrammar},
{"XML::Xercesc::DOMBuilder_getRootGrammar", _wrap_DOMBuilder_getRootGrammar},
{"XML::Xercesc::DOMBuilder_getURIText", _wrap_DOMBuilder_getURIText},
{"XML::Xercesc::DOMBuilder_resetCachedGrammarPool", _wrap_DOMBuilder_resetCachedGrammarPool},
{"XML::Xercesc::DOMBuilder_getSrcOffset", _wrap_DOMBuilder_getSrcOffset},
{"XML::Xercesc::new_StdOutFormatTarget", _wrap_new_StdOutFormatTarget},
{"XML::Xercesc::delete_StdOutFormatTarget", _wrap_delete_StdOutFormatTarget},
{"XML::Xercesc::StdOutFormatTarget_writeChars", _wrap_StdOutFormatTarget_writeChars},
{"XML::Xercesc::StdOutFormatTarget_flush", _wrap_StdOutFormatTarget_flush},
{"XML::Xercesc::new_LocalFileFormatTarget", _wrap_new_LocalFileFormatTarget},
{"XML::Xercesc::delete_LocalFileFormatTarget", _wrap_delete_LocalFileFormatTarget},
{"XML::Xercesc::LocalFileFormatTarget_writeChars", _wrap_LocalFileFormatTarget_writeChars},
{"XML::Xercesc::LocalFileFormatTarget_flush", _wrap_LocalFileFormatTarget_flush},
{"XML::Xercesc::new_MemBufFormatTarget", _wrap_new_MemBufFormatTarget},
{"XML::Xercesc::delete_MemBufFormatTarget", _wrap_delete_MemBufFormatTarget},
{"XML::Xercesc::MemBufFormatTarget_writeChars", _wrap_MemBufFormatTarget_writeChars},
{"XML::Xercesc::MemBufFormatTarget_getRawBuffer", _wrap_MemBufFormatTarget_getRawBuffer},
{"XML::Xercesc::MemBufFormatTarget_getLen", _wrap_MemBufFormatTarget_getLen},
{"XML::Xercesc::MemBufFormatTarget_reset", _wrap_MemBufFormatTarget_reset},
{"XML::Xercesc::delete_DOMWriter", _wrap_delete_DOMWriter},
{"XML::Xercesc::DOMWriter_canSetFeature", _wrap_DOMWriter_canSetFeature},
{"XML::Xercesc::DOMWriter_setFeature", _wrap_DOMWriter_setFeature},
{"XML::Xercesc::DOMWriter_getFeature", _wrap_DOMWriter_getFeature},
{"XML::Xercesc::DOMWriter_setEncoding", _wrap_DOMWriter_setEncoding},
{"XML::Xercesc::DOMWriter_setNewLine", _wrap_DOMWriter_setNewLine},
{"XML::Xercesc::DOMWriter_setErrorHandler", _wrap_DOMWriter_setErrorHandler},
{"XML::Xercesc::DOMWriter_setFilter", _wrap_DOMWriter_setFilter},
{"XML::Xercesc::DOMWriter_getEncoding", _wrap_DOMWriter_getEncoding},
{"XML::Xercesc::DOMWriter_getNewLine", _wrap_DOMWriter_getNewLine},
{"XML::Xercesc::DOMWriter_writeNode", _wrap_DOMWriter_writeNode},
{"XML::Xercesc::DOMWriter_writeToString", _wrap_DOMWriter_writeToString},
{"XML::Xercesc::DOMWriter_release", _wrap_DOMWriter_release},
{"XML::Xercesc::delete_DOMWriterFilter", _wrap_delete_DOMWriterFilter},
{"XML::Xercesc::DOMWriterFilter_acceptNode", _wrap_DOMWriterFilter_acceptNode},
{"XML::Xercesc::DOMWriterFilter_getWhatToShow", _wrap_DOMWriterFilter_getWhatToShow},
{"XML::Xercesc::DOMWriterFilter_setWhatToShow", _wrap_DOMWriterFilter_setWhatToShow},
{"XML::Xercesc::delete_SAXException", _wrap_delete_SAXException},
{"XML::Xercesc::SAXException_getMessage", _wrap_SAXException_getMessage},
{"XML::Xercesc::new_SAXNotSupportedException", _wrap_new_SAXNotSupportedException},
{"XML::Xercesc::delete_SAXNotSupportedException", _wrap_delete_SAXNotSupportedException},
{"XML::Xercesc::new_SAXNotRecognizedException", _wrap_new_SAXNotRecognizedException},
{"XML::Xercesc::delete_SAXNotRecognizedException", _wrap_delete_SAXNotRecognizedException},
{"XML::Xercesc::delete_SAXParseException", _wrap_delete_SAXParseException},
{"XML::Xercesc::SAXParseException_getColumnNumber", _wrap_SAXParseException_getColumnNumber},
{"XML::Xercesc::SAXParseException_getLineNumber", _wrap_SAXParseException_getLineNumber},
{"XML::Xercesc::SAXParseException_getPublicId", _wrap_SAXParseException_getPublicId},
{"XML::Xercesc::SAXParseException_getSystemId", _wrap_SAXParseException_getSystemId},
{"XML::Xercesc::delete_ErrorHandler", _wrap_delete_ErrorHandler},
{"XML::Xercesc::ErrorHandler_warning", _wrap_ErrorHandler_warning},
{"XML::Xercesc::ErrorHandler_error", _wrap_ErrorHandler_error},
{"XML::Xercesc::ErrorHandler_fatalError", _wrap_ErrorHandler_fatalError},
{"XML::Xercesc::ErrorHandler_resetErrors", _wrap_ErrorHandler_resetErrors},
{"XML::Xercesc::delete_DTDHandler", _wrap_delete_DTDHandler},
{"XML::Xercesc::DTDHandler_unparsedEntityDecl", _wrap_DTDHandler_unparsedEntityDecl},
{"XML::Xercesc::delete_DocumentHandler", _wrap_delete_DocumentHandler},
{"XML::Xercesc::DocumentHandler_characters", _wrap_DocumentHandler_characters},
{"XML::Xercesc::DocumentHandler_processingInstruction", _wrap_DocumentHandler_processingInstruction},
{"XML::Xercesc::DocumentHandler_setDocumentLocator", _wrap_DocumentHandler_setDocumentLocator},
{"XML::Xercesc::delete_EntityResolver", _wrap_delete_EntityResolver},
{"XML::Xercesc::delete_AttributeList", _wrap_delete_AttributeList},
{"XML::Xercesc::AttributeList_getLength", _wrap_AttributeList_getLength},
{"XML::Xercesc::AttributeList_getName", _wrap_AttributeList_getName},
{"XML::Xercesc::AttributeList_getType", _wrap_AttributeList_getType},
{"XML::Xercesc::AttributeList_getValue", _wrap_AttributeList_getValue},
{"XML::Xercesc::HandlerBase_characters", _wrap_HandlerBase_characters},
{"XML::Xercesc::HandlerBase_processingInstruction", _wrap_HandlerBase_processingInstruction},
{"XML::Xercesc::HandlerBase_setDocumentLocator", _wrap_HandlerBase_setDocumentLocator},
{"XML::Xercesc::HandlerBase_error", _wrap_HandlerBase_error},
{"XML::Xercesc::HandlerBase_fatalError", _wrap_HandlerBase_fatalError},
{"XML::Xercesc::HandlerBase_warning", _wrap_HandlerBase_warning},
{"XML::Xercesc::HandlerBase_resetErrors", _wrap_HandlerBase_resetErrors},
{"XML::Xercesc::HandlerBase_unparsedEntityDecl", _wrap_HandlerBase_unparsedEntityDecl},
{"XML::Xercesc::new_HandlerBase", _wrap_new_HandlerBase},
{"XML::Xercesc::delete_HandlerBase", _wrap_delete_HandlerBase},
{"XML::Xercesc::delete_Locator", _wrap_delete_Locator},
{"XML::Xercesc::Locator_getPublicId", _wrap_Locator_getPublicId},
{"XML::Xercesc::Locator_getSystemId", _wrap_Locator_getSystemId},
{"XML::Xercesc::Locator_getLineNumber", _wrap_Locator_getLineNumber},
{"XML::Xercesc::Locator_getColumnNumber", _wrap_Locator_getColumnNumber},
{"XML::Xercesc::delete_Attributes", _wrap_delete_Attributes},
{"XML::Xercesc::Attributes_getLength", _wrap_Attributes_getLength},
{"XML::Xercesc::Attributes_getURI", _wrap_Attributes_getURI},
{"XML::Xercesc::Attributes_getLocalName", _wrap_Attributes_getLocalName},
{"XML::Xercesc::Attributes_getQName", _wrap_Attributes_getQName},
{"XML::Xercesc::Attributes_getIndex", _wrap_Attributes_getIndex},
{"XML::Xercesc::Attributes_getType", _wrap_Attributes_getType},
{"XML::Xercesc::Attributes_getValue", _wrap_Attributes_getValue},
{"XML::Xercesc::delete_ContentHandler", _wrap_delete_ContentHandler},
{"XML::Xercesc::ContentHandler_characters", _wrap_ContentHandler_characters},
{"XML::Xercesc::ContentHandler_processingInstruction", _wrap_ContentHandler_processingInstruction},
{"XML::Xercesc::ContentHandler_setDocumentLocator", _wrap_ContentHandler_setDocumentLocator},
{"XML::Xercesc::ContentHandler_startPrefixMapping", _wrap_ContentHandler_startPrefixMapping},
{"XML::Xercesc::ContentHandler_endPrefixMapping", _wrap_ContentHandler_endPrefixMapping},
{"XML::Xercesc::ContentHandler_skippedEntity", _wrap_ContentHandler_skippedEntity},
{"XML::Xercesc::delete_LexicalHandler", _wrap_delete_LexicalHandler},
{"XML::Xercesc::LexicalHandler_comment", _wrap_LexicalHandler_comment},
{"XML::Xercesc::LexicalHandler_endCDATA", _wrap_LexicalHandler_endCDATA},
{"XML::Xercesc::LexicalHandler_endDTD", _wrap_LexicalHandler_endDTD},
{"XML::Xercesc::LexicalHandler_endEntity", _wrap_LexicalHandler_endEntity},
{"XML::Xercesc::LexicalHandler_startCDATA", _wrap_LexicalHandler_startCDATA},
{"XML::Xercesc::LexicalHandler_startDTD", _wrap_LexicalHandler_startDTD},
{"XML::Xercesc::LexicalHandler_startEntity", _wrap_LexicalHandler_startEntity},
{"XML::Xercesc::delete_DeclHandler", _wrap_delete_DeclHandler},
{"XML::Xercesc::DeclHandler_attributeDecl", _wrap_DeclHandler_attributeDecl},
{"XML::Xercesc::DeclHandler_internalEntityDecl", _wrap_DeclHandler_internalEntityDecl},
{"XML::Xercesc::DeclHandler_externalEntityDecl", _wrap_DeclHandler_externalEntityDecl},
{"XML::Xercesc::DefaultHandler_characters", _wrap_DefaultHandler_characters},
{"XML::Xercesc::DefaultHandler_processingInstruction", _wrap_DefaultHandler_processingInstruction},
{"XML::Xercesc::DefaultHandler_setDocumentLocator", _wrap_DefaultHandler_setDocumentLocator},
{"XML::Xercesc::DefaultHandler_startPrefixMapping", _wrap_DefaultHandler_startPrefixMapping},
{"XML::Xercesc::DefaultHandler_endPrefixMapping", _wrap_DefaultHandler_endPrefixMapping},
{"XML::Xercesc::DefaultHandler_skippedEntity", _wrap_DefaultHandler_skippedEntity},
{"XML::Xercesc::DefaultHandler_error", _wrap_DefaultHandler_error},
{"XML::Xercesc::DefaultHandler_fatalError", _wrap_DefaultHandler_fatalError},
{"XML::Xercesc::DefaultHandler_warning", _wrap_DefaultHandler_warning},
{"XML::Xercesc::DefaultHandler_resetErrors", _wrap_DefaultHandler_resetErrors},
{"XML::Xercesc::DefaultHandler_unparsedEntityDecl", _wrap_DefaultHandler_unparsedEntityDecl},
{"XML::Xercesc::DefaultHandler_comment", _wrap_DefaultHandler_comment},
{"XML::Xercesc::DefaultHandler_endCDATA", _wrap_DefaultHandler_endCDATA},
{"XML::Xercesc::DefaultHandler_endDTD", _wrap_DefaultHandler_endDTD},
{"XML::Xercesc::DefaultHandler_endEntity", _wrap_DefaultHandler_endEntity},
{"XML::Xercesc::DefaultHandler_startCDATA", _wrap_DefaultHandler_startCDATA},
{"XML::Xercesc::DefaultHandler_startDTD", _wrap_DefaultHandler_startDTD},
{"XML::Xercesc::DefaultHandler_startEntity", _wrap_DefaultHandler_startEntity},
{"XML::Xercesc::DefaultHandler_attributeDecl", _wrap_DefaultHandler_attributeDecl},
{"XML::Xercesc::DefaultHandler_internalEntityDecl", _wrap_DefaultHandler_internalEntityDecl},
{"XML::Xercesc::DefaultHandler_externalEntityDecl", _wrap_DefaultHandler_externalEntityDecl},
{"XML::Xercesc::new_DefaultHandler", _wrap_new_DefaultHandler},
{"XML::Xercesc::delete_DefaultHandler", _wrap_delete_DefaultHandler},
{"XML::Xercesc::new_XMLPScanToken", _wrap_new_XMLPScanToken},
{"XML::Xercesc::delete_XMLPScanToken", _wrap_delete_XMLPScanToken},
{"XML::Xercesc::delete_PSVIHandler", _wrap_delete_PSVIHandler},
{"XML::Xercesc::PSVIHandler_handleElementPSVI", _wrap_PSVIHandler_handleElementPSVI},
{"XML::Xercesc::PSVIHandler_handlePartialElementPSVI", _wrap_PSVIHandler_handlePartialElementPSVI},
{"XML::Xercesc::PSVIHandler_handleAttributesPSVI", _wrap_PSVIHandler_handleAttributesPSVI},
{"XML::Xercesc::delete_Parser", _wrap_delete_Parser},
{"XML::Xercesc::Parser_setEntityResolver", _wrap_Parser_setEntityResolver},
{"XML::Xercesc::Parser_setDTDHandler", _wrap_Parser_setDTDHandler},
{"XML::Xercesc::Parser_setDocumentHandler", _wrap_Parser_setDocumentHandler},
{"XML::Xercesc::Parser_setErrorHandler", _wrap_Parser_setErrorHandler},
{"XML::Xercesc::Parser_parse", _wrap_Parser_parse},
{"XML::Xercesc::delete_AbstractDOMParser", _wrap_delete_AbstractDOMParser},
{"XML::Xercesc::AbstractDOMParser_reset", _wrap_AbstractDOMParser_reset},
{"XML::Xercesc::AbstractDOMParser_adoptDocument", _wrap_AbstractDOMParser_adoptDocument},
{"XML::Xercesc::AbstractDOMParser_getDocument", _wrap_AbstractDOMParser_getDocument},
{"XML::Xercesc::AbstractDOMParser_getValidator", _wrap_AbstractDOMParser_getValidator},
{"XML::Xercesc::AbstractDOMParser_getValidationScheme", _wrap_AbstractDOMParser_getValidationScheme},
{"XML::Xercesc::AbstractDOMParser_getDoSchema", _wrap_AbstractDOMParser_getDoSchema},
{"XML::Xercesc::AbstractDOMParser_getValidationSchemaFullChecking", _wrap_AbstractDOMParser_getValidationSchemaFullChecking},
{"XML::Xercesc::AbstractDOMParser_getIdentityConstraintChecking", _wrap_AbstractDOMParser_getIdentityConstraintChecking},
{"XML::Xercesc::AbstractDOMParser_getErrorCount", _wrap_AbstractDOMParser_getErrorCount},
{"XML::Xercesc::AbstractDOMParser_getDoNamespaces", _wrap_AbstractDOMParser_getDoNamespaces},
{"XML::Xercesc::AbstractDOMParser_getExitOnFirstFatalError", _wrap_AbstractDOMParser_getExitOnFirstFatalError},
{"XML::Xercesc::AbstractDOMParser_getValidationConstraintFatal", _wrap_AbstractDOMParser_getValidationConstraintFatal},
{"XML::Xercesc::AbstractDOMParser_getCreateEntityReferenceNodes", _wrap_AbstractDOMParser_getCreateEntityReferenceNodes},
{"XML::Xercesc::AbstractDOMParser_getIncludeIgnorableWhitespace", _wrap_AbstractDOMParser_getIncludeIgnorableWhitespace},
{"XML::Xercesc::AbstractDOMParser_getExternalSchemaLocation", _wrap_AbstractDOMParser_getExternalSchemaLocation},
{"XML::Xercesc::AbstractDOMParser_getExternalNoNamespaceSchemaLocation", _wrap_AbstractDOMParser_getExternalNoNamespaceSchemaLocation},
{"XML::Xercesc::AbstractDOMParser_getSecurityManager", _wrap_AbstractDOMParser_getSecurityManager},
{"XML::Xercesc::AbstractDOMParser_getLoadExternalDTD", _wrap_AbstractDOMParser_getLoadExternalDTD},
{"XML::Xercesc::AbstractDOMParser_getCreateCommentNodes", _wrap_AbstractDOMParser_getCreateCommentNodes},
{"XML::Xercesc::AbstractDOMParser_getCalculateSrcOfs", _wrap_AbstractDOMParser_getCalculateSrcOfs},
{"XML::Xercesc::AbstractDOMParser_getStandardUriConformant", _wrap_AbstractDOMParser_getStandardUriConformant},
{"XML::Xercesc::AbstractDOMParser_getPSVIHandler", _wrap_AbstractDOMParser_getPSVIHandler},
{"XML::Xercesc::AbstractDOMParser_getCreateSchemaInfo", _wrap_AbstractDOMParser_getCreateSchemaInfo},
{"XML::Xercesc::AbstractDOMParser_getGenerateSyntheticAnnotations", _wrap_AbstractDOMParser_getGenerateSyntheticAnnotations},
{"XML::Xercesc::AbstractDOMParser_getValidateAnnotations", _wrap_AbstractDOMParser_getValidateAnnotations},
{"XML::Xercesc::AbstractDOMParser_getIgnoreAnnotations", _wrap_AbstractDOMParser_getIgnoreAnnotations},
{"XML::Xercesc::AbstractDOMParser_getDisableDefaultEntityResolution", _wrap_AbstractDOMParser_getDisableDefaultEntityResolution},
{"XML::Xercesc::AbstractDOMParser_getSkipDTDValidation", _wrap_AbstractDOMParser_getSkipDTDValidation},
{"XML::Xercesc::AbstractDOMParser_setGenerateSyntheticAnnotations", _wrap_AbstractDOMParser_setGenerateSyntheticAnnotations},
{"XML::Xercesc::AbstractDOMParser_setValidateAnnotations", _wrap_AbstractDOMParser_setValidateAnnotations},
{"XML::Xercesc::AbstractDOMParser_setDoNamespaces", _wrap_AbstractDOMParser_setDoNamespaces},
{"XML::Xercesc::AbstractDOMParser_setExitOnFirstFatalError", _wrap_AbstractDOMParser_setExitOnFirstFatalError},
{"XML::Xercesc::AbstractDOMParser_setValidationConstraintFatal", _wrap_AbstractDOMParser_setValidationConstraintFatal},
{"XML::Xercesc::AbstractDOMParser_setCreateEntityReferenceNodes", _wrap_AbstractDOMParser_setCreateEntityReferenceNodes},
{"XML::Xercesc::AbstractDOMParser_setIncludeIgnorableWhitespace", _wrap_AbstractDOMParser_setIncludeIgnorableWhitespace},
{"XML::Xercesc::AbstractDOMParser_setValidationScheme", _wrap_AbstractDOMParser_setValidationScheme},
{"XML::Xercesc::AbstractDOMParser_setDoSchema", _wrap_AbstractDOMParser_setDoSchema},
{"XML::Xercesc::AbstractDOMParser_setValidationSchemaFullChecking", _wrap_AbstractDOMParser_setValidationSchemaFullChecking},
{"XML::Xercesc::AbstractDOMParser_setIdentityConstraintChecking", _wrap_AbstractDOMParser_setIdentityConstraintChecking},
{"XML::Xercesc::AbstractDOMParser_setExternalSchemaLocation", _wrap_AbstractDOMParser_setExternalSchemaLocation},
{"XML::Xercesc::AbstractDOMParser_setExternalNoNamespaceSchemaLocation", _wrap_AbstractDOMParser_setExternalNoNamespaceSchemaLocation},
{"XML::Xercesc::AbstractDOMParser_setSecurityManager", _wrap_AbstractDOMParser_setSecurityManager},
{"XML::Xercesc::AbstractDOMParser_setLoadExternalDTD", _wrap_AbstractDOMParser_setLoadExternalDTD},
{"XML::Xercesc::AbstractDOMParser_setCreateCommentNodes", _wrap_AbstractDOMParser_setCreateCommentNodes},
{"XML::Xercesc::AbstractDOMParser_setCalculateSrcOfs", _wrap_AbstractDOMParser_setCalculateSrcOfs},
{"XML::Xercesc::AbstractDOMParser_setStandardUriConformant", _wrap_AbstractDOMParser_setStandardUriConformant},
{"XML::Xercesc::AbstractDOMParser_useScanner", _wrap_AbstractDOMParser_useScanner},
{"XML::Xercesc::AbstractDOMParser_useImplementation", _wrap_AbstractDOMParser_useImplementation},
{"XML::Xercesc::AbstractDOMParser_setPSVIHandler", _wrap_AbstractDOMParser_setPSVIHandler},
{"XML::Xercesc::AbstractDOMParser_setCreateSchemaInfo", _wrap_AbstractDOMParser_setCreateSchemaInfo},
{"XML::Xercesc::AbstractDOMParser_setIgnoreAnnotations", _wrap_AbstractDOMParser_setIgnoreAnnotations},
{"XML::Xercesc::AbstractDOMParser_setDisableDefaultEntityResolution", _wrap_AbstractDOMParser_setDisableDefaultEntityResolution},
{"XML::Xercesc::AbstractDOMParser_setSkipDTDValidation", _wrap_AbstractDOMParser_setSkipDTDValidation},
{"XML::Xercesc::AbstractDOMParser_parse", _wrap_AbstractDOMParser_parse},
{"XML::Xercesc::AbstractDOMParser_parseFirst", _wrap_AbstractDOMParser_parseFirst},
{"XML::Xercesc::AbstractDOMParser_parseNext", _wrap_AbstractDOMParser_parseNext},
{"XML::Xercesc::AbstractDOMParser_parseReset", _wrap_AbstractDOMParser_parseReset},
{"XML::Xercesc::AbstractDOMParser_handleElementPSVI", _wrap_AbstractDOMParser_handleElementPSVI},
{"XML::Xercesc::AbstractDOMParser_handlePartialElementPSVI", _wrap_AbstractDOMParser_handlePartialElementPSVI},
{"XML::Xercesc::AbstractDOMParser_handleAttributesPSVI", _wrap_AbstractDOMParser_handleAttributesPSVI},
{"XML::Xercesc::AbstractDOMParser_elementTypeInfo", _wrap_AbstractDOMParser_elementTypeInfo},
{"XML::Xercesc::AbstractDOMParser_getExpandEntityReferences", _wrap_AbstractDOMParser_getExpandEntityReferences},
{"XML::Xercesc::AbstractDOMParser_setExpandEntityReferences", _wrap_AbstractDOMParser_setExpandEntityReferences},
{"XML::Xercesc::new_XercesDOMParser", _wrap_new_XercesDOMParser},
{"XML::Xercesc::delete_XercesDOMParser", _wrap_delete_XercesDOMParser},
{"XML::Xercesc::XercesDOMParser_getErrorHandler", _wrap_XercesDOMParser_getErrorHandler},
{"XML::Xercesc::XercesDOMParser_getEntityResolver", _wrap_XercesDOMParser_getEntityResolver},
{"XML::Xercesc::XercesDOMParser_getXMLEntityResolver", _wrap_XercesDOMParser_getXMLEntityResolver},
{"XML::Xercesc::XercesDOMParser_isCachingGrammarFromParse", _wrap_XercesDOMParser_isCachingGrammarFromParse},
{"XML::Xercesc::XercesDOMParser_isUsingCachedGrammarInParse", _wrap_XercesDOMParser_isUsingCachedGrammarInParse},
{"XML::Xercesc::XercesDOMParser_getGrammar", _wrap_XercesDOMParser_getGrammar},
{"XML::Xercesc::XercesDOMParser_getRootGrammar", _wrap_XercesDOMParser_getRootGrammar},
{"XML::Xercesc::XercesDOMParser_getURIText", _wrap_XercesDOMParser_getURIText},
{"XML::Xercesc::XercesDOMParser_getSrcOffset", _wrap_XercesDOMParser_getSrcOffset},
{"XML::Xercesc::XercesDOMParser_getIgnoreCachedDTD", _wrap_XercesDOMParser_getIgnoreCachedDTD},
{"XML::Xercesc::XercesDOMParser_setErrorHandler", _wrap_XercesDOMParser_setErrorHandler},
{"XML::Xercesc::XercesDOMParser_setEntityResolver", _wrap_XercesDOMParser_setEntityResolver},
{"XML::Xercesc::XercesDOMParser_setXMLEntityResolver", _wrap_XercesDOMParser_setXMLEntityResolver},
{"XML::Xercesc::XercesDOMParser_cacheGrammarFromParse", _wrap_XercesDOMParser_cacheGrammarFromParse},
{"XML::Xercesc::XercesDOMParser_useCachedGrammarInParse", _wrap_XercesDOMParser_useCachedGrammarInParse},
{"XML::Xercesc::XercesDOMParser_setIgnoreCachedDTD", _wrap_XercesDOMParser_setIgnoreCachedDTD},
{"XML::Xercesc::XercesDOMParser_resetDocumentPool", _wrap_XercesDOMParser_resetDocumentPool},
{"XML::Xercesc::XercesDOMParser_error", _wrap_XercesDOMParser_error},
{"XML::Xercesc::XercesDOMParser_resetErrors", _wrap_XercesDOMParser_resetErrors},
{"XML::Xercesc::XercesDOMParser_loadGrammar", _wrap_XercesDOMParser_loadGrammar},
{"XML::Xercesc::XercesDOMParser_resetCachedGrammarPool", _wrap_XercesDOMParser_resetCachedGrammarPool},
{"XML::Xercesc::new_SAXParser", _wrap_new_SAXParser},
{"XML::Xercesc::delete_SAXParser", _wrap_delete_SAXParser},
{"XML::Xercesc::SAXParser_getDocumentHandler", _wrap_SAXParser_getDocumentHandler},
{"XML::Xercesc::SAXParser_getEntityResolver", _wrap_SAXParser_getEntityResolver},
{"XML::Xercesc::SAXParser_getXMLEntityResolver", _wrap_SAXParser_getXMLEntityResolver},
{"XML::Xercesc::SAXParser_getErrorHandler", _wrap_SAXParser_getErrorHandler},
{"XML::Xercesc::SAXParser_getPSVIHandler", _wrap_SAXParser_getPSVIHandler},
{"XML::Xercesc::SAXParser_getValidator", _wrap_SAXParser_getValidator},
{"XML::Xercesc::SAXParser_getValidationScheme", _wrap_SAXParser_getValidationScheme},
{"XML::Xercesc::SAXParser_getDoSchema", _wrap_SAXParser_getDoSchema},
{"XML::Xercesc::SAXParser_getValidationSchemaFullChecking", _wrap_SAXParser_getValidationSchemaFullChecking},
{"XML::Xercesc::SAXParser_getIdentityConstraintChecking", _wrap_SAXParser_getIdentityConstraintChecking},
{"XML::Xercesc::SAXParser_getErrorCount", _wrap_SAXParser_getErrorCount},
{"XML::Xercesc::SAXParser_getDoNamespaces", _wrap_SAXParser_getDoNamespaces},
{"XML::Xercesc::SAXParser_getExitOnFirstFatalError", _wrap_SAXParser_getExitOnFirstFatalError},
{"XML::Xercesc::SAXParser_getValidationConstraintFatal", _wrap_SAXParser_getValidationConstraintFatal},
{"XML::Xercesc::SAXParser_getExternalSchemaLocation", _wrap_SAXParser_getExternalSchemaLocation},
{"XML::Xercesc::SAXParser_getExternalNoNamespaceSchemaLocation", _wrap_SAXParser_getExternalNoNamespaceSchemaLocation},
{"XML::Xercesc::SAXParser_getSecurityManager", _wrap_SAXParser_getSecurityManager},
{"XML::Xercesc::SAXParser_getLoadExternalDTD", _wrap_SAXParser_getLoadExternalDTD},
{"XML::Xercesc::SAXParser_isCachingGrammarFromParse", _wrap_SAXParser_isCachingGrammarFromParse},
{"XML::Xercesc::SAXParser_isUsingCachedGrammarInParse", _wrap_SAXParser_isUsingCachedGrammarInParse},
{"XML::Xercesc::SAXParser_getCalculateSrcOfs", _wrap_SAXParser_getCalculateSrcOfs},
{"XML::Xercesc::SAXParser_getStandardUriConformant", _wrap_SAXParser_getStandardUriConformant},
{"XML::Xercesc::SAXParser_getGrammar", _wrap_SAXParser_getGrammar},
{"XML::Xercesc::SAXParser_getRootGrammar", _wrap_SAXParser_getRootGrammar},
{"XML::Xercesc::SAXParser_getURIText", _wrap_SAXParser_getURIText},
{"XML::Xercesc::SAXParser_getSrcOffset", _wrap_SAXParser_getSrcOffset},
{"XML::Xercesc::SAXParser_getGenerateSyntheticAnnotations", _wrap_SAXParser_getGenerateSyntheticAnnotations},
{"XML::Xercesc::SAXParser_getValidateAnnotations", _wrap_SAXParser_getValidateAnnotations},
{"XML::Xercesc::SAXParser_getIgnoreCachedDTD", _wrap_SAXParser_getIgnoreCachedDTD},
{"XML::Xercesc::SAXParser_getIgnoreAnnotations", _wrap_SAXParser_getIgnoreAnnotations},
{"XML::Xercesc::SAXParser_getDisableDefaultEntityResolution", _wrap_SAXParser_getDisableDefaultEntityResolution},
{"XML::Xercesc::SAXParser_getSkipDTDValidation", _wrap_SAXParser_getSkipDTDValidation},
{"XML::Xercesc::SAXParser_setGenerateSyntheticAnnotations", _wrap_SAXParser_setGenerateSyntheticAnnotations},
{"XML::Xercesc::SAXParser_setValidateAnnotations", _wrap_SAXParser_setValidateAnnotations},
{"XML::Xercesc::SAXParser_setDoNamespaces", _wrap_SAXParser_setDoNamespaces},
{"XML::Xercesc::SAXParser_setValidationScheme", _wrap_SAXParser_setValidationScheme},
{"XML::Xercesc::SAXParser_setDoSchema", _wrap_SAXParser_setDoSchema},
{"XML::Xercesc::SAXParser_setValidationSchemaFullChecking", _wrap_SAXParser_setValidationSchemaFullChecking},
{"XML::Xercesc::SAXParser_setIdentityConstraintChecking", _wrap_SAXParser_setIdentityConstraintChecking},
{"XML::Xercesc::SAXParser_setExitOnFirstFatalError", _wrap_SAXParser_setExitOnFirstFatalError},
{"XML::Xercesc::SAXParser_setValidationConstraintFatal", _wrap_SAXParser_setValidationConstraintFatal},
{"XML::Xercesc::SAXParser_setExternalSchemaLocation", _wrap_SAXParser_setExternalSchemaLocation},
{"XML::Xercesc::SAXParser_setExternalNoNamespaceSchemaLocation", _wrap_SAXParser_setExternalNoNamespaceSchemaLocation},
{"XML::Xercesc::SAXParser_setSecurityManager", _wrap_SAXParser_setSecurityManager},
{"XML::Xercesc::SAXParser_setLoadExternalDTD", _wrap_SAXParser_setLoadExternalDTD},
{"XML::Xercesc::SAXParser_cacheGrammarFromParse", _wrap_SAXParser_cacheGrammarFromParse},
{"XML::Xercesc::SAXParser_useCachedGrammarInParse", _wrap_SAXParser_useCachedGrammarInParse},
{"XML::Xercesc::SAXParser_setCalculateSrcOfs", _wrap_SAXParser_setCalculateSrcOfs},
{"XML::Xercesc::SAXParser_setStandardUriConformant", _wrap_SAXParser_setStandardUriConformant},
{"XML::Xercesc::SAXParser_useScanner", _wrap_SAXParser_useScanner},
{"XML::Xercesc::SAXParser_setInputBufferSize", _wrap_SAXParser_setInputBufferSize},
{"XML::Xercesc::SAXParser_setIgnoreCachedDTD", _wrap_SAXParser_setIgnoreCachedDTD},
{"XML::Xercesc::SAXParser_setIgnoreAnnotations", _wrap_SAXParser_setIgnoreAnnotations},
{"XML::Xercesc::SAXParser_setDisableDefaultEntityResolution", _wrap_SAXParser_setDisableDefaultEntityResolution},
{"XML::Xercesc::SAXParser_setSkipDTDValidation", _wrap_SAXParser_setSkipDTDValidation},
{"XML::Xercesc::SAXParser_installAdvDocHandler", _wrap_SAXParser_installAdvDocHandler},
{"XML::Xercesc::SAXParser_removeAdvDocHandler", _wrap_SAXParser_removeAdvDocHandler},
{"XML::Xercesc::SAXParser_parseFirst", _wrap_SAXParser_parseFirst},
{"XML::Xercesc::SAXParser_parseNext", _wrap_SAXParser_parseNext},
{"XML::Xercesc::SAXParser_parseReset", _wrap_SAXParser_parseReset},
{"XML::Xercesc::SAXParser_loadGrammar", _wrap_SAXParser_loadGrammar},
{"XML::Xercesc::SAXParser_resetCachedGrammarPool", _wrap_SAXParser_resetCachedGrammarPool},
{"XML::Xercesc::SAXParser_parse", _wrap_SAXParser_parse},
{"XML::Xercesc::SAXParser_setDocumentHandler", _wrap_SAXParser_setDocumentHandler},
{"XML::Xercesc::SAXParser_setDTDHandler", _wrap_SAXParser_setDTDHandler},
{"XML::Xercesc::SAXParser_setErrorHandler", _wrap_SAXParser_setErrorHandler},
{"XML::Xercesc::SAXParser_setPSVIHandler", _wrap_SAXParser_setPSVIHandler},
{"XML::Xercesc::SAXParser_setEntityResolver", _wrap_SAXParser_setEntityResolver},
{"XML::Xercesc::SAXParser_setXMLEntityResolver", _wrap_SAXParser_setXMLEntityResolver},
{"XML::Xercesc::SAXParser_error", _wrap_SAXParser_error},
{"XML::Xercesc::SAXParser_resetErrors", _wrap_SAXParser_resetErrors},
{"XML::Xercesc::delete_SAX2XMLReader", _wrap_delete_SAX2XMLReader},
{"XML::Xercesc::SAX2XMLReader_getContentHandler", _wrap_SAX2XMLReader_getContentHandler},
{"XML::Xercesc::SAX2XMLReader_getDTDHandler", _wrap_SAX2XMLReader_getDTDHandler},
{"XML::Xercesc::SAX2XMLReader_getFeature", _wrap_SAX2XMLReader_getFeature},
{"XML::Xercesc::SAX2XMLReader_getProperty", _wrap_SAX2XMLReader_getProperty},
{"XML::Xercesc::SAX2XMLReader_setContentHandler", _wrap_SAX2XMLReader_setContentHandler},
{"XML::Xercesc::SAX2XMLReader_setDTDHandler", _wrap_SAX2XMLReader_setDTDHandler},
{"XML::Xercesc::SAX2XMLReader_setEntityResolver", _wrap_SAX2XMLReader_setEntityResolver},
{"XML::Xercesc::SAX2XMLReader_setErrorHandler", _wrap_SAX2XMLReader_setErrorHandler},
{"XML::Xercesc::SAX2XMLReader_setFeature", _wrap_SAX2XMLReader_setFeature},
{"XML::Xercesc::SAX2XMLReader_setProperty", _wrap_SAX2XMLReader_setProperty},
{"XML::Xercesc::SAX2XMLReader_parse", _wrap_SAX2XMLReader_parse},
{"XML::Xercesc::SAX2XMLReader_getDeclarationHandler", _wrap_SAX2XMLReader_getDeclarationHandler},
{"XML::Xercesc::SAX2XMLReader_getLexicalHandler", _wrap_SAX2XMLReader_getLexicalHandler},
{"XML::Xercesc::SAX2XMLReader_setDeclarationHandler", _wrap_SAX2XMLReader_setDeclarationHandler},
{"XML::Xercesc::SAX2XMLReader_setLexicalHandler", _wrap_SAX2XMLReader_setLexicalHandler},
{"XML::Xercesc::SAX2XMLReader_getValidator", _wrap_SAX2XMLReader_getValidator},
{"XML::Xercesc::SAX2XMLReader_getErrorCount", _wrap_SAX2XMLReader_getErrorCount},
{"XML::Xercesc::SAX2XMLReader_getExitOnFirstFatalError", _wrap_SAX2XMLReader_getExitOnFirstFatalError},
{"XML::Xercesc::SAX2XMLReader_getValidationConstraintFatal", _wrap_SAX2XMLReader_getValidationConstraintFatal},
{"XML::Xercesc::SAX2XMLReader_getGrammar", _wrap_SAX2XMLReader_getGrammar},
{"XML::Xercesc::SAX2XMLReader_getRootGrammar", _wrap_SAX2XMLReader_getRootGrammar},
{"XML::Xercesc::SAX2XMLReader_getURIText", _wrap_SAX2XMLReader_getURIText},
{"XML::Xercesc::SAX2XMLReader_getSrcOffset", _wrap_SAX2XMLReader_getSrcOffset},
{"XML::Xercesc::SAX2XMLReader_setValidator", _wrap_SAX2XMLReader_setValidator},
{"XML::Xercesc::SAX2XMLReader_setExitOnFirstFatalError", _wrap_SAX2XMLReader_setExitOnFirstFatalError},
{"XML::Xercesc::SAX2XMLReader_setValidationConstraintFatal", _wrap_SAX2XMLReader_setValidationConstraintFatal},
{"XML::Xercesc::SAX2XMLReader_parseFirst", _wrap_SAX2XMLReader_parseFirst},
{"XML::Xercesc::SAX2XMLReader_parseNext", _wrap_SAX2XMLReader_parseNext},
{"XML::Xercesc::SAX2XMLReader_parseReset", _wrap_SAX2XMLReader_parseReset},
{"XML::Xercesc::SAX2XMLReader_loadGrammar", _wrap_SAX2XMLReader_loadGrammar},
{"XML::Xercesc::SAX2XMLReader_resetCachedGrammarPool", _wrap_SAX2XMLReader_resetCachedGrammarPool},
{"XML::Xercesc::SAX2XMLReader_setInputBufferSize", _wrap_SAX2XMLReader_setInputBufferSize},
{"XML::Xercesc::SAX2XMLReader_installAdvDocHandler", _wrap_SAX2XMLReader_installAdvDocHandler},
{"XML::Xercesc::SAX2XMLReader_removeAdvDocHandler", _wrap_SAX2XMLReader_removeAdvDocHandler},
{"XML::Xercesc::XMLReaderFactory_createXMLReader", _wrap_XMLReaderFactory_createXMLReader},
{"XML::Xercesc::new_PerlCallbackHandler", _wrap_new_PerlCallbackHandler},
{"XML::Xercesc::delete_PerlCallbackHandler", _wrap_delete_PerlCallbackHandler},
{"XML::Xercesc::PerlCallbackHandler_type", _wrap_PerlCallbackHandler_type},
{"XML::Xercesc::PerlCallbackHandler_set_callback_obj", _wrap_PerlCallbackHandler_set_callback_obj},
{"XML::Xercesc::PerlCallbackHandler_XMLString2Perl", _wrap_PerlCallbackHandler_XMLString2Perl},
{"XML::Xercesc::new_PerlErrorCallbackHandler", _wrap_new_PerlErrorCallbackHandler},
{"XML::Xercesc::delete_PerlErrorCallbackHandler", _wrap_delete_PerlErrorCallbackHandler},
{"XML::Xercesc::PerlErrorCallbackHandler_type", _wrap_PerlErrorCallbackHandler_type},
{"XML::Xercesc::PerlErrorCallbackHandler_resetErrors", _wrap_PerlErrorCallbackHandler_resetErrors},
{"XML::Xercesc::new_PerlEntityResolverHandler", _wrap_new_PerlEntityResolverHandler},
{"XML::Xercesc::delete_PerlEntityResolverHandler", _wrap_delete_PerlEntityResolverHandler},
{"XML::Xercesc::PerlEntityResolverHandler_type", _wrap_PerlEntityResolverHandler_type},
{"XML::Xercesc::new_PerlNodeFilterCallbackHandler", _wrap_new_PerlNodeFilterCallbackHandler},
{"XML::Xercesc::delete_PerlNodeFilterCallbackHandler", _wrap_delete_PerlNodeFilterCallbackHandler},
{"XML::Xercesc::PerlNodeFilterCallbackHandler_type", _wrap_PerlNodeFilterCallbackHandler_type},
{"XML::Xercesc::PerlNodeFilterCallbackHandler_acceptNode", _wrap_PerlNodeFilterCallbackHandler_acceptNode},
{"XML::Xercesc::new_PerlDocumentCallbackHandler", _wrap_new_PerlDocumentCallbackHandler},
{"XML::Xercesc::delete_PerlDocumentCallbackHandler", _wrap_delete_PerlDocumentCallbackHandler},
{"XML::Xercesc::PerlDocumentCallbackHandler_type", _wrap_PerlDocumentCallbackHandler_type},
{"XML::Xercesc::PerlDocumentCallbackHandler_characters", _wrap_PerlDocumentCallbackHandler_characters},
{"XML::Xercesc::PerlDocumentCallbackHandler_processingInstruction", _wrap_PerlDocumentCallbackHandler_processingInstruction},
{"XML::Xercesc::PerlDocumentCallbackHandler_setDocumentLocator", _wrap_PerlDocumentCallbackHandler_setDocumentLocator},
{"XML::Xercesc::new_PerlContentCallbackHandler", _wrap_new_PerlContentCallbackHandler},
{"XML::Xercesc::delete_PerlContentCallbackHandler", _wrap_delete_PerlContentCallbackHandler},
{"XML::Xercesc::PerlContentCallbackHandler_type", _wrap_PerlContentCallbackHandler_type},
{"XML::Xercesc::PerlContentCallbackHandler_characters", _wrap_PerlContentCallbackHandler_characters},
{"XML::Xercesc::PerlContentCallbackHandler_processingInstruction", _wrap_PerlContentCallbackHandler_processingInstruction},
{"XML::Xercesc::PerlContentCallbackHandler_setDocumentLocator", _wrap_PerlContentCallbackHandler_setDocumentLocator},
{"XML::Xercesc::PerlContentCallbackHandler_startPrefixMapping", _wrap_PerlContentCallbackHandler_startPrefixMapping},
{"XML::Xercesc::PerlContentCallbackHandler_endPrefixMapping", _wrap_PerlContentCallbackHandler_endPrefixMapping},
{"XML::Xercesc::PerlContentCallbackHandler_skippedEntity", _wrap_PerlContentCallbackHandler_skippedEntity},
{0,0}
};
/* -----------------------------------------------------------------------------
 * Type initialization:
 * This problem is tough by the requirement that no dynamic 
 * memory is used. Also, since swig_type_info structures store pointers to 
 * swig_cast_info structures and swig_cast_info structures store pointers back
 * to swig_type_info structures, we need some lookup code at initialization. 
 * The idea is that swig generates all the structures that are needed. 
 * The runtime then collects these partially filled structures. 
 * The SWIG_InitializeModule function takes these initial arrays out of 
 * swig_module, and does all the lookup, filling in the swig_module.types
 * array with the correct data and linking the correct swig_cast_info
 * structures together.
 *
 * The generated swig_type_info structures are assigned staticly to an initial 
 * array. We just loop though that array, and handle each type individually.
 * First we lookup if this type has been already loaded, and if so, use the
 * loaded structure instead of the generated one. Then we have to fill in the
 * cast linked list. The cast data is initially stored in something like a
 * two-dimensional array. Each row corresponds to a type (there are the same
 * number of rows as there are in the swig_type_initial array). Each entry in
 * a column is one of the swig_cast_info structures for that type.
 * The cast_initial array is actually an array of arrays, because each row has
 * a variable number of columns. So to actually build the cast linked list,
 * we find the array of casts associated with the type, and loop through it 
 * adding the casts to the list. The one last trick we need to do is making
 * sure the type pointer in the swig_cast_info struct is correct.
 *
 * First off, we lookup the cast->type name to see if it is already loaded. 
 * There are three cases to handle:
 *  1) If the cast->type has already been loaded AND the type we are adding
 *     casting info to has not been loaded (it is in this module), THEN we
 *     replace the cast->type pointer with the type pointer that has already
 *     been loaded.
 *  2) If BOTH types (the one we are adding casting info to, and the 
 *     cast->type) are loaded, THEN the cast info has already been loaded by
 *     the previous module so we just ignore it.
 *  3) Finally, if cast->type has not already been loaded, then we add that
 *     swig_cast_info to the linked list (because the cast->type) pointer will
 *     be correct.
 * ----------------------------------------------------------------------------- */

#ifdef __cplusplus
extern "C" {
#if 0
} /* c-mode */
#endif
#endif

#if 0
#define SWIGRUNTIME_DEBUG
#endif

SWIGRUNTIME void
SWIG_InitializeModule(void *clientdata) {
  size_t i;
  swig_module_info *module_head;
  static int init_run = 0;
  
  clientdata = clientdata;
  
  if (init_run) return;
  init_run = 1;
  
  /* Initialize the swig_module */
  swig_module.type_initial = swig_type_initial;
  swig_module.cast_initial = swig_cast_initial;
  
  /* Try and load any already created modules */
  module_head = SWIG_GetModule(clientdata);
  if (module_head) {
    swig_module.next = module_head->next;
    module_head->next = &swig_module;
  } else {
    /* This is the first module loaded */
    swig_module.next = &swig_module;
    SWIG_SetModule(clientdata, &swig_module);
  }
  
  /* Now work on filling in swig_module.types */
#ifdef SWIGRUNTIME_DEBUG
  printf("SWIG_InitializeModule: size %d\n", swig_module.size);
#endif
  for (i = 0; i < swig_module.size; ++i) {
    swig_type_info *type = 0;
    swig_type_info *ret;
    swig_cast_info *cast;
    
#ifdef SWIGRUNTIME_DEBUG
    printf("SWIG_InitializeModule: type %d %s\n", i, swig_module.type_initial[i]->name);
#endif
    
    /* if there is another module already loaded */
    if (swig_module.next != &swig_module) {
      type = SWIG_MangledTypeQueryModule(swig_module.next, &swig_module, swig_module.type_initial[i]->name);
    }
    if (type) {
      /* Overwrite clientdata field */
#ifdef SWIGRUNTIME_DEBUG
      printf("SWIG_InitializeModule: found type %s\n", type->name);
#endif
      if (swig_module.type_initial[i]->clientdata) {
        type->clientdata = swig_module.type_initial[i]->clientdata;
#ifdef SWIGRUNTIME_DEBUG
        printf("SWIG_InitializeModule: found and overwrite type %s \n", type->name);
#endif
      }
    } else {
      type = swig_module.type_initial[i];
    }
    
    /* Insert casting types */
    cast = swig_module.cast_initial[i];
    while (cast->type) {
      /* Don't need to add information already in the list */
      ret = 0;
#ifdef SWIGRUNTIME_DEBUG
      printf("SWIG_InitializeModule: look cast %s\n", cast->type->name);
#endif
      if (swig_module.next != &swig_module) {
        ret = SWIG_MangledTypeQueryModule(swig_module.next, &swig_module, cast->type->name);
#ifdef SWIGRUNTIME_DEBUG
        if (ret) printf("SWIG_InitializeModule: found cast %s\n", ret->name);
#endif
      }
      if (ret) {
        if (type == swig_module.type_initial[i]) {
#ifdef SWIGRUNTIME_DEBUG
          printf("SWIG_InitializeModule: skip old type %s\n", ret->name);
#endif
          cast->type = ret;
          ret = 0;
        } else {
          /* Check for casting already in the list */
          swig_cast_info *ocast = SWIG_TypeCheck(ret->name, type);
#ifdef SWIGRUNTIME_DEBUG
          if (ocast) printf("SWIG_InitializeModule: skip old cast %s\n", ret->name);
#endif
          if (!ocast) ret = 0;
        }
      }
      
      if (!ret) {
#ifdef SWIGRUNTIME_DEBUG
        printf("SWIG_InitializeModule: adding cast %s\n", cast->type->name);
#endif
        if (type->cast) {
          type->cast->prev = cast;
          cast->next = type->cast;
        }
        type->cast = cast;
      }
      cast++;
    }
    /* Set entry in modules->types array equal to the type */
    swig_module.types[i] = type;
  }
  swig_module.types[i] = 0;
  
#ifdef SWIGRUNTIME_DEBUG
  printf("**** SWIG_InitializeModule: Cast List ******\n");
  for (i = 0; i < swig_module.size; ++i) {
    int j = 0;
    swig_cast_info *cast = swig_module.cast_initial[i];
    printf("SWIG_InitializeModule: type %d %s\n", i, swig_module.type_initial[i]->name);
    while (cast->type) {
      printf("SWIG_InitializeModule: cast type %s\n", cast->type->name);
      cast++;
      ++j;
    }
    printf("---- Total casts: %d\n",j);
  }
  printf("**** SWIG_InitializeModule: Cast List ******\n");
#endif
}

/* This function will propagate the clientdata field of type to
* any new swig_type_info structures that have been added into the list
* of equivalent types.  It is like calling
* SWIG_TypeClientData(type, clientdata) a second time.
*/
SWIGRUNTIME void
SWIG_PropagateClientData(void) {
  size_t i;
  swig_cast_info *equiv;
  static int init_run = 0;
  
  if (init_run) return;
  init_run = 1;
  
  for (i = 0; i < swig_module.size; i++) {
    if (swig_module.types[i]->clientdata) {
      equiv = swig_module.types[i]->cast;
      while (equiv) {
        if (!equiv->converter) {
          if (equiv->type && !equiv->type->clientdata)
          SWIG_TypeClientData(equiv->type, swig_module.types[i]->clientdata);
        }
        equiv = equiv->next;
      }
    }
  }
}

#ifdef __cplusplus
#if 0
{
  /* c-mode */
#endif
}
#endif



#ifdef __cplusplus
extern "C"
#endif

XS(SWIG_init) {
  dXSARGS;
  int i;
  
  SWIG_InitializeModule(0);
  
  /* Install commands */
  for (i = 0; swig_commands[i].name; i++) {
    newXS((char*) swig_commands[i].name,swig_commands[i].wrapper, (char*)__FILE__);
  }
  
  /* Install variables */
  for (i = 0; swig_variables[i].name; i++) {
    SV *sv;
    sv = get_sv((char*) swig_variables[i].name, TRUE | 0x2);
    if (swig_variables[i].type) {
      SWIG_MakePtr(sv,(void *)1, *swig_variables[i].type,0);
    } else {
      sv_setiv(sv,(IV) 0);
    }
    swig_create_magic(sv, (char *) swig_variables[i].name, swig_variables[i].set, swig_variables[i].get); 
  }
  
  /* Install constant */
  for (i = 0; swig_constants[i].type; i++) {
    SV *sv;
    sv = get_sv((char*)swig_constants[i].name, TRUE | 0x2);
    switch(swig_constants[i].type) {
    case SWIG_INT:
      sv_setiv(sv, (IV) swig_constants[i].lvalue);
      break;
    case SWIG_FLOAT:
      sv_setnv(sv, (double) swig_constants[i].dvalue);
      break;
    case SWIG_STRING:
      sv_setpv(sv, (char *) swig_constants[i].pvalue);
      break;
    case SWIG_POINTER:
      SWIG_MakePtr(sv, swig_constants[i].pvalue, *(swig_constants[i].ptype),0);
      break;
    case SWIG_BINARY:
      SWIG_MakePackedObj(sv, swig_constants[i].pvalue, swig_constants[i].lvalue, *(swig_constants[i].ptype));
      break;
    default:
      break;
    }
    SvREADONLY_on(sv);
  }
  
  
  SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar->dcast = (swig_dycast_func) Grammar_dynamic_cast;
  
  
  SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode->dcast = (swig_dycast_func) DOMNode_dynamic_cast;
  
  
  SWIGTYPE_p_PerlCallbackHandler->dcast = (swig_dycast_func) PerlCallbackHandler_dynamic_cast;
  
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDeleter, (void*) "XML::Xerces::XMLDeleter");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPlatformUtils, (void*) "XML::Xerces::XMLPlatformUtils");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLURL_File", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLURL::File)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLURL_HTTP", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLURL::HTTP)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLURL_FTP", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLURL::FTP)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLURL_Protocols_Count", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLURL::Protocols_Count)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLURL_Unknown", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLURL::Unknown)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLURL, (void*) "XML::Xerces::XMLURL");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUri, (void*) "XML::Xerces::XMLUri");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NoError", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NoError)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_W_LowBounds", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::W_LowBounds)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Scan_CouldNotOpenSource_Warning", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Scan_CouldNotOpenSource_Warning)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_GC_ExistingGrammar", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::GC_ExistingGrammar)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_W_HighBounds", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::W_HighBounds)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_F_LowBounds", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::F_LowBounds)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Array_BadIndex", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Array_BadIndex)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Array_BadNewSize", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Array_BadNewSize)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_AttrList_BadIndex", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::AttrList_BadIndex)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_AttDef_BadAttType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::AttDef_BadAttType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_AttDef_BadDefAttType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::AttDef_BadDefAttType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Bitset_BadIndex", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Bitset_BadIndex)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Bitset_NotEqualSize", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Bitset_NotEqualSize)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_BufMgr_NoMoreBuffers", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::BufMgr_NoMoreBuffers)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_BufMgr_BufferNotInPool", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::BufMgr_BufferNotInPool)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_CPtr_PointerIsZero", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::CPtr_PointerIsZero)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_CM_BinOpHadUnaryType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::CM_BinOpHadUnaryType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_CM_MustBeMixedOrChildren", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::CM_MustBeMixedOrChildren)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_CM_NoPCDATAHere", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::CM_NoPCDATAHere)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_CM_NotValidForSpecType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::CM_NotValidForSpecType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_CM_UnaryOpHadBinType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::CM_UnaryOpHadBinType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_CM_UnknownCMType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::CM_UnknownCMType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_CM_UnknownCMSpecType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::CM_UnknownCMSpecType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_CM_NoParentCSN", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::CM_NoParentCSN)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_CM_NotValidSpecTypeForNode", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::CM_NotValidSpecTypeForNode)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DTD_UnknownCreateReason", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DTD_UnknownCreateReason)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_ElemStack_EmptyStack", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::ElemStack_EmptyStack)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_ElemStack_BadIndex", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::ElemStack_BadIndex)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_ElemStack_StackUnderflow", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::ElemStack_StackUnderflow)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_ElemStack_NoParentPushed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::ElemStack_NoParentPushed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Enum_NoMoreElements", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Enum_NoMoreElements)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_CouldNotOpenFile", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_CouldNotOpenFile)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_CouldNotGetCurPos", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_CouldNotGetCurPos)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_CouldNotCloseFile", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_CouldNotCloseFile)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_CouldNotSeekToEnd", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_CouldNotSeekToEnd)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_CouldNotSeekToPos", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_CouldNotSeekToPos)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_CouldNotDupHandle", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_CouldNotDupHandle)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_CouldNotReadFromFile", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_CouldNotReadFromFile)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_CouldNotWriteToFile", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_CouldNotWriteToFile)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_CouldNotResetFile", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_CouldNotResetFile)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_CouldNotGetSize", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_CouldNotGetSize)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_CouldNotGetBasePathName", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_CouldNotGetBasePathName)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_File_BasePathUnderflow", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::File_BasePathUnderflow)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Gen_ParseInProgress", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Gen_ParseInProgress)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Gen_NoDTDValidator", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Gen_NoDTDValidator)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Gen_CouldNotOpenDTD", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Gen_CouldNotOpenDTD)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Gen_CouldNotOpenExtEntity", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Gen_CouldNotOpenExtEntity)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Gen_UnexpectedEOF", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Gen_UnexpectedEOF)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_HshTbl_ZeroModulus", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::HshTbl_ZeroModulus)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_HshTbl_BadHashFromKey", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::HshTbl_BadHashFromKey)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_HshTbl_NoSuchKeyExists", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::HshTbl_NoSuchKeyExists)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Mutex_CouldNotCreate", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Mutex_CouldNotCreate)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Mutex_CouldNotClose", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Mutex_CouldNotClose)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Mutex_CouldNotLock", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Mutex_CouldNotLock)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Mutex_CouldNotUnlock", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Mutex_CouldNotUnlock)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Mutex_CouldNotDestroy", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Mutex_CouldNotDestroy)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NetAcc_InternalError", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NetAcc_InternalError)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NetAcc_LengthError", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NetAcc_LengthError)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NetAcc_InitFailed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NetAcc_InitFailed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NetAcc_TargetResolution", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NetAcc_TargetResolution)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NetAcc_CreateSocket", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NetAcc_CreateSocket)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NetAcc_ConnSocket", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NetAcc_ConnSocket)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NetAcc_WriteSocket", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NetAcc_WriteSocket)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NetAcc_ReadSocket", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NetAcc_ReadSocket)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NetAcc_UnsupportedMethod", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NetAcc_UnsupportedMethod)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Pool_ElemAlreadyExists", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Pool_ElemAlreadyExists)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Pool_BadHashFromKey", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Pool_BadHashFromKey)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Pool_InvalidId", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Pool_InvalidId)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Pool_ZeroModulus", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Pool_ZeroModulus)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_RdrMgr_ReaderIdNotFound", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::RdrMgr_ReaderIdNotFound)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Reader_BadAutoEncoding", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Reader_BadAutoEncoding)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Reader_CouldNotDecodeFirstLine", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Reader_CouldNotDecodeFirstLine)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Reader_NelLsepinDecl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Reader_NelLsepinDecl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Reader_EOIInMultiSeq", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Reader_EOIInMultiSeq)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Reader_SrcOfsNotSupported", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Reader_SrcOfsNotSupported)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Reader_EncodingStrRequired", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Reader_EncodingStrRequired)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Scan_CouldNotOpenSource", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Scan_CouldNotOpenSource)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Scan_UnbalancedStartEnd", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Scan_UnbalancedStartEnd)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Scan_BadPScanToken", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Scan_BadPScanToken)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Stack_BadIndex", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Stack_BadIndex)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Stack_EmptyStack", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Stack_EmptyStack)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Str_ZeroSizedTargetBuf", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Str_ZeroSizedTargetBuf)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Str_UnknownRadix", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Str_UnknownRadix)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Str_TargetBufTooSmall", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Str_TargetBufTooSmall)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Str_StartIndexPastEnd", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Str_StartIndexPastEnd)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Str_ConvertOverflow", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Str_ConvertOverflow)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Strm_StdErrWriteFailure", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Strm_StdErrWriteFailure)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Strm_StdOutWriteFailure", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Strm_StdOutWriteFailure)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Strm_ConWriteFailure", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Strm_ConWriteFailure)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_StrPool_IllegalId", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::StrPool_IllegalId)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Trans_CouldNotCreateDefCvtr", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Trans_CouldNotCreateDefCvtr)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Trans_InvalidSizeReq", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Trans_InvalidSizeReq)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Trans_Unrepresentable", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Trans_Unrepresentable)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Trans_NotValidForEncoding", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Trans_NotValidForEncoding)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Trans_BadBlockSize", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Trans_BadBlockSize)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Trans_BadSrcSeq", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Trans_BadSrcSeq)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Trans_BadSrcCP", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Trans_BadSrcCP)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Trans_BadTrailingSurrogate", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Trans_BadTrailingSurrogate)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Trans_CantCreateCvtrFor", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Trans_CantCreateCvtrFor)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_URL_MalformedURL", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::URL_MalformedURL)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_URL_UnsupportedProto", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::URL_UnsupportedProto)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_URL_UnsupportedProto1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::URL_UnsupportedProto1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_URL_OnlyLocalHost", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::URL_OnlyLocalHost)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_URL_NoProtocolPresent", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::URL_NoProtocolPresent)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_URL_ExpectingTwoSlashes", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::URL_ExpectingTwoSlashes)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_URL_IncorrectEscapedCharRef", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::URL_IncorrectEscapedCharRef)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_URL_UnterminatedHostComponent", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::URL_UnterminatedHostComponent)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_URL_RelativeBaseURL", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::URL_RelativeBaseURL)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_URL_BaseUnderflow", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::URL_BaseUnderflow)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_URL_BadPortField", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::URL_BadPortField)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_UTF8_FormatError", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::UTF8_FormatError)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_UTF8_Invalid_2BytesSeq", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::UTF8_Invalid_2BytesSeq)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_UTF8_Invalid_3BytesSeq", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::UTF8_Invalid_3BytesSeq)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_UTF8_Irregular_3BytesSeq", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::UTF8_Irregular_3BytesSeq)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_UTF8_Invalid_4BytesSeq", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::UTF8_Invalid_4BytesSeq)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_UTF8_Exceede_BytesLimit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::UTF8_Exceede_BytesLimit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Vector_BadIndex", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Vector_BadIndex)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Val_InvalidElemId", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Val_InvalidElemId)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Val_CantHaveIntSS", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Val_CantHaveIntSS)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLRec_UnknownEncoding", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLRec_UnknownEncoding)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Parse1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Parse1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Parse2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Parse2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Next1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Next1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Next2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Next2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Next3", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Next3)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Next4", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Next4)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Factor1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Factor1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Factor2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Factor2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Factor3", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Factor3)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Factor4", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Factor4)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Factor5", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Factor5)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Factor6", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Factor6)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Atom1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Atom1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Atom2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Atom2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Atom3", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Atom3)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Atom4", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Atom4)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Atom5", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Atom5)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_CC1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_CC1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_CC2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_CC2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_CC3", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_CC3)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_CC4", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_CC4)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_CC5", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_CC5)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_CC6", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_CC6)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Ope1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Ope1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Ope2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Ope2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Ope3", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Ope3)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Descape1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Descape1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Descape2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Descape2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Descape3", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Descape3)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Descape4", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Descape4)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Descape5", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Descape5)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Process1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Process1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Process2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Process2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Quantifier1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Quantifier1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Quantifier2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Quantifier2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Quantifier3", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Quantifier3)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Quantifier4", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Quantifier4)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Parser_Quantifier5", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Parser_Quantifier5)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Gen_NoSchemaValidator", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Gen_NoSchemaValidator)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XUTIL_UnCopyableNodeType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XUTIL_UnCopyableNodeType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_SubGrpComparator_NGR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::SubGrpComparator_NGR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Invalid_Len", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Invalid_Len)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Invalid_maxLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Invalid_maxLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Invalid_minLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Invalid_minLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_NonNeg_Len", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_NonNeg_Len)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_NonNeg_maxLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_NonNeg_maxLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_NonNeg_minLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_NonNeg_minLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Len_maxLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Len_maxLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Len_minLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Len_minLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxLen_minLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxLen_minLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_bool_Pattern", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_bool_Pattern)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Invalid_Tag", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Invalid_Tag)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Len_baseLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Len_baseLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minLen_baseminLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minLen_baseminLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minLen_basemaxLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minLen_basemaxLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxLen_basemaxLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxLen_basemaxLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxLen_baseminLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxLen_baseminLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Len_baseMinLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Len_baseMinLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Len_baseMaxLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Len_baseMaxLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minLen_baseLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minLen_baseLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxLen_baseLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxLen_baseLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_enum_base", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_enum_base)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Invalid_WS", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Invalid_WS)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_WS_collapse", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_WS_collapse)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_WS_replace", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_WS_replace)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Invalid_MaxIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Invalid_MaxIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Invalid_MaxExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Invalid_MaxExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Invalid_MinIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Invalid_MinIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Invalid_MinExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Invalid_MinExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Invalid_TotalDigit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Invalid_TotalDigit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Invalid_FractDigit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Invalid_FractDigit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_PosInt_TotalDigit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_PosInt_TotalDigit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_NonNeg_FractDigit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_NonNeg_FractDigit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_max_Incl_Excl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_max_Incl_Excl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_min_Incl_Excl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_min_Incl_Excl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxExcl_minExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxExcl_minExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxExcl_minIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxExcl_minIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxIncl_minExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxIncl_minExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxIncl_minIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxIncl_minIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_TotDigit_FractDigit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_TotDigit_FractDigit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxIncl_base_maxExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxIncl_base_maxExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxIncl_base_maxIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxIncl_base_maxIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxIncl_base_minIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxIncl_base_minIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxIncl_base_minExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxIncl_base_minExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxExcl_base_maxExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxExcl_base_maxExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxExcl_base_maxIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxExcl_base_maxIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxExcl_base_minIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxExcl_base_minIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxExcl_base_minExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxExcl_base_minExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minExcl_base_maxExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minExcl_base_maxExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minExcl_base_maxIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minExcl_base_maxIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minExcl_base_minIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minExcl_base_minIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minExcl_base_minExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minExcl_base_minExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minIncl_base_maxExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minIncl_base_maxExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minIncl_base_maxIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minIncl_base_maxIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minIncl_base_minIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minIncl_base_minIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minIncl_base_minExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minIncl_base_minExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxIncl_notFromBase", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxIncl_notFromBase)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxExcl_notFromBase", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxExcl_notFromBase)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minIncl_notFromBase", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minIncl_notFromBase)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minExcl_notFromBase", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minExcl_notFromBase)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_totalDigit_base_totalDigit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_totalDigit_base_totalDigit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_fractDigit_base_totalDigit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_fractDigit_base_totalDigit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_fractDigit_base_fractDigit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_fractDigit_base_fractDigit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxIncl_base_fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxIncl_base_fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxExcl_base_fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxExcl_base_fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minIncl_base_fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minIncl_base_fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minExcl_base_fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minExcl_base_fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_totalDigit_base_fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_totalDigit_base_fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_fractDigit_base_fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_fractDigit_base_fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_maxLen_base_fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_maxLen_base_fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_minLen_base_fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_minLen_base_fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_len_base_fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_len_base_fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_whitespace_base_fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_whitespace_base_fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_internalError_fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_internalError_fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_List_Null_baseValidator", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_List_Null_baseValidator)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Union_Null_memberTypeValidators", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Union_Null_memberTypeValidators)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Union_Null_baseValidator", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Union_Null_baseValidator)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_FACET_Union_invalid_baseValidatorType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::FACET_Union_invalid_baseValidatorType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_NotMatch_Pattern", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_NotMatch_Pattern)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_Not_Base64", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_Not_Base64)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_Not_HexBin", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_Not_HexBin)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_GT_maxLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_GT_maxLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_LT_minLen", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_LT_minLen)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_NE_Len", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_NE_Len)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_NotIn_Enumeration", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_NotIn_Enumeration)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_exceed_totalDigit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_exceed_totalDigit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_exceed_fractDigit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_exceed_fractDigit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_exceed_maxIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_exceed_maxIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_exceed_maxExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_exceed_maxExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_exceed_minIncl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_exceed_minIncl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_exceed_minExcl", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_exceed_minExcl)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_WS_replaced", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_WS_replaced)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_WS_collapsed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_WS_collapsed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_Invalid_NCName", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_Invalid_NCName)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_Invalid_Name", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_Invalid_Name)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_ID_Not_Unique", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_ID_Not_Unique)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_ENTITY_Invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_ENTITY_Invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_QName_Invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_QName_Invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_NOTATION_Invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_NOTATION_Invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_no_match_memberType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_no_match_memberType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_VALUE_URI_Malformed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::VALUE_URI_Malformed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_emptyString", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_emptyString)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_WSString", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_WSString)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_2ManyDecPoint", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_2ManyDecPoint)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_Inv_chars", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_Inv_chars)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_null_ptr", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_null_ptr)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_URI_Component_Empty", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_URI_Component_Empty)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_URI_Component_for_GenURI_Only", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_URI_Component_for_GenURI_Only)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_URI_Component_Invalid_EscapeSequence", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_URI_Component_Invalid_EscapeSequence)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_URI_Component_Invalid_Char", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_URI_Component_Invalid_Char)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_URI_Component_Set_Null", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_URI_Component_Set_Null)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_URI_Component_Not_Conformant", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_URI_Component_Not_Conformant)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_URI_No_Scheme", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_URI_No_Scheme)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_URI_NullHost", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_URI_NullHost)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_URI_NullPath", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_URI_NullPath)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_URI_Component_inPath", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_URI_Component_inPath)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_URI_PortNo_Invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_URI_PortNo_Invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_DBL_FLT_maxNeg", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_DBL_FLT_maxNeg)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_DBL_FLT_maxPos", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_DBL_FLT_maxPos)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_DBL_FLT_minNegPos", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_DBL_FLT_minNegPos)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_DBL_FLT_InvalidType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_DBL_FLT_InvalidType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XMLNUM_DBL_FLT_No_Exponent", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XMLNUM_DBL_FLT_No_Exponent)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_Result_Not_Set", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_Result_Not_Set)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_CompactRangesError", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_CompactRangesError)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_MergeRangesTypeMismatch", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_MergeRangesTypeMismatch)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_SubtractRangesError", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_SubtractRangesError)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_IntersectRangesError", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_IntersectRangesError)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_ComplementRangesInvalidArg", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_ComplementRangesInvalidArg)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_InvalidCategoryName", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_InvalidCategoryName)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_KeywordNotFound", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_KeywordNotFound)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_BadRefNo", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_BadRefNo)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_UnknownOption", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_UnknownOption)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_UnknownTokenType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_UnknownTokenType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_RangeTokenGetError", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_RangeTokenGetError)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_NotSupported", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_NotSupported)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_InvalidChildIndex", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_InvalidChildIndex)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_RepPatMatchesZeroString", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_RepPatMatchesZeroString)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Regex_InvalidRepPattern", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Regex_InvalidRepPattern)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NEL_RepeatedCalls", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NEL_RepeatedCalls)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_RethrowError", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::RethrowError)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_Out_Of_Memory", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::Out_Of_Memory)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DV_InvalidOperation", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DV_InvalidOperation)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_NoAttrSelector", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_NoAttrSelector)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_NoUnionAtStart", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_NoUnionAtStart)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_NoMultipleUnion", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_NoMultipleUnion)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_MissingAttr", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_MissingAttr)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_ExpectedToken1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_ExpectedToken1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_PrefixNoURI", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_PrefixNoURI)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_NoDoubleColon", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_NoDoubleColon)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_ExpectedStep1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_ExpectedStep1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_ExpectedStep2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_ExpectedStep2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_ExpectedStep3", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_ExpectedStep3)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_NoForwardSlash", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_NoForwardSlash)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_NoDoubleForwardSlash", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_NoDoubleForwardSlash)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_NoForwardSlashAtStart", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_NoForwardSlashAtStart)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_NoSelectionOfRoot", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_NoSelectionOfRoot)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_EmptyExpr", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_EmptyExpr)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_NoUnionAtEnd", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_NoUnionAtEnd)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_InvalidChar", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_InvalidChar)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_TokenNotSupported", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_TokenNotSupported)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XPath_FindSolution", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XPath_FindSolution)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_Assert_Buffer_Fail", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_Assert_Buffer_Fail)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_dt_missingT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_dt_missingT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_gDay_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_gDay_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_gMth_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_gMth_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_gMthDay_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_gMthDay_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_dur_Start_dashP", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_dur_Start_dashP)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_dur_noP", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_dur_noP)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_dur_DashNotFirst", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_dur_DashNotFirst)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_dur_inv_b4T", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_dur_inv_b4T)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_dur_NoTimeAfterT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_dur_NoTimeAfterT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_dur_NoElementAtAll", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_dur_NoElementAtAll)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_dur_inv_seconds", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_dur_inv_seconds)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_date_incomplete", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_date_incomplete)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_date_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_date_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_time_incomplete", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_time_incomplete)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_time_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_time_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_ms_noDigit", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_ms_noDigit)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_ym_incomplete", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_ym_incomplete)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_ym_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_ym_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_year_tooShort", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_year_tooShort)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_year_leadingZero", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_year_leadingZero)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_ym_noMonth", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_ym_noMonth)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_tz_noUTCsign", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_tz_noUTCsign)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_tz_stuffAfterZ", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_tz_stuffAfterZ)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_tz_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_tz_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_year_zero", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_year_zero)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_mth_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_mth_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_day_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_day_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_hour_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_hour_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_min_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_min_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_second_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_second_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_DateTime_tz_hh_invalid", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::DateTime_tz_hh_invalid)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_EmptyBase", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_EmptyBase)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_NSCompat1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_NSCompat1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_OccurRangeE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_OccurRangeE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_NameTypeOK1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_NameTypeOK1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_NameTypeOK2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_NameTypeOK2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_NameTypeOK3", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_NameTypeOK3)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_NameTypeOK4", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_NameTypeOK4)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_NameTypeOK5", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_NameTypeOK5)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_NameTypeOK6", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_NameTypeOK6)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_NameTypeOK7", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_NameTypeOK7)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_RecurseAsIfGroup", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_RecurseAsIfGroup)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_Recurse1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_Recurse1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_Recurse2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_Recurse2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_ForbiddenRes1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_ForbiddenRes1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_ForbiddenRes2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_ForbiddenRes2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_ForbiddenRes3", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_ForbiddenRes3)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_ForbiddenRes4", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_ForbiddenRes4)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_NSSubset1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_NSSubset1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_NSSubset2", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_NSSubset2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_NSRecurseCheckCardinality1", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_NSRecurseCheckCardinality1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_RecurseUnordered", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_RecurseUnordered)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_MapAndSum", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_MapAndSum)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_PD_InvalidContentType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::PD_InvalidContentType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_NodeIDMap_GrowErr", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::NodeIDMap_GrowErr)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_ProtoType_Null_ClassName", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_ProtoType_Null_ClassName)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_ProtoType_NameLen_Dif", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_ProtoType_NameLen_Dif)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_ProtoType_Name_Dif", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_ProtoType_Name_Dif)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_InStream_Read_LT_Req", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_InStream_Read_LT_Req)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_InStream_Read_OverFlow", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_InStream_Read_OverFlow)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_Storing_Violation", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_Storing_Violation)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_StoreBuffer_Violation", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_StoreBuffer_Violation)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_LoadPool_UppBnd_Exceed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_LoadPool_UppBnd_Exceed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_LoadPool_NoTally_ObjCnt", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_LoadPool_NoTally_ObjCnt)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_Loading_Violation", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_Loading_Violation)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_LoadBuffer_Violation", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_LoadBuffer_Violation)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_Inv_ClassIndex", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_Inv_ClassIndex)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_Inv_FillBuffer_Size", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_Inv_FillBuffer_Size)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_Inv_checkFillBuffer_Size", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_Inv_checkFillBuffer_Size)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_Inv_checkFlushBuffer_Size", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_Inv_checkFlushBuffer_Size)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_Inv_Null_Pointer", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_Inv_Null_Pointer)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_Inv_Buffer_Len", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_Inv_Buffer_Len)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_CreateObject_Fail", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_CreateObject_Fail)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_ObjCount_UppBnd_Exceed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_ObjCount_UppBnd_Exceed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_GrammarPool_Locked", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_GrammarPool_Locked)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_GrammarPool_Empty", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_GrammarPool_Empty)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_GrammarPool_NotEmpty", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_GrammarPool_NotEmpty)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_StringPool_NotEmpty", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_StringPool_NotEmpty)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_XSer_Storer_NewerThan_Loader", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::XSer_Storer_NewerThan_Loader)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_F_HighBounds", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::F_HighBounds)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_E_LowBounds", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::E_LowBounds)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLExcepts_E_HighBounds", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLExcepts::E_HighBounds)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLExcepts, (void*) "XML::Xerces::XMLExcepts");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLException, (void*) "XML::Xerces::XMLException");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLUni, (void*) "XML::Xerces::XMLUni");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__QName, (void*) "XML::Xerces::QName");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_NoReason", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::NoReason)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_Declared", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::Declared)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_AttList", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::AttList)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_InContentModel", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::InContentModel)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_AsRootElem", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::AsRootElem)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_JustFaultIn", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::JustFaultIn)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_AddIfNotFound", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::AddIfNotFound)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_FailIfNotFound", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::FailIfNotFound)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_NoCharData", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::NoCharData)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_SpacesOk", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::SpacesOk)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_AllCharData", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::AllCharData)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_Schema", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::Schema)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_DTD", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::DTD)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLElementDecl_UnKnown", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLElementDecl::UnKnown)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLElementDecl, (void*) "XML::Xerces::XMLElementDecl");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLEntityDecl, (void*) "XML::Xerces::XMLEntityDecl");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLNotationDecl, (void*) "XML::Xerces::XMLNotationDecl");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDefList, (void*) "XML::Xerces::XMLAttDefList");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_CData", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::CData)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_ID", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::ID)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_IDRef", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::IDRef)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_IDRefs", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::IDRefs)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Entity", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Entity)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Entities", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Entities)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_NmToken", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::NmToken)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_NmTokens", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::NmTokens)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Notation", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Notation)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Enumeration", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Enumeration)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Simple", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Simple)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Any_Any", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Any_Any)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Any_Other", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Any_Other)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Any_List", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Any_List)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_AttTypes_Count", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes_Count)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_AttTypes_Min", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes_Min)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_AttTypes_Max", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes_Max)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_AttTypes_Unknown", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::AttTypes_Unknown)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Default", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Default)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Required", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Required)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Required_And_Fixed", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Required_And_Fixed)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Implied", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Implied)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_ProcessContents_Skip", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::ProcessContents_Skip)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_ProcessContents_Lax", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::ProcessContents_Lax)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_ProcessContents_Strict", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::ProcessContents_Strict)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_Prohibited", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::Prohibited)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_DefAttTypes_Count", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes_Count)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_DefAttTypes_Min", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes_Min)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_DefAttTypes_Max", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes_Max)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_DefAttTypes_Unknown", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::DefAttTypes_Unknown)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_NoReason", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::NoReason)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLAttDef_JustFaultIn", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLAttDef::JustFaultIn)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLAttDef, (void*) "XML::Xerces::XMLAttDef");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLValidator, (void*) "XML::Xerces::XMLValidator");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "Grammar_DTDGrammarType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::Grammar::DTDGrammarType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "Grammar_SchemaGrammarType", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::Grammar::SchemaGrammarType)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "Grammar_UnKnown", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::Grammar::UnKnown)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "Grammar_UNKNOWN_SCOPE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::Grammar::UNKNOWN_SCOPE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "Grammar_TOP_LEVEL_SCOPE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::Grammar::TOP_LEVEL_SCOPE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Grammar, (void*) "XML::Xerces::Grammar");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLGrammarDescription, (void*) "XML::Xerces::XMLGrammarDescription");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLDTDDescription, (void*) "XML::Xerces::XMLDTDDescription");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLSchemaDescription_CONTEXT_INCLUDE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLSchemaDescription::CONTEXT_INCLUDE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLSchemaDescription_CONTEXT_REDEFINE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLSchemaDescription::CONTEXT_REDEFINE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLSchemaDescription_CONTEXT_IMPORT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLSchemaDescription::CONTEXT_IMPORT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLSchemaDescription_CONTEXT_PREPARSE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLSchemaDescription::CONTEXT_PREPARSE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLSchemaDescription_CONTEXT_INSTANCE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLSchemaDescription::CONTEXT_INSTANCE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLSchemaDescription_CONTEXT_ELEMENT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLSchemaDescription::CONTEXT_ELEMENT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLSchemaDescription_CONTEXT_ATTRIBUTE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLSchemaDescription::CONTEXT_ATTRIBUTE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLSchemaDescription_CONTEXT_XSITYPE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLSchemaDescription::CONTEXT_XSITYPE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "XMLSchemaDescription_CONTEXT_UNKNOWN", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::XMLSchemaDescription::CONTEXT_UNKNOWN)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLSchemaDescription, (void*) "XML::Xerces::XMLSchemaDescription");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DTDElementDecl_Empty", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DTDElementDecl::Empty)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DTDElementDecl_Any", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DTDElementDecl::Any)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DTDElementDecl_Mixed_Simple", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DTDElementDecl::Mixed_Simple)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DTDElementDecl_Children", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DTDElementDecl::Children)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DTDElementDecl_ModelTypes_Count", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DTDElementDecl::ModelTypes_Count)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDElementDecl, (void*) "XML::Xerces::DTDElementDecl");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDElementDecl_t, (void*) "XML::Xerces::DTDElementDeclEnumerator");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDEntityDecl, (void*) "XML::Xerces::DTDEntityDecl");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__NameIdPoolEnumeratorTXERCES_CPP_NAMESPACE__DTDEntityDecl_t, (void*) "XML::Xerces::DTDEntityDeclEnumerator");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDefList, (void*) "XML::Xerces::DTDAttDefList");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDAttDef, (void*) "XML::Xerces::DTDAttDef");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDGrammar, (void*) "XML::Xerces::DTDGrammar");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDValidator, (void*) "XML::Xerces::DTDValidator");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SchemaElementDecl_Empty", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SchemaElementDecl::Empty)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SchemaElementDecl_Any", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SchemaElementDecl::Any)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SchemaElementDecl_Mixed_Simple", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SchemaElementDecl::Mixed_Simple)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SchemaElementDecl_Mixed_Complex", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SchemaElementDecl::Mixed_Complex)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SchemaElementDecl_Children", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SchemaElementDecl::Children)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SchemaElementDecl_Simple", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SchemaElementDecl::Simple)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SchemaElementDecl_ModelTypes_Count", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SchemaElementDecl::ModelTypes_Count)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaElementDecl, (void*) "XML::Xerces::SchemaElementDecl");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__RefHash3KeysIdPoolEnumeratorTXERCES_CPP_NAMESPACE__SchemaElementDecl_t, (void*) "XML::Xerces::SchemaElementDeclEnumerator");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaGrammar, (void*) "XML::Xerces::SchemaGrammar");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaValidator, (void*) "XML::Xerces::SchemaValidator");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDefList, (void*) "XML::Xerces::SchemaAttDefList");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__SchemaAttDef, (void*) "XML::Xerces::SchemaAttDef");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__InputSource, (void*) "XML::Xerces::InputSource");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileInputSource, (void*) "XML::Xerces::LocalFileInputSource");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__StdInInputSource, (void*) "XML::Xerces::StdInInputSource");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__URLInputSource, (void*) "XML::Xerces::URLInputSource");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufInputSource, (void*) "XML::Xerces::MemBufInputSource");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_INDEX_SIZE_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::INDEX_SIZE_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_DOMSTRING_SIZE_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::DOMSTRING_SIZE_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_HIERARCHY_REQUEST_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::HIERARCHY_REQUEST_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_WRONG_DOCUMENT_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::WRONG_DOCUMENT_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_INVALID_CHARACTER_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::INVALID_CHARACTER_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_NO_DATA_ALLOWED_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::NO_DATA_ALLOWED_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_NO_MODIFICATION_ALLOWED_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::NO_MODIFICATION_ALLOWED_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_NOT_FOUND_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::NOT_FOUND_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_NOT_SUPPORTED_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::NOT_SUPPORTED_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_INUSE_ATTRIBUTE_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::INUSE_ATTRIBUTE_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_INVALID_STATE_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::INVALID_STATE_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_SYNTAX_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::SYNTAX_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_INVALID_MODIFICATION_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::INVALID_MODIFICATION_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_NAMESPACE_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::NAMESPACE_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_INVALID_ACCESS_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::INVALID_ACCESS_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMException_VALIDATION_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMException::VALIDATION_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMException, (void*) "XML::Xerces::DOMException");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_ELEMENT_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::ELEMENT_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_ATTRIBUTE_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::ATTRIBUTE_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_TEXT_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::TEXT_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_CDATA_SECTION_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::CDATA_SECTION_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_ENTITY_REFERENCE_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::ENTITY_REFERENCE_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_ENTITY_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::ENTITY_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_PROCESSING_INSTRUCTION_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::PROCESSING_INSTRUCTION_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_COMMENT_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::COMMENT_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_DOCUMENT_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::DOCUMENT_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_DOCUMENT_TYPE_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::DOCUMENT_TYPE_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_DOCUMENT_FRAGMENT_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::DOCUMENT_FRAGMENT_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_NOTATION_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::NOTATION_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_TREE_POSITION_PRECEDING", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::TREE_POSITION_PRECEDING)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_TREE_POSITION_FOLLOWING", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::TREE_POSITION_FOLLOWING)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_TREE_POSITION_ANCESTOR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::TREE_POSITION_ANCESTOR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_TREE_POSITION_DESCENDANT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::TREE_POSITION_DESCENDANT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_TREE_POSITION_EQUIVALENT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::TREE_POSITION_EQUIVALENT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_TREE_POSITION_SAME_NODE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::TREE_POSITION_SAME_NODE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNode_TREE_POSITION_DISCONNECTED", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNode::TREE_POSITION_DISCONNECTED)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNode, (void*) "XML::Xerces::DOMNode");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMAttr, (void*) "XML::Xerces::DOMAttr");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMElement, (void*) "XML::Xerces::DOMElement");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntity, (void*) "XML::Xerces::DOMEntity");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentType, (void*) "XML::Xerces::DOMDocumentType");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCharacterData, (void*) "XML::Xerces::DOMCharacterData");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMComment, (void*) "XML::Xerces::DOMComment");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMText, (void*) "XML::Xerces::DOMText");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMCDATASection, (void*) "XML::Xerces::DOMCDATASection");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeList, (void*) "XML::Xerces::DOMNodeList");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNamedNodeMap, (void*) "XML::Xerces::DOMNamedNodeMap");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentFragment, (void*) "XML::Xerces::DOMDocumentFragment");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntityReference, (void*) "XML::Xerces::DOMEntityReference");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNotation, (void*) "XML::Xerces::DOMNotation");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMProcessingInstruction, (void*) "XML::Xerces::DOMProcessingInstruction");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentRange, (void*) "XML::Xerces::DOMDocumentRange");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocumentTraversal, (void*) "XML::Xerces::DOMDocumentTraversal");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeIterator, (void*) "XML::Xerces::DOMNodeIterator");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_FILTER_ACCEPT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::FILTER_ACCEPT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_FILTER_REJECT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::FILTER_REJECT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_FILTER_SKIP", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::FILTER_SKIP)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_ALL", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_ALL)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_ELEMENT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_ELEMENT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_ATTRIBUTE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_ATTRIBUTE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_TEXT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_TEXT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_CDATA_SECTION", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_CDATA_SECTION)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_ENTITY_REFERENCE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_ENTITY_REFERENCE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_ENTITY", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_ENTITY)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_PROCESSING_INSTRUCTION", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_PROCESSING_INSTRUCTION)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_COMMENT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_COMMENT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_DOCUMENT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_DOCUMENT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_DOCUMENT_TYPE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_DOCUMENT_TYPE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_DOCUMENT_FRAGMENT", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_DOCUMENT_FRAGMENT)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMNodeFilter_SHOW_NOTATION", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMNodeFilter::SHOW_NOTATION)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMNodeFilter, (void*) "XML::Xerces::DOMNodeFilter");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMRange_START_TO_START", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMRange::START_TO_START)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMRange_START_TO_END", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMRange::START_TO_END)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMRange_END_TO_END", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMRange::END_TO_END)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMRange_END_TO_START", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMRange::END_TO_START)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRange, (void*) "XML::Xerces::DOMRange");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMRangeException_BAD_BOUNDARYPOINTS_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMRangeException::BAD_BOUNDARYPOINTS_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMRangeException_INVALID_NODE_TYPE_ERR", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMRangeException::INVALID_NODE_TYPE_ERR)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMRangeException, (void*) "XML::Xerces::DOMRangeException");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMTreeWalker, (void*) "XML::Xerces::DOMTreeWalker");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMImplementationLS_MODE_SYNCHRONOUS", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMImplementationLS::MODE_SYNCHRONOUS)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMImplementationLS_MODE_ASYNCHRONOUS", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMImplementationLS::MODE_ASYNCHRONOUS)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationLS, (void*) "XML::Xerces::DOMImplementationLS");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementation, (void*) "XML::Xerces::DOMImplementation");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationSource, (void*) "XML::Xerces::DOMImplementationSource");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMImplementationRegistry, (void*) "XML::Xerces::DOMImplementationRegistry");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMErrorHandler, (void*) "XML::Xerces::DOMErrorHandler");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMEntityResolver, (void*) "XML::Xerces::DOMEntityResolver");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMDocument, (void*) "XML::Xerces::DOMDocument");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMLocator, (void*) "XML::Xerces::DOMLocator");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMInputSource, (void*) "XML::Xerces::DOMInputSource");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4InputSource, (void*) "XML::Xerces::Wrapper4InputSource");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Wrapper4DOMInputSource, (void*) "XML::Xerces::Wrapper4DOMInputSource");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMBuilder_ACTION_REPLACE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMBuilder::ACTION_REPLACE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMBuilder_ACTION_APPEND_AS_CHILDREN", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMBuilder::ACTION_APPEND_AS_CHILDREN)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMBuilder_ACTION_INSERT_AFTER", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMBuilder::ACTION_INSERT_AFTER)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "DOMBuilder_ACTION_INSERT_BEFORE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::DOMBuilder::ACTION_INSERT_BEFORE)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMBuilder, (void*) "XML::Xerces::DOMBuilder");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__StdOutFormatTarget, (void*) "XML::Xerces::StdOutFormatTarget");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__LocalFileFormatTarget, (void*) "XML::Xerces::LocalFileFormatTarget");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__MemBufFormatTarget, (void*) "XML::Xerces::MemBufFormatTarget");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriter, (void*) "XML::Xerces::DOMWriter");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DOMWriterFilter, (void*) "XML::Xerces::DOMWriterFilter");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXException, (void*) "XML::Xerces::SAXException");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXNotSupportedException, (void*) "XML::Xerces::SAXNotSupportedException");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXNotRecognizedException, (void*) "XML::Xerces::SAXNotRecognizedException");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParseException, (void*) "XML::Xerces::SAXParseException");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__ErrorHandler, (void*) "XML::Xerces::ErrorHandler");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DTDHandler, (void*) "XML::Xerces::DTDHandler");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DocumentHandler, (void*) "XML::Xerces::DocumentHandler");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__EntityResolver, (void*) "XML::Xerces::EntityResolver");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__AttributeList, (void*) "XML::Xerces::AttributeList");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__HandlerBase, (void*) "XML::Xerces::HandlerBase");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Locator, (void*) "XML::Xerces::Locator");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Attributes, (void*) "XML::Xerces::Attributes");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__ContentHandler, (void*) "XML::Xerces::ContentHandler");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__LexicalHandler, (void*) "XML::Xerces::LexicalHandler");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DeclHandler, (void*) "XML::Xerces::DeclHandler");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__DefaultHandler, (void*) "XML::Xerces::DefaultHandler");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLPScanToken, (void*) "XML::Xerces::XMLPScanToken");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__PSVIHandler, (void*) "XML::Xerces::PSVIHandler");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__Parser, (void*) "XML::Xerces::Parser");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "AbstractDOMParser_Val_Never", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::AbstractDOMParser::Val_Never)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "AbstractDOMParser_Val_Always", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::AbstractDOMParser::Val_Always)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "AbstractDOMParser_Val_Auto", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::AbstractDOMParser::Val_Auto)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__AbstractDOMParser, (void*) "XML::Xerces::AbstractDOMParser");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XercesDOMParser, (void*) "XML::Xerces::XercesDOMParser");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SAXParser_Val_Never", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SAXParser::Val_Never)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SAXParser_Val_Always", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SAXParser::Val_Always)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SAXParser_Val_Auto", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SAXParser::Val_Auto)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAXParser, (void*) "XML::Xerces::SAXParser");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SAX2XMLReader_Val_Never", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SAX2XMLReader::Val_Never)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SAX2XMLReader_Val_Always", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SAX2XMLReader::Val_Always)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "SAX2XMLReader_Val_Auto", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(XERCES_CPP_NAMESPACE::SAX2XMLReader::Val_Auto)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__SAX2XMLReader, (void*) "XML::Xerces::SAX2XMLReader");
  SWIG_TypeClientData(SWIGTYPE_p_XERCES_CPP_NAMESPACE__XMLReaderFactory, (void*) "XML::Xerces::XMLReaderFactory");
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "PERLCALLBACKHANDLER_BASE_TYPE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(-1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "PERLCALLBACKHANDLER_ERROR_TYPE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(0)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "PERLCALLBACKHANDLER_ENTITY_TYPE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(1)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "PERLCALLBACKHANDLER_NODE_TYPE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(2)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "PERLCALLBACKHANDLER_CONTENT_TYPE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(3)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  /*@SWIG:%set_constant@*/ do {
    SV *sv = get_sv((char*) SWIG_prefix "PERLCALLBACKHANDLER_DOCUMENT_TYPE", TRUE | 0x2);
    sv_setsv(sv, SWIG_From_int  SWIG_PERL_CALL_ARGS_1(static_cast< int >(4)));
    SvREADONLY_on(sv);
  } while(0) /*@SWIG@*/;
  SWIG_TypeClientData(SWIGTYPE_p_PerlCallbackHandler, (void*) "XML::Xerces::PerlCallbackHandler");
  SWIG_TypeClientData(SWIGTYPE_p_PerlErrorCallbackHandler, (void*) "XML::Xerces::PerlErrorCallbackHandler");
  SWIG_TypeClientData(SWIGTYPE_p_PerlEntityResolverHandler, (void*) "XML::Xerces::PerlEntityResolverHandler");
  SWIG_TypeClientData(SWIGTYPE_p_PerlNodeFilterCallbackHandler, (void*) "XML::Xerces::PerlNodeFilterCallbackHandler");
  SWIG_TypeClientData(SWIGTYPE_p_PerlDocumentCallbackHandler, (void*) "XML::Xerces::PerlDocumentCallbackHandler");
  SWIG_TypeClientData(SWIGTYPE_p_PerlContentCallbackHandler, (void*) "XML::Xerces::PerlContentCallbackHandler");
  
  // we create the global transcoder for UTF-8 to UTF-16
  XMLTransService::Codes failReason;
  XMLPlatformUtils::Initialize(); // first we must create the transservice
  UTF8_ENCODING = XMLString::transcode("UTF-8");
  UTF8_TRANSCODER =
  XMLPlatformUtils::fgTransService->makeNewTranscoderFor(UTF8_ENCODING,
    failReason,
    1024,
    XMLPlatformUtils::fgMemoryManager);
  if (! UTF8_TRANSCODER) {
    croak("ERROR: XML::Xerces: INIT: Could not create UTF-8 transcoder");
  }
  
  ST(0) = &PL_sv_yes;
  XSRETURN(1);
}

